//
// Automatically generated by GenNvs ver 2.4.6
// Please DO NOT modify !!!
//


/** @file
  ACPI DSDT table

 @copyright
  INTEL CONFIDENTIAL
  Copyright 2011 - 2020 Intel Corporation.

  The source code contained or described herein and all documents related to the
  source code ("Material") are owned by Intel Corporation or its suppliers or
  licensors. Title to the Material remains with Intel Corporation or its suppliers
  and licensors. The Material may contain trade secrets and proprietary and
  confidential information of Intel Corporation and its suppliers and licensors,
  and is protected by worldwide copyright and trade secret laws and treaty
  provisions. No part of the Material may be used, copied, reproduced, modified,
  published, uploaded, posted, transmitted, distributed, or disclosed in any way
  without Intel's prior express written permission.

  No license under any patent, copyright, trade secret or other intellectual
  property right is granted to or conferred upon you by disclosure or delivery
  of the Materials, either expressly, by implication, inducement, estoppel or
  otherwise. Any license under such intellectual property rights must be
  express and approved by Intel in writing.

  Unless otherwise agreed by Intel in writing, you may not remove or alter
  this notice or any other notice embedded in Materials by Intel or
  Intel's suppliers or licensors in any way.

  This file contains a 'Sample Driver' and is licensed as such under the terms
  of your license agreement with Intel or your vendor. This file may be modified
  by the user, subject to the additional terms of the license agreement.

@par Specification
**/

  // Define a Global region of ACPI NVS Region that may be used for any
  // type of implementation.  The starting offset and size will be fixed
  // up by the System BIOS during POST.  Note that the Size must be a word
  // in size to be fixed up correctly.



  OperationRegion(GNVS,SystemMemory,0xFFFF0000,0xAA55)
  Field(GNVS,AnyAcc,Lock,Preserve)
  {  //
  // Miscellaneous Dynamic Registers:
  //
  Offset(0),      OSYS, 16, // Offset(0),     Operating System
  Offset(2),      SMIF, 8,  // Offset(2),     SMI Function Call (ASL to SMI via I/O Trap)
  Offset(3),      PRM0, 8,  // Offset(3),     SMIF - Parameter 0
  Offset(4),      PRM1, 8,  // Offset(4),     SMIF - Parameter 1
  Offset(5),      SCIF, 8,  // Offset(5),     SCI Function Call (SMI to ASL via _L00)
  Offset(6),      PRM2, 8,  // Offset(6),     SCIF - Parameter 0
  Offset(7),      PRM3, 8,  // Offset(7),     SCIF - Parameter 1
  Offset(8),      LCKF, 8,  // Offset(8),     Global Lock Function Call (EC Communication)
  Offset(9),      PRM4, 8,  // Offset(9),     LCKF - Parameter 0
  Offset(10),     PRM5, 8,  // Offset(10),    LCKF - Parameter 1
  Offset(11),     PWRS, 8,  // Offset(11),    Power State (AC Mode = 1)
  Offset(12),     DBGS, 8,  // Offset(12),    Debug State
  //
  // Thermal Policy Registers:
  //
  Offset(13),     THOF, 8,  // Offset(13),    Enable Thermal Offset for KSC
  Offset(14),     ACT1, 8,  // Offset(14),    Active Trip Point 1
  Offset(15),     ACTT, 8,  // Offset(15),    Active Trip Point
  Offset(16),     PSVT, 8,  // Offset(16),    Passive Trip Point
  Offset(17),     TC1V, 8,  // Offset(17),    Passive Trip Point TC1 Value
  Offset(18),     TC2V, 8,  // Offset(18),    Passive Trip Point TC2 Value
  Offset(19),     TSPV, 8,  // Offset(19),    Passive Trip Point TSP Value
  Offset(20),     CRTT, 8,  // Offset(20),    Critical Trip Point
  Offset(21),     DTSE, 8,  // Offset(21),    Digital Thermal Sensor Enable
  Offset(22),     DTS1, 8,  // Offset(22),    Digital Thermal Sensor 1 Reading
  Offset(23),     DTS2, 8,  // Offset(23),    Digital Thermal Sensor 2 Reading
  Offset(24),     DTSF, 8,  // Offset(24),    DTS SMI Function Call
  //
  // Revision Field:
  //
  Offset(25),     REVN, 8,  // Offset(25),    Revison of GlobalNvsArea
  //
  // CPU Identification Registers:
  //
  Offset(26),     APIC, 8,  // Offset(26),    APIC Enabled by SBIOS (APIC Enabled = 1)
  Offset(27),     TCNT, 8,  // Offset(27),    Number of Enabled Threads
  Offset(28),     PCP0, 8,  // Offset(28),    PDC Settings, Processor 0
  Offset(29),     PCP1, 8,  // Offset(29),    PDC Settings, Processor 1
  Offset(30),     PPCM, 8,  // Offset(30),    Maximum PPC state
  Offset(31),     PPMF, 32, // Offset(31),    PPM Flags (Same as CFGD)
  Offset(35),     C67L, 8,  // Offset(35),    C6/C7 Entry/Exit latency
  //
  // SIO Configuration Registers:
  //
  Offset(36),     NATP, 8,  // Offset(36),    National SIO Present
  Offset(37),     CMAP, 8,  // Offset(37),    COM A Port
  Offset(38),     CMBP, 8,  // Offset(38),    COM B Port
  Offset(39),     LPTP, 8,  // Offset(39),    LPT Port
  Offset(40),     FDCP, 8,  // Offset(40),    FDC Port
  Offset(41),     CMCP, 8,  // Offset(41),    SMSC Com Port
  Offset(42),     CIRP, 8,  // Offset(42),    SMSC Com CIR Port
  Offset(43),     SMSC, 8,  // Offset(43),    SMSC1007 SIO Present
  Offset(44),     W381, 8,  // Offset(44),    WPCN381U SIO Present
  Offset(45),     SMC1, 8,  // Offset(45),    SMSC1000 SIO Present
  //
  // Extended Mobile Access Values
  //
  Offset(46),     EMAE, 8,  // Offset(46),    EMA Enable
  Offset(47),     EMAP, 16, // Offset(47),    EMA Pointer
  Offset(49),     EMAL, 16, // Offset(49),    EMA Length
  //
  // MEF Registers:
  //
  Offset(51),     MEFE, 8,  // Offset(51),    MEF Enable
  //
  // PCIe Dock Status:
  //
  Offset(52),     DSTS, 8,  // Offset(52),    PCIe Dock Status
  //
  // TPM Registers
  //
  Offset(53),     MORD, 8,  // Offset(53),    Memory Overwrite Request Data
  Offset(54),     TCGP, 8,  // Offset(54),    Used for save the Mor and/or physical presence paramter
  Offset(55),     PPRP, 32, // Offset(55),    Physical Presence request operation response
  Offset(59),     PPRQ, 8,  // Offset(59),    Physical Presence request operation
  Offset(60),     LPPR, 8,  // Offset(60),    Last Physical Presence request operation
  //
  // SATA Registers:
  //
  Offset(61),     IDEM, 8,  // Offset(61),    IDE Mode (Compatible\Enhanced)
  //
  // Board Id
  //
  Offset(62),     PLID, 8,  // Offset(62),    Platform id
  Offset(63),     BTYP, 8,  // Offset(63),    Board Type
  //
  // PCIe Hot Plug
  //
  Offset(64),     OSCC, 8,  // Offset(64),    PCIE OSC Control
  Offset(65),     NEXP, 8,  // Offset(65),    Native PCIE Setup Value
  //
  // USB Sideband Deferring Support
  //
  Offset(66),     SBV1, 8,  // Offset(66),    USB Sideband Deferring GPE Vector (HOST_ALERT#1)
  Offset(67),     SBV2, 8,  // Offset(67),    USB Sideband Deferring GPE Vector (HOST_ALERT#2)
  //
  // Embedded Controller Availability Flag.
  //
  Offset(68),     ECON, 8,  // Offset(68),    Embedded Controller Availability Flag.
  //
  // Global Variables
  //
  Offset(69),     DSEN, 8,  // Offset(69),    _DOS Display Support Flag.
  Offset(70),     GPIC, 8,  // Offset(70),    Global IOAPIC/8259 Interrupt Mode Flag.
  Offset(71),     CTYP, 8,  // Offset(71),    Global Cooling Type Flag.
  Offset(72),     L01C, 8,  // Offset(72),    Global L01 Counter.
  Offset(73),     VFN0, 8,  // Offset(73),    Virtual Fan0 Status.
  Offset(74),     VFN1, 8,  // Offset(74),    Virtual Fan1 Status.
  Offset(75),     VFN2, 8,  // Offset(75),    Virtual Fan2 Status.
  Offset(76),     VFN3, 8,  // Offset(76),    Virtual Fan3 Status.
  Offset(77),     VFN4, 8,  // Offset(77),    Virtual Fan4 Status.
  Offset(78),     VFN5, 8,  // Offset(78),    Virtual Fan5 Status.
  Offset(79),     VFN6, 8,  // Offset(79),    Virtual Fan6 Status.
  Offset(80),     VFN7, 8,  // Offset(80),    Virtual Fan7 Status.
  Offset(81),     VFN8, 8,  // Offset(81),    Virtual Fan8 Status.
  Offset(82),     VFN9, 8,  // Offset(82),    Virtual Fan9 Status.
  //
  // Thermal
  //
  Offset(83),     PNHM, 32, // Offset(83),    CPUID Feature Information [EAX]
  Offset(87),     TBAL, 32, // Offset(87),    Reserved for Thermal Base Low Address for BIOS
  Offset(91),     TBAH, 32, // Offset(91),    Reserved for Thermal Base High Address for BIOS
  Offset(95),     TSOD, 8,  // Offset(95),    TS-on-DIMM is chosen in SETUP and present on the DIMM
  //
  // Board info
  //
  Offset(96),     PFLV, 8,  // Offset(96),    Platform Flavor
  Offset(97),     BREV, 16, // Offset(97),    Board Rev
  //
  // Package temperature
  //
  Offset(99),     PDTS, 8,  // Offset(99),    Package Temperature
  Offset(100),    PKGA, 8,  // Offset(100),   Package Temperature MSR available
  Offset(101),    PAMT, 8,  // Offset(101),   Peci Access Method
  Offset(102),    AC0F, 8,  // Offset(102),   _AC0 Fan Speed
  Offset(103),    AC1F, 8,  // Offset(103),   _AC1 Fan Speed
  Offset(104),    DTS3, 8,  // Offset(104),   Digital Thermal Sensor 3 Reading
  Offset(105),    DTS4, 8,  // Offset(105),   Digital Thermal Sensor 4 Reading
  //
  // XTU 3.0 Specification
  //
  Offset(106),    XTUB, 32, // Offset(106),   XTU Continous structure Base Address
  Offset(110),    XTUS, 32, // Offset(110),   XMP Size
  Offset(114),    XMPB, 32, // Offset(114),   XMP Base Address
  Offset(118),    DDRF, 8,  // Offset(118),   DDR Reference Frequency
  Offset(119),    RTD3, 8,  // Offset(119),   Runtime D3 support.
  Offset(120),    PEP0, 8,  // Offset(120),   User selctable Delay for Device D0 transition.
  Offset(121),    PEP3, 8,  // Offset(121),   User selctable Delay for Device D3 transition.
  //
  // Intel(R) Dynamic Tuning Technology Devices and trip points
  //
  Offset(122),    DPTF, 8,  // Offset(122),   EnableDptf
  Offset(123),    DCFE, 16, // Offset(123),   EnableDCFG
  Offset(125),    SADE, 8,  // Offset(125),   EnableSaDevice
  // DPPM Devices and trip points
  //
  Offset(126),    FND1, 8,  // Offset(126),   EnableFan1Device
  Offset(127),    AMBD, 8,  // Offset(127),   EnableAmbientDevice
  Offset(128),    AMAT, 8,  // Offset(128),   ActiveThermalTripPointAmbient
  Offset(129),    AMPT, 8,  // Offset(129),   PassiveThermalTripPointAmbient
  Offset(130),    AMCT, 8,  // Offset(130),   CriticalThermalTripPointAmbient
  Offset(131),    AMHT, 8,  // Offset(131),   HotThermalTripPointAmbient
  Offset(132),    SKDE, 8,  // Offset(132),   EnableSkinDevice
  Offset(133),    SKAT, 8,  // Offset(133),   ActiveThermalTripPointSkin
  Offset(134),    SKPT, 8,  // Offset(134),   PassiveThermalTripPointSkin
  Offset(135),    SKCT, 8,  // Offset(135),   CriticalThermalTripPointSkin
  Offset(136),    SKHT, 8,  // Offset(136),   HotThermalTripPointSkin
  Offset(137),    EFDE, 8,  // Offset(137),   EnableExhaustFanDevice
  Offset(138),    EFAT, 8,  // Offset(138),   ActiveThermalTripPointExhaustFan
  Offset(139),    EFPT, 8,  // Offset(139),   PassiveThermalTripPointExhaustFan
  Offset(140),    EFCT, 8,  // Offset(140),   CriticalThermalTripPointExhaustFan
  Offset(141),    EFHT, 8,  // Offset(141),   HotThermalTripPointExhaustFan
  Offset(142),    VRDE, 8,  // Offset(142),   EnableVRDevice
  Offset(143),    VRAT, 8,  // Offset(143),   ActiveThermalTripPointVR
  Offset(144),    VRPT, 8,  // Offset(144),   PassiveThermalTripPointVR
  Offset(145),    VRCT, 8,  // Offset(145),   CriticalThermalTripPointVR
  Offset(146),    VRHT, 8,  // Offset(146),   HotThermalTripPointVR
  //
  // DPPM Policies
  //
  Offset(147),    DPAP, 8,  // Offset(147),   EnableActivePolicy @deprecated. Intel(R) Dynamic Tuning can dynamically enable/disable policies
  Offset(148),    DPPP, 8,  // Offset(148),   EnablePassivePolicy @deprecated. Intel(R) Dynamic Tuning can dynamically enable/disable policies
  Offset(149),    DPCP, 8,  // Offset(149),   EnableCriticalPolicy @deprecated. Intel(R) Dynamic Tuning can dynamically enable/disable policies
  Offset(150),    PIDE, 8,  // Offset(150),   EnablePIDPolicy @deprecated. Intel(R) Dynamic Tuning can dynamically enable/disable policies
  //
  // Miscellaneous Intel(R) Dynamic Tuning Technology
  //
  Offset(151),    PPSZ, 32, // Offset(151),   PPCC Step Size
  //
  // Never Sleep Technology
  //
  Offset(155),    IRMC, 8,  // Offset(155),   Irmt Configuration
  //
  // Comms Hub
  //
  Offset(156),    CHEN, 8,  // Offset(156),   Comms Hub Enable/Disable
  Offset(157),    S0ID, 8,  // Offset(157),   Low Power S0 Idle Enable
  //
  // BIOS only version of Config TDP
  //
  Offset(158),    CTDB, 8,  // Offset(158),   enable/disable BIOS only version of Config TDP
  Offset(159),    DKSM, 8,  // Offset(159),   Dock SMI number
  //
  // LPC SIO configuration
  //
  Offset(160),    SIO1, 16, // Offset(160),   SIO config port 1
  Offset(162),    SIO2, 16, // Offset(162),   SIO config port 2
  Offset(164),    SPBA, 16, // Offset(164),   SIO PME Base Address
  Offset(500),              // Offset(166) : Offset(499), Reserved bytes
  Offset(500),    PWRE, 8,  // Offset(500),   EnablePowerParticipant
  Offset(501),        , 16, // Offset(501),   DPTFRsvd0
  Offset(503),    PPPR, 16, // Offset(503),   PowerParticipantPollingRate
  Offset(505),        , 8,  // Offset(505),   EnablePowerBossPolicy @deprecated. Intel(R) Dynamic Tuning can dynamically enable/disable policies
  Offset(506),    VSPE, 8,  // Offset(506),   EnableVSPolicy @deprecated. Intel(R) Dynamic Tuning can dynamically enable/disable policies
  Offset(507),    RFIM, 8,  // Offset(507),   RFI Mitigation @deprecated. Intel(R) Dynamic Tuning can dynamically enable/disable policies
  Offset(515),              // Offset(508) : Offset(514), Reserved bytes
  Offset(515),    XHPR, 8,  // Offset(515),   RTD3 USB Power Resource config
  Offset(516),    RIC0, 8,  // Offset(516),   RTD3 support for I2C0 SH
  Offset(517),    GBSX, 8,  // Offset(517),   Virtual GPIO button Notify Sleep State Change
  Offset(518),    IUBE, 8,  // Offset(518),   IUER Button Enable
  Offset(519),    IUCE, 8,  // Offset(519),   IUER Convertible Enable
  Offset(520),    IUDE, 8,  // Offset(520),   IUER Dock Enable
  Offset(521),    ECNO, 8,  // Offset(521),   EC Notification of Low Power S0 Idle State
  Offset(522),    AUDD, 16, // Offset(522),   RTD3 Audio Codec device delay
  Offset(524),    IC0D, 16, // Offset(524),   RTD3 SensorHub delay time after applying power to device
  Offset(526),    IC1D, 16, // Offset(526),   RTD3 TouchPanel delay time after applying power to device
  Offset(528),    IC1S, 16, // Offset(528),   RTD3 TouchPad delay time after applying power to device
  Offset(530),    VRRD, 16, // Offset(530),   VR Ramp up delay
  Offset(532),    PSCP, 8,  // Offset(532),   P-state Capping
  Offset(533),    I20D, 16, // Offset(533),   Delay in _PS0 after powering up I2C0 Controller
  Offset(535),    I21D, 16, // Offset(535),   Delay in _PS0 after powering up I2C1 Controller
  Offset(537),    RCG0, 16, // Offset(537),   RTD3 Config Setting0(BIT0:ZPODD, BIT1:Reserved, BIT2:PCIe NVMe, BIT3:BT, BIT4:SKL SDS SIP I2C Touch, BIT6:Card Reader, BIT7:WWAN)
  Offset(539),    RCG1, 16, // Offset(539),   RTD3 Config Setting1(BIT0:Sata Port0, BIT1:Sata Port1, BIT2:Sata Port2, BIT3:Sata Port3)
  Offset(541),    ECDB, 8,  // Offset(541),   EC Debug Light (CAPS LOCK) for when in Low Power S0 Idle State
  Offset(542),    P2ME, 8,  // Offset(542),   Ps2 Mouse Enable
  Offset(543),    P2MK, 8,  // Offset(543),   Ps2 Keyboard and Mouse Enable
  Offset(544),    SSH0, 16, // Offset(544),   SSCN-HIGH for I2C0
  Offset(546),    SSL0, 16, // Offset(546),   SSCN-LOW  for I2C0
  Offset(548),    SSD0, 16, // Offset(548),   SSCN-HOLD for I2C0
  Offset(550),    FMH0, 16, // Offset(550),   FMCN-HIGH for I2C0
  Offset(552),    FML0, 16, // Offset(552),   FMCN-LOW  for I2C0
  Offset(554),    FMD0, 16, // Offset(554),   FMCN-HOLD for I2C0
  Offset(556),    FPH0, 16, // Offset(556),   FPCN-HIGH for I2C0
  Offset(558),    FPL0, 16, // Offset(558),   FPCN-LOW  for I2C0
  Offset(560),    FPD0, 16, // Offset(560),   FPCN-HOLD for I2C0
  Offset(562),    HSH0, 16, // Offset(562),   HSCN-HIGH for I2C0
  Offset(564),    HSL0, 16, // Offset(564),   HSCN-LOW  for I2C0
  Offset(566),    HSD0, 16, // Offset(566),   HSCN-HOLD for I2C0
  Offset(573),              // Offset(568) : Offset(572), Reserved bytes
  Offset(573),    SSH1, 16, // Offset(573),   SSCN-HIGH for I2C1
  Offset(575),    SSL1, 16, // Offset(575),   SSCN-LOW  for I2C1
  Offset(577),    SSD1, 16, // Offset(577),   SSCN-HOLD for I2C1
  Offset(579),    FMH1, 16, // Offset(579),   FMCN-HIGH for I2C1
  Offset(581),    FML1, 16, // Offset(581),   FMCN-LOW  for I2C1
  Offset(583),    FMD1, 16, // Offset(583),   FMCN-HOLD for I2C1
  Offset(585),    FPH1, 16, // Offset(585),   FPCN-HIGH for I2C1
  Offset(587),    FPL1, 16, // Offset(587),   FPCN-LOW  for I2C1
  Offset(589),    FPD1, 16, // Offset(589),   FPCN-HOLD for I2C1
  Offset(591),    HSH1, 16, // Offset(591),   HSCN-HIGH for I2C1
  Offset(593),    HSL1, 16, // Offset(593),   HSCN-LOW  for I2C1
  Offset(595),    HSD1, 16, // Offset(595),   HSCN-HOLD for I2C1
  Offset(598),              // Offset(597) : Offset(597), Reserved bytes
  Offset(598),    SSH2, 16, // Offset(598),   SSCN-HIGH for I2C2
  Offset(600),    SSL2, 16, // Offset(600),   SSCN-LOW  for I2C2
  Offset(602),    SSD2, 16, // Offset(602),   SSCN-HOLD for I2C2
  Offset(604),    FMH2, 16, // Offset(604),   FMCN-HIGH for I2C2
  Offset(606),    FML2, 16, // Offset(606),   FMCN-LOW  for I2C2
  Offset(608),    FMD2, 16, // Offset(608),   FMCN-HOLD for I2C2
  Offset(610),    FPH2, 16, // Offset(610),   FPCN-HIGH for I2C2
  Offset(612),    FPL2, 16, // Offset(612),   FPCN-LOW  for I2C2
  Offset(614),    FPD2, 16, // Offset(614),   FPCN-HOLD for I2C2
  Offset(616),    HSH2, 16, // Offset(616),   HSCN-HIGH for I2C2
  Offset(618),    HSL2, 16, // Offset(618),   HSCN-LOW  for I2C2
  Offset(620),    HSD2, 16, // Offset(620),   HSCN-HOLD for I2C2
  Offset(623),              // Offset(622) : Offset(622), Reserved bytes
  Offset(623),    SSH3, 16, // Offset(623),   SSCN-HIGH for I2C3
  Offset(625),    SSL3, 16, // Offset(625),   SSCN-LOW  for I2C3
  Offset(627),    SSD3, 16, // Offset(627),   SSCN-HOLD for I2C3
  Offset(629),    FMH3, 16, // Offset(629),   FMCN-HIGH for I2C3
  Offset(631),    FML3, 16, // Offset(631),   FMCN-LOW  for I2C3
  Offset(633),    FMD3, 16, // Offset(633),   FMCN-HOLD for I2C3
  Offset(635),    FPH3, 16, // Offset(635),   FPCN-HIGH for I2C3
  Offset(637),    FPL3, 16, // Offset(637),   FPCN-LOW  for I2C3
  Offset(639),    FPD3, 16, // Offset(639),   FPCN-HOLD for I2C3
  Offset(641),    HSH3, 16, // Offset(641),   HSCN-HIGH for I2C3
  Offset(643),    HSL3, 16, // Offset(643),   HSCN-LOW  for I2C3
  Offset(645),    HSD3, 16, // Offset(645),   HSCN-HOLD for I2C3
  Offset(648),              // Offset(647) : Offset(647), Reserved bytes
  Offset(648),    SSH4, 16, // Offset(648),   SSCN-HIGH for I2C4
  Offset(650),    SSL4, 16, // Offset(650),   SSCN-LOW  for I2C4
  Offset(652),    SSD4, 16, // Offset(652),   SSCN-HOLD for I2C4
  Offset(654),    FMH4, 16, // Offset(654),   FMCN-HIGH for I2C4
  Offset(656),    FML4, 16, // Offset(656),   FMCN-LOW  for I2C4
  Offset(658),    FMD4, 16, // Offset(658),   FMCN-HOLD for I2C4
  Offset(660),    FPH4, 16, // Offset(660),   FPCN-HIGH for I2C4
  Offset(662),    FPL4, 16, // Offset(662),   FPCN-LOW  for I2C4
  Offset(664),    FPD4, 16, // Offset(664),   FPCN-HOLD for I2C4
  Offset(666),    HSH4, 16, // Offset(666),   HSCN-HIGH for I2C4
  Offset(668),    HSL4, 16, // Offset(668),   HSCN-LOW  for I2C4
  Offset(670),    HSD4, 16, // Offset(670),   HSCN-HOLD for I2C4
  Offset(673),              // Offset(672) : Offset(672), Reserved bytes
  Offset(673),    SSH5, 16, // Offset(673),   SSCN-HIGH for I2C5
  Offset(675),    SSL5, 16, // Offset(675),   SSCN-LOW  for I2C5
  Offset(677),    SSD5, 16, // Offset(677),   SSCN-HOLD for I2C5
  Offset(679),    FMH5, 16, // Offset(679),   FMCN-HIGH for I2C5
  Offset(681),    FML5, 16, // Offset(681),   FMCN-LOW  for I2C5
  Offset(683),    FMD5, 16, // Offset(683),   FMCN-HOLD for I2C5
  Offset(685),    FPH5, 16, // Offset(685),   FPCN-HIGH for I2C5
  Offset(687),    FPL5, 16, // Offset(687),   FPCN-LOW  for I2C5
  Offset(689),    FPD5, 16, // Offset(689),   FPCN-HOLD for I2C5
  Offset(691),    HSH5, 16, // Offset(691),   HSCN-HIGH for I2C5
  Offset(693),    HSL5, 16, // Offset(693),   HSCN-LOW  for I2C5
  Offset(695),    HSD5, 16, // Offset(695),   HSCN-HOLD for I2C5
  Offset(698),              // Offset(697) : Offset(697), Reserved bytes
  Offset(698),    M0C0, 16, // Offset(698),   M0D3 for I2C0
  Offset(700),    M1C0, 16, // Offset(700),   M1D3 for I2C0
  Offset(702),    M0C1, 16, // Offset(702),   M0D3 for I2C1
  Offset(704),    M1C1, 16, // Offset(704),   M1D3 for I2C1
  Offset(706),    M0C2, 16, // Offset(706),   M0D3 for I2C2
  Offset(708),    M1C2, 16, // Offset(708),   M1D3 for I2C2
  Offset(710),    M0C3, 16, // Offset(710),   M0D3 for I2C3
  Offset(712),    M1C3, 16, // Offset(712),   M1D3 for I2C3
  Offset(714),    M0C4, 16, // Offset(714),   M0D3 for I2C4
  Offset(716),    M1C4, 16, // Offset(716),   M1D3 for I2C4
  Offset(718),    M0C5, 16, // Offset(718),   M0D3 for I2C5
  Offset(720),    M1C5, 16, // Offset(720),   M1D3 for I2C5
  Offset(722),    M0C6, 16, // Offset(722),   M0D3 for SPI0
  Offset(724),    M1C6, 16, // Offset(724),   M1D3 for SPI0
  Offset(726),    M0C7, 16, // Offset(726),   M0D3 for SPI1
  Offset(728),    M1C7, 16, // Offset(728),   M1D3 for SPI1
  Offset(730),    M0C8, 16, // Offset(730),   M0D3 for SPI2
  Offset(732),    M1C8, 16, // Offset(732),   M1D3 for SPI2
  Offset(735),              // Offset(734) : Offset(734), Reserved bytes
  Offset(735),    M0C9, 16, // Offset(735),   M0D3 for UART0
  Offset(737),    M1C9, 16, // Offset(737),   M1D3 for UART0
  Offset(739),    M0CA, 16, // Offset(739),   M0D3 for UART1
  Offset(741),    M1CA, 16, // Offset(741),   M1D3 for UART1
  Offset(743),    M0CB, 16, // Offset(743),   M0D3 for UART2
  Offset(745),    M1CB, 16, // Offset(745),   M1D3 for UART2
  Offset(748),              // Offset(747) : Offset(747), Reserved bytes
  //
  // Driver Mode
  //
  Offset(748),    GIRQ, 32, // Offset(748),   GPIO IRQ
  Offset(752),    DMTP, 8,  // Offset(752),   PIRQS 34,50(GPIO)
  Offset(753),    DMTD, 8,  // Offset(753),   PIRQX 39,55(GPIO)
  Offset(754),    DMSH, 8,  // Offset(754),   PIRQM 28,14(GPIO)
  Offset(755),    SHSB, 8,  // Offset(755),   Sensor Standby mode
  Offset(756),    PLCS, 8,  // Offset(756),   set PL1 limit when entering CS
  Offset(757),    PLVL, 16, // Offset(757),   PL1 limit value
  Offset(759),    WWSD, 8,  // Offset(759),   EnableWwanTempSensorDevice
  Offset(760),    CVSD, 8,  // Offset(760),   EnableCpuVrTempSensorDevice
  Offset(761),    SSDD, 8,  // Offset(761),   EnableSsdTempSensorDevice
  Offset(762),    INLD, 8,  // Offset(762),   EnableInletFanTempSensorDevice
  Offset(763),    IFAT, 8,  // Offset(763),   ActiveThermalTripPointInletFan
  Offset(764),    IFPT, 8,  // Offset(764),   PassiveThermalTripPointInletFan
  Offset(765),    IFCT, 8,  // Offset(765),   CriticalThermalTripPointInletFan
  Offset(766),    IFHT, 8,  // Offset(766),   HotThermalTripPointInletFan
  Offset(767),    USBH, 8,  // Offset(767),   Sensor Hub Type - (0)None, (1)USB, (2)I2C Intel, (3)I2C STM
  Offset(768),    BCV4, 8,  // Offset(768),   Broadcom's Bluetooth adapter's revision
  Offset(769),    WTV0, 8,  // Offset(769),   I2C0/WITT devices version
  Offset(770),    WTV1, 8,  // Offset(770),   I2C1/WITT devices version
  Offset(771),    APFU, 8,  // Offset(771),   Atmel panel FW update Enable/Disable
  Offset(778),              // Offset(772) : Offset(777), Reserved bytes
  Offset(778),    PEPC, 64, // Offset(778),   PEP Constraints
  // Bit[1:0]   - Storage (0:None, 1:Storage Controller, 2:Raid)
  // Bit[2]     - En/Dis UART0
  // Bit[3]     - En/Dis UART1
  // Bit[4]     - En/Dis PCIe NVMe/AHCI
  // Bit[5]     - En/Dis I2C0
  // Bit[6]     - En/Dis I2C1
  // Bit[7]     - En/Dis XHCI
  // Bit[8]     - En/Dis HD Audio (includes ADSP)
  // Bit[9]     - En/Dis Gfx
  // Bit[10]    - En/Dis CPU
  // Bit[11]    - En/Dis EMMC
  // Bit[12]    - En/Dis SDXC
  // Bit[13]    - En/Dis I2C2
  // Bit[14]    - En/Dis I2C3
  // Bit[15]    - En/Dis I2C4
  // Bit[16]    - En/Dis I2C5
  // Bit[17]    - En/Dis UART2
  // Bit[18]    - En/Dis SPI0
  // Bit[19]    - En/Dis SPI1
  // Bit[20]    - En/Dis SPI2
  // Bit[21]    - En/Dis IPU0
  // Bit[22]    - En/Dis CSME
  // Bit[23]    - En/Dis LAN(GBE)
  // Bit[24]    - En/Dis PEG0 NVMe/AHCI
  // Bit[25]    - En/Dis THC0
  // Bit[26]    - En/Dis THC1
  // Bit[27]    - En/Dis IDA
  // Bit[28]    - En/Dis I2C6
  // Bit[29]    - En/Dis TCSS IPs
  // Bit[30]    - En/Dis GNA
  // Bit[31]    - En/Dis VMD
  // Bit[32]    - En/Dis DG1 PEG0
  // Bit[33]    - En/Dis PEP COnstraint Override
  // Bit[35:34] - PCIe RP03 (0: No Constraints or 1: D0/F1 or 3:D3)
  // Bit[37:36] - PCIe RP05 (0: No Constraints or 1: D0/F1 or 3:D3)
  // Bit[39:38] - PCIe RP09 (0: No Constraints or 1: D0/F1 or 3:D3)
  // Bit[41:40] - PEG0  (0: No Constraints or 1: D0/F1 or 3:D3)
  Offset(786),    VRSD, 16, // Offset(786),   VR Staggering delay
  Offset(788),    PB1E, 8,  // Offset(788),   10sec Power button support
  // Bit0: 10 sec P-button Enable/Disable
  // Bit1: Internal Flag
  // Bit2: Rotation Lock flag, 0:unlock, 1:lock
  // Bit3: Slate/Laptop Mode Flag, 0: Slate, 1: Laptop
  // Bit4: Undock / Dock Flag, 0: Undock, 1: Dock
  // Bit5: VBDL Flag. 0: VBDL is not called, 1: VBDL is called, Virtual Button Driver is loaded.
  // Bit7-6: Reserved for future use.
  //
  // Generation Id(Tock/Tick)
  //
  Offset(789),    GNID, 8,  // Offset(789),   Generation Id(0=Shark bay, 1=Crescent Bay)
  //
  // Intel(R) Dynamic Tuning Technology
  //
  Offset(807),              // Offset(790) : Offset(806), Reserved bytes
  Offset(807),    CHGE, 8,  // Offset(807),   EnableChargerParticipant
  Offset(808),    AMC3, 8,  // Offset(808),   CriticalThermalTripPointAmbientS3
  Offset(809),    SKC3, 8,  // Offset(809),   CriticalThermalTripPointSkinS3
  Offset(810),    EFC3, 8,  // Offset(810),   CriticalThermalTripPointExhaustFanS3
  Offset(811),    VRC3, 8,  // Offset(811),   CriticalThermalTripPointVRS3
  Offset(812),    IFC3, 8,  // Offset(812),   CriticalThermalTripPointInletFanS3
  Offset(813),    WGC3, 8,  // Offset(813),   CriticalThermalTripPointWGigS3
  Offset(814),    SPST, 8,  // Offset(814),   SATA port state, Bit0 - Port0, Bit1 - Port1, Bit2 - Port2, Bit3 - Port3
  //
  // Intel(R) Dynamic Tuning Technology
  //
  Offset(815),    BATR, 8,  // Offset(815),   EnableBatteryParticipant
  Offset(816),    IN34, 8,  // Offset(816),   EnableInt3400Device. new ACPI ID is INTC1040
  Offset(817),    ECLP, 8,  // Offset(817),   EC Low Power Mode: 1 - Enabled, 0 - Disabled
  Offset(818),    MEMS, 8,  // Offset(818),   ThermalSamplingPeriodTMEM @deprecated. Memory Participant is not POR for Intel(R) Dynamic Tuning Technology
  Offset(819),    S1DE, 8,  // Offset(819),   EnableSen1Participant
  Offset(820),    S2DE, 8,  // Offset(820),   EnableSen2Participant
  Offset(821),    S3DE, 8,  // Offset(821),   EnableSen3Participant
  Offset(822),    S4DE, 8,  // Offset(822),   EnableSen4Participant
  Offset(823),    S5DE, 8,  // Offset(823),   EnableSen5Participant
  Offset(824),    S1S3, 8,  // Offset(824),   CriticalThermalTripPointSen1S3
  Offset(825),    S2S3, 8,  // Offset(825),   CriticalThermalTripPointSen2S3
  Offset(826),    S3S3, 8,  // Offset(826),   CriticalThermalTripPointSen3S3
  Offset(827),    S4S3, 8,  // Offset(827),   CriticalThermalTripPointSen4S3
  Offset(828),    S5S3, 8,  // Offset(828),   CriticalThermalTripPointSen5S3
  Offset(829),    PSME, 8,  // Offset(829),   PowerSharingManagerEnable
  Offset(830),    PDT1, 8,  // Offset(830),   PsmSplcDomainType1
  Offset(831),    PLM1, 32, // Offset(831),   PsmSplcPowerLimit1
  Offset(835),    PTW1, 32, // Offset(835),   PsmSplcTimeWindow1
  Offset(839),    DDT1, 8,  // Offset(839),   PsmDplcDomainType1
  Offset(840),    DDP1, 8,  // Offset(840),   PsmDplcDomainPreference1
  Offset(841),    DLI1, 16, // Offset(841),   PsmDplcPowerLimitIndex1
  Offset(843),    DPL1, 16, // Offset(843),   PsmDplcDefaultPowerLimit1
  Offset(845),    DTW1, 32, // Offset(845),   PsmDplcDefaultTimeWindow1
  Offset(849),    DMI1, 16, // Offset(849),   PsmDplcMinimumPowerLimit1
  Offset(851),    DMA1, 16, // Offset(851),   PsmDplcMaximumPowerLimit1
  Offset(853),    DMT1, 16, // Offset(853),   PsmDplcMaximumTimeWindow1
  Offset(855),    WIFE, 8,  // Offset(855),   WifiEnable
  Offset(856),    DOM1, 8,  // Offset(856),   WifiDomainType1
  Offset(857),    LIM1, 16, // Offset(857),   WifiPowerLimit1
  Offset(859),    TIM1, 32, // Offset(859),   WifiTimeWindow1
  Offset(863),    TRD0, 8,  // Offset(863),   TRxDelay0
  Offset(864),    TRL0, 8,  // Offset(864),   TRxCableLength0
  Offset(865),    TRD1, 8,  // Offset(865),   TRxDelay1
  Offset(866),    TRL1, 8,  // Offset(866),   TRxCableLength1
  Offset(867),    WDM1, 8,  // Offset(867),   WrddDomainType1
  Offset(868),    CID1, 16, // Offset(868),   WrddCountryIndentifier1
  Offset(1018),             // Offset(870) : Offset(1017), Reserved bytes
  Offset(1018),   APPE, 8,  // Offset(1018),  Adaptive Performance Policy @deprecated. Intel(R) Dynamic Tuning can dynamically enable/disable policies
  //
  // Intel Serial(R) IO Sensor Device Selection
  //
  Offset(1019),   SDS0, 8,  // Offset(1019),  SerialIo Devices for controller0
  Offset(1020),   SDS1, 8,  // Offset(1020),  SerialIo Devices for controller1
  Offset(1021),   SDS2, 8,  // Offset(1021),  SerialIo Devices for controller2
  Offset(1022),   SDS3, 8,  // Offset(1022),  SerialIo Devices for controller3
  Offset(1023),   SDS4, 8,  // Offset(1023),  SerialIo Devices for controller4
  Offset(1024),   SDS5, 8,  // Offset(1024),  SerialIo Devices for controller5
  Offset(1025),   SDS6, 8,  // Offset(1025),  SerialIo Devices for controller6
  Offset(1026),   SDS7, 8,  // Offset(1026),  SerialIo Devices for controller7
  Offset(1027),   SDS8, 8,  // Offset(1027),  SerialIo Devices for controller8
  Offset(1028),   SDS9, 8,  // Offset(1028),  SerialIo Devices for controller9
  Offset(1029),   SDSA, 8,  // Offset(1029),  SerialIo Devices for controller10
  Offset(1030),   TPLT, 8,  // Offset(1030),  I2C SerialIo Devices Type of TouchPanel
  Offset(1031),   TPLM, 8,  // Offset(1031),  I2C SerialIo Devices Interrupt Mode for TouchPanel
  Offset(1032),   TPLB, 8,  // Offset(1032),  I2C Custom TouchPanel's BUS Address
  Offset(1033),   TPLH, 16, // Offset(1033),  I2C Custom TouchPanel's HID Address
  Offset(1035),   TPLS, 8,  // Offset(1035),  I2C Custom TouchPanel's BUS Speed
  Offset(1036),   TPDT, 8,  // Offset(1036),  I2C SerialIo Devices Type of TouchPad
  Offset(1037),   TPDM, 8,  // Offset(1037),  I2C SerialIo Devices Interrupt Mode for TouchPad
  Offset(1038),   TPDB, 8,  // Offset(1038),  I2C Custom TouchPad's BUS Address
  Offset(1039),   TPDH, 16, // Offset(1039),  I2C Custom TouchPad's HID Address
  Offset(1041),   TPDS, 8,  // Offset(1041),  I2C Custom TouchPad's BUS Speed
  Offset(1042),   FPTT, 8,  // Offset(1042),  SPI SerialIo Devices Type of FingerPrint
  Offset(1043),   FPTM, 8,  // Offset(1043),  SPI SerialIo Devices Interrupt Mode for FingerPrint
  Offset(1044),   WTVX, 8,  // Offset(1044),  WITT test devices' version
  Offset(1045),   WITX, 8,  // Offset(1045),  WITT test devices' connection point
  Offset(1046),   GPTD, 8,  // Offset(1046),  GPIO test devices
  Offset(1047),   GDBT, 16, // Offset(1047),  GPIO test devices' debounce value,
  Offset(1049),   UTKX, 8,  // Offset(1049),  UTK test devices' connection point
  Offset(1050),   SPTD, 8,  // Offset(1050),  SerialIo additional test devices
  Offset(1066),             // Offset(1051) : Offset(1065), Reserved bytes
  Offset(1066),   ATLB, 32, // Offset(1066),  Buffer for runtime ACPI Table loading
  Offset(1070),   SDM0, 8,  // Offset(1070),  interrupt mode for controller0 devices
  Offset(1071),   SDM1, 8,  // Offset(1071),  interrupt mode for controller1 devices
  Offset(1072),   SDM2, 8,  // Offset(1072),  interrupt mode for controller2 devices
  Offset(1073),   SDM3, 8,  // Offset(1073),  interrupt mode for controller3 devices
  Offset(1074),   SDM4, 8,  // Offset(1074),  interrupt mode for controller4 devices
  Offset(1075),   SDM5, 8,  // Offset(1075),  interrupt mode for controller5 devices
  Offset(1076),   SDM6, 8,  // Offset(1076),  interrupt mode for controller6 devices
  Offset(1077),   SDM7, 8,  // Offset(1077),  interrupt mode for controller7 devices
  Offset(1078),   SDM8, 8,  // Offset(1078),  interrupt mode for controller8 devices
  Offset(1079),   SDM9, 8,  // Offset(1079),  interrupt mode for controller9 devices
  Offset(1080),   SDMA, 8,  // Offset(1080),  interrupt mode for controller10 devices
  Offset(1081),   SDMB, 8,  // Offset(1081),  interrupt mode for controller11 devices
  Offset(1083),             // Offset(1082) : Offset(1082), Reserved bytes
  Offset(1083),   USTP, 8,  // Offset(1083),  use SerialIo timing parameters
  Offset(1125),             // Offset(1084) : Offset(1124), Reserved bytes
  Offset(1125),   GFPS, 32, // Offset(1125),  Gpio for fingerprint sleep
  Offset(1129),   GFPI, 32, // Offset(1129),  Gpio for fingerprint irq
  Offset(1133),   WBBR, 32, // Offset(1133),  Gpio for modem reset
  Offset(1137),   GBTK, 32, // Offset(1137),  Gpio for Bluetooth RfKill
  Offset(1141),   GBTI, 32, // Offset(1141),  Gpio for Bluetooth interrupt
  Offset(1145),   GPDI, 32, // Offset(1145),  Gpio for touchPaD Interrupt
  Offset(1149),   GPLI, 32, // Offset(1149),  Gpio for touchPaneL Interrupt
  //
  // MipiCam specific
  //
  Offset(1153),   CL00, 8,  // Offset(1153),
  Offset(1154),   CL01, 8,  // Offset(1154),
  Offset(1155),   CL02, 8,  // Offset(1155),
  Offset(1156),   CL03, 8,  // Offset(1156),
  Offset(1157),   CL04, 8,  // Offset(1157),
  Offset(1158),   CL05, 8,  // Offset(1158),
  Offset(1159),   L0EN, 8,  // Offset(1159),
  Offset(1160),   L1EN, 8,  // Offset(1160),
  Offset(1161),   L2EN, 8,  // Offset(1161),
  Offset(1162),   L3EN, 8,  // Offset(1162),
  Offset(1163),   L4EN, 8,  // Offset(1163),
  Offset(1164),   L5EN, 8,  // Offset(1164),
  Offset(1165),   CDIV, 8,  // Offset(1165),
  // Control Logic 0 options
  Offset(1166),   C0VE, 8,  // Offset(1166),  Version of CLDB structure
  Offset(1167),   C0TP, 8,  // Offset(1167),  Type
  Offset(1168),   C0CV, 8,  // Offset(1168),  Version of CRD
  Offset(1169),   C0IC, 32, // Offset(1169),  Input Clock
  Offset(1173),   C0GP, 8,  // Offset(1173),  Number of GPIO Pins enabled
  Offset(1174),   C0IB, 8,  // Offset(1174),  I2C Serial Bus Number
  Offset(1175),   C0IA, 16, // Offset(1175),  I2C Address
  Offset(1177),   C0P0, 8,  // Offset(1177),  GPIO Group Pad Number
  Offset(1178),   C0P1, 8,  // Offset(1178),
  Offset(1179),   C0P2, 8,  // Offset(1179),
  Offset(1180),   C0P3, 8,  // Offset(1180),
  Offset(1181),   C0G0, 8,  // Offset(1181),  GPIO Group Number
  Offset(1182),   C0G1, 8,  // Offset(1182),
  Offset(1183),   C0G2, 8,  // Offset(1183),
  Offset(1184),   C0G3, 8,  // Offset(1184),
  Offset(1185),   C0F0, 8,  // Offset(1185),  GPIO Function
  Offset(1186),   C0F1, 8,  // Offset(1186),
  Offset(1187),   C0F2, 8,  // Offset(1187),
  Offset(1188),   C0F3, 8,  // Offset(1188),
  Offset(1189),   C0A0, 8,  // Offset(1189),  GPIO Active Value
  Offset(1190),   C0A1, 8,  // Offset(1190),
  Offset(1191),   C0A2, 8,  // Offset(1191),
  Offset(1192),   C0A3, 8,  // Offset(1192),
  Offset(1193),   C0I0, 8,  // Offset(1193),  GPIO Initial Value
  Offset(1194),   C0I1, 8,  // Offset(1194),
  Offset(1195),   C0I2, 8,  // Offset(1195),
  Offset(1196),   C0I3, 8,  // Offset(1196),
  Offset(1197),   C0PL, 8,  // Offset(1197),  Camera Position
  Offset(1198),   C0W0, 8,  // Offset(1198),  WLED1 Flash Max Current
  Offset(1199),   C0W1, 8,  // Offset(1199),  WLED1 Torch Max Current
  Offset(1200),   C0W2, 8,  // Offset(1200),  WLED2 Flash Max Current
  Offset(1201),   C0W3, 8,  // Offset(1201),  WLED2 Torch Max Current
  Offset(1202),   C0SP, 8,  // Offset(1202),  Sub Platform Id
  Offset(1203),   C0W4, 8,  // Offset(1203),  WLED1 Type
  Offset(1204),   C0W5, 8,  // Offset(1204),  WLED2 Type
  Offset(1205),   C0CS, 8,  // Offset(1205),  PCH Clock source
  // Control Logic 1 options
  Offset(1206),   C1VE, 8,  // Offset(1206),  Version of CLDB structure
  Offset(1207),   C1TP, 8,  // Offset(1207),  Type
  Offset(1208),   C1CV, 8,  // Offset(1208),  Version of CRD
  Offset(1209),   C1IC, 32, // Offset(1209),  Input Clock
  Offset(1213),   C1GP, 8,  // Offset(1213),  Number of GPIO Pins enabled
  Offset(1214),   C1IB, 8,  // Offset(1214),  I2C Serial Bus Number
  Offset(1215),   C1IA, 16, // Offset(1215),  I2C Address
  Offset(1217),   C1P0, 8,  // Offset(1217),  GPIO Group Pad Number
  Offset(1218),   C1P1, 8,  // Offset(1218),
  Offset(1219),   C1P2, 8,  // Offset(1219),
  Offset(1220),   C1P3, 8,  // Offset(1220),
  Offset(1221),   C1G0, 8,  // Offset(1221),  GPIO Group Number
  Offset(1222),   C1G1, 8,  // Offset(1222),
  Offset(1223),   C1G2, 8,  // Offset(1223),
  Offset(1224),   C1G3, 8,  // Offset(1224),
  Offset(1225),   C1F0, 8,  // Offset(1225),  GPIO Function
  Offset(1226),   C1F1, 8,  // Offset(1226),
  Offset(1227),   C1F2, 8,  // Offset(1227),
  Offset(1228),   C1F3, 8,  // Offset(1228),
  Offset(1229),   C1A0, 8,  // Offset(1229),  GPIO Active Value
  Offset(1230),   C1A1, 8,  // Offset(1230),
  Offset(1231),   C1A2, 8,  // Offset(1231),
  Offset(1232),   C1A3, 8,  // Offset(1232),
  Offset(1233),   C1I0, 8,  // Offset(1233),  GPIO Initial Value
  Offset(1234),   C1I1, 8,  // Offset(1234),
  Offset(1235),   C1I2, 8,  // Offset(1235),
  Offset(1236),   C1I3, 8,  // Offset(1236),
  Offset(1237),   C1PL, 8,  // Offset(1237),  Camera Position
  Offset(1238),   C1W0, 8,  // Offset(1238),  WLED1 Flash Max Current
  Offset(1239),   C1W1, 8,  // Offset(1239),  WLED1 Torch Max Current
  Offset(1240),   C1W2, 8,  // Offset(1240),  WLED2 Flash Max Current
  Offset(1241),   C1W3, 8,  // Offset(1241),  WLED2 Torch Max Current
  Offset(1242),   C1SP, 8,  // Offset(1242),  Sub Platform Id
  Offset(1243),   C1W4, 8,  // Offset(1243),  WLED1 Type
  Offset(1244),   C1W5, 8,  // Offset(1244),  WLED2 Type
  Offset(1245),   C1CS, 8,  // Offset(1245),  PCH Clock source
  // Control Logic 2 options
  Offset(1246),   C2VE, 8,  // Offset(1246),  Version of CLDB structure
  Offset(1247),   C2TP, 8,  // Offset(1247),  Type
  Offset(1248),   C2CV, 8,  // Offset(1248),  Version of CRD
  Offset(1249),   C2IC, 32, // Offset(1249),  Input Clock
  Offset(1253),   C2GP, 8,  // Offset(1253),  Number of GPIO Pins enabled
  Offset(1254),   C2IB, 8,  // Offset(1254),  I2C Serial Bus Number
  Offset(1255),   C2IA, 16, // Offset(1255),  I2C Address
  Offset(1257),   C2P0, 8,  // Offset(1257),  GPIO Group Pad Number
  Offset(1258),   C2P1, 8,  // Offset(1258),
  Offset(1259),   C2P2, 8,  // Offset(1259),
  Offset(1260),   C2P3, 8,  // Offset(1260),
  Offset(1261),   C2G0, 8,  // Offset(1261),  GPIO Group Number
  Offset(1262),   C2G1, 8,  // Offset(1262),
  Offset(1263),   C2G2, 8,  // Offset(1263),
  Offset(1264),   C2G3, 8,  // Offset(1264),
  Offset(1265),   C2F0, 8,  // Offset(1265),  GPIO Function
  Offset(1266),   C2F1, 8,  // Offset(1266),
  Offset(1267),   C2F2, 8,  // Offset(1267),
  Offset(1268),   C2F3, 8,  // Offset(1268),
  Offset(1269),   C2A0, 8,  // Offset(1269),  GPIO Active Value
  Offset(1270),   C2A1, 8,  // Offset(1270),
  Offset(1271),   C2A2, 8,  // Offset(1271),
  Offset(1272),   C2A3, 8,  // Offset(1272),
  Offset(1273),   C2I0, 8,  // Offset(1273),  GPIO Initial Value
  Offset(1274),   C2I1, 8,  // Offset(1274),
  Offset(1275),   C2I2, 8,  // Offset(1275),
  Offset(1276),   C2I3, 8,  // Offset(1276),
  Offset(1277),   C2PL, 8,  // Offset(1277),  Camera Position
  Offset(1278),   C2W0, 8,  // Offset(1278),  WLED1 Flash Max Current
  Offset(1279),   C2W1, 8,  // Offset(1279),  WLED1 Torch Max Current
  Offset(1280),   C2W2, 8,  // Offset(1280),  WLED2 Flash Max Current
  Offset(1281),   C2W3, 8,  // Offset(1281),  WLED2 Torch Max Current
  Offset(1282),   C2SP, 8,  // Offset(1282),  Sub Platform Id
  Offset(1283),   C2W4, 8,  // Offset(1283),  WLED1 Type
  Offset(1284),   C2W5, 8,  // Offset(1284),  WLED2 Type
  Offset(1285),   C2CS, 8,  // Offset(1285),  PCH Clock source
  // Control Logic 3 options
  Offset(1286),   C3VE, 8,  // Offset(1286),  Version of CLDB structure
  Offset(1287),   C3TP, 8,  // Offset(1287),  Type
  Offset(1288),   C3CV, 8,  // Offset(1288),  Version of CRD
  Offset(1289),   C3IC, 32, // Offset(1289),  Input Clock
  Offset(1293),   C3GP, 8,  // Offset(1293),  Number of GPIO Pins enabled
  Offset(1294),   C3IB, 8,  // Offset(1294),  I2C Serial Bus Number
  Offset(1295),   C3IA, 16, // Offset(1295),  I2C Address
  Offset(1297),   C3P0, 8,  // Offset(1297),  GPIO Group Pad Number
  Offset(1298),   C3P1, 8,  // Offset(1298),
  Offset(1299),   C3P2, 8,  // Offset(1299),
  Offset(1300),   C3P3, 8,  // Offset(1300),
  Offset(1301),   C3G0, 8,  // Offset(1301),  GPIO Group Number
  Offset(1302),   C3G1, 8,  // Offset(1302),
  Offset(1303),   C3G2, 8,  // Offset(1303),
  Offset(1304),   C3G3, 8,  // Offset(1304),
  Offset(1305),   C3F0, 8,  // Offset(1305),  GPIO Function
  Offset(1306),   C3F1, 8,  // Offset(1306),
  Offset(1307),   C3F2, 8,  // Offset(1307),
  Offset(1308),   C3F3, 8,  // Offset(1308),
  Offset(1309),   C3A0, 8,  // Offset(1309),  GPIO Active Value
  Offset(1310),   C3A1, 8,  // Offset(1310),
  Offset(1311),   C3A2, 8,  // Offset(1311),
  Offset(1312),   C3A3, 8,  // Offset(1312),
  Offset(1313),   C3I0, 8,  // Offset(1313),  GPIO Initial Value
  Offset(1314),   C3I1, 8,  // Offset(1314),
  Offset(1315),   C3I2, 8,  // Offset(1315),
  Offset(1316),   C3I3, 8,  // Offset(1316),
  Offset(1317),   C3PL, 8,  // Offset(1317),  Camera Position
  Offset(1318),   C3W0, 8,  // Offset(1318),  WLED1 Flash Max Current
  Offset(1319),   C3W1, 8,  // Offset(1319),  WLED1 Torch Max Current
  Offset(1320),   C3W2, 8,  // Offset(1320),  WLED2 Flash Max Current
  Offset(1321),   C3W3, 8,  // Offset(1321),  WLED2 Torch Max Current
  Offset(1322),   C3SP, 8,  // Offset(1322),  Sub Platform Id
  Offset(1323),   C3W4, 8,  // Offset(1323),  WLED1 Type
  Offset(1324),   C3W5, 8,  // Offset(1324),  WLED2 Type
  Offset(1325),   C3CS, 8,  // Offset(1325),  PCH Clock source
  // Control Logic 4 options
  Offset(1326),   C4VE, 8,  // Offset(1326),  Version of CLDB structure
  Offset(1327),   C4TP, 8,  // Offset(1327),  Type
  Offset(1328),   C4CV, 8,  // Offset(1328),  Version of CRD
  Offset(1329),   C4IC, 32, // Offset(1329),  Input Clock
  Offset(1333),   C4GP, 8,  // Offset(1333),  Number of GPIO Pins enabled
  Offset(1334),   C4IB, 8,  // Offset(1334),  I2C Serial Bus Number
  Offset(1335),   C4IA, 16, // Offset(1335),  I2C Address
  Offset(1337),   C4P0, 8,  // Offset(1337),  GPIO Group Pad Number
  Offset(1338),   C4P1, 8,  // Offset(1338),
  Offset(1339),   C4P2, 8,  // Offset(1339),
  Offset(1340),   C4P3, 8,  // Offset(1340),
  Offset(1341),   C4G0, 8,  // Offset(1341),  GPIO Group Number
  Offset(1342),   C4G1, 8,  // Offset(1342),
  Offset(1343),   C4G2, 8,  // Offset(1343),
  Offset(1344),   C4G3, 8,  // Offset(1344),
  Offset(1345),   C4F0, 8,  // Offset(1345),  GPIO Function
  Offset(1346),   C4F1, 8,  // Offset(1346),
  Offset(1347),   C4F2, 8,  // Offset(1347),
  Offset(1348),   C4F3, 8,  // Offset(1348),
  Offset(1349),   C4A0, 8,  // Offset(1349),  GPIO Active Value
  Offset(1350),   C4A1, 8,  // Offset(1350),
  Offset(1351),   C4A2, 8,  // Offset(1351),
  Offset(1352),   C4A3, 8,  // Offset(1352),
  Offset(1353),   C4I0, 8,  // Offset(1353),  GPIO Initial Value
  Offset(1354),   C4I1, 8,  // Offset(1354),
  Offset(1355),   C4I2, 8,  // Offset(1355),
  Offset(1356),   C4I3, 8,  // Offset(1356),
  Offset(1357),   C4PL, 8,  // Offset(1357),  Camera Position
  Offset(1358),   C4W0, 8,  // Offset(1358),  WLED1 Flash Max Current
  Offset(1359),   C4W1, 8,  // Offset(1359),  WLED1 Torch Max Current
  Offset(1360),   C4W2, 8,  // Offset(1360),  WLED2 Flash Max Current
  Offset(1361),   C4W3, 8,  // Offset(1361),  WLED2 Torch Max Current
  Offset(1362),   C4SP, 8,  // Offset(1362),  Sub Platform Id
  Offset(1363),   C4W4, 8,  // Offset(1363),  WLED1 Type
  Offset(1364),   C4W5, 8,  // Offset(1364),  WLED2 Type
  Offset(1365),   C4CS, 8,  // Offset(1365),  PCH Clock source
  // Control Logic 5 options
  Offset(1366),   C5VE, 8,  // Offset(1366),  Version of CLDB structure
  Offset(1367),   C5TP, 8,  // Offset(1367),  Type
  Offset(1368),   C5CV, 8,  // Offset(1368),  Version of CRD
  Offset(1369),   C5IC, 32, // Offset(1369),  Input Clock
  Offset(1373),   C5GP, 8,  // Offset(1373),  Number of GPIO Pins enabled
  Offset(1374),   C5IB, 8,  // Offset(1374),  I2C Serial Bus Number
  Offset(1375),   C5IA, 16, // Offset(1375),  I2C Address
  Offset(1377),   C5P0, 8,  // Offset(1377),  GPIO Group Pad Number
  Offset(1378),   C5P1, 8,  // Offset(1378),
  Offset(1379),   C5P2, 8,  // Offset(1379),
  Offset(1380),   C5P3, 8,  // Offset(1380),
  Offset(1381),   C5G0, 8,  // Offset(1381),  GPIO Group Number
  Offset(1382),   C5G1, 8,  // Offset(1382),
  Offset(1383),   C5G2, 8,  // Offset(1383),
  Offset(1384),   C5G3, 8,  // Offset(1384),
  Offset(1385),   C5F0, 8,  // Offset(1385),  GPIO Function
  Offset(1386),   C5F1, 8,  // Offset(1386),
  Offset(1387),   C5F2, 8,  // Offset(1387),
  Offset(1388),   C5F3, 8,  // Offset(1388),
  Offset(1389),   C5A0, 8,  // Offset(1389),  GPIO Active Value
  Offset(1390),   C5A1, 8,  // Offset(1390),
  Offset(1391),   C5A2, 8,  // Offset(1391),
  Offset(1392),   C5A3, 8,  // Offset(1392),
  Offset(1393),   C5I0, 8,  // Offset(1393),  GPIO Initial Value
  Offset(1394),   C5I1, 8,  // Offset(1394),
  Offset(1395),   C5I2, 8,  // Offset(1395),
  Offset(1396),   C5I3, 8,  // Offset(1396),
  Offset(1397),   C5PL, 8,  // Offset(1397),  Camera Position
  Offset(1398),   C5W0, 8,  // Offset(1398),  WLED1 Flash Max Current
  Offset(1399),   C5W1, 8,  // Offset(1399),  WLED1 Torch Max Current
  Offset(1400),   C5W2, 8,  // Offset(1400),  WLED2 Flash Max Current
  Offset(1401),   C5W3, 8,  // Offset(1401),  WLED2 Torch Max Current
  Offset(1402),   C5SP, 8,  // Offset(1402),  Sub Platform Id
  Offset(1403),   C5W4, 8,  // Offset(1403),  WLED1 Type
  Offset(1404),   C5W5, 8,  // Offset(1404),  WLED2 Type
  Offset(1405),   C5CS, 8,  // Offset(1405),  PCH Clock source
  // Mipi Cam Link0 options
  Offset(1406),   L0SM, 8,  // Offset(1406),  Sensor Model
  Offset(1407),   L0H0, 8,  // Offset(1407),  User defined HID ASCII character 0
  Offset(1408),   L0H1, 8,  // Offset(1408),
  Offset(1409),   L0H2, 8,  // Offset(1409),
  Offset(1410),   L0H3, 8,  // Offset(1410),
  Offset(1411),   L0H4, 8,  // Offset(1411),
  Offset(1412),   L0H5, 8,  // Offset(1412),
  Offset(1413),   L0H6, 8,  // Offset(1413),
  Offset(1414),   L0H7, 8,  // Offset(1414),
  Offset(1415),   L0H8, 8,  // Offset(1415),  User defined HID ASCII character 8
  Offset(1416),   L0PL, 8,  // Offset(1416),  Camera Position
  Offset(1417),   L0M0, 8,  // Offset(1417),  Camera Module Name ASCII character 0
  Offset(1418),   L0M1, 8,  // Offset(1418),
  Offset(1419),   L0M2, 8,  // Offset(1419),
  Offset(1420),   L0M3, 8,  // Offset(1420),
  Offset(1421),   L0M4, 8,  // Offset(1421),
  Offset(1422),   L0M5, 8,  // Offset(1422),
  Offset(1423),   L0M6, 8,  // Offset(1423),
  Offset(1424),   L0M7, 8,  // Offset(1424),
  Offset(1425),   L0M8, 8,  // Offset(1425),
  Offset(1426),   L0M9, 8,  // Offset(1426),
  Offset(1427),   L0MA, 8,  // Offset(1427),
  Offset(1428),   L0MB, 8,  // Offset(1428),
  Offset(1429),   L0MC, 8,  // Offset(1429),
  Offset(1430),   L0MD, 8,  // Offset(1430),
  Offset(1431),   L0ME, 8,  // Offset(1431),
  Offset(1432),   L0MF, 8,  // Offset(1432),  Camera Module Name ASCII character 15
  Offset(1433),   L0DI, 8,  // Offset(1433),  Number of I2C devices
  Offset(1434),   L0BS, 8,  // Offset(1434),  I2C Serial Bus number
  Offset(1435),   L0A0, 16, // Offset(1435),  Address of I2C Device0 on Link0
  Offset(1437),   L0A1, 16, // Offset(1437),  Address of I2C Device1 on Link0
  Offset(1439),   L0A2, 16, // Offset(1439),  Address of I2C Device2 on Link0
  Offset(1441),   L0A3, 16, // Offset(1441),  Address of I2C Device3 on Link0
  Offset(1443),   L0A4, 16, // Offset(1443),  Address of I2C Device4 on Link0
  Offset(1445),   L0A5, 16, // Offset(1445),  Address of I2C Device5 on Link0
  Offset(1447),   L0A6, 16, // Offset(1447),  Address of I2C Device6 on Link0
  Offset(1449),   L0A7, 16, // Offset(1449),  Address of I2C Device7 on Link0
  Offset(1451),   L0A8, 16, // Offset(1451),  Address of I2C Device8 on Link0
  Offset(1453),   L0A9, 16, // Offset(1453),  Address of I2C Device9 on Link0
  Offset(1455),   L0AA, 16, // Offset(1455),  Address of I2C Device10 on Link0
  Offset(1457),   L0AB, 16, // Offset(1457),  Address of I2C Device11 on Link0
  Offset(1459),   L0D0, 8,  // Offset(1459),  Type of I2C Device0 on Link0
  Offset(1460),   L0D1, 8,  // Offset(1460),  Type of I2C Device1 on Link0
  Offset(1461),   L0D2, 8,  // Offset(1461),  Type of I2C Device2 on Link0
  Offset(1462),   L0D3, 8,  // Offset(1462),  Type of I2C Device3 on Link0
  Offset(1463),   L0D4, 8,  // Offset(1463),  Type of I2C Device4 on Link0
  Offset(1464),   L0D5, 8,  // Offset(1464),  Type of I2C Device5 on Link0
  Offset(1465),   L0D6, 8,  // Offset(1465),  Type of I2C Device6 on Link0
  Offset(1466),   L0D7, 8,  // Offset(1466),  Type of I2C Device7 on Link0
  Offset(1467),   L0D8, 8,  // Offset(1467),  Type of I2C Device8 on Link0
  Offset(1468),   L0D9, 8,  // Offset(1468),  Type of I2C Device9 on Link0
  Offset(1469),   L0DA, 8,  // Offset(1469),  Type of I2C Device10 on Link0
  Offset(1470),   L0DB, 8,  // Offset(1470),  Type of I2C Device11 on Link0
  Offset(1471),   L0DV, 8,  // Offset(1471),  Version of SSDB structure
  Offset(1472),   L0CV, 8,  // Offset(1472),  Version of CRD
  Offset(1473),   L0LU, 8,  // Offset(1473),  CSI2 Link used
  Offset(1474),   L0NL, 8,  // Offset(1474),  MIPI-CSI2 Data Lane
  Offset(1475),   L0EE, 8,  // Offset(1475),  EEPROM Type
  Offset(1476),   L0VC, 8,  // Offset(1476),  VCM Type
  Offset(1477),   L0FS, 8,  // Offset(1477),  Flash Support
  Offset(1478),   L0LE, 8,  // Offset(1478),  Privacy LED
  Offset(1479),   L0DG, 8,  // Offset(1479),  Degree
  Offset(1480),   L0CK, 32, // Offset(1480),  MCLK
  Offset(1484),   L0CL, 8,  // Offset(1484),  Control Logic
  Offset(1485),   L0PP, 8,  // Offset(1485),  PMIC Position
  Offset(1486),   L0VR, 8,  // Offset(1486),  Voltage Rail
  Offset(1487),   L0PV, 8,  // Offset(1487),  PPR Value
  Offset(1488),   L0PU, 8,  // Offset(1488),  PPR Unit
  Offset(1489),   L0FD, 8,  // Offset(1489),  Flash Driver Selection
  // Mipi Cam Link1 options
  Offset(1490),   L1SM, 8,  // Offset(1490),  Sensor Model
  Offset(1491),   L1H0, 8,  // Offset(1491),  User defined HID ASCII character 0
  Offset(1492),   L1H1, 8,  // Offset(1492),
  Offset(1493),   L1H2, 8,  // Offset(1493),
  Offset(1494),   L1H3, 8,  // Offset(1494),
  Offset(1495),   L1H4, 8,  // Offset(1495),
  Offset(1496),   L1H5, 8,  // Offset(1496),
  Offset(1497),   L1H6, 8,  // Offset(1497),
  Offset(1498),   L1H7, 8,  // Offset(1498),
  Offset(1499),   L1H8, 8,  // Offset(1499),  User defined HID ASCII character 8
  Offset(1500),   L1PL, 8,  // Offset(1500),  Camera Position
  Offset(1501),   L1M0, 8,  // Offset(1501),  Camera Module Name ASCII character 0
  Offset(1502),   L1M1, 8,  // Offset(1502),
  Offset(1503),   L1M2, 8,  // Offset(1503),
  Offset(1504),   L1M3, 8,  // Offset(1504),
  Offset(1505),   L1M4, 8,  // Offset(1505),
  Offset(1506),   L1M5, 8,  // Offset(1506),
  Offset(1507),   L1M6, 8,  // Offset(1507),
  Offset(1508),   L1M7, 8,  // Offset(1508),
  Offset(1509),   L1M8, 8,  // Offset(1509),
  Offset(1510),   L1M9, 8,  // Offset(1510),
  Offset(1511),   L1MA, 8,  // Offset(1511),
  Offset(1512),   L1MB, 8,  // Offset(1512),
  Offset(1513),   L1MC, 8,  // Offset(1513),
  Offset(1514),   L1MD, 8,  // Offset(1514),
  Offset(1515),   L1ME, 8,  // Offset(1515),
  Offset(1516),   L1MF, 8,  // Offset(1516),  Camera Module Name ASCII character 15
  Offset(1517),   L1DI, 8,  // Offset(1517),  Number of I2C devices
  Offset(1518),   L1BS, 8,  // Offset(1518),  I2C Serial Bus number
  Offset(1519),   L1A0, 16, // Offset(1519),  Address of I2C Device0 on Link1
  Offset(1521),   L1A1, 16, // Offset(1521),  Address of I2C Device1 on Link1
  Offset(1523),   L1A2, 16, // Offset(1523),  Address of I2C Device2 on Link1
  Offset(1525),   L1A3, 16, // Offset(1525),  Address of I2C Device3 on Link1
  Offset(1527),   L1A4, 16, // Offset(1527),  Address of I2C Device4 on Link1
  Offset(1529),   L1A5, 16, // Offset(1529),  Address of I2C Device5 on Link1
  Offset(1531),   L1A6, 16, // Offset(1531),  Address of I2C Device6 on Link1
  Offset(1533),   L1A7, 16, // Offset(1533),  Address of I2C Device7 on Link1
  Offset(1535),   L1A8, 16, // Offset(1535),  Address of I2C Device8 on Link1
  Offset(1537),   L1A9, 16, // Offset(1537),  Address of I2C Device9 on Link1
  Offset(1539),   L1AA, 16, // Offset(1539),  Address of I2C Device10 on Link1
  Offset(1541),   L1AB, 16, // Offset(1541),  Address of I2C Device11 on Link1
  Offset(1543),   L1D0, 8,  // Offset(1543),  Type of I2C Device0 on Link1
  Offset(1544),   L1D1, 8,  // Offset(1544),  Type of I2C Device1 on Link1
  Offset(1545),   L1D2, 8,  // Offset(1545),  Type of I2C Device2 on Link1
  Offset(1546),   L1D3, 8,  // Offset(1546),  Type of I2C Device3 on Link1
  Offset(1547),   L1D4, 8,  // Offset(1547),  Type of I2C Device4 on Link1
  Offset(1548),   L1D5, 8,  // Offset(1548),  Type of I2C Device5 on Link1
  Offset(1549),   L1D6, 8,  // Offset(1549),  Type of I2C Device6 on Link1
  Offset(1550),   L1D7, 8,  // Offset(1550),  Type of I2C Device7 on Link1
  Offset(1551),   L1D8, 8,  // Offset(1551),  Type of I2C Device8 on Link1
  Offset(1552),   L1D9, 8,  // Offset(1552),  Type of I2C Device9 on Link1
  Offset(1553),   L1DA, 8,  // Offset(1553),  Type of I2C Device10 on Link1
  Offset(1554),   L1DB, 8,  // Offset(1554),  Type of I2C Device11 on Link1
  Offset(1555),   L1DV, 8,  // Offset(1555),  Version of SSDB structure
  Offset(1556),   L1CV, 8,  // Offset(1556),  Version of CRD
  Offset(1557),   L1LU, 8,  // Offset(1557),  CSI2 Link used
  Offset(1558),   L1NL, 8,  // Offset(1558),  MIPI-CSI2 Data Lane
  Offset(1559),   L1EE, 8,  // Offset(1559),  EEPROM Type
  Offset(1560),   L1VC, 8,  // Offset(1560),  VCM Type
  Offset(1561),   L1FS, 8,  // Offset(1561),  Flash Support
  Offset(1562),   L1LE, 8,  // Offset(1562),  Privacy LED
  Offset(1563),   L1DG, 8,  // Offset(1563),  Degree
  Offset(1564),   L1CK, 32, // Offset(1564),  MCLK
  Offset(1568),   L1CL, 8,  // Offset(1568),  Control Logic
  Offset(1569),   L1PP, 8,  // Offset(1569),  PMIC Position
  Offset(1570),   L1VR, 8,  // Offset(1570),  Voltage Rail
  Offset(1571),   L1PV, 8,  // Offset(1571),  PPR Value
  Offset(1572),   L1PU, 8,  // Offset(1572),  PPR Unit
  Offset(1573),   L1FD, 8,  // Offset(1573),  Flash Driver Selection
  // Mipi Cam Link2 options
  Offset(1574),   L2SM, 8,  // Offset(1574),  Sensor Model
  Offset(1575),   L2H0, 8,  // Offset(1575),  User defined HID ASCII character 0
  Offset(1576),   L2H1, 8,  // Offset(1576),
  Offset(1577),   L2H2, 8,  // Offset(1577),
  Offset(1578),   L2H3, 8,  // Offset(1578),
  Offset(1579),   L2H4, 8,  // Offset(1579),
  Offset(1580),   L2H5, 8,  // Offset(1580),
  Offset(1581),   L2H6, 8,  // Offset(1581),
  Offset(1582),   L2H7, 8,  // Offset(1582),
  Offset(1583),   L2H8, 8,  // Offset(1583),  User defined HID ASCII character 8
  Offset(1584),   L2PL, 8,  // Offset(1584),  Camera Position
  Offset(1585),   L2M0, 8,  // Offset(1585),  Camera Module Name ASCII character 0
  Offset(1586),   L2M1, 8,  // Offset(1586),
  Offset(1587),   L2M2, 8,  // Offset(1587),
  Offset(1588),   L2M3, 8,  // Offset(1588),
  Offset(1589),   L2M4, 8,  // Offset(1589),
  Offset(1590),   L2M5, 8,  // Offset(1590),
  Offset(1591),   L2M6, 8,  // Offset(1591),
  Offset(1592),   L2M7, 8,  // Offset(1592),
  Offset(1593),   L2M8, 8,  // Offset(1593),
  Offset(1594),   L2M9, 8,  // Offset(1594),
  Offset(1595),   L2MA, 8,  // Offset(1595),
  Offset(1596),   L2MB, 8,  // Offset(1596),
  Offset(1597),   L2MC, 8,  // Offset(1597),
  Offset(1598),   L2MD, 8,  // Offset(1598),
  Offset(1599),   L2ME, 8,  // Offset(1599),
  Offset(1600),   L2MF, 8,  // Offset(1600),  Camera Module Name ASCII character 15
  Offset(1601),   L2DI, 8,  // Offset(1601),  Number of I2C devices
  Offset(1602),   L2BS, 8,  // Offset(1602),  I2C Serial Bus number
  Offset(1603),   L2A0, 16, // Offset(1603),  Address of I2C Device0 on Link2
  Offset(1605),   L2A1, 16, // Offset(1605),  Address of I2C Device1 on Link2
  Offset(1607),   L2A2, 16, // Offset(1607),  Address of I2C Device2 on Link2
  Offset(1609),   L2A3, 16, // Offset(1609),  Address of I2C Device3 on Link2
  Offset(1611),   L2A4, 16, // Offset(1611),  Address of I2C Device4 on Link2
  Offset(1613),   L2A5, 16, // Offset(1613),  Address of I2C Device5 on Link2
  Offset(1615),   L2A6, 16, // Offset(1615),  Address of I2C Device6 on Link2
  Offset(1617),   L2A7, 16, // Offset(1617),  Address of I2C Device7 on Link2
  Offset(1619),   L2A8, 16, // Offset(1619),  Address of I2C Device8 on Link2
  Offset(1621),   L2A9, 16, // Offset(1621),  Address of I2C Device9 on Link2
  Offset(1623),   L2AA, 16, // Offset(1623),  Address of I2C Device10 on Link2
  Offset(1625),   L2AB, 16, // Offset(1625),  Address of I2C Device11 on Link2
  Offset(1627),   L2D0, 8,  // Offset(1627),  Type of I2C Device0 on Link2
  Offset(1628),   L2D1, 8,  // Offset(1628),  Type of I2C Device1 on Link2
  Offset(1629),   L2D2, 8,  // Offset(1629),  Type of I2C Device2 on Link2
  Offset(1630),   L2D3, 8,  // Offset(1630),  Type of I2C Device3 on Link2
  Offset(1631),   L2D4, 8,  // Offset(1631),  Type of I2C Device4 on Link2
  Offset(1632),   L2D5, 8,  // Offset(1632),  Type of I2C Device5 on Link2
  Offset(1633),   L2D6, 8,  // Offset(1633),  Type of I2C Device6 on Link2
  Offset(1634),   L2D7, 8,  // Offset(1634),  Type of I2C Device7 on Link2
  Offset(1635),   L2D8, 8,  // Offset(1635),  Type of I2C Device8 on Link2
  Offset(1636),   L2D9, 8,  // Offset(1636),  Type of I2C Device9 on Link2
  Offset(1637),   L2DA, 8,  // Offset(1637),  Type of I2C Device10 on Link2
  Offset(1638),   L2DB, 8,  // Offset(1638),  Type of I2C Device11 on Link2
  Offset(1639),   L2DV, 8,  // Offset(1639),  Version of SSDB structure
  Offset(1640),   L2CV, 8,  // Offset(1640),  Version of CRD
  Offset(1641),   L2LU, 8,  // Offset(1641),  CSI2 Link used
  Offset(1642),   L2NL, 8,  // Offset(1642),  MIPI-CSI2 Data Lane
  Offset(1643),   L2EE, 8,  // Offset(1643),  EEPROM Type
  Offset(1644),   L2VC, 8,  // Offset(1644),  VCM Type
  Offset(1645),   L2FS, 8,  // Offset(1645),  Flash Support
  Offset(1646),   L2LE, 8,  // Offset(1646),  Privacy LED
  Offset(1647),   L2DG, 8,  // Offset(1647),  Degree
  Offset(1648),   L2CK, 32, // Offset(1648),  MCLK
  Offset(1652),   L2CL, 8,  // Offset(1652),  Control Logic
  Offset(1653),   L2PP, 8,  // Offset(1653),  PMIC Position
  Offset(1654),   L2VR, 8,  // Offset(1654),  Voltage Rail
  Offset(1655),   L2PV, 8,  // Offset(1655),  PPR Value
  Offset(1656),   L2PU, 8,  // Offset(1656),  PPR Unit
  Offset(1657),   L2FD, 8,  // Offset(1657),  Flash Driver Selection
  // Mipi Cam Link3 options
  Offset(1658),   L3SM, 8,  // Offset(1658),  Sensor Model
  Offset(1659),   L3H0, 8,  // Offset(1659),  User defined HID ASCII character 0
  Offset(1660),   L3H1, 8,  // Offset(1660),
  Offset(1661),   L3H2, 8,  // Offset(1661),
  Offset(1662),   L3H3, 8,  // Offset(1662),
  Offset(1663),   L3H4, 8,  // Offset(1663),
  Offset(1664),   L3H5, 8,  // Offset(1664),
  Offset(1665),   L3H6, 8,  // Offset(1665),
  Offset(1666),   L3H7, 8,  // Offset(1666),
  Offset(1667),   L3H8, 8,  // Offset(1667),  User defined HID ASCII character 8
  Offset(1668),   L3PL, 8,  // Offset(1668),  Camera Position
  Offset(1669),   L3M0, 8,  // Offset(1669),  Camera Module Name ASCII character 0
  Offset(1670),   L3M1, 8,  // Offset(1670),
  Offset(1671),   L3M2, 8,  // Offset(1671),
  Offset(1672),   L3M3, 8,  // Offset(1672),
  Offset(1673),   L3M4, 8,  // Offset(1673),
  Offset(1674),   L3M5, 8,  // Offset(1674),
  Offset(1675),   L3M6, 8,  // Offset(1675),
  Offset(1676),   L3M7, 8,  // Offset(1676),
  Offset(1677),   L3M8, 8,  // Offset(1677),
  Offset(1678),   L3M9, 8,  // Offset(1678),
  Offset(1679),   L3MA, 8,  // Offset(1679),
  Offset(1680),   L3MB, 8,  // Offset(1680),
  Offset(1681),   L3MC, 8,  // Offset(1681),
  Offset(1682),   L3MD, 8,  // Offset(1682),
  Offset(1683),   L3ME, 8,  // Offset(1683),
  Offset(1684),   L3MF, 8,  // Offset(1684),  Camera Module Name ASCII character 15
  Offset(1685),   L3DI, 8,  // Offset(1685),  Number of I2C devices
  Offset(1686),   L3BS, 8,  // Offset(1686),  I2C Serial Bus number
  Offset(1687),   L3A0, 16, // Offset(1687),  Address of I2C Device0 on Link3
  Offset(1689),   L3A1, 16, // Offset(1689),  Address of I2C Device1 on Link3
  Offset(1691),   L3A2, 16, // Offset(1691),  Address of I2C Device2 on Link3
  Offset(1693),   L3A3, 16, // Offset(1693),  Address of I2C Device3 on Link3
  Offset(1695),   L3A4, 16, // Offset(1695),  Address of I2C Device4 on Link3
  Offset(1697),   L3A5, 16, // Offset(1697),  Address of I2C Device5 on Link3
  Offset(1699),   L3A6, 16, // Offset(1699),  Address of I2C Device6 on Link3
  Offset(1701),   L3A7, 16, // Offset(1701),  Address of I2C Device7 on Link3
  Offset(1703),   L3A8, 16, // Offset(1703),  Address of I2C Device8 on Link3
  Offset(1705),   L3A9, 16, // Offset(1705),  Address of I2C Device9 on Link3
  Offset(1707),   L3AA, 16, // Offset(1707),  Address of I2C Device10 on Link3
  Offset(1709),   L3AB, 16, // Offset(1709),  Address of I2C Device11 on Link3
  Offset(1711),   L3D0, 8,  // Offset(1711),  Type of I2C Device0 on Link3
  Offset(1712),   L3D1, 8,  // Offset(1712),  Type of I2C Device1 on Link3
  Offset(1713),   L3D2, 8,  // Offset(1713),  Type of I2C Device2 on Link3
  Offset(1714),   L3D3, 8,  // Offset(1714),  Type of I2C Device3 on Link3
  Offset(1715),   L3D4, 8,  // Offset(1715),  Type of I2C Device4 on Link3
  Offset(1716),   L3D5, 8,  // Offset(1716),  Type of I2C Device5 on Link3
  Offset(1717),   L3D6, 8,  // Offset(1717),  Type of I2C Device6 on Link3
  Offset(1718),   L3D7, 8,  // Offset(1718),  Type of I2C Device7 on Link3
  Offset(1719),   L3D8, 8,  // Offset(1719),  Type of I2C Device8 on Link3
  Offset(1720),   L3D9, 8,  // Offset(1720),  Type of I2C Device9 on Link3
  Offset(1721),   L3DA, 8,  // Offset(1721),  Type of I2C Device10 on Link3
  Offset(1722),   L3DB, 8,  // Offset(1722),  Type of I2C Device11 on Link3
  Offset(1723),   L3DV, 8,  // Offset(1723),  Version of SSDB structure
  Offset(1724),   L3CV, 8,  // Offset(1724),  Version of CRD
  Offset(1725),   L3LU, 8,  // Offset(1725),  CSI2 Link used
  Offset(1726),   L3NL, 8,  // Offset(1726),  MIPI-CSI2 Data Lane
  Offset(1727),   L3EE, 8,  // Offset(1727),  EEPROM Type
  Offset(1728),   L3VC, 8,  // Offset(1728),  VCM Type
  Offset(1729),   L3FS, 8,  // Offset(1729),  Flash Support
  Offset(1730),   L3LE, 8,  // Offset(1730),  Privacy LED
  Offset(1731),   L3DG, 8,  // Offset(1731),  Degree
  Offset(1732),   L3CK, 32, // Offset(1732),  MCLK
  Offset(1736),   L3CL, 8,  // Offset(1736),  Control Logic
  Offset(1737),   L3PP, 8,  // Offset(1737),  PMIC Position
  Offset(1738),   L3VR, 8,  // Offset(1738),  Voltage Rail
  Offset(1739),   L3PV, 8,  // Offset(1739),  PPR Value
  Offset(1740),   L3PU, 8,  // Offset(1740),  PPR Unit
  Offset(1741),   L3FD, 8,  // Offset(1741),  Flash Driver Selection
  // Mipi Cam Link4 options
  Offset(1742),   L4SM, 8,  // Offset(1742),  Sensor Model
  Offset(1743),   L4H0, 8,  // Offset(1743),  User defined HID ASCII character 0
  Offset(1744),   L4H1, 8,  // Offset(1744),
  Offset(1745),   L4H2, 8,  // Offset(1745),
  Offset(1746),   L4H3, 8,  // Offset(1746),
  Offset(1747),   L4H4, 8,  // Offset(1747),
  Offset(1748),   L4H5, 8,  // Offset(1748),
  Offset(1749),   L4H6, 8,  // Offset(1749),
  Offset(1750),   L4H7, 8,  // Offset(1750),
  Offset(1751),   L4H8, 8,  // Offset(1751),  User defined HID ASCII character 8
  Offset(1752),   L4PL, 8,  // Offset(1752),  Camera Position
  Offset(1753),   L4M0, 8,  // Offset(1753),  Camera Module Name ASCII character 0
  Offset(1754),   L4M1, 8,  // Offset(1754),
  Offset(1755),   L4M2, 8,  // Offset(1755),
  Offset(1756),   L4M3, 8,  // Offset(1756),
  Offset(1757),   L4M4, 8,  // Offset(1757),
  Offset(1758),   L4M5, 8,  // Offset(1758),
  Offset(1759),   L4M6, 8,  // Offset(1759),
  Offset(1760),   L4M7, 8,  // Offset(1760),
  Offset(1761),   L4M8, 8,  // Offset(1761),
  Offset(1762),   L4M9, 8,  // Offset(1762),
  Offset(1763),   L4MA, 8,  // Offset(1763),
  Offset(1764),   L4MB, 8,  // Offset(1764),
  Offset(1765),   L4MC, 8,  // Offset(1765),
  Offset(1766),   L4MD, 8,  // Offset(1766),
  Offset(1767),   L4ME, 8,  // Offset(1767),
  Offset(1768),   L4MF, 8,  // Offset(1768),  Camera Module Name ASCII character 15
  Offset(1769),   L4DI, 8,  // Offset(1769),  Number of I2C devices
  Offset(1770),   L4BS, 8,  // Offset(1770),  I2C Serial Bus number
  Offset(1771),   L4A0, 16, // Offset(1771),  Address of I2C Device0 on Link4
  Offset(1773),   L4A1, 16, // Offset(1773),  Address of I2C Device1 on Link4
  Offset(1775),   L4A2, 16, // Offset(1775),  Address of I2C Device2 on Link4
  Offset(1777),   L4A3, 16, // Offset(1777),  Address of I2C Device3 on Link4
  Offset(1779),   L4A4, 16, // Offset(1779),  Address of I2C Device4 on Link4
  Offset(1781),   L4A5, 16, // Offset(1781),  Address of I2C Device5 on Link4
  Offset(1783),   L4A6, 16, // Offset(1783),  Address of I2C Device6 on Link4
  Offset(1785),   L4A7, 16, // Offset(1785),  Address of I2C Device7 on Link4
  Offset(1787),   L4A8, 16, // Offset(1787),  Address of I2C Device8 on Link4
  Offset(1789),   L4A9, 16, // Offset(1789),  Address of I2C Device9 on Link4
  Offset(1791),   L4AA, 16, // Offset(1791),  Address of I2C Device10 on Link4
  Offset(1793),   L4AB, 16, // Offset(1793),  Address of I2C Device11 on Link4
  Offset(1795),   L4D0, 8,  // Offset(1795),  Type of I2C Device0 on Link4
  Offset(1796),   L4D1, 8,  // Offset(1796),  Type of I2C Device1 on Link4
  Offset(1797),   L4D2, 8,  // Offset(1797),  Type of I2C Device2 on Link4
  Offset(1798),   L4D3, 8,  // Offset(1798),  Type of I2C Device3 on Link4
  Offset(1799),   L4D4, 8,  // Offset(1799),  Type of I2C Device4 on Link4
  Offset(1800),   L4D5, 8,  // Offset(1800),  Type of I2C Device5 on Link4
  Offset(1801),   L4D6, 8,  // Offset(1801),  Type of I2C Device6 on Link4
  Offset(1802),   L4D7, 8,  // Offset(1802),  Type of I2C Device7 on Link4
  Offset(1803),   L4D8, 8,  // Offset(1803),  Type of I2C Device8 on Link4
  Offset(1804),   L4D9, 8,  // Offset(1804),  Type of I2C Device9 on Link4
  Offset(1805),   L4DA, 8,  // Offset(1805),  Type of I2C Device10 on Link4
  Offset(1806),   L4DB, 8,  // Offset(1806),  Type of I2C Device11 on Link4
  Offset(1807),   L4DV, 8,  // Offset(1807),  Version of SSDB structure
  Offset(1808),   L4CV, 8,  // Offset(1808),  Version of CRD
  Offset(1809),   L4LU, 8,  // Offset(1809),  CSI2 Link used
  Offset(1810),   L4NL, 8,  // Offset(1810),  MIPI-CSI2 Data Lane
  Offset(1811),   L4EE, 8,  // Offset(1811),  EEPROM Type
  Offset(1812),   L4VC, 8,  // Offset(1812),  VCM Type
  Offset(1813),   L4FS, 8,  // Offset(1813),  Flash Support
  Offset(1814),   L4LE, 8,  // Offset(1814),  Privacy LED
  Offset(1815),   L4DG, 8,  // Offset(1815),  Degree
  Offset(1816),   L4CK, 32, // Offset(1816),  MCLK
  Offset(1820),   L4CL, 8,  // Offset(1820),  Control Logic
  Offset(1821),   L4PP, 8,  // Offset(1821),  PMIC Position
  Offset(1822),   L4VR, 8,  // Offset(1822),  Voltage Rail
  Offset(1823),   L4PV, 8,  // Offset(1823),  PPR Value
  Offset(1824),   L4PU, 8,  // Offset(1824),  PPR Unit
  Offset(1825),   L4FD, 8,  // Offset(1825),  Flash Driver Selection
  // Mipi Cam Link5 options
  Offset(1826),   L5SM, 8,  // Offset(1826),  Sensor Model
  Offset(1827),   L5H0, 8,  // Offset(1827),  User defined HID ASCII character 0
  Offset(1828),   L5H1, 8,  // Offset(1828),
  Offset(1829),   L5H2, 8,  // Offset(1829),
  Offset(1830),   L5H3, 8,  // Offset(1830),
  Offset(1831),   L5H4, 8,  // Offset(1831),
  Offset(1832),   L5H5, 8,  // Offset(1832),
  Offset(1833),   L5H6, 8,  // Offset(1833),
  Offset(1834),   L5H7, 8,  // Offset(1834),
  Offset(1835),   L5H8, 8,  // Offset(1835),  User defined HID ASCII character 8
  Offset(1836),   L5PL, 8,  // Offset(1836),  Camera Position
  Offset(1837),   L5M0, 8,  // Offset(1837),  Camera Module Name ASCII character 0
  Offset(1838),   L5M1, 8,  // Offset(1838),
  Offset(1839),   L5M2, 8,  // Offset(1839),
  Offset(1840),   L5M3, 8,  // Offset(1840),
  Offset(1841),   L5M4, 8,  // Offset(1841),
  Offset(1842),   L5M5, 8,  // Offset(1842),
  Offset(1843),   L5M6, 8,  // Offset(1843),
  Offset(1844),   L5M7, 8,  // Offset(1844),
  Offset(1845),   L5M8, 8,  // Offset(1845),
  Offset(1846),   L5M9, 8,  // Offset(1846),
  Offset(1847),   L5MA, 8,  // Offset(1847),
  Offset(1848),   L5MB, 8,  // Offset(1848),
  Offset(1849),   L5MC, 8,  // Offset(1849),
  Offset(1850),   L5MD, 8,  // Offset(1850),
  Offset(1851),   L5ME, 8,  // Offset(1851),
  Offset(1852),   L5MF, 8,  // Offset(1852),  Camera Module Name ASCII character 15
  Offset(1853),   L5DI, 8,  // Offset(1853),  Number of I2C devices
  Offset(1854),   L5BS, 8,  // Offset(1854),  I2C Serial Bus number
  Offset(1855),   L5A0, 16, // Offset(1855),  Address of I2C Device0 on Link5
  Offset(1857),   L5A1, 16, // Offset(1857),  Address of I2C Device1 on Link5
  Offset(1859),   L5A2, 16, // Offset(1859),  Address of I2C Device2 on Link5
  Offset(1861),   L5A3, 16, // Offset(1861),  Address of I2C Device3 on Link5
  Offset(1863),   L5A4, 16, // Offset(1863),  Address of I2C Device4 on Link5
  Offset(1865),   L5A5, 16, // Offset(1865),  Address of I2C Device5 on Link5
  Offset(1867),   L5A6, 16, // Offset(1867),  Address of I2C Device6 on Link5
  Offset(1869),   L5A7, 16, // Offset(1869),  Address of I2C Device7 on Link5
  Offset(1871),   L5A8, 16, // Offset(1871),  Address of I2C Device8 on Link5
  Offset(1873),   L5A9, 16, // Offset(1873),  Address of I2C Device9 on Link5
  Offset(1875),   L5AA, 16, // Offset(1875),  Address of I2C Device10 on Link5
  Offset(1877),   L5AB, 16, // Offset(1877),  Address of I2C Device11 on Link5
  Offset(1879),   L5D0, 8,  // Offset(1879),  Type of I2C Device0 on Link5
  Offset(1880),   L5D1, 8,  // Offset(1880),  Type of I2C Device1 on Link5
  Offset(1881),   L5D2, 8,  // Offset(1881),  Type of I2C Device2 on Link5
  Offset(1882),   L5D3, 8,  // Offset(1882),  Type of I2C Device3 on Link5
  Offset(1883),   L5D4, 8,  // Offset(1883),  Type of I2C Device4 on Link5
  Offset(1884),   L5D5, 8,  // Offset(1884),  Type of I2C Device5 on Link5
  Offset(1885),   L5D6, 8,  // Offset(1885),  Type of I2C Device6 on Link5
  Offset(1886),   L5D7, 8,  // Offset(1886),  Type of I2C Device7 on Link5
  Offset(1887),   L5D8, 8,  // Offset(1887),  Type of I2C Device8 on Link5
  Offset(1888),   L5D9, 8,  // Offset(1888),  Type of I2C Device9 on Link5
  Offset(1889),   L5DA, 8,  // Offset(1889),  Type of I2C Device10 on Link5
  Offset(1890),   L5DB, 8,  // Offset(1890),  Type of I2C Device11 on Link5
  Offset(1891),   L5DV, 8,  // Offset(1891),  Version of SSDB structure
  Offset(1892),   L5CV, 8,  // Offset(1892),  Version of CRD
  Offset(1893),   L5LU, 8,  // Offset(1893),  CSI2 Link used
  Offset(1894),   L5NL, 8,  // Offset(1894),  MIPI-CSI2 Data Lane
  Offset(1895),   L5EE, 8,  // Offset(1895),  EEPROM Type
  Offset(1896),   L5VC, 8,  // Offset(1896),  VCM Type
  Offset(1897),   L5FS, 8,  // Offset(1897),  Flash Support
  Offset(1898),   L5LE, 8,  // Offset(1898),  Privacy LED
  Offset(1899),   L5DG, 8,  // Offset(1899),  Degree
  Offset(1900),   L5CK, 32, // Offset(1900),  MCLK
  Offset(1904),   L5CL, 8,  // Offset(1904),  Control Logic
  Offset(1905),   L5PP, 8,  // Offset(1905),  PMIC Position
  Offset(1906),   L5VR, 8,  // Offset(1906),  Voltage Rail
  Offset(1907),   L5PV, 8,  // Offset(1907),  PPR Value
  Offset(1908),   L5PU, 8,  // Offset(1908),  PPR Unit
  Offset(1909),   L5FD, 8,  // Offset(1909),  Flash Driver Selection
  Offset(1910),   F0FM, 8,  // Offset(1910),  Flash Driver Model
  Offset(1911),   F0MS, 8,  // Offset(1911),  Flash Mode Selection
  Offset(1912),   F0M0, 8,  // Offset(1912),  Flash Module Name ASCII character 0
  Offset(1913),   F0M1, 8,  // Offset(1913),
  Offset(1914),   F0M2, 8,  // Offset(1914),
  Offset(1915),   F0M3, 8,  // Offset(1915),
  Offset(1916),   F0M4, 8,  // Offset(1916),
  Offset(1917),   F0M5, 8,  // Offset(1917),
  Offset(1918),   F0M6, 8,  // Offset(1918),
  Offset(1919),   F0M7, 8,  // Offset(1919),
  Offset(1920),   F0M8, 8,  // Offset(1920),
  Offset(1921),   F0M9, 8,  // Offset(1921),
  Offset(1922),   F0MA, 8,  // Offset(1922),
  Offset(1923),   F0MB, 8,  // Offset(1923),
  Offset(1924),   F0MC, 8,  // Offset(1924),
  Offset(1925),   F0MD, 8,  // Offset(1925),
  Offset(1926),   F0ME, 8,  // Offset(1926),
  Offset(1927),   F0MF, 8,  // Offset(1927),  Flash Module Name ASCII character 15
  Offset(1928),   F0BS, 8,  // Offset(1928),  I2C Bus Number
  Offset(1929),   F0AB, 16, // Offset(1929),  I2C Slave Device Address
  Offset(1931),   F0GP, 8,  // Offset(1931),  GPIO Group Pad Number
  Offset(1932),   F0GG, 16, // Offset(1932),  GPIO Group Number
  Offset(1934),   F0AV, 8,  // Offset(1934),  GPIO Active Value
  Offset(1935),   F0IV, 8,  // Offset(1935),  GPIO Initial Value
  Offset(1936),   F0OM, 8,  // Offset(1936),  Flash Driver Operating Mode
  Offset(1937),   F1FM, 8,  // Offset(1937),  Flash Driver Model
  Offset(1938),   F1MS, 8,  // Offset(1938),  Flash Mode Selection
  Offset(1939),   F1M0, 8,  // Offset(1939),  Flash Module Name ASCII character 0
  Offset(1940),   F1M1, 8,  // Offset(1940),
  Offset(1941),   F1M2, 8,  // Offset(1941),
  Offset(1942),   F1M3, 8,  // Offset(1942),
  Offset(1943),   F1M4, 8,  // Offset(1943),
  Offset(1944),   F1M5, 8,  // Offset(1944),
  Offset(1945),   F1M6, 8,  // Offset(1945),
  Offset(1946),   F1M7, 8,  // Offset(1946),
  Offset(1947),   F1M8, 8,  // Offset(1947),
  Offset(1948),   F1M9, 8,  // Offset(1948),
  Offset(1949),   F1MA, 8,  // Offset(1949),
  Offset(1950),   F1MB, 8,  // Offset(1950),
  Offset(1951),   F1MC, 8,  // Offset(1951),
  Offset(1952),   F1MD, 8,  // Offset(1952),
  Offset(1953),   F1ME, 8,  // Offset(1953),
  Offset(1954),   F1MF, 8,  // Offset(1954),  Flash Module Name ASCII character 15
  Offset(1955),   F1BS, 8,  // Offset(1955),  I2C Bus Number
  Offset(1956),   F1AB, 16, // Offset(1956),  I2C Slave Device Address
  Offset(1958),   F1GP, 8,  // Offset(1958),  GPIO Group Pad Number
  Offset(1959),   F1GG, 16, // Offset(1959),  GPIO Group Number
  Offset(1961),   F1AV, 8,  // Offset(1961),  GPIO Active Value
  Offset(1962),   F1IV, 8,  // Offset(1962),  GPIO Initial Value
  Offset(1963),   F1OM, 8,  // Offset(1963),  Flash Driver Operating Mode
  Offset(1964),   F2FM, 8,  // Offset(1964),  Flash Driver Model
  Offset(1965),   F2MS, 8,  // Offset(1965),  Flash Mode Selection
  Offset(1966),   F2M0, 8,  // Offset(1966),  Flash Module Name ASCII character 0
  Offset(1967),   F2M1, 8,  // Offset(1967),
  Offset(1968),   F2M2, 8,  // Offset(1968),
  Offset(1969),   F2M3, 8,  // Offset(1969),
  Offset(1970),   F2M4, 8,  // Offset(1970),
  Offset(1971),   F2M5, 8,  // Offset(1971),
  Offset(1972),   F2M6, 8,  // Offset(1972),
  Offset(1973),   F2M7, 8,  // Offset(1973),
  Offset(1974),   F2M8, 8,  // Offset(1974),
  Offset(1975),   F2M9, 8,  // Offset(1975),
  Offset(1976),   F2MA, 8,  // Offset(1976),
  Offset(1977),   F2MB, 8,  // Offset(1977),
  Offset(1978),   F2MC, 8,  // Offset(1978),
  Offset(1979),   F2MD, 8,  // Offset(1979),
  Offset(1980),   F2ME, 8,  // Offset(1980),
  Offset(1981),   F2MF, 8,  // Offset(1981),  Flash Module Name ASCII character 15
  Offset(1982),   F2BS, 8,  // Offset(1982),  I2C Bus Number
  Offset(1983),   F2AB, 16, // Offset(1983),  I2C Slave Device Address
  Offset(1985),   F2GP, 8,  // Offset(1985),  GPIO Group Pad Number
  Offset(1986),   F2GG, 16, // Offset(1986),  GPIO Group Number
  Offset(1988),   F2AV, 8,  // Offset(1988),  GPIO Active Value
  Offset(1989),   F2IV, 8,  // Offset(1989),  GPIO Initial Value
  Offset(1990),   F2OM, 8,  // Offset(1990),  Flash Driver Operating Mode
  Offset(1991),   F3FM, 8,  // Offset(1991),  Flash Driver Model
  Offset(1992),   F3MS, 8,  // Offset(1992),  Flash Mode Selection
  Offset(1993),   F3M0, 8,  // Offset(1993),  Flash Module Name ASCII character 0
  Offset(1994),   F3M1, 8,  // Offset(1994),
  Offset(1995),   F3M2, 8,  // Offset(1995),
  Offset(1996),   F3M3, 8,  // Offset(1996),
  Offset(1997),   F3M4, 8,  // Offset(1997),
  Offset(1998),   F3M5, 8,  // Offset(1998),
  Offset(1999),   F3M6, 8,  // Offset(1999),
  Offset(2000),   F3M7, 8,  // Offset(2000),
  Offset(2001),   F3M8, 8,  // Offset(2001),
  Offset(2002),   F3M9, 8,  // Offset(2002),
  Offset(2003),   F3MA, 8,  // Offset(2003),
  Offset(2004),   F3MB, 8,  // Offset(2004),
  Offset(2005),   F3MC, 8,  // Offset(2005),
  Offset(2006),   F3MD, 8,  // Offset(2006),
  Offset(2007),   F3ME, 8,  // Offset(2007),
  Offset(2008),   F3MF, 8,  // Offset(2008),  Flash Module Name ASCII character 15
  Offset(2009),   F3BS, 8,  // Offset(2009),  I2C Bus Number
  Offset(2010),   F3AB, 16, // Offset(2010),  I2C Slave Device Address
  Offset(2012),   F3GP, 8,  // Offset(2012),  GPIO Group Pad Number
  Offset(2013),   F3GG, 16, // Offset(2013),  GPIO Group Number
  Offset(2015),   F3AV, 8,  // Offset(2015),  GPIO Active Value
  Offset(2016),   F3IV, 8,  // Offset(2016),  GPIO Initial Value
  Offset(2017),   F3OM, 8,  // Offset(2017),  Flash Driver Operating Mode
  Offset(2018),   F4FM, 8,  // Offset(2018),  Flash Driver Model
  Offset(2019),   F4MS, 8,  // Offset(2019),  Flash Mode Selection
  Offset(2020),   F4M0, 8,  // Offset(2020),  Flash Module Name ASCII character 0
  Offset(2021),   F4M1, 8,  // Offset(2021),
  Offset(2022),   F4M2, 8,  // Offset(2022),
  Offset(2023),   F4M3, 8,  // Offset(2023),
  Offset(2024),   F4M4, 8,  // Offset(2024),
  Offset(2025),   F4M5, 8,  // Offset(2025),
  Offset(2026),   F4M6, 8,  // Offset(2026),
  Offset(2027),   F4M7, 8,  // Offset(2027),
  Offset(2028),   F4M8, 8,  // Offset(2028),
  Offset(2029),   F4M9, 8,  // Offset(2029),
  Offset(2030),   F4MA, 8,  // Offset(2030),
  Offset(2031),   F4MB, 8,  // Offset(2031),
  Offset(2032),   F4MC, 8,  // Offset(2032),
  Offset(2033),   F4MD, 8,  // Offset(2033),
  Offset(2034),   F4ME, 8,  // Offset(2034),
  Offset(2035),   F4MF, 8,  // Offset(2035),  Flash Module Name ASCII character 15
  Offset(2036),   F4BS, 8,  // Offset(2036),  I2C Bus Number
  Offset(2037),   F4AB, 16, // Offset(2037),  I2C Slave Device Address
  Offset(2039),   F4GP, 8,  // Offset(2039),  GPIO Group Pad Number
  Offset(2040),   F4GG, 16, // Offset(2040),  GPIO Group Number
  Offset(2042),   F4AV, 8,  // Offset(2042),  GPIO Active Value
  Offset(2043),   F4IV, 8,  // Offset(2043),  GPIO Initial Value
  Offset(2044),   F4OM, 8,  // Offset(2044),  Flash Driver Operating Mode
  Offset(2045),   F5FM, 8,  // Offset(2045),  Flash Driver Model
  Offset(2046),   F5MS, 8,  // Offset(2046),  Flash Mode Selection
  Offset(2047),   F5M0, 8,  // Offset(2047),  Flash Module Name ASCII character 0
  Offset(2048),   F5M1, 8,  // Offset(2048),
  Offset(2049),   F5M2, 8,  // Offset(2049),
  Offset(2050),   F5M3, 8,  // Offset(2050),
  Offset(2051),   F5M4, 8,  // Offset(2051),
  Offset(2052),   F5M5, 8,  // Offset(2052),
  Offset(2053),   F5M6, 8,  // Offset(2053),
  Offset(2054),   F5M7, 8,  // Offset(2054),
  Offset(2055),   F5M8, 8,  // Offset(2055),
  Offset(2056),   F5M9, 8,  // Offset(2056),
  Offset(2057),   F5MA, 8,  // Offset(2057),
  Offset(2058),   F5MB, 8,  // Offset(2058),
  Offset(2059),   F5MC, 8,  // Offset(2059),
  Offset(2060),   F5MD, 8,  // Offset(2060),
  Offset(2061),   F5ME, 8,  // Offset(2061),
  Offset(2062),   F5MF, 8,  // Offset(2062),  Flash Module Name ASCII character 15
  Offset(2063),   F5BS, 8,  // Offset(2063),  I2C Bus Number
  Offset(2064),   F5AB, 16, // Offset(2064),  I2C Slave Device Address
  Offset(2066),   F5GP, 8,  // Offset(2066),  GPIO Group Pad Number
  Offset(2067),   F5GG, 16, // Offset(2067),  GPIO Group Number
  Offset(2069),   F5AV, 8,  // Offset(2069),  GPIO Active Value
  Offset(2070),   F5IV, 8,  // Offset(2070),  GPIO Initial Value
  Offset(2071),   F5OM, 8,  // Offset(2071),  Flash Driver Operating Mode
  Offset(2072),             // Offset(2072) : Offset(2071), Reserved bytes
  Offset(2072),   ECR1, 8,  // Offset(2072),
  Offset(2073),   I2SC, 8,  // Offset(2073),  HD Audio I2S Codec Selection
  Offset(2074),   I2SI, 32, // Offset(2074),  HD Audio I2S Codec Interrupt Pin
  Offset(2078),   I2SB, 8,  // Offset(2078),  HD Audio I2S Codec Connection to I2C bus controller instance (I2C[0-5])
  Offset(2079),   ODV0, 8,  // Offset(2079),  Intel(R) Dynamic Tuning Technology Oem Design Variables
  Offset(2080),   ODV1, 8,  // Offset(2080),  Intel(R) Dynamic Tuning Technology Oem Design Variables
  Offset(2081),   ODV2, 8,  // Offset(2081),  Intel(R) Dynamic Tuning Technology Oem Design Variables
  Offset(2082),   ODV3, 8,  // Offset(2082),  Intel(R) Dynamic Tuning Technology Oem Design Variables
  Offset(2083),   ODV4, 8,  // Offset(2083),  Intel(R) Dynamic Tuning Technology Oem Design Variables
  Offset(2084),   ODV5, 8,  // Offset(2084),  Intel(R) Dynamic Tuning Technology Oem Design Variables
  Offset(2085),   UBCB, 32, // Offset(2085),  USB Type C Opregion base address
  Offset(2089),             // Offset(2089) : Offset(2088), Reserved bytes
  Offset(2089),   WIFC, 8,  // Offset(2089),  WirelessCharging
  Offset(2096),             // Offset(2090) : Offset(2095), Reserved bytes
  Offset(2096),   ADPM, 32, // Offset(2096),  HD-Audio DSP Post-Processing Module Mask
  Offset(2100),   AG1L, 64, // Offset(2100),  HDA PP module custom GUID 1 - first 64bit  [0-63]
  Offset(2108),   AG1H, 64, // Offset(2108),  HDA PP module custom GUID 1 - second 64bit [64-127]
  Offset(2116),   AG2L, 64, // Offset(2116),  HDA PP module custom GUID 2 - first 64bit  [0-63]
  Offset(2124),   AG2H, 64, // Offset(2124),  HDA PP module custom GUID 2 - second 64bit [64-127]
  Offset(2132),   AG3L, 64, // Offset(2132),  HDA PP module custom GUID 3 - first 64bit  [0-63]
  Offset(2140),   AG3H, 64, // Offset(2140),  HDA PP module custom GUID 3 - second 64bit [64-127]
  Offset(2148),   HEFE, 8,  // Offset(2148),  HID Event Filter Driver enable
  Offset(2149),   XDCE, 8,  // Offset(2149),  XDCI Enable/Disable status
  Offset(2150),   STXE, 8,  // Offset(2150),  WrdsWiFiSarEnable
  Offset(2151),   ST10, 8,  // Offset(2151),  WrdsWiFiSarTxPowerSet1Limit1
  Offset(2152),   ST11, 8,  // Offset(2152),  WrdsWiFiSarTxPowerSet1Limit2
  Offset(2153),   ST12, 8,  // Offset(2153),  WrdsWiFiSarTxPowerSet1Limit3
  Offset(2154),   ST13, 8,  // Offset(2154),  WrdsWiFiSarTxPowerSet1Limit4
  Offset(2155),   ST14, 8,  // Offset(2155),  WrdsWiFiSarTxPowerSet1Limit5
  Offset(2156),   ST15, 8,  // Offset(2156),  WrdsWiFiSarTxPowerSet1Limit6
  Offset(2157),   ST16, 8,  // Offset(2157),  WrdsWiFiSarTxPowerSet1Limit7
  Offset(2158),   ST17, 8,  // Offset(2158),  WrdsWiFiSarTxPowerSet1Limit8
  Offset(2159),   ST18, 8,  // Offset(2159),  WrdsWiFiSarTxPowerSet1Limit9
  Offset(2160),   ST19, 8,  // Offset(2160),  WrdsWiFiSarTxPowerSet1Limit10
  Offset(2161),   ENVM, 8,  // Offset(2161),  Enable Voltage Margining
  Offset(2162),   DHSP, 16, // Offset(2162),  D-State for xHCI HS port(BIT0:USB HS Port0 ~ BIT15:USB HS Port15)
  Offset(2164),   DSSP, 16, // Offset(2164),  D-State for xHCI SS port(BIT0:USB SS Port0 ~ BIT15:USB SS Port15)
  Offset(2166),   DSTP, 8,  // Offset(2166),  D-State for SATA port(BIT0:SATA Port0 ~ BIT7:SATA Port7)
  Offset(2167),   STDE, 8,  // Offset(2167),  EwrdWiFiDynamicSarEnable
  Offset(2168),   STRS, 8,  // Offset(2168),  EwrdWiFiDynamicSarRangeSets
  Offset(2169),   ST20, 8,  // Offset(2169),  EwrdWiFiSarTxPowerSet2Limit1
  Offset(2170),   ST21, 8,  // Offset(2170),  EwrdWiFiSarTxPowerSet2Limit2
  Offset(2171),   ST22, 8,  // Offset(2171),  EwrdWiFiSarTxPowerSet2Limit3
  Offset(2172),   ST23, 8,  // Offset(2172),  EwrdWiFiSarTxPowerSet2Limit4
  Offset(2173),   ST24, 8,  // Offset(2173),  EwrdWiFiSarTxPowerSet2Limit5
  Offset(2174),   ST25, 8,  // Offset(2174),  EwrdWiFiSarTxPowerSet2Limit6
  Offset(2175),   ST26, 8,  // Offset(2175),  EwrdWiFiSarTxPowerSet2Limit7
  Offset(2176),   ST27, 8,  // Offset(2176),  EwrdWiFiSarTxPowerSet2Limit8
  Offset(2177),   ST28, 8,  // Offset(2177),  EwrdWiFiSarTxPowerSet2Limit9
  Offset(2178),   ST29, 8,  // Offset(2178),  EwrdWiFiSarTxPowerSet2Limit10
  Offset(2179),   ST30, 8,  // Offset(2179),  EwrdWiFiSarTxPowerSet3Limit1
  Offset(2180),   ST31, 8,  // Offset(2180),  EwrdWiFiSarTxPowerSet3Limit2
  Offset(2181),   ST32, 8,  // Offset(2181),  EwrdWiFiSarTxPowerSet3Limit3
  Offset(2182),   ST33, 8,  // Offset(2182),  EwrdWiFiSarTxPowerSet3Limit4
  Offset(2183),   ST34, 8,  // Offset(2183),  EwrdWiFiSarTxPowerSet3Limit5
  Offset(2184),   ST35, 8,  // Offset(2184),  EwrdWiFiSarTxPowerSet3Limit6
  Offset(2185),   ST36, 8,  // Offset(2185),  EwrdWiFiSarTxPowerSet3Limit7
  Offset(2186),   ST37, 8,  // Offset(2186),  EwrdWiFiSarTxPowerSet3Limit8
  Offset(2187),   ST38, 8,  // Offset(2187),  EwrdWiFiSarTxPowerSet3Limit9
  Offset(2188),   ST39, 8,  // Offset(2188),  EwrdWiFiSarTxPowerSet3Limit10
  Offset(2189),   ST40, 8,  // Offset(2189),  EwrdWiFiSarTxPowerSet4Limit1
  Offset(2190),   ST41, 8,  // Offset(2190),  EwrdWiFiSarTxPowerSet4Limit2
  Offset(2191),   ST42, 8,  // Offset(2191),  EwrdWiFiSarTxPowerSet4Limit3
  Offset(2192),   ST43, 8,  // Offset(2192),  EwrdWiFiSarTxPowerSet4Limit4
  Offset(2193),   ST44, 8,  // Offset(2193),  EwrdWiFiSarTxPowerSet4Limit5
  Offset(2194),   ST45, 8,  // Offset(2194),  EwrdWiFiSarTxPowerSet4Limit6
  Offset(2195),   ST46, 8,  // Offset(2195),  EwrdWiFiSarTxPowerSet4Limit7
  Offset(2196),   ST47, 8,  // Offset(2196),  EwrdWiFiSarTxPowerSet4Limit8
  Offset(2197),   ST48, 8,  // Offset(2197),  EwrdWiFiSarTxPowerSet4Limit9
  Offset(2198),   ST49, 8,  // Offset(2198),  EwrdWiFiSarTxPowerSet4Limit10
  Offset(2199),   SD11, 8,  // Offset(2199),  WgdsWiFiSarDeltaGroup1PowerMax1
  Offset(2200),   SD12, 8,  // Offset(2200),  WgdsWiFiSarDeltaGroup1PowerChainA1
  Offset(2201),   SD13, 8,  // Offset(2201),  WgdsWiFiSarDeltaGroup1PowerChainB1
  Offset(2202),   SD14, 8,  // Offset(2202),  WgdsWiFiSarDeltaGroup1PowerMax2
  Offset(2203),   SD15, 8,  // Offset(2203),  WgdsWiFiSarDeltaGroup1PowerChainA2
  Offset(2204),   SD16, 8,  // Offset(2204),  WgdsWiFiSarDeltaGroup1PowerChainB2
  Offset(2205),   SD21, 8,  // Offset(2205),  WgdsWiFiSarDeltaGroup2PowerMax1
  Offset(2206),   SD22, 8,  // Offset(2206),  WgdsWiFiSarDeltaGroup2PowerChainA1
  Offset(2207),   SD23, 8,  // Offset(2207),  WgdsWiFiSarDeltaGroup2PowerChainB1
  Offset(2208),   SD24, 8,  // Offset(2208),  WgdsWiFiSarDeltaGroup2PowerMax2
  Offset(2209),   SD25, 8,  // Offset(2209),  WgdsWiFiSarDeltaGroup2PowerChainA2
  Offset(2210),   SD26, 8,  // Offset(2210),  WgdsWiFiSarDeltaGroup2PowerChainB2
  Offset(2211),   SD31, 8,  // Offset(2211),  WgdsWiFiSarDeltaGroup3PowerMax1
  Offset(2212),   SD32, 8,  // Offset(2212),  WgdsWiFiSarDeltaGroup3PowerChainA1
  Offset(2213),   SD33, 8,  // Offset(2213),  WgdsWiFiSarDeltaGroup3PowerChainB1
  Offset(2214),   SD34, 8,  // Offset(2214),  WgdsWiFiSarDeltaGroup3PowerMax2
  Offset(2215),   SD35, 8,  // Offset(2215),  WgdsWiFiSarDeltaGroup3PowerChainA2
  Offset(2216),   SD36, 8,  // Offset(2216),  WgdsWiFiSarDeltaGroup3PowerChainB2
  Offset(2258),             // Offset(2217) : Offset(2257), Reserved bytes
  // Reserved for Groups 4 to 9, each needs 6 bytes and total 36 bytes reserved
  Offset(2258),   SDAA, 8,  // Offset(2258),  WiFiDynamicSarAntennaACurrentSet
  Offset(2259),   SDAB, 8,  // Offset(2259),  WiFiDynamicSarAntennaBCurrentSet
  Offset(2260),   BTSE, 8,  // Offset(2260),  BluetoothSar
  Offset(2261),   BTBR, 8,  // Offset(2261),  BluetoothSarBr
  Offset(2262),   BED2, 8,  // Offset(2262),  BluetoothSarEdr2
  Offset(2263),   BED3, 8,  // Offset(2263),  BluetoothSarEdr3
  Offset(2264),   BTLE, 8,  // Offset(2264),  BluetoothSarLe
  Offset(2265),   BTL2, 8,  // Offset(2265),  BluetoothSarLe2Mhz
  Offset(2266),   BTLL, 8,  // Offset(2266),  BluetoothSarLeLr
  Offset(2269),             // Offset(2267) : Offset(2268), Reserved bytes
  // Reserved for Bluetooth Sar future use
  Offset(2269),   ATDV, 8,  // Offset(2269),  AntennaDiversity
  Offset(2270),   COEM, 8,  // Offset(2270),  CoExistenceManager
  Offset(2271),   RTVM, 8,  // Offset(2271),  RunTime VM Control
  //
  //Feature Specific Data Bits
  //
  Offset(2272),   USTC, 8,  // Offset(2272),  USB Type C Supported
  Offset(2273),   HEB1, 32, // Offset(2273),  HebcValue
  Offset(2277),   BATP, 8,  // Offset(2277),  Battery Present - Bit0: Real Battery is supported on this platform. Bit1: Virtual Battery is supported on this platform.
  Offset(2278),   TSDB, 8,  // Offset(2278),  TS-on-DIMM temperature
  Offset(2281),             // Offset(2279) : Offset(2280), Reserved bytes
  Offset(2281),   RBY1, 8,  // Offset(2281),  Real Battery 1 Control
  Offset(2282),   RBY2, 8,  // Offset(2282),  Real Battery 2 Control
  Offset(2283),   SCSS, 8,  // Offset(2283),  Mipi Camera Sensor
  Offset(2284),   NCTC, 8,  // Offset(2284),  NCT6776F COM
  Offset(2285),   NCTI, 8,  // Offset(2285),  NCT6776F SIO
  Offset(2286),   NCTH, 8,  // Offset(2286),  NCT6776F HWMON
  Offset(2287),   HSIO, 8,  // Offset(2287),  H8S2113 SIO
  Offset(2288),   ZPOD, 8,  // Offset(2288),  ZPODD
  Offset(2289),   RGBC, 8,  // Offset(2289),  RGB Camera Address
  Offset(2290),   DPTC, 8,  // Offset(2290),  Depth Camera Addresy
  Offset(2291),   SRSP, 32, // Offset(2291),  SMC Runtime Sci Pin
  Offset(2295),   CEDS, 8,  // Offset(2295),  Convertable Dock Support
  Offset(2296),   EHK3, 8,  // Offset(2296),  Ec Hotkey F3 Support
  Offset(2297),   EHK4, 8,  // Offset(2297),  Ec Hotkey F4 Support
  Offset(2298),   EHK5, 8,  // Offset(2298),  Ec Hotkey F5 Support
  Offset(2299),   EHK6, 8,  // Offset(2299),  Ec Hotkey F6 Support
  Offset(2300),   EHK7, 8,  // Offset(2300),  Ec Hotkey F7 Support
  Offset(2301),   EHK8, 8,  // Offset(2301),  Ec Hotkey F8 Support
  Offset(2302),   VBVP, 8,  // Offset(2302),  Virtual Button Volume Up Support
  Offset(2303),   VBVD, 8,  // Offset(2303),  Virtual Button Volume Down Support
  Offset(2304),   VBHB, 8,  // Offset(2304),  Virtual Button Home Button Support
  Offset(2305),   VBRL, 8,  // Offset(2305),  Virtual Button Rotation Lock Support
  Offset(2306),   SMSS, 8,  // Offset(2306),  Slate Mode Switch Support
  Offset(2307),   VBST, 8,  // Offset(2307),  Virtual Button Support
  Offset(2308),   ADAS, 8,  // Offset(2308),  Ac Dc Auto Switch Support
  Offset(2309),   PPBG, 32, // Offset(2309),  Pm Power Button Gpio Pin
  Offset(2313),   AEAB, 8,  // Offset(2313),  Acpi Enable All Button Support
  Offset(2314),   AHDB, 8,  // Offset(2314),  Acpi Hid Driver Button Support
  Offset(2315),   ELPM, 32, // Offset(2315),  EcLowPowerModeGpioPin
  Offset(2319),   ELPS, 32, // Offset(2319),  EcSmiGpioPin
  //
  // UCMC setup option, GPIO Pad
  //
  Offset(2323),   UCMS, 8,  // Offset(2323),  Option to select UCSI/UCMC device
  Offset(2324),   UCG1, 32, // Offset(2324),  Gpio for UCMC Port 1 Interrupt
  Offset(2328),   UCG2, 32, // Offset(2328),  Gpio for UCMC Port 2 Interrupt
  Offset(2361),             // Offset(2332) : Offset(2360), Reserved bytes
  Offset(2361),   PCHE, 8,  // Offset(2361),  EnablePchFivrParticipant
  Offset(2365),             // Offset(2362) : Offset(2364), Reserved bytes
  Offset(2365),   UDGF, 8,  // Offset(2365),  Upstream Facing port or Downstream Facing port Global Flag from LPC EC
  Offset(2366),   UDUP, 8,  // Offset(2366),  Upstream Facing port or Downstream Facing port number from LPC EC
  Offset(2367),   DBGF, 8,  // Offset(2367),  Debug Mode Global Flag from LPC EC
  Offset(2368),   DBUP, 8,  // Offset(2368),  Debug Mode USB Port Number from LPC EC
  Offset(2369),   TTUP, 8,  // Offset(2369),  Total Number of type C ports that are supported by platform
  Offset(2370),   TP1T, 8,  // Offset(2370),  Type C Connector 1  Port mapping within the controller the port exposed
  Offset(2371),   TP1P, 8,  // Offset(2371),  Type C Connector 1  Port mapping within the PCH controller (If Split mode supported)
  Offset(2372),   TP1D, 8,  // Offset(2372),  Type C Connector 1  Portperties Split Support/Controller(PCH/TBT/CPU)/Root port (vaild for TBT)
  Offset(2373),   TP2T, 8,  // Offset(2373),  Type C Connector 2  Port mapping within the controller the port exposed
  Offset(2374),   TP2P, 8,  // Offset(2374),  Type C Connector 2  Port mapping within the PCH controller (If Split mode supported)
  Offset(2375),   TP2D, 8,  // Offset(2375),  Type C Connector 2  Portperties Split Support/Controller(PCH/TBT/CPU)/Root port (vaild for TBT)
  Offset(2376),   TP3T, 8,  // Offset(2376),  Type C Connector 3  Port mapping within the controller the port exposed
  Offset(2377),   TP3P, 8,  // Offset(2377),  Type C Connector 3  Port mapping within the PCH controller (If Split mode supported)
  Offset(2378),   TP3D, 8,  // Offset(2378),  Type C Connector 3  Portperties Split Support/Controller(PCH/TBT/CPU)/Root port (vaild for TBT)
  Offset(2379),   TP4T, 8,  // Offset(2379),  Type C Connector 4  Port mapping within the controller the port exposed
  Offset(2380),   TP4P, 8,  // Offset(2380),  Type C Connector 4  Port mapping within the PCH controller (If Split mode supported)
  Offset(2381),   TP4D, 8,  // Offset(2381),  Type C Connector 4  Portperties Split Support/Controller(PCH/TBT/CPU)/Root port (vaild for TBT)
  Offset(2382),   TP5T, 8,  // Offset(2382),  Type C Connector 5  Port mapping within the controller the port exposed
  Offset(2383),   TP5P, 8,  // Offset(2383),  Type C Connector 5  Port mapping within the PCH controller (If Split mode supported)
  Offset(2384),   TP5D, 8,  // Offset(2384),  Type C Connector 5  Portperties Split Support/Controller(PCH/TBT/CPU)/Root port (vaild for TBT)
  Offset(2385),   TP6T, 8,  // Offset(2385),  Type C Connector 6  Port mapping within the controller the port exposed
  Offset(2386),   TP6P, 8,  // Offset(2386),  Type C Connector 6  Port mapping within the PCH controller (If Split mode supported)
  Offset(2387),   TP6D, 8,  // Offset(2387),  Type C Connector 6  Portperties Split Support/Controller(PCH/TBT/CPU)/Root port (vaild for TBT)
  Offset(2388),   STAS, 8,  // Offset(2388),  Select source for System time and alarm
  Offset(2389),   WRTO, 8,  // Offset(2389),  WWAN RTD3 options
  Offset(2390),   PRST, 32, // Offset(2390),  WWAN PERST Gpio pin
  Offset(2394),   WPRP, 8,  // Offset(2394),  WWAN PERST Gpio polarity
  Offset(2395),   PSWP, 32, // Offset(2395),  Pcie Slot Wake Gpio pin
  Offset(2399),   RPNB, 8,  // Offset(2399),  Pcie Slot Root Port Number
  Offset(2400),   POME, 8,  // Offset(2400),  Enable PowerMeter
  Offset(2401),   PSW2, 32, // Offset(2401),  Pcie Slot 2 Wake Gpio pin
  Offset(2405),   RPN2, 8,  // Offset(2405),  Pcie Slot 2 Root Port Number
  Offset(2406),   WFCP, 32, // Offset(2406),  WWAN Full card power off gpio pin
  Offset(2410),   PFCP, 8,  // Offset(2410),  WWAN Full card power off gpio pin polarity
  Offset(2411),   WBRS, 32, // Offset(2411),  WWAN BBRST Gpio pin
  Offset(2415),   PBRS, 8,  // Offset(2415),  WWAN BBRST Gpio pin polarity
  Offset(2416),   WWKP, 32, // Offset(2416),  WWAN Wake Gpio pin
  Offset(2420),   GPLP, 32, // Offset(2420),  Gpio for touchPaneL 0 power enable
  Offset(2424),   GPLR, 32, // Offset(2424),  Gpio for touchPaneL 0 Reset
  Offset(2428),   GPI1, 32, // Offset(2428),  Gpio for touchPaneL 1 Interrupt
  Offset(2432),   TPP1, 32, // Offset(2432),  Gpio for touchPaneL 1 power enable
  Offset(2436),   TPR1, 32, // Offset(2436),  Gpio for touchPaneL 1 Reset
  Offset(2440),   PPDI, 8,  // Offset(2440),  TouchPaD Interrupt Gpio pin polarity
  Offset(2441),   PPLI, 8,  // Offset(2441),  TouchPaneL 0 Interrupt Gpio pin polarity
  Offset(2442),   PPLP, 8,  // Offset(2442),  TouchPaneL 0 power enable Gpio pin polarity
  Offset(2443),   PPLR, 8,  // Offset(2443),  TouchPaneL 0 Reset Gpio pin polarity
  Offset(2444),   PPI1, 8,  // Offset(2444),  TouchPaneL 1 Interrupt Gpio pin polarity
  Offset(2445),   PPP1, 8,  // Offset(2445),  TouchPaneL 1 power enable Gpio pin polarity
  Offset(2446),   PPR1, 8,  // Offset(2446),  TouchPaneL 1 Reset Gpio pin polarity
  Offset(2447),   PSPE, 32, // Offset(2447),  Pcie Slot 1 Power Enable Gpio pin
  Offset(2451),   PPSP, 8,  // Offset(2451),  Pcie Slot 1 Power Enable Gpio pin polarity
  Offset(2452),   PSPR, 32, // Offset(2452),  Pcie Slot 1 Reset Gpio pin
  Offset(2456),   PPSR, 8,  // Offset(2456),  Pcie Slot 1 Reset Gpio pin polarity
  Offset(2457),   PSP2, 32, // Offset(2457),  Pcie Slot 2 Power Enable Gpio pin
  Offset(2461),   PS2P, 8,  // Offset(2461),  Pcie Slot 2 Power Enable Gpio pin polarity
  Offset(2462),   PSR2, 32, // Offset(2462),  Pcie Slot 2 Reset Gpio pin
  Offset(2466),   SR2P, 8,  // Offset(2466),  Pcie Slot 2 Reset Gpio pin polarity
  Offset(2467),   WLWK, 32, // Offset(2467),  WLAN Wake Gpio pin
  Offset(2471),   WLRP, 8,  // Offset(2471),  WLAN Root Port Number
  Offset(2472),   SATP, 32, // Offset(2472),  Sata port Power Enable Gpio pin
  Offset(2476),   STPP, 8,  // Offset(2476),  Sata port Power Enable Gpio pin polarity
  Offset(2477),   SSDP, 32, // Offset(2477),  Pch M.2 SSD Power Enable Gpio pin
  Offset(2481),   SDPP, 8,  // Offset(2481),  Pch M.2 SSD Power Enable Gpio pin polarity
  Offset(2482),   SSDR, 32, // Offset(2482),  Pch M.2 SSD Reset Gpio pin
  Offset(2486),   SDRP, 8,  // Offset(2486),  Pch M.2 SSD Reset Gpio pin polarity
  Offset(2487),   S2DP, 32, // Offset(2487),  Pch M.2 SSD #2 Power Enable Gpio pin
  Offset(2491),   S2PP, 8,  // Offset(2491),  Pch M.2 SSD #2 Power Enable Gpio pin polarity
  Offset(2492),   S2DR, 32, // Offset(2492),  Pch M.2 SSD #2 Reset Gpio pin
  Offset(2496),   S2RP, 8,  // Offset(2496),  Pch M.2 SSD #2 Reset Gpio pin polarity
  Offset(2497),   SD2P, 32, // Offset(2497),  PCIe x4 M.2 SSD Power Enable Gpio pin
  Offset(2501),   SDP1, 8,  // Offset(2501),  PCIe x4 M.2 SSD Power Enable Gpio pin polarity
  Offset(2502),   SD2R, 32, // Offset(2502),  PCIe x4 M.2 SSD Reset Gpio pin
  Offset(2506),   SDR1, 8,  // Offset(2506),  PCIe x4 M.2 SSD Reset Gpio pin polarity
  Offset(2507),   SXI1, 8,  // Offset(2507),  SDEV xHCI Interface Number for device 1
  Offset(2508),   SXI2, 8,  // Offset(2508),  SDEV xHCI Interface Number for device 2
  Offset(2509),   SXP1, 8,  // Offset(2509),  SDEV xHCI Root Port Number for device 1
  Offset(2510),   SXP2, 8,  // Offset(2510),  SDEV xHCI Root Port Number for device 2
  Offset(2511),   TSD0, 8,  // Offset(2511),  TSN PCS device Enable
  Offset(2512),   WCLK, 8,  // Offset(2512),  WWAN Source Clock
  Offset(2513),   CWEF, 8,  // Offset(2513),  CPU_WAKE_EN value
  Offset(2514),   CECV, 32, // Offset(2514),  CNV external 32KHz Clock
  Offset(2518),   WWRP, 8,  // Offset(2518),  WWAN Root Port Nmuber
  Offset(2519),   WAGE, 8,  // Offset(2519),  Wifi Ant Gain Enable
  Offset(2520),   AGA1, 8,  // Offset(2520),  Ant Gain Table Chain A 2400
  Offset(2521),   AGA2, 8,  // Offset(2521),  Ant Gain Table Chain A 5150-5350
  Offset(2522),   AGA3, 8,  // Offset(2522),  Ant Gain Table Chain A 5350-5470
  Offset(2523),   AGA4, 8,  // Offset(2523),  Ant Gain Table Chain A 5470-5725
  Offset(2524),   AGA5, 8,  // Offset(2524),  Ant Gain Table Chain A 5725-5945
  Offset(2525),   AGB1, 8,  // Offset(2525),  Ant Gain Table Chain B 2400
  Offset(2526),   AGB2, 8,  // Offset(2526),  Ant Gain Table Chain B 5150-5350
  Offset(2527),   AGB3, 8,  // Offset(2527),  Ant Gain Table Chain B 5350-5470
  Offset(2528),   AGB4, 8,  // Offset(2528),  Ant Gain Table Chain B 5470-5725
  Offset(2529),   AGB5, 8,  // Offset(2529),  Ant Gain Table Chain B 5725-5945
  Offset(2530),   ACSD, 32, // Offset(2530),  SRD Active Channels Selection
  Offset(2534),   I5BS, 32, // Offset(2534),  Indonesia 5.15-5.35 GHz Band Support Selection
  Offset(2538),   DGVR, 32, // Offset(2538),  DG1 VRAM Self Refresh Gpio pin
  Offset(2542),   PAPE, 32, // Offset(2542),  PEG slot A power enable gpio
  Offset(2546),   PAPP, 8,  // Offset(2546),  power enable polarity
  Offset(2547),   PARE, 32, // Offset(2547),  PEG slot A reset gpio
  Offset(2551),   PARP, 8,  // Offset(2551),  reset polarity
  Offset(2552),   PAWK, 32, // Offset(2552),  PEG slot A wake gpio
  Offset(2556),   PART, 8,  // Offset(2556),  PEG slot A Root Port
  Offset(2557),   PBPE, 32, // Offset(2557),  PEG slot B power enable gpio
  Offset(2561),   PBPP, 8,  // Offset(2561),  power enable polarity
  Offset(2562),   PBRE, 32, // Offset(2562),  PEG slot B reset gpio
  Offset(2566),   PBRP, 8,  // Offset(2566),  reset polarity
  Offset(2567),   PBWK, 32, // Offset(2567),  PEG slot B wake gpio
  Offset(2571),   PBRT, 8,  // Offset(2571),  PEG slot B Root Port
  Offset(2572),   PCPE, 32, // Offset(2572),  PEG slot C power enable gpio
  Offset(2576),   PCPP, 8,  // Offset(2576),  power enable polarity
  Offset(2577),   PCRE, 32, // Offset(2577),  PEG slot C reset gpio
  Offset(2581),   PCRP, 8,  // Offset(2581),  reset polarity
  Offset(2582),   PCWK, 32, // Offset(2582),  PEG slot C wake gpio
  Offset(2586),   PCRT, 8,  // Offset(2586),  PEG slot C Root Port
  Offset(2587),   LPMR, 32, // Offset(2587),  Low Power Mode required register Address
  Offset(2591),   CVFS, 8,  // Offset(2591),  To enable/disable cloverfalls(CVF)
  Offset(2592),   NCNV, 8,  // Offset(2592),  scrachpad WA
  Offset(2593),   DGOP, 32, // Offset(2593),  Dg1 OpRegion base address
  Offset(2597),   ST50, 8,  // Offset(2597),  WrdsWiFiSarTxPowerSet1Limit11
  Offset(2598),   ST51, 8,  // Offset(2598),  WrdsWiFiSarTxPowerSet1Limit12
  Offset(2599),   ST52, 8,  // Offset(2599),  WrdsWiFiSarTxPowerSet1Limit13
  Offset(2600),   ST53, 8,  // Offset(2600),  WrdsWiFiSarTxPowerSet1Limit14
  Offset(2601),   ST54, 8,  // Offset(2601),  WrdsWiFiSarTxPowerSet1Limit15
  Offset(2602),   ST55, 8,  // Offset(2602),  WrdsWiFiSarTxPowerSet1Limit16
  Offset(2603),   ST56, 8,  // Offset(2603),  WrdsWiFiSarTxPowerSet1Limit17
  Offset(2604),   ST57, 8,  // Offset(2604),  WrdsWiFiSarTxPowerSet1Limit18
  Offset(2605),   ST58, 8,  // Offset(2605),  WrdsWiFiSarTxPowerSet1Limit19
  Offset(2606),   ST59, 8,  // Offset(2606),  WrdsWiFiSarTxPowerSet1Limit20
  Offset(2607),   ST5A, 8,  // Offset(2607),  WrdsWiFiSarTxPowerSet1Limit21
  Offset(2608),   ST5B, 8,  // Offset(2608),  WrdsWiFiSarTxPowerSet1Limit22
  Offset(2609),   ST60, 8,  // Offset(2609),  EwrdWiFiSarTxPowerSet2Limit11
  Offset(2610),   ST61, 8,  // Offset(2610),  EwrdWiFiSarTxPowerSet2Limit12
  Offset(2611),   ST62, 8,  // Offset(2611),  EwrdWiFiSarTxPowerSet2Limit13
  Offset(2612),   ST63, 8,  // Offset(2612),  EwrdWiFiSarTxPowerSet2Limit14
  Offset(2613),   ST64, 8,  // Offset(2613),  EwrdWiFiSarTxPowerSet2Limit15
  Offset(2614),   ST65, 8,  // Offset(2614),  EwrdWiFiSarTxPowerSet2Limit16
  Offset(2615),   ST66, 8,  // Offset(2615),  EwrdWiFiSarTxPowerSet2Limit17
  Offset(2616),   ST67, 8,  // Offset(2616),  EwrdWiFiSarTxPowerSet2Limit18
  Offset(2617),   ST68, 8,  // Offset(2617),  EwrdWiFiSarTxPowerSet2Limit19
  Offset(2618),   ST69, 8,  // Offset(2618),  EwrdWiFiSarTxPowerSet2Limit20
  Offset(2619),   ST6A, 8,  // Offset(2619),  EwrdWiFiSarTxPowerSet2Limit21
  Offset(2620),   ST6B, 8,  // Offset(2620),  EwrdWiFiSarTxPowerSet2Limit22
  Offset(2621),   ST70, 8,  // Offset(2621),  EwrdWiFiSarTxPowerSet3Limit11
  Offset(2622),   ST71, 8,  // Offset(2622),  EwrdWiFiSarTxPowerSet3Limit12
  Offset(2623),   ST72, 8,  // Offset(2623),  EwrdWiFiSarTxPowerSet3Limit13
  Offset(2624),   ST73, 8,  // Offset(2624),  EwrdWiFiSarTxPowerSet3Limit14
  Offset(2625),   ST74, 8,  // Offset(2625),  EwrdWiFiSarTxPowerSet3Limit15
  Offset(2626),   ST75, 8,  // Offset(2626),  EwrdWiFiSarTxPowerSet3Limit16
  Offset(2627),   ST76, 8,  // Offset(2627),  EwrdWiFiSarTxPowerSet3Limit17
  Offset(2628),   ST77, 8,  // Offset(2628),  EwrdWiFiSarTxPowerSet3Limit18
  Offset(2629),   ST78, 8,  // Offset(2629),  EwrdWiFiSarTxPowerSet3Limit19
  Offset(2630),   ST79, 8,  // Offset(2630),  EwrdWiFiSarTxPowerSet3Limit20
  Offset(2631),   ST7A, 8,  // Offset(2631),  EwrdWiFiSarTxPowerSet3Limit21
  Offset(2632),   ST7B, 8,  // Offset(2632),  EwrdWiFiSarTxPowerSet3Limit22
  Offset(2633),   ST80, 8,  // Offset(2633),  EwrdWiFiSarTxPowerSet4Limit11
  Offset(2634),   ST81, 8,  // Offset(2634),  EwrdWiFiSarTxPowerSet4Limit12
  Offset(2635),   ST82, 8,  // Offset(2635),  EwrdWiFiSarTxPowerSet4Limit13
  Offset(2636),   ST83, 8,  // Offset(2636),  EwrdWiFiSarTxPowerSet4Limit14
  Offset(2637),   ST84, 8,  // Offset(2637),  EwrdWiFiSarTxPowerSet4Limit15
  Offset(2638),   ST85, 8,  // Offset(2638),  EwrdWiFiSarTxPowerSet4Limit16
  Offset(2639),   ST86, 8,  // Offset(2639),  EwrdWiFiSarTxPowerSet4Limit17
  Offset(2640),   ST87, 8,  // Offset(2640),  EwrdWiFiSarTxPowerSet4Limit18
  Offset(2641),   ST88, 8,  // Offset(2641),  EwrdWiFiSarTxPowerSet4Limit19
  Offset(2642),   ST89, 8,  // Offset(2642),  EwrdWiFiSarTxPowerSet4Limit20
  Offset(2643),   ST8A, 8,  // Offset(2643),  EwrdWiFiSarTxPowerSet4Limit21
  Offset(2644),   ST8B, 8,  // Offset(2644),  EwrdWiFiSarTxPowerSet4Limit22
  Offset(2645),   SD17, 8,  // Offset(2645),  WgdsWiFiSarDeltaGroup1PowerMax3
  Offset(2646),   SD18, 8,  // Offset(2646),  WgdsWiFiSarDeltaGroup1PowerChainA3
  Offset(2647),   SD19, 8,  // Offset(2647),  WgdsWiFiSarDeltaGroup1PowerChainB3
  Offset(2648),   SD27, 8,  // Offset(2648),  WgdsWiFiSarDeltaGroup2PowerMax3
  Offset(2649),   SD28, 8,  // Offset(2649),  WgdsWiFiSarDeltaGroup2PowerChainA3
  Offset(2650),   SD29, 8,  // Offset(2650),  WgdsWiFiSarDeltaGroup2PowerChainB3
  Offset(2651),   SD37, 8,  // Offset(2651),  WgdsWiFiSarDeltaGroup3PowerMax3
  Offset(2652),   SD38, 8,  // Offset(2652),  WgdsWiFiSarDeltaGroup3PowerChainA3
  Offset(2653),   SD39, 8,  // Offset(2653),  WgdsWiFiSarDeltaGroup3PowerChainB3
  Offset(2654),   AGA6, 8,  // Offset(2654),  Ant Gain Table Chain A 5945-6165
  Offset(2655),   AGA7, 8,  // Offset(2655),  Ant Gain Table Chain A 6165-6405
  Offset(2656),   AGA8, 8,  // Offset(2656),  Ant Gain Table Chain A 6405-6525
  Offset(2657),   AGA9, 8,  // Offset(2657),  Ant Gain Table Chain A 6525-6705
  Offset(2658),   AGAA, 8,  // Offset(2658),  Ant Gain Table Chain A 6705-6865
  Offset(2659),   AGAB, 8,  // Offset(2659),  Ant Gain Table Chain A 6865-7105
  Offset(2660),   AGB6, 8,  // Offset(2660),  Ant Gain Table Chain B 5945-6165
  Offset(2661),   AGB7, 8,  // Offset(2661),  Ant Gain Table Chain B 6165-6405
  Offset(2662),   AGB8, 8,  // Offset(2662),  Ant Gain Table Chain B 6405-6525
  Offset(2663),   AGB9, 8,  // Offset(2663),  Ant Gain Table Chain B 6525-6705
  Offset(2664),   AGBA, 8,  // Offset(2664),  Ant Gain Table Chain B 6705-6865
  Offset(2665),   AGBB, 8,  // Offset(2665),  Ant Gain Table Chain B 6865-7105
  Offset(2666),   UHBS, 32, // Offset(2666),  WifiUltraHighBandSupport
  }
