
/** @file
  pcie_0_9_0_cfg_instCommon.h

  @copyright
  INTEL CONFIDENTIAL
  Copyright 2007 - 2019 Intel Corporation. <BR>

  The source code contained or described herein and all documents related to the
  source code ("Material") are owned by Intel Corporation or its suppliers or
  licensors. Title to the Material remains with Intel Corporation or its suppliers
  and licensors. The Material may contain trade secrets and proprietary    and
  confidential information of Intel Corporation and its suppliers and licensors,
  and is protected by worldwide copyright and trade secret laws and treaty
  provisions. No part of the Material may be used, copied, reproduced, modified,
  published, uploaded, posted, transmitted, distributed, or disclosed in any way
  without Intel's prior express written permission.

  No license under any patent, copyright, trade secret or other intellectual
  property right is granted to or conferred upon you by disclosure or delivery
  of the Materials, either expressly, by implication, inducement, estoppel or
  otherwise. Any license under such intellectual property rights must be
  express and approved by Intel in writing.

  Unless otherwise agreed by Intel in writing, you may not remove or alter
  this notice or any other notice embedded in Materials by Intel or
  Intel's suppliers or licensors in any way.

  This file contains Silicon register definitions.

  This is a generated file; please do not modify it directly.

**/

#ifndef _PCH_REGS_PCIE_0_9_0_CFG_INSTCOMMON_CFG_H_
#define _PCH_REGS_PCIE_0_9_0_CFG_INSTCOMMON_CFG_H_



#define R_PCH_PCIE_CFG_VID 0x00000000
#define S_PCH_PCIE_CFG_VID 2



#define N_PCH_PCIE_CFG_VID_VID 0
#define B_PCH_PCIE_CFG_VID_VID (0xFFFF)



#define R_PCH_PCIE_CFG_DID 0x00000002
#define S_PCH_PCIE_CFG_DID 2

#define N_PCH_PCIE_CFG_DID_DID 0
#define B_PCH_PCIE_CFG_DID_DID (0xFFFF)



#define R_PCH_PCIE_CFG_PCICMD 0x00000004
#define S_PCH_PCIE_CFG_PCICMD 2

#define N_PCH_PCIE_CFG_PCICMD_IOSE 0
#define B_PCH_PCIE_CFG_PCICMD_IOSE BIT0

#define N_PCH_PCIE_CFG_PCICMD_MSE 1
#define B_PCH_PCIE_CFG_PCICMD_MSE BIT1

#define N_PCH_PCIE_CFG_PCICMD_BME 2
#define B_PCH_PCIE_CFG_PCICMD_BME BIT2



#define N_PCH_PCIE_CFG_PCICMD_SCE 3
#define B_PCH_PCIE_CFG_PCICMD_SCE BIT3



#define N_PCH_PCIE_CFG_PCICMD_MWIE 4
#define B_PCH_PCIE_CFG_PCICMD_MWIE BIT4



#define N_PCH_PCIE_CFG_PCICMD_VGA_PSE 5
#define B_PCH_PCIE_CFG_PCICMD_VGA_PSE BIT5



#define N_PCH_PCIE_CFG_PCICMD_PERE 6
#define B_PCH_PCIE_CFG_PCICMD_PERE BIT6



#define N_PCH_PCIE_CFG_PCICMD_WCC 7
#define B_PCH_PCIE_CFG_PCICMD_WCC BIT7

#define N_PCH_PCIE_CFG_PCICMD_SEE 8
#define B_PCH_PCIE_CFG_PCICMD_SEE BIT8



#define N_PCH_PCIE_CFG_PCICMD_FBE 9
#define B_PCH_PCIE_CFG_PCICMD_FBE BIT9

#define N_PCH_PCIE_CFG_PCICMD_INTXD 10
#define B_PCH_PCIE_CFG_PCICMD_INTXD BIT10



#define R_PCH_PCIE_CFG_PCISTS 0x00000006
#define S_PCH_PCIE_CFG_PCISTS 2

#define N_PCH_PCIE_CFG_PCISTS_INTS 3
#define B_PCH_PCIE_CFG_PCISTS_INTS BIT3

#define N_PCH_PCIE_CFG_PCISTS_CAPE 4
#define B_PCH_PCIE_CFG_PCISTS_CAPE BIT4



#define N_PCH_PCIE_CFG_PCISTS_C66 5
#define B_PCH_PCIE_CFG_PCISTS_C66 BIT5



#define N_PCH_PCIE_CFG_PCISTS_FBC 7
#define B_PCH_PCIE_CFG_PCISTS_FBC BIT7

#define N_PCH_PCIE_CFG_PCISTS_MDPD 8
#define B_PCH_PCIE_CFG_PCISTS_MDPD BIT8



#define N_PCH_PCIE_CFG_PCISTS_DVT 9
#define B_PCH_PCIE_CFG_PCISTS_DVT (BIT10 | BIT9)

#define N_PCH_PCIE_CFG_PCISTS_STA 11
#define B_PCH_PCIE_CFG_PCISTS_STA BIT11



#define N_PCH_PCIE_CFG_PCISTS_RTA 12
#define B_PCH_PCIE_CFG_PCISTS_RTA BIT12



#define N_PCH_PCIE_CFG_PCISTS_RMA 13
#define B_PCH_PCIE_CFG_PCISTS_RMA BIT13



#define N_PCH_PCIE_CFG_PCISTS_SSE 14
#define B_PCH_PCIE_CFG_PCISTS_SSE BIT14



#define N_PCH_PCIE_CFG_PCISTS_DPE 15
#define B_PCH_PCIE_CFG_PCISTS_DPE BIT15



#define R_PCH_PCIE_CFG_RID 0x00000008
#define S_PCH_PCIE_CFG_RID 1

#define N_PCH_PCIE_CFG_RID_RID 0
#define B_PCH_PCIE_CFG_RID_RID (0xFF)



#define R_PCH_PCIE_CFG_CCRPI 0x00000009
#define S_PCH_PCIE_CFG_CCRPI 1

#define N_PCH_PCIE_CFG_CCRPI_RLPI 0
#define B_PCH_PCIE_CFG_CCRPI_RLPI (0xFF)



#define R_PCH_PCIE_CFG_CCRSCC 0x0000000A
#define S_PCH_PCIE_CFG_CCRSCC 1

#define N_PCH_PCIE_CFG_CCRSCC_SC 0
#define B_PCH_PCIE_CFG_CCRSCC_SC (0xFF)



#define R_PCH_PCIE_CFG_CCRBCC 0x0000000B
#define S_PCH_PCIE_CFG_CCRBCC 1

#define N_PCH_PCIE_CFG_CCRBCC_BC 0
#define B_PCH_PCIE_CFG_CCRBCC_BC (0xFF)



#define R_PCH_PCIE_CFG_CLS 0x0000000C
#define S_PCH_PCIE_CFG_CLS 1



#define N_PCH_PCIE_CFG_CLS_CLS 0
#define B_PCH_PCIE_CFG_CLS_CLS (0xFF)



#define R_PCH_PCIE_CFG_PLAT 0x0000000D
#define S_PCH_PCIE_CFG_PLAT 1

#define N_PCH_PCIE_CFG_PLAT_PRIM_LAT_TIMER 0
#define B_PCH_PCIE_CFG_PLAT_PRIM_LAT_TIMER (0xFF)



#define R_PCH_PCIE_CFG_HDR 0x0000000E
#define S_PCH_PCIE_CFG_HDR 1



#define N_PCH_PCIE_CFG_HDR_HTYPE 0
#define B_PCH_PCIE_CFG_HDR_HTYPE (0x7F)



#define N_PCH_PCIE_CFG_HDR_MFD 7
#define B_PCH_PCIE_CFG_HDR_MFD BIT7



#define R_PCH_PCIE_CFG_BIST 0x0000000F
#define S_PCH_PCIE_CFG_BIST 1



#define N_PCH_PCIE_CFG_BIST_BIST_TST 0
#define B_PCH_PCIE_CFG_BIST_BIST_TST (0xFF)



#define R_PCH_PCIE_CFG_EXPPTMBAR 0x00000010
#define S_PCH_PCIE_CFG_EXPPTMBAR 8

#define N_PCH_PCIE_CFG_EXPPTMBAR_MSI 0
#define B_PCH_PCIE_CFG_EXPPTMBAR_MSI BIT0



#define N_PCH_PCIE_CFG_EXPPTMBAR_TYPE 1
#define B_PCH_PCIE_CFG_EXPPTMBAR_TYPE (BIT2 | BIT1)



#define N_PCH_PCIE_CFG_EXPPTMBAR_PREF 3
#define B_PCH_PCIE_CFG_EXPPTMBAR_PREF BIT3



#define N_PCH_PCIE_CFG_EXPPTMBAR_BADDR 17
#define B_PCH_PCIE_CFG_EXPPTMBAR_BADDR (0xFFFFFFFFFFFE0000ULL)



#define R_PCH_PCIE_CFG_PRIBUS 0x00000018
#define S_PCH_PCIE_CFG_PRIBUS 1



#define N_PCH_PCIE_CFG_PRIBUS_PBN 0
#define B_PCH_PCIE_CFG_PRIBUS_PBN (0xFF)



#define R_PCH_PCIE_CFG_SECBUS 0x00000019
#define S_PCH_PCIE_CFG_SECBUS 1



#define N_PCH_PCIE_CFG_SECBUS_SCBN 0
#define B_PCH_PCIE_CFG_SECBUS_SCBN (0xFF)



#define R_PCH_PCIE_CFG_SUBBUS 0x0000001A
#define S_PCH_PCIE_CFG_SUBBUS 1



#define N_PCH_PCIE_CFG_SUBBUS_SBBN 0
#define B_PCH_PCIE_CFG_SUBBUS_SBBN (0xFF)

#define R_PCH_PCIE_CFG_IOBASE  0x0000001C
#define S_PCH_PCIE_CFG_IOBASE 1



#define N_PCH_PCIE_CFG_IOBASE_IOBC 0
#define B_PCH_PCIE_CFG_IOBASE_IOBC (BIT3 | BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_IOBASE_IOBA 4
#define B_PCH_PCIE_CFG_IOBASE_IOBA (BIT7 | BIT6 | BIT5 | BIT4)

#define R_PCH_PCIE_CFG_IOLIMIT  0x0000001D
#define S_PCH_PCIE_CFG_IOLIMIT 1



#define N_PCH_PCIE_CFG_IOLIMIT_IOLC 0
#define B_PCH_PCIE_CFG_IOLIMIT_IOLC (BIT3 | BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_IOLIMIT_IOLA 4
#define B_PCH_PCIE_CFG_IOLIMIT_IOLA (BIT7 | BIT6 | BIT5 | BIT4)



#define R_PCH_PCIE_CFG_SECSTS 0x0000001E
#define S_PCH_PCIE_CFG_SECSTS 2



#define N_PCH_PCIE_CFG_SECSTS_C66 5
#define B_PCH_PCIE_CFG_SECSTS_C66 BIT5



#define N_PCH_PCIE_CFG_SECSTS_FBC 7
#define B_PCH_PCIE_CFG_SECSTS_FBC BIT7

#define N_PCH_PCIE_CFG_SECSTS_MDPD 8
#define B_PCH_PCIE_CFG_SECSTS_MDPD BIT8



#define N_PCH_PCIE_CFG_SECSTS_DVT 9
#define B_PCH_PCIE_CFG_SECSTS_DVT (BIT10 | BIT9)



#define N_PCH_PCIE_CFG_SECSTS_STA 11
#define B_PCH_PCIE_CFG_SECSTS_STA BIT11



#define N_PCH_PCIE_CFG_SECSTS_RTA 12
#define B_PCH_PCIE_CFG_SECSTS_RTA BIT12



#define N_PCH_PCIE_CFG_SECSTS_RMA 13
#define B_PCH_PCIE_CFG_SECSTS_RMA BIT13



#define N_PCH_PCIE_CFG_SECSTS_RSE 14
#define B_PCH_PCIE_CFG_SECSTS_RSE BIT14



#define N_PCH_PCIE_CFG_SECSTS_DPE 15
#define B_PCH_PCIE_CFG_SECSTS_DPE BIT15

#define R_PCH_PCIE_CFG_MEMBASE  0x00000020
#define S_PCH_PCIE_CFG_MEMBASE 2



#define N_PCH_PCIE_CFG_MEMBASE_MB 4
#define B_PCH_PCIE_CFG_MEMBASE_MB (0xFFF0)

#define R_PCH_PCIE_CFG_MEMLIMIT  0x00000022
#define S_PCH_PCIE_CFG_MEMLIMIT 2



#define N_PCH_PCIE_CFG_MEMLIMIT_ML 4
#define B_PCH_PCIE_CFG_MEMLIMIT_ML (0xFFF0)

#define R_PCH_PCIE_CFG_PFBASE  0x00000024
#define S_PCH_PCIE_CFG_PFBASE 2

#define N_PCH_PCIE_CFG_PFBASE_PFMCAP 0
#define B_PCH_PCIE_CFG_PFBASE_PFMCAP (BIT3 | BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_PFBASE_PMB 4
#define B_PCH_PCIE_CFG_PFBASE_PMB (0xFFF0)

#define R_PCH_PCIE_CFG_PFLIMIT  0x00000026
#define S_PCH_PCIE_CFG_PFLIMIT 2



#define N_PCH_PCIE_CFG_PFLIMIT_PMLC 0
#define B_PCH_PCIE_CFG_PFLIMIT_PMLC (BIT3 | BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_PFLIMIT_PML 4
#define B_PCH_PCIE_CFG_PFLIMIT_PML (0xFFF0)

#define R_PCH_PCIE_CFG_PFBASEU  0x00000028
#define S_PCH_PCIE_CFG_PFBASEU 4

#define N_PCH_PCIE_CFG_PFBASEU_PMBU 0
#define B_PCH_PCIE_CFG_PFBASEU_PMBU (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_PFLIMITU 0x0000002C
#define S_PCH_PCIE_CFG_PFLIMITU 4

#define N_PCH_PCIE_CFG_PFLIMITU_PMLU 0
#define B_PCH_PCIE_CFG_PFLIMITU_PMLU (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_CAPPTR 0x00000034
#define S_PCH_PCIE_CFG_CAPPTR 1



#define N_PCH_PCIE_CFG_CAPPTR_CPTR 0
#define B_PCH_PCIE_CFG_CAPPTR_CPTR (0xFF)



#define R_PCH_PCIE_CFG_INTL 0x0000003C
#define S_PCH_PCIE_CFG_INTL 1



#define N_PCH_PCIE_CFG_INTL_INTL 0
#define B_PCH_PCIE_CFG_INTL_INTL (0xFF)



#define R_PCH_PCIE_CFG_INTP 0x0000003D
#define S_PCH_PCIE_CFG_INTP 1

#define N_PCH_PCIE_CFG_INTP_INTP 0
#define B_PCH_PCIE_CFG_INTP_INTP (0xFF)



#define R_PCH_PCIE_CFG_BCTL 0x0000003E
#define S_PCH_PCIE_CFG_BCTL 2

#define N_PCH_PCIE_CFG_BCTL_PERE 0
#define B_PCH_PCIE_CFG_BCTL_PERE BIT0

#define N_PCH_PCIE_CFG_BCTL_SE 1
#define B_PCH_PCIE_CFG_BCTL_SE BIT1

#define N_PCH_PCIE_CFG_BCTL_IE 2
#define B_PCH_PCIE_CFG_BCTL_IE BIT2

#define N_PCH_PCIE_CFG_BCTL_VGAE 3
#define B_PCH_PCIE_CFG_BCTL_VGAE BIT3

#define N_PCH_PCIE_CFG_BCTL_VGA16BD 4
#define B_PCH_PCIE_CFG_BCTL_VGA16BD BIT4



#define N_PCH_PCIE_CFG_BCTL_MAM 5
#define B_PCH_PCIE_CFG_BCTL_MAM BIT5

#define N_PCH_PCIE_CFG_BCTL_SBR 6
#define B_PCH_PCIE_CFG_BCTL_SBR BIT6



#define N_PCH_PCIE_CFG_BCTL_FBE 7
#define B_PCH_PCIE_CFG_BCTL_FBE BIT7



#define N_PCH_PCIE_CFG_BCTL_PDT 8
#define B_PCH_PCIE_CFG_BCTL_PDT BIT8



#define N_PCH_PCIE_CFG_BCTL_SDT 9
#define B_PCH_PCIE_CFG_BCTL_SDT BIT9



#define N_PCH_PCIE_CFG_BCTL_DTS 10
#define B_PCH_PCIE_CFG_BCTL_DTS BIT10



#define N_PCH_PCIE_CFG_BCTL_DTSE 11
#define B_PCH_PCIE_CFG_BCTL_DTSE BIT11



#define R_PCH_PCIE_CFG_EXPCAPLST 0x00000040
#define S_PCH_PCIE_CFG_EXPCAPLST 2



#define N_PCH_PCIE_CFG_EXPCAPLST_CAPID 0
#define B_PCH_PCIE_CFG_EXPCAPLST_CAPID (0x00FF)



#define N_PCH_PCIE_CFG_EXPCAPLST_NP 8
#define B_PCH_PCIE_CFG_EXPCAPLST_NP (0xFF00)



#define R_PCH_PCIE_CFG_EXPCAP 0x00000042
#define S_PCH_PCIE_CFG_EXPCAP 2



#define N_PCH_PCIE_CFG_EXPCAP_VN 0
#define B_PCH_PCIE_CFG_EXPCAP_VN (BIT3 | BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_EXPCAP_DT 4
#define B_PCH_PCIE_CFG_EXPCAP_DT (BIT7 | BIT6 | BIT5 | BIT4)

#define N_PCH_PCIE_CFG_EXPCAP_SI 8
#define B_PCH_PCIE_CFG_EXPCAP_SI BIT8

#define N_PCH_PCIE_CFG_EXPCAP_IMN 9
#define B_PCH_PCIE_CFG_EXPCAP_IMN (0x3E00)



#define R_PCH_PCIE_CFG_DEVCAP 0x00000044
#define S_PCH_PCIE_CFG_DEVCAP 4

#define N_PCH_PCIE_CFG_DEVCAP_MPSS 0
#define B_PCH_PCIE_CFG_DEVCAP_MPSS (BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_DEVCAP_PFS 3
#define B_PCH_PCIE_CFG_DEVCAP_PFS (BIT4 | BIT3)

#define N_PCH_PCIE_CFG_DEVCAP_ETFG 5
#define B_PCH_PCIE_CFG_DEVCAP_ETFG BIT5



#define N_PCH_PCIE_CFG_DEVCAP_EPL0AL 6
#define B_PCH_PCIE_CFG_DEVCAP_EPL0AL (BIT8 | BIT7 | BIT6)



#define N_PCH_PCIE_CFG_DEVCAP_EPL1AL 9
#define B_PCH_PCIE_CFG_DEVCAP_EPL1AL (BIT11 | BIT10 | BIT9)



#define N_PCH_PCIE_CFG_DEVCAP_UNDEFINED 12
#define B_PCH_PCIE_CFG_DEVCAP_UNDEFINED (BIT14 | BIT13 | BIT12)



#define N_PCH_PCIE_CFG_DEVCAP_RBER 15
#define B_PCH_PCIE_CFG_DEVCAP_RBER BIT15

#define N_PCH_PCIE_CFG_DEVCAP_CSPLV 18
#define B_PCH_PCIE_CFG_DEVCAP_CSPLV (0x03FC0000)

#define N_PCH_PCIE_CFG_DEVCAP_CSPLS 26
#define B_PCH_PCIE_CFG_DEVCAP_CSPLS (BIT27 | BIT26)



#define R_PCH_PCIE_CFG_DEVCTL 0x00000048
#define S_PCH_PCIE_CFG_DEVCTL 2



#define N_PCH_PCIE_CFG_DEVCTL_CERE 0
#define B_PCH_PCIE_CFG_DEVCTL_CERE BIT0



#define N_PCH_PCIE_CFG_DEVCTL_NFERE 1
#define B_PCH_PCIE_CFG_DEVCTL_NFERE BIT1



#define N_PCH_PCIE_CFG_DEVCTL_FERE 2
#define B_PCH_PCIE_CFG_DEVCTL_FERE BIT2



#define N_PCH_PCIE_CFG_DEVCTL_URRE 3
#define B_PCH_PCIE_CFG_DEVCTL_URRE BIT3

#define N_PCH_PCIE_CFG_DEVCTL_ENRO 4
#define B_PCH_PCIE_CFG_DEVCTL_ENRO BIT4

#define N_PCH_PCIE_CFG_DEVCTL_MPS 5
#define B_PCH_PCIE_CFG_DEVCTL_MPS (BIT7 | BIT6 | BIT5)



#define N_PCH_PCIE_CFG_DEVCTL_ETFE 8
#define B_PCH_PCIE_CFG_DEVCTL_ETFE BIT8

#define N_PCH_PCIE_CFG_DEVCTL_PFE 9
#define B_PCH_PCIE_CFG_DEVCTL_PFE BIT9



#define N_PCH_PCIE_CFG_DEVCTL_AUXPME 10
#define B_PCH_PCIE_CFG_DEVCTL_AUXPME BIT10

#define N_PCH_PCIE_CFG_DEVCTL_ENOSNP 11
#define B_PCH_PCIE_CFG_DEVCTL_ENOSNP BIT11

#define N_PCH_PCIE_CFG_DEVCTL_MRRS 12
#define B_PCH_PCIE_CFG_DEVCTL_MRRS (BIT14 | BIT13 | BIT12)



#define R_PCH_PCIE_CFG_DEVSTS 0x0000004A
#define S_PCH_PCIE_CFG_DEVSTS 2



#define N_PCH_PCIE_CFG_DEVSTS_CED 0
#define B_PCH_PCIE_CFG_DEVSTS_CED BIT0



#define N_PCH_PCIE_CFG_DEVSTS_NFED 1
#define B_PCH_PCIE_CFG_DEVSTS_NFED BIT1



#define N_PCH_PCIE_CFG_DEVSTS_FED 2
#define B_PCH_PCIE_CFG_DEVSTS_FED BIT2



#define N_PCH_PCIE_CFG_DEVSTS_URD 3
#define B_PCH_PCIE_CFG_DEVSTS_URD BIT3



#define N_PCH_PCIE_CFG_DEVSTS_APD 4
#define B_PCH_PCIE_CFG_DEVSTS_APD BIT4

#define N_PCH_PCIE_CFG_DEVSTS_TP 5
#define B_PCH_PCIE_CFG_DEVSTS_TP BIT5



#define R_PCH_PCIE_CFG_LINKCAP 0x0000004C
#define S_PCH_PCIE_CFG_LINKCAP 4

#define N_PCH_PCIE_CFG_LINKCAP_MLS 0
#define B_PCH_PCIE_CFG_LINKCAP_MLS (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_LINKCAP_MLW 4
#define B_PCH_PCIE_CFG_LINKCAP_MLW (0x000003F0)

#define N_PCH_PCIE_CFG_LINKCAP_ASPMSUP 10
#define B_PCH_PCIE_CFG_LINKCAP_ASPMSUP (BIT11 | BIT10)

#define N_PCH_PCIE_CFG_LINKCAP_L0SEL 12
#define B_PCH_PCIE_CFG_LINKCAP_L0SEL (BIT14 | BIT13 | BIT12)

#define N_PCH_PCIE_CFG_LINKCAP_L1EL 15
#define B_PCH_PCIE_CFG_LINKCAP_L1EL (BIT17 | BIT16 | BIT15)

#define N_PCH_PCIE_CFG_LINKCAP_CPMC 18
#define B_PCH_PCIE_CFG_LINKCAP_CPMC BIT18

#define N_PCH_PCIE_CFG_LINKCAP_SLDERC 19
#define B_PCH_PCIE_CFG_LINKCAP_SLDERC BIT19

#define N_PCH_PCIE_CFG_LINKCAP_DLLERC 20
#define B_PCH_PCIE_CFG_LINKCAP_DLLERC BIT20

#define N_PCH_PCIE_CFG_LINKCAP_LBNC 21
#define B_PCH_PCIE_CFG_LINKCAP_LBNC BIT21

#define N_PCH_PCIE_CFG_LINKCAP_ASPMOPCMP 22
#define B_PCH_PCIE_CFG_LINKCAP_ASPMOPCMP BIT22

#define N_PCH_PCIE_CFG_LINKCAP_PN 24
#define B_PCH_PCIE_CFG_LINKCAP_PN (0xFF000000)



#define R_PCH_PCIE_CFG_LINKCTL 0x00000050
#define S_PCH_PCIE_CFG_LINKCTL 2

#define N_PCH_PCIE_CFG_LINKCTL_ASPMCTL 0
#define B_PCH_PCIE_CFG_LINKCTL_ASPMCTL (BIT1 | BIT0)

#define N_PCH_PCIE_CFG_LINKCTL_RCB 3
#define B_PCH_PCIE_CFG_LINKCTL_RCB BIT3

#define N_PCH_PCIE_CFG_LINKCTL_LD 4
#define B_PCH_PCIE_CFG_LINKCTL_LD BIT4

#define N_PCH_PCIE_CFG_LINKCTL_RL 5
#define B_PCH_PCIE_CFG_LINKCTL_RL BIT5

#define N_PCH_PCIE_CFG_LINKCTL_CCCFG 6
#define B_PCH_PCIE_CFG_LINKCTL_CCCFG BIT6

#define N_PCH_PCIE_CFG_LINKCTL_ES 7
#define B_PCH_PCIE_CFG_LINKCTL_ES BIT7

#define N_PCH_PCIE_CFG_LINKCTL_ECPM 8
#define B_PCH_PCIE_CFG_LINKCTL_ECPM BIT8

#define N_PCH_PCIE_CFG_LINKCTL_HAWD 9
#define B_PCH_PCIE_CFG_LINKCTL_HAWD BIT9

#define N_PCH_PCIE_CFG_LINKCTL_LBMIE 10
#define B_PCH_PCIE_CFG_LINKCTL_LBMIE BIT10

#define N_PCH_PCIE_CFG_LINKCTL_LABIE 11
#define B_PCH_PCIE_CFG_LINKCTL_LABIE BIT11



#define R_PCH_PCIE_CFG_LINKSTS 0x00000052
#define S_PCH_PCIE_CFG_LINKSTS 2

#define N_PCH_PCIE_CFG_LINKSTS_CLS 0
#define B_PCH_PCIE_CFG_LINKSTS_CLS (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_LINKSTS_NLW 4
#define B_PCH_PCIE_CFG_LINKSTS_NLW (0x03F0)



#define N_PCH_PCIE_CFG_LINKSTS_UNDEFINED 10
#define B_PCH_PCIE_CFG_LINKSTS_UNDEFINED BIT10



#define N_PCH_PCIE_CFG_LINKSTS_LT 11
#define B_PCH_PCIE_CFG_LINKSTS_LT BIT11

#define N_PCH_PCIE_CFG_LINKSTS_SCC 12
#define B_PCH_PCIE_CFG_LINKSTS_SCC BIT12



#define N_PCH_PCIE_CFG_LINKSTS_DLLLA 13
#define B_PCH_PCIE_CFG_LINKSTS_DLLLA BIT13

#define N_PCH_PCIE_CFG_LINKSTS_LBMS 14
#define B_PCH_PCIE_CFG_LINKSTS_LBMS BIT14

#define N_PCH_PCIE_CFG_LINKSTS_LABS 15
#define B_PCH_PCIE_CFG_LINKSTS_LABS BIT15



#define R_PCH_PCIE_CFG_SLOTCAP 0x00000054
#define S_PCH_PCIE_CFG_SLOTCAP 4

#define N_PCH_PCIE_CFG_SLOTCAP_ABP 0
#define B_PCH_PCIE_CFG_SLOTCAP_ABP BIT0

#define N_PCH_PCIE_CFG_SLOTCAP_PCP 1
#define B_PCH_PCIE_CFG_SLOTCAP_PCP BIT1

#define N_PCH_PCIE_CFG_SLOTCAP_MRLSP 2
#define B_PCH_PCIE_CFG_SLOTCAP_MRLSP BIT2

#define N_PCH_PCIE_CFG_SLOTCAP_AIP 3
#define B_PCH_PCIE_CFG_SLOTCAP_AIP BIT3

#define N_PCH_PCIE_CFG_SLOTCAP_PIP 4
#define B_PCH_PCIE_CFG_SLOTCAP_PIP BIT4

#define N_PCH_PCIE_CFG_SLOTCAP_HPS 5
#define B_PCH_PCIE_CFG_SLOTCAP_HPS BIT5

#define N_PCH_PCIE_CFG_SLOTCAP_HPC 6
#define B_PCH_PCIE_CFG_SLOTCAP_HPC BIT6

#define N_PCH_PCIE_CFG_SLOTCAP_SPLV 7
#define B_PCH_PCIE_CFG_SLOTCAP_SPLV (0x00007F80)

#define N_PCH_PCIE_CFG_SLOTCAP_SPLS 15
#define B_PCH_PCIE_CFG_SLOTCAP_SPLS (BIT16 | BIT15)



#define N_PCH_PCIE_CFG_SLOTCAP_EMIP 17
#define B_PCH_PCIE_CFG_SLOTCAP_EMIP BIT17

#define N_PCH_PCIE_CFG_SLOTCAP_NCCS 18
#define B_PCH_PCIE_CFG_SLOTCAP_NCCS BIT18



#define N_PCH_PCIE_CFG_SLOTCAP_PSN 19
#define B_PCH_PCIE_CFG_SLOTCAP_PSN (0xFFF80000)



#define R_PCH_PCIE_CFG_SLOTCTL 0x00000058
#define S_PCH_PCIE_CFG_SLOTCTL 2

#define N_PCH_PCIE_CFG_SLOTCTL_ABPE 0
#define B_PCH_PCIE_CFG_SLOTCTL_ABPE BIT0

#define N_PCH_PCIE_CFG_SLOTCTL_PFDIE 1
#define B_PCH_PCIE_CFG_SLOTCTL_PFDIE BIT1

#define N_PCH_PCIE_CFG_SLOTCTL_MSCIE 2
#define B_PCH_PCIE_CFG_SLOTCTL_MSCIE BIT2

#define N_PCH_PCIE_CFG_SLOTCTL_PDCIE 3
#define B_PCH_PCIE_CFG_SLOTCTL_PDCIE BIT3

#define N_PCH_PCIE_CFG_SLOTCTL_CCIE 4
#define B_PCH_PCIE_CFG_SLOTCTL_CCIE BIT4

#define N_PCH_PCIE_CFG_SLOTCTL_HPIE 5
#define B_PCH_PCIE_CFG_SLOTCTL_HPIE BIT5

#define N_PCH_PCIE_CFG_SLOTCTL_AIC 6
#define B_PCH_PCIE_CFG_SLOTCTL_AIC (BIT7 | BIT6)

#define N_PCH_PCIE_CFG_SLOTCTL_PIC 8
#define B_PCH_PCIE_CFG_SLOTCTL_PIC (BIT9 | BIT8)

#define N_PCH_PCIE_CFG_SLOTCTL_PCC 10
#define B_PCH_PCIE_CFG_SLOTCTL_PCC BIT10

#define N_PCH_PCIE_CFG_SLOTCTL_EIC 11
#define B_PCH_PCIE_CFG_SLOTCTL_EIC BIT11



#define N_PCH_PCIE_CFG_SLOTCTL_DLLSCE 12
#define B_PCH_PCIE_CFG_SLOTCTL_DLLSCE BIT12



#define N_PCH_PCIE_CFG_SLOTCTL_ASPLD 13
#define B_PCH_PCIE_CFG_SLOTCTL_ASPLD BIT13



#define R_PCH_PCIE_CFG_SLOTSTS 0x0000005A
#define S_PCH_PCIE_CFG_SLOTSTS 2

#define N_PCH_PCIE_CFG_SLOTSTS_ABP 0
#define B_PCH_PCIE_CFG_SLOTSTS_ABP BIT0



#define N_PCH_PCIE_CFG_SLOTSTS_PFD 1
#define B_PCH_PCIE_CFG_SLOTSTS_PFD BIT1



#define N_PCH_PCIE_CFG_SLOTSTS_MRLSC 2
#define B_PCH_PCIE_CFG_SLOTSTS_MRLSC BIT2

#define N_PCH_PCIE_CFG_SLOTSTS_PDCS 3
#define B_PCH_PCIE_CFG_SLOTSTS_PDCS BIT3

#define N_PCH_PCIE_CFG_SLOTSTS_CCS 4
#define B_PCH_PCIE_CFG_SLOTSTS_CCS BIT4

#define N_PCH_PCIE_CFG_SLOTSTS_MRLSS 5
#define B_PCH_PCIE_CFG_SLOTSTS_MRLSS BIT5

#define N_PCH_PCIE_CFG_SLOTSTS_PDS 6
#define B_PCH_PCIE_CFG_SLOTSTS_PDS BIT6

#define N_PCH_PCIE_CFG_SLOTSTS_ELS 7
#define B_PCH_PCIE_CFG_SLOTSTS_ELS BIT7

#define N_PCH_PCIE_CFG_SLOTSTS_DLLSCS 8
#define B_PCH_PCIE_CFG_SLOTSTS_DLLSCS BIT8



#define R_PCH_PCIE_CFG_ROOTCTL 0x0000005C
#define S_PCH_PCIE_CFG_ROOTCTL 2

#define N_PCH_PCIE_CFG_ROOTCTL_SECEE 0
#define B_PCH_PCIE_CFG_ROOTCTL_SECEE BIT0

#define N_PCH_PCIE_CFG_ROOTCTL_SENFEE 1
#define B_PCH_PCIE_CFG_ROOTCTL_SENFEE BIT1

#define N_PCH_PCIE_CFG_ROOTCTL_SEFEE 2
#define B_PCH_PCIE_CFG_ROOTCTL_SEFEE BIT2

#define N_PCH_PCIE_CFG_ROOTCTL_PMEIE 3
#define B_PCH_PCIE_CFG_ROOTCTL_PMEIE BIT3

#define N_PCH_PCIE_CFG_ROOTCTL_CRSSVE 4
#define B_PCH_PCIE_CFG_ROOTCTL_CRSSVE BIT4



#define R_PCH_PCIE_CFG_ROOTCAP 0x0000005E
#define S_PCH_PCIE_CFG_ROOTCAP 2

#define N_PCH_PCIE_CFG_ROOTCAP_CRSSV 0
#define B_PCH_PCIE_CFG_ROOTCAP_CRSSV BIT0



#define R_PCH_PCIE_CFG_ROOTSTS 0x00000060
#define S_PCH_PCIE_CFG_ROOTSTS 4



#define N_PCH_PCIE_CFG_ROOTSTS_PMERID 0
#define B_PCH_PCIE_CFG_ROOTSTS_PMERID (0x0000FFFF)

#define N_PCH_PCIE_CFG_ROOTSTS_PMESTS 16
#define B_PCH_PCIE_CFG_ROOTSTS_PMESTS BIT16

#define N_PCH_PCIE_CFG_ROOTSTS_PMEPEND 17
#define B_PCH_PCIE_CFG_ROOTSTS_PMEPEND BIT17



#define R_PCH_PCIE_CFG_DEVCAP2 0x00000064
#define S_PCH_PCIE_CFG_DEVCAP2 4

#define N_PCH_PCIE_CFG_DEVCAP2_CTRS 0
#define B_PCH_PCIE_CFG_DEVCAP2_CTRS (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_DEVCAP2_CTDS 4
#define B_PCH_PCIE_CFG_DEVCAP2_CTDS BIT4

#define N_PCH_PCIE_CFG_DEVCAP2_ARI 5
#define B_PCH_PCIE_CFG_DEVCAP2_ARI BIT5

#define N_PCH_PCIE_CFG_DEVCAP2_ARS 6
#define B_PCH_PCIE_CFG_DEVCAP2_ARS BIT6

#define N_PCH_PCIE_CFG_DEVCAP2_AD32ACS 7
#define B_PCH_PCIE_CFG_DEVCAP2_AD32ACS BIT7

#define N_PCH_PCIE_CFG_DEVCAP2_AD64ACS 8
#define B_PCH_PCIE_CFG_DEVCAP2_AD64ACS BIT8

#define N_PCH_PCIE_CFG_DEVCAP2_AD128ACS 9
#define B_PCH_PCIE_CFG_DEVCAP2_AD128ACS BIT9

#define N_PCH_PCIE_CFG_DEVCAP2_NROEPRPASS 10
#define B_PCH_PCIE_CFG_DEVCAP2_NROEPRPASS BIT10

#define N_PCH_PCIE_CFG_DEVCAP2_LTRMS 11
#define B_PCH_PCIE_CFG_DEVCAP2_LTRMS BIT11

#define N_PCH_PCIE_CFG_DEVCAP2_TPHCS 12
#define B_PCH_PCIE_CFG_DEVCAP2_TPHCS (BIT13 | BIT12)

#define N_PCH_PCIE_CFG_DEVCAP2_OBFFS 18
#define B_PCH_PCIE_CFG_DEVCAP2_OBFFS (BIT19 | BIT18)

#define N_PCH_PCIE_CFG_DEVCAP2_EXFMTFS 20
#define B_PCH_PCIE_CFG_DEVCAP2_EXFMTFS BIT20

#define N_PCH_PCIE_CFG_DEVCAP2_E2ETLPS 21
#define B_PCH_PCIE_CFG_DEVCAP2_E2ETLPS BIT21

#define N_PCH_PCIE_CFG_DEVCAP2_MAXE2ETLP 22
#define B_PCH_PCIE_CFG_DEVCAP2_MAXE2ETLP (BIT23 | BIT22)



#define R_PCH_PCIE_CFG_DEVCTL2 0x00000068
#define S_PCH_PCIE_CFG_DEVCTL2 2

#define N_PCH_PCIE_CFG_DEVCTL2_CTV 0
#define B_PCH_PCIE_CFG_DEVCTL2_CTV (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_DEVCTL2_CTD 4
#define B_PCH_PCIE_CFG_DEVCTL2_CTD BIT4

#define N_PCH_PCIE_CFG_DEVCTL2_ARIE 5
#define B_PCH_PCIE_CFG_DEVCTL2_ARIE BIT5



#define N_PCH_PCIE_CFG_DEVCTL2_ARE 6
#define B_PCH_PCIE_CFG_DEVCTL2_ARE BIT6

#define N_PCH_PCIE_CFG_DEVCTL2_AEB 7
#define B_PCH_PCIE_CFG_DEVCTL2_AEB BIT7

#define N_PCH_PCIE_CFG_DEVCTL2_IDORE 8
#define B_PCH_PCIE_CFG_DEVCTL2_IDORE BIT8

#define N_PCH_PCIE_CFG_DEVCTL2_IDOCE 9
#define B_PCH_PCIE_CFG_DEVCTL2_IDOCE BIT9

#define N_PCH_PCIE_CFG_DEVCTL2_LTRME 10
#define B_PCH_PCIE_CFG_DEVCTL2_LTRME BIT10

#define N_PCH_PCIE_CFG_DEVCTL2_OBFFE 13
#define B_PCH_PCIE_CFG_DEVCTL2_OBFFE (BIT14 | BIT13)

#define N_PCH_PCIE_CFG_DEVCTL2_E2ETLPBLK 15
#define B_PCH_PCIE_CFG_DEVCTL2_E2ETLPBLK BIT15



#define R_PCH_PCIE_CFG_LINKCAP2 0x0000006C
#define S_PCH_PCIE_CFG_LINKCAP2 4

#define N_PCH_PCIE_CFG_LINKCAP2_SLNKSPV 1
#define B_PCH_PCIE_CFG_LINKCAP2_SLNKSPV (0x000000FE)

#define N_PCH_PCIE_CFG_LINKCAP2_CLS 8
#define B_PCH_PCIE_CFG_LINKCAP2_CLS BIT8

#define N_PCH_PCIE_CFG_LINKCAP2_LSKPOSGSSV 9
#define B_PCH_PCIE_CFG_LINKCAP2_LSKPOSGSSV (0x0000FE00)

#define N_PCH_PCIE_CFG_LINKCAP2_LSKPOSRSSV 16
#define B_PCH_PCIE_CFG_LINKCAP2_LSKPOSRSSV (0x007F0000)



#define R_PCH_PCIE_CFG_LINKCTL2 0x00000070
#define S_PCH_PCIE_CFG_LINKCTL2 2

#define N_PCH_PCIE_CFG_LINKCTL2_TLS 0
#define B_PCH_PCIE_CFG_LINKCTL2_TLS (BIT3 | BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_LINKCTL2_EC 4
#define B_PCH_PCIE_CFG_LINKCTL2_EC BIT4



#define N_PCH_PCIE_CFG_LINKCTL2_HASD 5
#define B_PCH_PCIE_CFG_LINKCTL2_HASD BIT5

#define N_PCH_PCIE_CFG_LINKCTL2_SD 6
#define B_PCH_PCIE_CFG_LINKCTL2_SD BIT6

#define N_PCH_PCIE_CFG_LINKCTL2_TM 7
#define B_PCH_PCIE_CFG_LINKCTL2_TM (BIT9 | BIT8 | BIT7)

#define N_PCH_PCIE_CFG_LINKCTL2_EMC 10
#define B_PCH_PCIE_CFG_LINKCTL2_EMC BIT10



#define N_PCH_PCIE_CFG_LINKCTL2_CSOS 11
#define B_PCH_PCIE_CFG_LINKCTL2_CSOS BIT11

#define N_PCH_PCIE_CFG_LINKCTL2_CD 12
#define B_PCH_PCIE_CFG_LINKCTL2_CD (BIT15 | BIT14 | BIT13 | BIT12)



#define R_PCH_PCIE_CFG_LINKSTS2 0x00000072
#define S_PCH_PCIE_CFG_LINKSTS2 2

#define N_PCH_PCIE_CFG_LINKSTS2_CDL 0
#define B_PCH_PCIE_CFG_LINKSTS2_CDL BIT0



#define N_PCH_PCIE_CFG_LINKSTS2_EQCMPLT 1
#define B_PCH_PCIE_CFG_LINKSTS2_EQCMPLT BIT1



#define N_PCH_PCIE_CFG_LINKSTS2_EQPH1SUCC 2
#define B_PCH_PCIE_CFG_LINKSTS2_EQPH1SUCC BIT2



#define N_PCH_PCIE_CFG_LINKSTS2_EQPH2SUCC 3
#define B_PCH_PCIE_CFG_LINKSTS2_EQPH2SUCC BIT3



#define N_PCH_PCIE_CFG_LINKSTS2_EQPH3SUCC 4
#define B_PCH_PCIE_CFG_LINKSTS2_EQPH3SUCC BIT4



#define N_PCH_PCIE_CFG_LINKSTS2_LNKEQREQ 5
#define B_PCH_PCIE_CFG_LINKSTS2_LNKEQREQ BIT5



#define R_PCH_PCIE_CFG_PMCAPLST 0x00000080
#define S_PCH_PCIE_CFG_PMCAPLST 2



#define N_PCH_PCIE_CFG_PMCAPLST_CAPABILITYID 0
#define B_PCH_PCIE_CFG_PMCAPLST_CAPABILITYID (0x00FF)



#define N_PCH_PCIE_CFG_PMCAPLST_NEXTPOINTER 8
#define B_PCH_PCIE_CFG_PMCAPLST_NEXTPOINTER (0xFF00)



#define R_PCH_PCIE_CFG_PMCAP 0x00000082
#define S_PCH_PCIE_CFG_PMCAP 2



#define N_PCH_PCIE_CFG_PMCAP_VER 0
#define B_PCH_PCIE_CFG_PMCAP_VER (BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_PMCAP_PMECLK 3
#define B_PCH_PCIE_CFG_PMCAP_PMECLK BIT3

#define N_PCH_PCIE_CFG_PMCAP_DSI 5
#define B_PCH_PCIE_CFG_PMCAP_DSI BIT5



#define N_PCH_PCIE_CFG_PMCAP_AC 6
#define B_PCH_PCIE_CFG_PMCAP_AC (BIT8 | BIT7 | BIT6)



#define N_PCH_PCIE_CFG_PMCAP_D1S 9
#define B_PCH_PCIE_CFG_PMCAP_D1S BIT9



#define N_PCH_PCIE_CFG_PMCAP_D2S 10
#define B_PCH_PCIE_CFG_PMCAP_D2S BIT10

#define N_PCH_PCIE_CFG_PMCAP_PMES 11
#define B_PCH_PCIE_CFG_PMCAP_PMES (0xF800)



#define R_PCH_PCIE_CFG_PMCSR 0x00000084
#define S_PCH_PCIE_CFG_PMCSR 2

#define N_PCH_PCIE_CFG_PMCSR_PS 0
#define B_PCH_PCIE_CFG_PMCSR_PS (BIT1 | BIT0)

#define N_PCH_PCIE_CFG_PMCSR_NSR 3
#define B_PCH_PCIE_CFG_PMCSR_NSR BIT3



#define N_PCH_PCIE_CFG_PMCSR_PMEEN 8
#define B_PCH_PCIE_CFG_PMCSR_PMEEN BIT8



#define N_PCH_PCIE_CFG_PMCSR_DS 9
#define B_PCH_PCIE_CFG_PMCSR_DS (BIT12 | BIT11 | BIT10 | BIT9)



#define N_PCH_PCIE_CFG_PMCSR_DC 13
#define B_PCH_PCIE_CFG_PMCSR_DC (BIT14 | BIT13)



#define N_PCH_PCIE_CFG_PMCSR_PMESTS 15
#define B_PCH_PCIE_CFG_PMCSR_PMESTS BIT15



#define R_PCH_PCIE_CFG_PMBSE 0x00000086
#define S_PCH_PCIE_CFG_PMBSE 1

#define N_PCH_PCIE_CFG_PMBSE_B23EN 6
#define B_PCH_PCIE_CFG_PMBSE_B23EN BIT6



#define N_PCH_PCIE_CFG_PMBSE_BPCC_EN 7
#define B_PCH_PCIE_CFG_PMBSE_BPCC_EN BIT7



#define R_PCH_PCIE_CFG_SSCAPLST 0x00000088
#define S_PCH_PCIE_CFG_SSCAPLST 2



#define N_PCH_PCIE_CFG_SSCAPLST_CAPID 0
#define B_PCH_PCIE_CFG_SSCAPLST_CAPID (0x00FF)



#define N_PCH_PCIE_CFG_SSCAPLST_NP 8
#define B_PCH_PCIE_CFG_SSCAPLST_NP (0xFF00)



#define R_PCH_PCIE_CFG_SSVID 0x0000008C
#define S_PCH_PCIE_CFG_SSVID 2

#define N_PCH_PCIE_CFG_SSVID_SSVID 0
#define B_PCH_PCIE_CFG_SSVID_SSVID (0xFFFF)



#define R_PCH_PCIE_CFG_SSID 0x0000008E
#define S_PCH_PCIE_CFG_SSID 2

#define N_PCH_PCIE_CFG_SSID_SSID 0
#define B_PCH_PCIE_CFG_SSID_SSID (0xFFFF)



#define R_PCH_PCIE_CFG_MSICAPLST 0x00000090
#define S_PCH_PCIE_CFG_MSICAPLST 2



#define N_PCH_PCIE_CFG_MSICAPLST_CAPID 0
#define B_PCH_PCIE_CFG_MSICAPLST_CAPID (0x00FF)

#define N_PCH_PCIE_CFG_MSICAPLST_NP 8
#define B_PCH_PCIE_CFG_MSICAPLST_NP (0xFF00)



#define R_PCH_PCIE_CFG_MSICTL 0x00000092
#define S_PCH_PCIE_CFG_MSICTL 2



#define N_PCH_PCIE_CFG_MSICTL_MSIE 0
#define B_PCH_PCIE_CFG_MSICTL_MSIE BIT0



#define N_PCH_PCIE_CFG_MSICTL_MMC 1
#define B_PCH_PCIE_CFG_MSICTL_MMC (BIT3 | BIT2 | BIT1)



#define N_PCH_PCIE_CFG_MSICTL_MMEN 4
#define B_PCH_PCIE_CFG_MSICTL_MMEN (BIT6 | BIT5 | BIT4)



#define N_PCH_PCIE_CFG_MSICTL_AD64C 7
#define B_PCH_PCIE_CFG_MSICTL_AD64C BIT7

#define N_PCH_PCIE_CFG_MSICTL_PVM 8
#define B_PCH_PCIE_CFG_MSICTL_PVM BIT8



#define R_PCH_PCIE_CFG_MSIADDR 0x00000094
#define S_PCH_PCIE_CFG_MSIADDR 4



#define N_PCH_PCIE_CFG_MSIADDR_ADDRESS 2
#define B_PCH_PCIE_CFG_MSIADDR_ADDRESS (0xFFFFFFFC)



#define R_PCH_PCIE_CFG_MSIDATA 0x00000098
#define S_PCH_PCIE_CFG_MSIDATA 4

#define N_PCH_PCIE_CFG_MSIDATA_IV 0
#define B_PCH_PCIE_CFG_MSIDATA_IV (0x000000FF)

#define N_PCH_PCIE_CFG_MSIDATA_DM 8
#define B_PCH_PCIE_CFG_MSIDATA_DM (BIT11 | BIT10 | BIT9 | BIT8)



#define N_PCH_PCIE_CFG_MSIDATA_FUTURE 12
#define B_PCH_PCIE_CFG_MSIDATA_FUTURE (BIT13 | BIT12)

#define N_PCH_PCIE_CFG_MSIDATA_LVL 14
#define B_PCH_PCIE_CFG_MSIDATA_LVL BIT14

#define N_PCH_PCIE_CFG_MSIDATA_TM 15
#define B_PCH_PCIE_CFG_MSIDATA_TM BIT15



#define R_PCH_PCIE_CFG_MSIMSK 0x0000009C
#define S_PCH_PCIE_CFG_MSIMSK 4

#define N_PCH_PCIE_CFG_MSIMSK_MSKB 0
#define B_PCH_PCIE_CFG_MSIMSK_MSKB BIT0



#define R_PCH_PCIE_CFG_MSIPENDING 0x000000A0
#define S_PCH_PCIE_CFG_MSIPENDING 4

#define N_PCH_PCIE_CFG_MSIPENDING_PB 0
#define B_PCH_PCIE_CFG_MSIPENDING_PB BIT0



#define R_PCH_PCIE_CFG_RPPMCSR 0x000000A8
#define S_PCH_PCIE_CFG_RPPMCSR 4

#define N_PCH_PCIE_CFG_RPPMCSR_L23RDYER 0
#define B_PCH_PCIE_CFG_RPPMCSR_L23RDYER BIT0

#define N_PCH_PCIE_CFG_RPPMCSR_L23RDY2DT 1
#define B_PCH_PCIE_CFG_RPPMCSR_L23RDY2DT BIT1

#define N_PCH_PCIE_CFG_RPPMCSR_PME_TO_ACK_TO 2
#define B_PCH_PCIE_CFG_RPPMCSR_PME_TO_ACK_TO (BIT3 | BIT2)



#define N_PCH_PCIE_CFG_RPPMCSR_PME_TO_ACK_TOP 4
#define B_PCH_PCIE_CFG_RPPMCSR_PME_TO_ACK_TOP BIT4

#define N_PCH_PCIE_CFG_RPPMCSR_MDLSWPR 5
#define B_PCH_PCIE_CFG_RPPMCSR_MDLSWPR BIT5

#define N_PCH_PCIE_CFG_RPPMCSR_MDLSWPGEA 6
#define B_PCH_PCIE_CFG_RPPMCSR_MDLSWPGEA BIT6

#define N_PCH_PCIE_CFG_RPPMCSR_MDLSWPGXA 7
#define B_PCH_PCIE_CFG_RPPMCSR_MDLSWPGXA BIT7

#define N_PCH_PCIE_CFG_RPPMCSR_MCWPGS 8
#define B_PCH_PCIE_CFG_RPPMCSR_MCWPGS BIT8

#define R_PCH_PCIE_CFG_AERPR  0x000000AC
#define S_PCH_PCIE_CFG_AERPR 4

#define N_PCH_PCIE_CFG_AERPR_IPTLPFE 0
#define B_PCH_PCIE_CFG_AERPR_IPTLPFE BIT0

#define N_PCH_PCIE_CFG_AERPR_TUNCE 1
#define B_PCH_PCIE_CFG_AERPR_TUNCE BIT1



#define R_PCH_PCIE_CFG_PMCSRS 0x000000B0
#define S_PCH_PCIE_CFG_PMCSRS 2



#define N_PCH_PCIE_CFG_PMCSRS_PMESTS 15
#define B_PCH_PCIE_CFG_PMCSRS_PMESTS BIT15



#define R_PCH_PCIE_CFG_PPBIFCTL 0x000000C0
#define S_PCH_PCIE_CFG_PPBIFCTL 4

#define N_PCH_PCIE_CFG_PPBIFCTL_BIFCTL0 0
#define B_PCH_PCIE_CFG_PPBIFCTL_BIFCTL0 (BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_PPBIFCTL_CL 31
#define B_PCH_PCIE_CFG_PPBIFCTL_CL BIT31



#define R_PCH_PCIE_CFG_SMICSR 0x000000C8
#define S_PCH_PCIE_CFG_SMICSR 4



#define N_PCH_PCIE_CFG_SMICSR_PMSMIE 0
#define B_PCH_PCIE_CFG_SMICSR_PMSMIE BIT0



#define N_PCH_PCIE_CFG_SMICSR_HPSMIE 1
#define B_PCH_PCIE_CFG_SMICSR_HPSMIE BIT1



#define N_PCH_PCIE_CFG_SMICSR_PMSMISTS 16
#define B_PCH_PCIE_CFG_SMICSR_PMSMISTS BIT16



#define N_PCH_PCIE_CFG_SMICSR_HPSMISTS 17
#define B_PCH_PCIE_CFG_SMICSR_HPSMISTS BIT17



#define N_PCH_PCIE_CFG_SMICSR_HPLSCSMISTS 18
#define B_PCH_PCIE_CFG_SMICSR_HPLSCSMISTS BIT18



#define R_PCH_PCIE_CFG_SCICSR 0x000000CC
#define S_PCH_PCIE_CFG_SCICSR 4



#define N_PCH_PCIE_CFG_SCICSR_PMSCIE 0
#define B_PCH_PCIE_CFG_SCICSR_PMSCIE BIT0



#define N_PCH_PCIE_CFG_SCICSR_HPSCIE 1
#define B_PCH_PCIE_CFG_SCICSR_HPSCIE BIT1



#define N_PCH_PCIE_CFG_SCICSR_PMSCISTS 16
#define B_PCH_PCIE_CFG_SCICSR_PMSCISTS BIT16



#define N_PCH_PCIE_CFG_SCICSR_HPSCISTS 17
#define B_PCH_PCIE_CFG_SCICSR_HPSCISTS BIT17



#define N_PCH_PCIE_CFG_SCICSR_HPLSCSCISTS 18
#define B_PCH_PCIE_CFG_SCICSR_HPLSCSCISTS BIT18



#define R_PCH_PCIE_CFG_SSCTL 0x000000D0
#define S_PCH_PCIE_CFG_SSCTL 2

#define N_PCH_PCIE_CFG_SSCTL_SSEN 0
#define B_PCH_PCIE_CFG_SSCTL_SSEN BIT0

#define N_PCH_PCIE_CFG_SSCTL_SSLTOP 1
#define B_PCH_PCIE_CFG_SSCTL_SSLTOP BIT1



#define N_PCH_PCIE_CFG_SSCTL_SSES 8
#define B_PCH_PCIE_CFG_SSCTL_SSES BIT8



#define R_PCH_PCIE_CFG_EXPPTMBARCTL 0x000000D2
#define S_PCH_PCIE_CFG_EXPPTMBARCTL 2



#define N_PCH_PCIE_CFG_EXPPTMBARCTL_D1STPAGE 0
#define B_PCH_PCIE_CFG_EXPPTMBARCTL_D1STPAGE BIT0



#define N_PCH_PCIE_CFG_EXPPTMBARCTL_D2NDPAGE 1
#define B_PCH_PCIE_CFG_EXPPTMBARCTL_D2NDPAGE BIT1



#define N_PCH_PCIE_CFG_EXPPTMBARCTL_D3RDPAGE 2
#define B_PCH_PCIE_CFG_EXPPTMBARCTL_D3RDPAGE BIT2



#define N_PCH_PCIE_CFG_EXPPTMBARCTL_D4THPAGE 3
#define B_PCH_PCIE_CFG_EXPPTMBARCTL_D4THPAGE BIT3



#define N_PCH_PCIE_CFG_EXPPTMBARCTL_DMBARMPHY 8
#define B_PCH_PCIE_CFG_EXPPTMBARCTL_DMBARMPHY BIT8



#define R_PCH_PCIE_CFG_PPD0 0x000000D4
#define S_PCH_PCIE_CFG_PPD0 4



#define N_PCH_PCIE_CFG_PPD0_CLRTRNENONLNKDN 0
#define B_PCH_PCIE_CFG_PPD0_CLRTRNENONLNKDN BIT0

#define N_PCH_PCIE_CFG_PPD0_ILINKTRN0 3
#define B_PCH_PCIE_CFG_PPD0_ILINKTRN0 BIT3

#define N_PCH_PCIE_CFG_PPD0_NPD 8
#define B_PCH_PCIE_CFG_PPD0_NPD (BIT9 | BIT8)

#define N_PCH_PCIE_CFG_PPD0_CRE 13
#define B_PCH_PCIE_CFG_PPD0_CRE BIT13

#define N_PCH_PCIE_CFG_PPD0_CL 31
#define B_PCH_PCIE_CFG_PPD0_CL BIT31



#define R_PCH_PCIE_CFG_PBTXNCTL 0x000000D8
#define S_PCH_PCIE_CFG_PBTXNCTL 4

#define N_PCH_PCIE_CFG_PBTXNCTL_P8XDE 0
#define B_PCH_PCIE_CFG_PBTXNCTL_P8XDE BIT0

#define N_PCH_PCIE_CFG_PBTXNCTL_RECO 1
#define B_PCH_PCIE_CFG_PBTXNCTL_RECO (0x1FFFFFFE)

#define N_PCH_PCIE_CFG_PBTXNCTL_GPEE 29
#define B_PCH_PCIE_CFG_PBTXNCTL_GPEE BIT29



#define N_PCH_PCIE_CFG_PBTXNCTL_DEOIM 30
#define B_PCH_PCIE_CFG_PBTXNCTL_DEOIM BIT30

#define N_PCH_PCIE_CFG_PBTXNCTL_CL 31
#define B_PCH_PCIE_CFG_PBTXNCTL_CL BIT31



#define R_PCH_PCIE_CFG_VPPCSR 0x000000DC
#define S_PCH_PCIE_CFG_VPPCSR 4

#define N_PCH_PCIE_CFG_VPPCSR_VPPIO 0
#define B_PCH_PCIE_CFG_VPPCSR_VPPIO (0x000000FF)



#define N_PCH_PCIE_CFG_VPPCSR_VPPCFG 8
#define B_PCH_PCIE_CFG_VPPCSR_VPPCFG (0x0000FF00)



#define N_PCH_PCIE_CFG_VPPCSR_IOE 16
#define B_PCH_PCIE_CFG_VPPCSR_IOE BIT16



#define N_PCH_PCIE_CFG_VPPCSR_UNDEFINED 17
#define B_PCH_PCIE_CFG_VPPCSR_UNDEFINED (0x00FE0000)

#define N_PCH_PCIE_CFG_VPPCSR_HPFF 24
#define B_PCH_PCIE_CFG_VPPCSR_HPFF BIT24

#define N_PCH_PCIE_CFG_VPPCSR_VPPE 25
#define B_PCH_PCIE_CFG_VPPCSR_VPPE BIT25

#define N_PCH_PCIE_CFG_VPPCSR_VPPN 26
#define B_PCH_PCIE_CFG_VPPCSR_VPPN (BIT29 | BIT28 | BIT27 | BIT26)

#define N_PCH_PCIE_CFG_VPPCSR_VPPMO 30
#define B_PCH_PCIE_CFG_VPPCSR_VPPMO (BIT31 | BIT30)



#define R_PCH_PCIE_CFG_VPPCSR1 0x000000E0
#define S_PCH_PCIE_CFG_VPPCSR1 4



#define N_PCH_PCIE_CFG_VPPCSR1_VPPIMME 0
#define B_PCH_PCIE_CFG_VPPCSR1_VPPIMME (BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_VPPCSR1_VPPIMPDS 3
#define B_PCH_PCIE_CFG_VPPCSR1_VPPIMPDS (BIT5 | BIT4 | BIT3)



#define N_PCH_PCIE_CFG_VPPCSR1_VPPIMPFD 6
#define B_PCH_PCIE_CFG_VPPCSR1_VPPIMPFD (BIT8 | BIT7 | BIT6)



#define N_PCH_PCIE_CFG_VPPCSR1_VPPIMABP 9
#define B_PCH_PCIE_CFG_VPPCSR1_VPPIMABP (BIT11 | BIT10 | BIT9)



#define N_PCH_PCIE_CFG_VPPCSR1_VPPOMEIC 12
#define B_PCH_PCIE_CFG_VPPCSR1_VPPOMEIC (BIT14 | BIT13 | BIT12)



#define N_PCH_PCIE_CFG_VPPCSR1_VPPOMPCC 15
#define B_PCH_PCIE_CFG_VPPCSR1_VPPOMPCC (BIT17 | BIT16 | BIT15)



#define N_PCH_PCIE_CFG_VPPCSR1_VPPOMPWRLED 18
#define B_PCH_PCIE_CFG_VPPCSR1_VPPOMPWRLED (BIT20 | BIT19 | BIT18)



#define N_PCH_PCIE_CFG_VPPCSR1_VPPOMATNLED 21
#define B_PCH_PCIE_CFG_VPPCSR1_VPPOMATNLED (BIT23 | BIT22 | BIT21)



#define N_PCH_PCIE_CFG_VPPCSR1_VPPE 24
#define B_PCH_PCIE_CFG_VPPCSR1_VPPE BIT24

#define N_PCH_PCIE_CFG_VPPCSR1_VPPET 25
#define B_PCH_PCIE_CFG_VPPCSR1_VPPET (BIT28 | BIT27 | BIT26 | BIT25)



#define N_PCH_PCIE_CFG_VPPCSR1_ECO 29
#define B_PCH_PCIE_CFG_VPPCSR1_ECO (BIT31 | BIT30 | BIT29)



#define R_PCH_PCIE_CFG_PLKCTL 0x000000EA
#define S_PCH_PCIE_CFG_PLKCTL 2

#define N_PCH_PCIE_CFG_PLKCTL_CL 0
#define B_PCH_PCIE_CFG_PLKCTL_CL BIT0

#define N_PCH_PCIE_CFG_PLKCTL_TLCL 1
#define B_PCH_PCIE_CFG_PLKCTL_TLCL BIT1

#define N_PCH_PCIE_CFG_PLKCTL_LLCL 2
#define B_PCH_PCIE_CFG_PLKCTL_LLCL BIT2

#define N_PCH_PCIE_CFG_PLKCTL_PLCL 4
#define B_PCH_PCIE_CFG_PLKCTL_PLCL BIT4



#define R_PCH_PCIE_CFG_LTRCSR 0x000000EC
#define S_PCH_PCIE_CFG_LTRCSR 4

#define N_PCH_PCIE_CFG_LTRCSR_LTRSOVREN 0
#define B_PCH_PCIE_CFG_LTRCSR_LTRSOVREN BIT0

#define N_PCH_PCIE_CFG_LTRCSR_LTRNSOVREN 1
#define B_PCH_PCIE_CFG_LTRCSR_LTRNSOVREN BIT1

#define N_PCH_PCIE_CFG_LTRCSR_LTROVRPLCY 2
#define B_PCH_PCIE_CFG_LTRCSR_LTROVRPLCY BIT2

#define N_PCH_PCIE_CFG_LTRCSR_LTRAMD 3
#define B_PCH_PCIE_CFG_LTRCSR_LTRAMD BIT3

#define N_PCH_PCIE_CFG_LTRCSR_LTRR 16
#define B_PCH_PCIE_CFG_LTRCSR_LTRR BIT16

#define N_PCH_PCIE_CFG_LTRCSR_IVLSVR 17
#define B_PCH_PCIE_CFG_LTRCSR_IVLSVR BIT17

#define N_PCH_PCIE_CFG_LTRCSR_CL 31
#define B_PCH_PCIE_CFG_LTRCSR_CL BIT31



#define R_PCH_PCIE_CFG_LTRL 0x000000F0
#define S_PCH_PCIE_CFG_LTRL 4

#define N_PCH_PCIE_CFG_LTRL_LTRSLF 0
#define B_PCH_PCIE_CFG_LTRL_LTRSLF (0x0000FFFF)

#define N_PCH_PCIE_CFG_LTRL_LTRNSLF 16
#define B_PCH_PCIE_CFG_LTRL_LTRNSLF (0xFFFF0000)



#define R_PCH_PCIE_CFG_LTROVR 0x000000F4
#define S_PCH_PCIE_CFG_LTROVR 4

#define N_PCH_PCIE_CFG_LTROVR_LTRSLOVRV 0
#define B_PCH_PCIE_CFG_LTROVR_LTRSLOVRV (0x000003FF)

#define N_PCH_PCIE_CFG_LTROVR_LTRSLSOVRV 10
#define B_PCH_PCIE_CFG_LTROVR_LTRSLSOVRV (BIT12 | BIT11 | BIT10)

#define N_PCH_PCIE_CFG_LTROVR_LTRSROVR 15
#define B_PCH_PCIE_CFG_LTROVR_LTRSROVR BIT15

#define N_PCH_PCIE_CFG_LTROVR_LTRNSLOVRV 16
#define B_PCH_PCIE_CFG_LTROVR_LTRNSLOVRV (0x03FF0000)

#define N_PCH_PCIE_CFG_LTROVR_LTRNSLSOVRV 26
#define B_PCH_PCIE_CFG_LTROVR_LTRNSLSOVRV (BIT28 | BIT27 | BIT26)

#define N_PCH_PCIE_CFG_LTROVR_LTRNSROVR 31
#define B_PCH_PCIE_CFG_LTROVR_LTRNSROVR BIT31

#define R_PCH_PCIE_CFG_INTXSWZCTL  0x000000F8
#define S_PCH_PCIE_CFG_INTXSWZCTL 1

#define N_PCH_PCIE_CFG_INTXSWZCTL_INTXSWZ 0
#define B_PCH_PCIE_CFG_INTXSWZCTL_INTXSWZ (BIT2 | BIT1 | BIT0)



#define R_PCH_PCIE_CFG_CFGAGTERR 0x000000FC
#define S_PCH_PCIE_CFG_CFGAGTERR 4



#define N_PCH_PCIE_CFG_CFGAGTERR_PLIPEM 0
#define B_PCH_PCIE_CFG_CFGAGTERR_PLIPEM BIT0



#define N_PCH_PCIE_CFG_CFGAGTERR_LLIPEM 1
#define B_PCH_PCIE_CFG_CFGAGTERR_LLIPEM BIT1



#define N_PCH_PCIE_CFG_CFGAGTERR_TLIPEM 2
#define B_PCH_PCIE_CFG_CFGAGTERR_TLIPEM BIT2



#define N_PCH_PCIE_CFG_CFGAGTERR_DPEM 4
#define B_PCH_PCIE_CFG_CFGAGTERR_DPEM BIT4



#define N_PCH_PCIE_CFG_CFGAGTERR_PLIPES 6
#define B_PCH_PCIE_CFG_CFGAGTERR_PLIPES BIT6



#define N_PCH_PCIE_CFG_CFGAGTERR_LLIPES 7
#define B_PCH_PCIE_CFG_CFGAGTERR_LLIPES BIT7



#define N_PCH_PCIE_CFG_CFGAGTERR_TLIPES 8
#define B_PCH_PCIE_CFG_CFGAGTERR_TLIPES BIT8



#define N_PCH_PCIE_CFG_CFGAGTERR_DPES 10
#define B_PCH_PCIE_CFG_CFGAGTERR_DPES BIT10



#define R_PCH_PCIE_CFG_AERCAPHDR 0x00000100
#define S_PCH_PCIE_CFG_AERCAPHDR 4



#define N_PCH_PCIE_CFG_AERCAPHDR_EXCAPID 0
#define B_PCH_PCIE_CFG_AERCAPHDR_EXCAPID (0x0000FFFF)



#define N_PCH_PCIE_CFG_AERCAPHDR_CV 16
#define B_PCH_PCIE_CFG_AERCAPHDR_CV (BIT19 | BIT18 | BIT17 | BIT16)

#define N_PCH_PCIE_CFG_AERCAPHDR_NCO 20
#define B_PCH_PCIE_CFG_AERCAPHDR_NCO (0xFFF00000)



#define R_PCH_PCIE_CFG_ERRUNCSTS 0x00000104
#define S_PCH_PCIE_CFG_ERRUNCSTS 4



#define N_PCH_PCIE_CFG_ERRUNCSTS_DLPE 4
#define B_PCH_PCIE_CFG_ERRUNCSTS_DLPE BIT4

#define N_PCH_PCIE_CFG_ERRUNCSTS_SLDE 5
#define B_PCH_PCIE_CFG_ERRUNCSTS_SLDE BIT5



#define N_PCH_PCIE_CFG_ERRUNCSTS_PTLPE 12
#define B_PCH_PCIE_CFG_ERRUNCSTS_PTLPE BIT12



#define N_PCH_PCIE_CFG_ERRUNCSTS_FCE 13
#define B_PCH_PCIE_CFG_ERRUNCSTS_FCE BIT13



#define N_PCH_PCIE_CFG_ERRUNCSTS_CTE 14
#define B_PCH_PCIE_CFG_ERRUNCSTS_CTE BIT14



#define N_PCH_PCIE_CFG_ERRUNCSTS_CAE 15
#define B_PCH_PCIE_CFG_ERRUNCSTS_CAE BIT15



#define N_PCH_PCIE_CFG_ERRUNCSTS_UCE 16
#define B_PCH_PCIE_CFG_ERRUNCSTS_UCE BIT16



#define N_PCH_PCIE_CFG_ERRUNCSTS_ROE 17
#define B_PCH_PCIE_CFG_ERRUNCSTS_ROE BIT17



#define N_PCH_PCIE_CFG_ERRUNCSTS_MTLPE 18
#define B_PCH_PCIE_CFG_ERRUNCSTS_MTLPE BIT18



#define N_PCH_PCIE_CFG_ERRUNCSTS_ECRCE 19
#define B_PCH_PCIE_CFG_ERRUNCSTS_ECRCE BIT19



#define N_PCH_PCIE_CFG_ERRUNCSTS_URE 20
#define B_PCH_PCIE_CFG_ERRUNCSTS_URE BIT20



#define N_PCH_PCIE_CFG_ERRUNCSTS_ACSE 21
#define B_PCH_PCIE_CFG_ERRUNCSTS_ACSE BIT21



#define N_PCH_PCIE_CFG_ERRUNCSTS_UIE 22
#define B_PCH_PCIE_CFG_ERRUNCSTS_UIE BIT22



#define N_PCH_PCIE_CFG_ERRUNCSTS_MCE 23
#define B_PCH_PCIE_CFG_ERRUNCSTS_MCE BIT23



#define N_PCH_PCIE_CFG_ERRUNCSTS_AEBE 24
#define B_PCH_PCIE_CFG_ERRUNCSTS_AEBE BIT24



#define N_PCH_PCIE_CFG_ERRUNCSTS_TPBE 25
#define B_PCH_PCIE_CFG_ERRUNCSTS_TPBE BIT25



#define N_PCH_PCIE_CFG_ERRUNCSTS_PTLPEB 26
#define B_PCH_PCIE_CFG_ERRUNCSTS_PTLPEB BIT26

#define R_PCH_PCIE_CFG_ERRUNCMSK  0x00000108
#define S_PCH_PCIE_CFG_ERRUNCMSK 4



#define N_PCH_PCIE_CFG_ERRUNCMSK_DLPEM 4
#define B_PCH_PCIE_CFG_ERRUNCMSK_DLPEM BIT4



#define N_PCH_PCIE_CFG_ERRUNCMSK_SLDEM 5
#define B_PCH_PCIE_CFG_ERRUNCMSK_SLDEM BIT5



#define N_PCH_PCIE_CFG_ERRUNCMSK_PTLPEM 12
#define B_PCH_PCIE_CFG_ERRUNCMSK_PTLPEM BIT12



#define N_PCH_PCIE_CFG_ERRUNCMSK_FCEM 13
#define B_PCH_PCIE_CFG_ERRUNCMSK_FCEM BIT13



#define N_PCH_PCIE_CFG_ERRUNCMSK_CTEM 14
#define B_PCH_PCIE_CFG_ERRUNCMSK_CTEM BIT14



#define N_PCH_PCIE_CFG_ERRUNCMSK_CAEM 15
#define B_PCH_PCIE_CFG_ERRUNCMSK_CAEM BIT15



#define N_PCH_PCIE_CFG_ERRUNCMSK_UCEM 16
#define B_PCH_PCIE_CFG_ERRUNCMSK_UCEM BIT16



#define N_PCH_PCIE_CFG_ERRUNCMSK_ROEM 17
#define B_PCH_PCIE_CFG_ERRUNCMSK_ROEM BIT17



#define N_PCH_PCIE_CFG_ERRUNCMSK_MTLPEM 18
#define B_PCH_PCIE_CFG_ERRUNCMSK_MTLPEM BIT18



#define N_PCH_PCIE_CFG_ERRUNCMSK_ECRCEM 19
#define B_PCH_PCIE_CFG_ERRUNCMSK_ECRCEM BIT19



#define N_PCH_PCIE_CFG_ERRUNCMSK_UREM 20
#define B_PCH_PCIE_CFG_ERRUNCMSK_UREM BIT20



#define N_PCH_PCIE_CFG_ERRUNCMSK_ACSEM 21
#define B_PCH_PCIE_CFG_ERRUNCMSK_ACSEM BIT21



#define N_PCH_PCIE_CFG_ERRUNCMSK_UIEM 22
#define B_PCH_PCIE_CFG_ERRUNCMSK_UIEM BIT22



#define N_PCH_PCIE_CFG_ERRUNCMSK_MCEM 23
#define B_PCH_PCIE_CFG_ERRUNCMSK_MCEM BIT23



#define N_PCH_PCIE_CFG_ERRUNCMSK_AEBEM 24
#define B_PCH_PCIE_CFG_ERRUNCMSK_AEBEM BIT24



#define N_PCH_PCIE_CFG_ERRUNCMSK_TPBEM 25
#define B_PCH_PCIE_CFG_ERRUNCMSK_TPBEM BIT25



#define N_PCH_PCIE_CFG_ERRUNCMSK_PTLPEBM 26
#define B_PCH_PCIE_CFG_ERRUNCMSK_PTLPEBM BIT26

#define R_PCH_PCIE_CFG_ERRUNCSEV  0x0000010C
#define S_PCH_PCIE_CFG_ERRUNCSEV 4



#define N_PCH_PCIE_CFG_ERRUNCSEV_DLPES 4
#define B_PCH_PCIE_CFG_ERRUNCSEV_DLPES BIT4



#define N_PCH_PCIE_CFG_ERRUNCSEV_SLDES 5
#define B_PCH_PCIE_CFG_ERRUNCSEV_SLDES BIT5



#define N_PCH_PCIE_CFG_ERRUNCSEV_PTLPES 12
#define B_PCH_PCIE_CFG_ERRUNCSEV_PTLPES BIT12



#define N_PCH_PCIE_CFG_ERRUNCSEV_FCES 13
#define B_PCH_PCIE_CFG_ERRUNCSEV_FCES BIT13



#define N_PCH_PCIE_CFG_ERRUNCSEV_CTES 14
#define B_PCH_PCIE_CFG_ERRUNCSEV_CTES BIT14



#define N_PCH_PCIE_CFG_ERRUNCSEV_CAES 15
#define B_PCH_PCIE_CFG_ERRUNCSEV_CAES BIT15



#define N_PCH_PCIE_CFG_ERRUNCSEV_UCES 16
#define B_PCH_PCIE_CFG_ERRUNCSEV_UCES BIT16



#define N_PCH_PCIE_CFG_ERRUNCSEV_ROES 17
#define B_PCH_PCIE_CFG_ERRUNCSEV_ROES BIT17



#define N_PCH_PCIE_CFG_ERRUNCSEV_MTLPES 18
#define B_PCH_PCIE_CFG_ERRUNCSEV_MTLPES BIT18



#define N_PCH_PCIE_CFG_ERRUNCSEV_ECRCES 19
#define B_PCH_PCIE_CFG_ERRUNCSEV_ECRCES BIT19



#define N_PCH_PCIE_CFG_ERRUNCSEV_URES 20
#define B_PCH_PCIE_CFG_ERRUNCSEV_URES BIT20



#define N_PCH_PCIE_CFG_ERRUNCSEV_ACSES 21
#define B_PCH_PCIE_CFG_ERRUNCSEV_ACSES BIT21



#define N_PCH_PCIE_CFG_ERRUNCSEV_UIES 22
#define B_PCH_PCIE_CFG_ERRUNCSEV_UIES BIT22



#define N_PCH_PCIE_CFG_ERRUNCSEV_MCES 23
#define B_PCH_PCIE_CFG_ERRUNCSEV_MCES BIT23



#define N_PCH_PCIE_CFG_ERRUNCSEV_AEBES 24
#define B_PCH_PCIE_CFG_ERRUNCSEV_AEBES BIT24



#define N_PCH_PCIE_CFG_ERRUNCSEV_TPBES 25
#define B_PCH_PCIE_CFG_ERRUNCSEV_TPBES BIT25



#define N_PCH_PCIE_CFG_ERRUNCSEV_PTLPEBS 26
#define B_PCH_PCIE_CFG_ERRUNCSEV_PTLPEBS BIT26



#define R_PCH_PCIE_CFG_ERRCORSTS 0x00000110
#define S_PCH_PCIE_CFG_ERRCORSTS 4



#define N_PCH_PCIE_CFG_ERRCORSTS_RE 0
#define B_PCH_PCIE_CFG_ERRCORSTS_RE BIT0



#define N_PCH_PCIE_CFG_ERRCORSTS_BTLPE 6
#define B_PCH_PCIE_CFG_ERRCORSTS_BTLPE BIT6



#define N_PCH_PCIE_CFG_ERRCORSTS_BDLLPE 7
#define B_PCH_PCIE_CFG_ERRCORSTS_BDLLPE BIT7



#define N_PCH_PCIE_CFG_ERRCORSTS_RNRE 8
#define B_PCH_PCIE_CFG_ERRCORSTS_RNRE BIT8



#define N_PCH_PCIE_CFG_ERRCORSTS_RTTE 12
#define B_PCH_PCIE_CFG_ERRCORSTS_RTTE BIT12



#define N_PCH_PCIE_CFG_ERRCORSTS_ANFE 13
#define B_PCH_PCIE_CFG_ERRCORSTS_ANFE BIT13



#define N_PCH_PCIE_CFG_ERRCORSTS_CIE 14
#define B_PCH_PCIE_CFG_ERRCORSTS_CIE BIT14



#define N_PCH_PCIE_CFG_ERRCORSTS_HLOE 15
#define B_PCH_PCIE_CFG_ERRCORSTS_HLOE BIT15



#define R_PCH_PCIE_CFG_ERRCORMSK 0x00000114
#define S_PCH_PCIE_CFG_ERRCORMSK 4



#define N_PCH_PCIE_CFG_ERRCORMSK_REM 0
#define B_PCH_PCIE_CFG_ERRCORMSK_REM BIT0



#define N_PCH_PCIE_CFG_ERRCORMSK_BTLPEM 6
#define B_PCH_PCIE_CFG_ERRCORMSK_BTLPEM BIT6



#define N_PCH_PCIE_CFG_ERRCORMSK_BDLLPEM 7
#define B_PCH_PCIE_CFG_ERRCORMSK_BDLLPEM BIT7



#define N_PCH_PCIE_CFG_ERRCORMSK_RNREM 8
#define B_PCH_PCIE_CFG_ERRCORMSK_RNREM BIT8



#define N_PCH_PCIE_CFG_ERRCORMSK_RTTEM 12
#define B_PCH_PCIE_CFG_ERRCORMSK_RTTEM BIT12



#define N_PCH_PCIE_CFG_ERRCORMSK_ANFEM 13
#define B_PCH_PCIE_CFG_ERRCORMSK_ANFEM BIT13



#define N_PCH_PCIE_CFG_ERRCORMSK_CIEM 14
#define B_PCH_PCIE_CFG_ERRCORMSK_CIEM BIT14



#define N_PCH_PCIE_CFG_ERRCORMSK_HLOEM 15
#define B_PCH_PCIE_CFG_ERRCORMSK_HLOEM BIT15



#define R_PCH_PCIE_CFG_AERCAPCTL 0x00000118
#define S_PCH_PCIE_CFG_AERCAPCTL 4



#define N_PCH_PCIE_CFG_AERCAPCTL_FEP 0
#define B_PCH_PCIE_CFG_AERCAPCTL_FEP (0x0000001F)

#define N_PCH_PCIE_CFG_AERCAPCTL_EGC 5
#define B_PCH_PCIE_CFG_AERCAPCTL_EGC BIT5

#define N_PCH_PCIE_CFG_AERCAPCTL_EGE 6
#define B_PCH_PCIE_CFG_AERCAPCTL_EGE BIT6

#define N_PCH_PCIE_CFG_AERCAPCTL_ECC 7
#define B_PCH_PCIE_CFG_AERCAPCTL_ECC BIT7



#define N_PCH_PCIE_CFG_AERCAPCTL_ECE 8
#define B_PCH_PCIE_CFG_AERCAPCTL_ECE BIT8



#define N_PCH_PCIE_CFG_AERCAPCTL_MHRC 9
#define B_PCH_PCIE_CFG_AERCAPCTL_MHRC BIT9



#define N_PCH_PCIE_CFG_AERCAPCTL_MHRE 10
#define B_PCH_PCIE_CFG_AERCAPCTL_MHRE BIT10



#define N_PCH_PCIE_CFG_AERCAPCTL_TLPPLP 11
#define B_PCH_PCIE_CFG_AERCAPCTL_TLPPLP BIT11

#define N_PCH_PCIE_CFG_AERCAPCTL_CTPHLC 12
#define B_PCH_PCIE_CFG_AERCAPCTL_CTPHLC BIT12



#define R_PCH_PCIE_CFG_AERHDRLOG1 0x0000011C
#define S_PCH_PCIE_CFG_AERHDRLOG1 4



#define N_PCH_PCIE_CFG_AERHDRLOG1_TLPHDRLOG 0
#define B_PCH_PCIE_CFG_AERHDRLOG1_TLPHDRLOG (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_AERHDRLOG2 0x00000120
#define S_PCH_PCIE_CFG_AERHDRLOG2 4



#define N_PCH_PCIE_CFG_AERHDRLOG2_TLPHDRLOG 0
#define B_PCH_PCIE_CFG_AERHDRLOG2_TLPHDRLOG (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_AERHDRLOG3 0x00000124
#define S_PCH_PCIE_CFG_AERHDRLOG3 4



#define N_PCH_PCIE_CFG_AERHDRLOG3_TLPHDRLOG 0
#define B_PCH_PCIE_CFG_AERHDRLOG3_TLPHDRLOG (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_AERHDRLOG4 0x00000128
#define S_PCH_PCIE_CFG_AERHDRLOG4 4



#define N_PCH_PCIE_CFG_AERHDRLOG4_TLPHDRLOG 0
#define B_PCH_PCIE_CFG_AERHDRLOG4_TLPHDRLOG (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_ROOTERRCMD 0x0000012C
#define S_PCH_PCIE_CFG_ROOTERRCMD 4



#define N_PCH_PCIE_CFG_ROOTERRCMD_CERE 0
#define B_PCH_PCIE_CFG_ROOTERRCMD_CERE BIT0



#define N_PCH_PCIE_CFG_ROOTERRCMD_NFERE 1
#define B_PCH_PCIE_CFG_ROOTERRCMD_NFERE BIT1



#define N_PCH_PCIE_CFG_ROOTERRCMD_FERE 2
#define B_PCH_PCIE_CFG_ROOTERRCMD_FERE BIT2



#define R_PCH_PCIE_CFG_ROOTERRSTS 0x00000130
#define S_PCH_PCIE_CFG_ROOTERRSTS 4



#define N_PCH_PCIE_CFG_ROOTERRSTS_CER 0
#define B_PCH_PCIE_CFG_ROOTERRSTS_CER BIT0



#define N_PCH_PCIE_CFG_ROOTERRSTS_MCER 1
#define B_PCH_PCIE_CFG_ROOTERRSTS_MCER BIT1



#define N_PCH_PCIE_CFG_ROOTERRSTS_EFR 2
#define B_PCH_PCIE_CFG_ROOTERRSTS_EFR BIT2



#define N_PCH_PCIE_CFG_ROOTERRSTS_MEFR 3
#define B_PCH_PCIE_CFG_ROOTERRSTS_MEFR BIT3



#define N_PCH_PCIE_CFG_ROOTERRSTS_FUF 4
#define B_PCH_PCIE_CFG_ROOTERRSTS_FUF BIT4



#define N_PCH_PCIE_CFG_ROOTERRSTS_NFEMR 5
#define B_PCH_PCIE_CFG_ROOTERRSTS_NFEMR BIT5



#define N_PCH_PCIE_CFG_ROOTERRSTS_FEMR 6
#define B_PCH_PCIE_CFG_ROOTERRSTS_FEMR BIT6

#define N_PCH_PCIE_CFG_ROOTERRSTS_AEMN 27
#define B_PCH_PCIE_CFG_ROOTERRSTS_AEMN (0xF8000000)



#define R_PCH_PCIE_CFG_ERRSRCID 0x00000134
#define S_PCH_PCIE_CFG_ERRSRCID 4



#define N_PCH_PCIE_CFG_ERRSRCID_ECSID 0
#define B_PCH_PCIE_CFG_ERRSRCID_ECSID (0x0000FFFF)



#define N_PCH_PCIE_CFG_ERRSRCID_EFSID 16
#define B_PCH_PCIE_CFG_ERRSRCID_EFSID (0xFFFF0000)



#define R_PCH_PCIE_CFG_ACSCAPHDR 0x00000148
#define S_PCH_PCIE_CFG_ACSCAPHDR 4



#define N_PCH_PCIE_CFG_ACSCAPHDR_ECID 0
#define B_PCH_PCIE_CFG_ACSCAPHDR_ECID (0x0000FFFF)



#define N_PCH_PCIE_CFG_ACSCAPHDR_CV 16
#define B_PCH_PCIE_CFG_ACSCAPHDR_CV (BIT19 | BIT18 | BIT17 | BIT16)

#define N_PCH_PCIE_CFG_ACSCAPHDR_NCO 20
#define B_PCH_PCIE_CFG_ACSCAPHDR_NCO (0xFFF00000)



#define R_PCH_PCIE_CFG_ACSCAP 0x0000014C
#define S_PCH_PCIE_CFG_ACSCAP 2

#define N_PCH_PCIE_CFG_ACSCAP_VACSSV 0
#define B_PCH_PCIE_CFG_ACSCAP_VACSSV BIT0

#define N_PCH_PCIE_CFG_ACSCAP_BACSTB 1
#define B_PCH_PCIE_CFG_ACSCAP_BACSTB BIT1

#define N_PCH_PCIE_CFG_ACSCAP_RACSP2PRR 2
#define B_PCH_PCIE_CFG_ACSCAP_RACSP2PRR BIT2

#define N_PCH_PCIE_CFG_ACSCAP_CACSP2PRR 3
#define B_PCH_PCIE_CFG_ACSCAP_CACSP2PRR BIT3

#define N_PCH_PCIE_CFG_ACSCAP_UACSUF 4
#define B_PCH_PCIE_CFG_ACSCAP_UACSUF BIT4



#define N_PCH_PCIE_CFG_ACSCAP_EACSP2PEC 5
#define B_PCH_PCIE_CFG_ACSCAP_EACSP2PEC BIT5

#define N_PCH_PCIE_CFG_ACSCAP_TACSDTP2P 6
#define B_PCH_PCIE_CFG_ACSCAP_TACSDTP2P BIT6



#define N_PCH_PCIE_CFG_ACSCAP_ECVS 8
#define B_PCH_PCIE_CFG_ACSCAP_ECVS (0xFF00)



#define R_PCH_PCIE_CFG_ACSCTL 0x0000014E
#define S_PCH_PCIE_CFG_ACSCTL 2



#define N_PCH_PCIE_CFG_ACSCTL_VACSSVE 0
#define B_PCH_PCIE_CFG_ACSCTL_VACSSVE BIT0



#define N_PCH_PCIE_CFG_ACSCTL_BACSTBE 1
#define B_PCH_PCIE_CFG_ACSCTL_BACSTBE BIT1



#define N_PCH_PCIE_CFG_ACSCTL_RACSP2PRRE 2
#define B_PCH_PCIE_CFG_ACSCTL_RACSP2PRRE BIT2



#define N_PCH_PCIE_CFG_ACSCTL_CACSP2PCRE 3
#define B_PCH_PCIE_CFG_ACSCTL_CACSP2PCRE BIT3



#define N_PCH_PCIE_CFG_ACSCTL_UACSUFE 4
#define B_PCH_PCIE_CFG_ACSCTL_UACSUFE BIT4



#define N_PCH_PCIE_CFG_ACSCTL_EACSP2PECE 5
#define B_PCH_PCIE_CFG_ACSCTL_EACSP2PECE BIT5

#define N_PCH_PCIE_CFG_ACSCTL_TACSP2PECE 6
#define B_PCH_PCIE_CFG_ACSCTL_TACSP2PECE BIT6



#define R_PCH_PCIE_CFG_MCSTCAPHDR 0x00000150
#define S_PCH_PCIE_CFG_MCSTCAPHDR 4



#define N_PCH_PCIE_CFG_MCSTCAPHDR_ECID 0
#define B_PCH_PCIE_CFG_MCSTCAPHDR_ECID (0x0000FFFF)



#define N_PCH_PCIE_CFG_MCSTCAPHDR_CV 16
#define B_PCH_PCIE_CFG_MCSTCAPHDR_CV (BIT19 | BIT18 | BIT17 | BIT16)

#define N_PCH_PCIE_CFG_MCSTCAPHDR_NCO 20
#define B_PCH_PCIE_CFG_MCSTCAPHDR_NCO (0xFFF00000)



#define R_PCH_PCIE_CFG_MCSTCAP 0x00000154
#define S_PCH_PCIE_CFG_MCSTCAP 2



#define N_PCH_PCIE_CFG_MCSTCAP_MCMG 0
#define B_PCH_PCIE_CFG_MCSTCAP_MCMG (0x003F)



#define N_PCH_PCIE_CFG_MCSTCAP_MCERS 15
#define B_PCH_PCIE_CFG_MCSTCAP_MCERS BIT15



#define R_PCH_PCIE_CFG_MCSTCTL 0x00000156
#define S_PCH_PCIE_CFG_MCSTCTL 2

#define N_PCH_PCIE_CFG_MCSTCTL_MCNG 0
#define B_PCH_PCIE_CFG_MCSTCTL_MCNG (0x003F)



#define N_PCH_PCIE_CFG_MCSTCTL_MCEN 15
#define B_PCH_PCIE_CFG_MCSTCTL_MCEN BIT15

#define R_PCH_PCIE_CFG_MCSTBAR  0x00000158
#define S_PCH_PCIE_CFG_MCSTBAR 4

#define N_PCH_PCIE_CFG_MCSTBAR_MCIP 0
#define B_PCH_PCIE_CFG_MCSTBAR_MCIP (0x0000003F)



#define N_PCH_PCIE_CFG_MCSTBAR_L32ADR 12
#define B_PCH_PCIE_CFG_MCSTBAR_L32ADR (0xFFFFF000)



#define R_PCH_PCIE_CFG_MCSTUBAR 0x0000015C
#define S_PCH_PCIE_CFG_MCSTUBAR 4



#define N_PCH_PCIE_CFG_MCSTUBAR_U32ADR 0
#define B_PCH_PCIE_CFG_MCSTUBAR_U32ADR (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_MCSTRCV 0x00000160
#define S_PCH_PCIE_CFG_MCSTRCV 4

#define N_PCH_PCIE_CFG_MCSTRCV_MCR 0
#define B_PCH_PCIE_CFG_MCSTRCV_MCR (0x0000FFFF)



#define R_PCH_PCIE_CFG_MCSTBLKALL 0x00000168
#define S_PCH_PCIE_CFG_MCSTBLKALL 4

#define N_PCH_PCIE_CFG_MCSTBLKALL_MCBA 0
#define B_PCH_PCIE_CFG_MCSTBLKALL_MCBA (0x0000FFFF)



#define R_PCH_PCIE_CFG_MCSTBLKUT 0x00000170
#define S_PCH_PCIE_CFG_MCSTBLKUT 4

#define N_PCH_PCIE_CFG_MCSTBLKUT_MCBUT 0
#define B_PCH_PCIE_CFG_MCSTBLKUT_MCBUT (0x0000FFFF)



#define R_PCH_PCIE_CFG_MCSTOLBAR 0x00000178
#define S_PCH_PCIE_CFG_MCSTOLBAR 4

#define N_PCH_PCIE_CFG_MCSTOLBAR_MCOVRSZ 0
#define B_PCH_PCIE_CFG_MCSTOLBAR_MCOVRSZ (0x0000003F)

#define N_PCH_PCIE_CFG_MCSTOLBAR_MCOVRBAR 12
#define B_PCH_PCIE_CFG_MCSTOLBAR_MCOVRBAR (0xFFFFF000)



#define R_PCH_PCIE_CFG_MCSTUOLBAR 0x0000017C
#define S_PCH_PCIE_CFG_MCSTUOLBAR 4



#define N_PCH_PCIE_CFG_MCSTUOLBAR_MCOVRBARU32 0
#define B_PCH_PCIE_CFG_MCSTUOLBAR_MCOVRBARU32 (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_EINJCAPHDR 0x00000180
#define S_PCH_PCIE_CFG_EINJCAPHDR 4



#define N_PCH_PCIE_CFG_EINJCAPHDR_ECID 0
#define B_PCH_PCIE_CFG_EINJCAPHDR_ECID (0x0000FFFF)



#define N_PCH_PCIE_CFG_EINJCAPHDR_CV 16
#define B_PCH_PCIE_CFG_EINJCAPHDR_CV (BIT19 | BIT18 | BIT17 | BIT16)

#define N_PCH_PCIE_CFG_EINJCAPHDR_NCO 20
#define B_PCH_PCIE_CFG_EINJCAPHDR_NCO (0xFFF00000)



#define R_PCH_PCIE_CFG_EINJHDR 0x00000184
#define S_PCH_PCIE_CFG_EINJHDR 4

#define N_PCH_PCIE_CFG_EINJHDR_VSECID 0
#define B_PCH_PCIE_CFG_EINJHDR_VSECID (0x0000FFFF)

#define N_PCH_PCIE_CFG_EINJHDR_VSECREV 16
#define B_PCH_PCIE_CFG_EINJHDR_VSECREV (BIT19 | BIT18 | BIT17 | BIT16)



#define N_PCH_PCIE_CFG_EINJHDR_VSECLEN 20
#define B_PCH_PCIE_CFG_EINJHDR_VSECLEN (0xFFF00000)



#define R_PCH_PCIE_CFG_EINJCTL 0x00000188
#define S_PCH_PCIE_CFG_EINJCTL 2

#define N_PCH_PCIE_CFG_EINJCTL_EINJDIS 0
#define B_PCH_PCIE_CFG_EINJCTL_EINJDIS BIT0

#define N_PCH_PCIE_CFG_EINJCTL_INJRCVERR 1
#define B_PCH_PCIE_CFG_EINJCTL_INJRCVERR BIT1

#define N_PCH_PCIE_CFG_EINJCTL_INJCTOERR 2
#define B_PCH_PCIE_CFG_EINJCTL_INJCTOERR BIT2



#define R_PCH_PCIE_CFG_EDPCPR 0x0000018C
#define S_PCH_PCIE_CFG_EDPCPR 4



#define N_PCH_PCIE_CFG_EDPCPR_SERR_COR 0
#define B_PCH_PCIE_CFG_EDPCPR_SERR_COR BIT0



#define N_PCH_PCIE_CFG_EDPCPR_SERR_FNAT 1
#define B_PCH_PCIE_CFG_EDPCPR_SERR_FNAT BIT1



#define N_PCH_PCIE_CFG_EDPCPR_SERR_FAT 2
#define B_PCH_PCIE_CFG_EDPCPR_SERR_FAT BIT2

#define N_PCH_PCIE_CFG_EDPCPR_SERRSEV_UR 3
#define B_PCH_PCIE_CFG_EDPCPR_SERRSEV_UR (BIT4 | BIT3)

#define N_PCH_PCIE_CFG_EDPCPR_SERRSEV_CA 5
#define B_PCH_PCIE_CFG_EDPCPR_SERRSEV_CA (BIT6 | BIT5)

#define N_PCH_PCIE_CFG_EDPCPR_SERRSEV_CTO 7
#define B_PCH_PCIE_CFG_EDPCPR_SERRSEV_CTO (BIT8 | BIT7)

#define N_PCH_PCIE_CFG_EDPCPR_CPLSTS 9
#define B_PCH_PCIE_CFG_EDPCPR_CPLSTS (BIT11 | BIT10 | BIT9)

#define N_PCH_PCIE_CFG_EDPCPR_TXURE 12
#define B_PCH_PCIE_CFG_EDPCPR_TXURE BIT12



#define R_PCH_PCIE_CFG_DPCECH 0x00000190
#define S_PCH_PCIE_CFG_DPCECH 4



#define N_PCH_PCIE_CFG_DPCECH_ECID 0
#define B_PCH_PCIE_CFG_DPCECH_ECID (0x0000FFFF)



#define N_PCH_PCIE_CFG_DPCECH_CV 16
#define B_PCH_PCIE_CFG_DPCECH_CV (BIT19 | BIT18 | BIT17 | BIT16)

#define N_PCH_PCIE_CFG_DPCECH_NCO 20
#define B_PCH_PCIE_CFG_DPCECH_NCO (0xFFF00000)



#define R_PCH_PCIE_CFG_DPCCAP 0x00000194
#define S_PCH_PCIE_CFG_DPCCAP 2

#define N_PCH_PCIE_CFG_DPCCAP_DPCIMN 0
#define B_PCH_PCIE_CFG_DPCCAP_DPCIMN (0x001F)



#define N_PCH_PCIE_CFG_DPCCAP_RPEDPC 5
#define B_PCH_PCIE_CFG_DPCCAP_RPEDPC BIT5



#define N_PCH_PCIE_CFG_DPCCAP_PTLPEBS 6
#define B_PCH_PCIE_CFG_DPCCAP_PTLPEBS BIT6



#define N_PCH_PCIE_CFG_DPCCAP_DPCSTS 7
#define B_PCH_PCIE_CFG_DPCCAP_DPCSTS BIT7



#define N_PCH_PCIE_CFG_DPCCAP_RPPIOLS 8
#define B_PCH_PCIE_CFG_DPCCAP_RPPIOLS (BIT11 | BIT10 | BIT9 | BIT8)



#define N_PCH_PCIE_CFG_DPCCAP_DLAECSS 12
#define B_PCH_PCIE_CFG_DPCCAP_DLAECSS BIT12



#define R_PCH_PCIE_CFG_DPCCTL 0x00000196
#define S_PCH_PCIE_CFG_DPCCTL 2

#define N_PCH_PCIE_CFG_DPCCTL_DPCTE 0
#define B_PCH_PCIE_CFG_DPCCTL_DPCTE (BIT1 | BIT0)

#define N_PCH_PCIE_CFG_DPCCTL_DPCCC 2
#define B_PCH_PCIE_CFG_DPCCTL_DPCCC BIT2



#define N_PCH_PCIE_CFG_DPCCTL_DPCIE 3
#define B_PCH_PCIE_CFG_DPCCTL_DPCIE BIT3



#define N_PCH_PCIE_CFG_DPCCTL_DPCECE 4
#define B_PCH_PCIE_CFG_DPCCTL_DPCECE BIT4

#define N_PCH_PCIE_CFG_DPCCTL_PTLPEBE 5
#define B_PCH_PCIE_CFG_DPCCTL_PTLPEBE BIT5

#define N_PCH_PCIE_CFG_DPCCTL_DPCST 6
#define B_PCH_PCIE_CFG_DPCCTL_DPCST BIT6

#define N_PCH_PCIE_CFG_DPCCTL_DLAECE 7
#define B_PCH_PCIE_CFG_DPCCTL_DLAECE BIT7



#define R_PCH_PCIE_CFG_DPCSTS 0x00000198
#define S_PCH_PCIE_CFG_DPCSTS 2

#define N_PCH_PCIE_CFG_DPCSTS_DPCTS 0
#define B_PCH_PCIE_CFG_DPCSTS_DPCTS BIT0

#define N_PCH_PCIE_CFG_DPCSTS_DPCTR 1
#define B_PCH_PCIE_CFG_DPCSTS_DPCTR (BIT2 | BIT1)



#define N_PCH_PCIE_CFG_DPCSTS_DPCIS 3
#define B_PCH_PCIE_CFG_DPCSTS_DPCIS BIT3

#define N_PCH_PCIE_CFG_DPCSTS_DPCRPB 4
#define B_PCH_PCIE_CFG_DPCSTS_DPCRPB BIT4

#define N_PCH_PCIE_CFG_DPCSTS_DPCTRE 5
#define B_PCH_PCIE_CFG_DPCSTS_DPCTRE (BIT6 | BIT5)

#define N_PCH_PCIE_CFG_DPCSTS_RPPIOFEP 8
#define B_PCH_PCIE_CFG_DPCSTS_RPPIOFEP (0x1F00)



#define R_PCH_PCIE_CFG_DPCESID 0x0000019A
#define S_PCH_PCIE_CFG_DPCESID 2



#define N_PCH_PCIE_CFG_DPCESID_DPCESID 0
#define B_PCH_PCIE_CFG_DPCESID_DPCESID (0xFFFF)



#define R_PCH_PCIE_CFG_RPPIOSTS 0x0000019C
#define S_PCH_PCIE_CFG_RPPIOSTS 4



#define N_PCH_PCIE_CFG_RPPIOSTS_CFGURC 0
#define B_PCH_PCIE_CFG_RPPIOSTS_CFGURC BIT0



#define N_PCH_PCIE_CFG_RPPIOSTS_CFGCAC 1
#define B_PCH_PCIE_CFG_RPPIOSTS_CFGCAC BIT1



#define N_PCH_PCIE_CFG_RPPIOSTS_CFGCTO 2
#define B_PCH_PCIE_CFG_RPPIOSTS_CFGCTO BIT2



#define N_PCH_PCIE_CFG_RPPIOSTS_IOURC 8
#define B_PCH_PCIE_CFG_RPPIOSTS_IOURC BIT8



#define N_PCH_PCIE_CFG_RPPIOSTS_IOCAC 9
#define B_PCH_PCIE_CFG_RPPIOSTS_IOCAC BIT9



#define N_PCH_PCIE_CFG_RPPIOSTS_IOCTO 10
#define B_PCH_PCIE_CFG_RPPIOSTS_IOCTO BIT10



#define N_PCH_PCIE_CFG_RPPIOSTS_MEMURC 16
#define B_PCH_PCIE_CFG_RPPIOSTS_MEMURC BIT16



#define N_PCH_PCIE_CFG_RPPIOSTS_MEMCAC 17
#define B_PCH_PCIE_CFG_RPPIOSTS_MEMCAC BIT17



#define N_PCH_PCIE_CFG_RPPIOSTS_MEMCTO 18
#define B_PCH_PCIE_CFG_RPPIOSTS_MEMCTO BIT18



#define R_PCH_PCIE_CFG_RPPIOMSK 0x000001A0
#define S_PCH_PCIE_CFG_RPPIOMSK 4



#define N_PCH_PCIE_CFG_RPPIOMSK_CFGURC 0
#define B_PCH_PCIE_CFG_RPPIOMSK_CFGURC BIT0



#define N_PCH_PCIE_CFG_RPPIOMSK_CFGCAC 1
#define B_PCH_PCIE_CFG_RPPIOMSK_CFGCAC BIT1



#define N_PCH_PCIE_CFG_RPPIOMSK_CFGCTO 2
#define B_PCH_PCIE_CFG_RPPIOMSK_CFGCTO BIT2



#define N_PCH_PCIE_CFG_RPPIOMSK_IOURC 8
#define B_PCH_PCIE_CFG_RPPIOMSK_IOURC BIT8



#define N_PCH_PCIE_CFG_RPPIOMSK_IOCAC 9
#define B_PCH_PCIE_CFG_RPPIOMSK_IOCAC BIT9



#define N_PCH_PCIE_CFG_RPPIOMSK_IOCTO 10
#define B_PCH_PCIE_CFG_RPPIOMSK_IOCTO BIT10



#define N_PCH_PCIE_CFG_RPPIOMSK_MEMURC 16
#define B_PCH_PCIE_CFG_RPPIOMSK_MEMURC BIT16



#define N_PCH_PCIE_CFG_RPPIOMSK_MEMCAC 17
#define B_PCH_PCIE_CFG_RPPIOMSK_MEMCAC BIT17



#define N_PCH_PCIE_CFG_RPPIOMSK_MEMCTO 18
#define B_PCH_PCIE_CFG_RPPIOMSK_MEMCTO BIT18



#define R_PCH_PCIE_CFG_RPPIOSEV 0x000001A4
#define S_PCH_PCIE_CFG_RPPIOSEV 4



#define N_PCH_PCIE_CFG_RPPIOSEV_CFGURC 0
#define B_PCH_PCIE_CFG_RPPIOSEV_CFGURC BIT0



#define N_PCH_PCIE_CFG_RPPIOSEV_CFGCAC 1
#define B_PCH_PCIE_CFG_RPPIOSEV_CFGCAC BIT1



#define N_PCH_PCIE_CFG_RPPIOSEV_CFGCTO 2
#define B_PCH_PCIE_CFG_RPPIOSEV_CFGCTO BIT2



#define N_PCH_PCIE_CFG_RPPIOSEV_IOURC 8
#define B_PCH_PCIE_CFG_RPPIOSEV_IOURC BIT8



#define N_PCH_PCIE_CFG_RPPIOSEV_IOCAC 9
#define B_PCH_PCIE_CFG_RPPIOSEV_IOCAC BIT9



#define N_PCH_PCIE_CFG_RPPIOSEV_IOCTO 10
#define B_PCH_PCIE_CFG_RPPIOSEV_IOCTO BIT10



#define N_PCH_PCIE_CFG_RPPIOSEV_MEMURC 16
#define B_PCH_PCIE_CFG_RPPIOSEV_MEMURC BIT16



#define N_PCH_PCIE_CFG_RPPIOSEV_MEMCAC 17
#define B_PCH_PCIE_CFG_RPPIOSEV_MEMCAC BIT17



#define N_PCH_PCIE_CFG_RPPIOSEV_MEMCTO 18
#define B_PCH_PCIE_CFG_RPPIOSEV_MEMCTO BIT18



#define R_PCH_PCIE_CFG_RPPIOSE 0x000001A8
#define S_PCH_PCIE_CFG_RPPIOSE 4



#define N_PCH_PCIE_CFG_RPPIOSE_CFGURC 0
#define B_PCH_PCIE_CFG_RPPIOSE_CFGURC BIT0



#define N_PCH_PCIE_CFG_RPPIOSE_CFGCAC 1
#define B_PCH_PCIE_CFG_RPPIOSE_CFGCAC BIT1



#define N_PCH_PCIE_CFG_RPPIOSE_CFGCTO 2
#define B_PCH_PCIE_CFG_RPPIOSE_CFGCTO BIT2



#define N_PCH_PCIE_CFG_RPPIOSE_IOURC 8
#define B_PCH_PCIE_CFG_RPPIOSE_IOURC BIT8



#define N_PCH_PCIE_CFG_RPPIOSE_IOCAC 9
#define B_PCH_PCIE_CFG_RPPIOSE_IOCAC BIT9



#define N_PCH_PCIE_CFG_RPPIOSE_IOCTO 10
#define B_PCH_PCIE_CFG_RPPIOSE_IOCTO BIT10



#define N_PCH_PCIE_CFG_RPPIOSE_MEMURC 16
#define B_PCH_PCIE_CFG_RPPIOSE_MEMURC BIT16



#define N_PCH_PCIE_CFG_RPPIOSE_MEMCAC 17
#define B_PCH_PCIE_CFG_RPPIOSE_MEMCAC BIT17



#define N_PCH_PCIE_CFG_RPPIOSE_MEMCTO 18
#define B_PCH_PCIE_CFG_RPPIOSE_MEMCTO BIT18



#define R_PCH_PCIE_CFG_RPPIOEXC 0x000001AC
#define S_PCH_PCIE_CFG_RPPIOEXC 4



#define N_PCH_PCIE_CFG_RPPIOEXC_CFGURC 0
#define B_PCH_PCIE_CFG_RPPIOEXC_CFGURC BIT0



#define N_PCH_PCIE_CFG_RPPIOEXC_CFGCAC 1
#define B_PCH_PCIE_CFG_RPPIOEXC_CFGCAC BIT1



#define N_PCH_PCIE_CFG_RPPIOEXC_CFGCTO 2
#define B_PCH_PCIE_CFG_RPPIOEXC_CFGCTO BIT2



#define N_PCH_PCIE_CFG_RPPIOEXC_IOURC 8
#define B_PCH_PCIE_CFG_RPPIOEXC_IOURC BIT8



#define N_PCH_PCIE_CFG_RPPIOEXC_IOCAC 9
#define B_PCH_PCIE_CFG_RPPIOEXC_IOCAC BIT9



#define N_PCH_PCIE_CFG_RPPIOEXC_IOCTO 10
#define B_PCH_PCIE_CFG_RPPIOEXC_IOCTO BIT10



#define N_PCH_PCIE_CFG_RPPIOEXC_MEMURC 16
#define B_PCH_PCIE_CFG_RPPIOEXC_MEMURC BIT16



#define N_PCH_PCIE_CFG_RPPIOEXC_MEMCAC 17
#define B_PCH_PCIE_CFG_RPPIOEXC_MEMCAC BIT17



#define N_PCH_PCIE_CFG_RPPIOEXC_MEMCTO 18
#define B_PCH_PCIE_CFG_RPPIOEXC_MEMCTO BIT18



#define R_PCH_PCIE_CFG_RPPIOHDRLOG1 0x000001B0
#define S_PCH_PCIE_CFG_RPPIOHDRLOG1 4



#define N_PCH_PCIE_CFG_RPPIOHDRLOG1_HB 0
#define B_PCH_PCIE_CFG_RPPIOHDRLOG1_HB (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_RPPIOHDRLOG2 0x000001B4
#define S_PCH_PCIE_CFG_RPPIOHDRLOG2 4



#define N_PCH_PCIE_CFG_RPPIOHDRLOG2_HB 0
#define B_PCH_PCIE_CFG_RPPIOHDRLOG2_HB (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_RPPIOHDRLOG3 0x000001B8
#define S_PCH_PCIE_CFG_RPPIOHDRLOG3 4



#define N_PCH_PCIE_CFG_RPPIOHDRLOG3_HB 0
#define B_PCH_PCIE_CFG_RPPIOHDRLOG3_HB (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_RPPIOHDRLOG4 0x000001BC
#define S_PCH_PCIE_CFG_RPPIOHDRLOG4 4



#define N_PCH_PCIE_CFG_RPPIOHDRLOG4_HB 0
#define B_PCH_PCIE_CFG_RPPIOHDRLOG4_HB (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_L1PMSECH 0x000001D0
#define S_PCH_PCIE_CFG_L1PMSECH 4



#define N_PCH_PCIE_CFG_L1PMSECH_ECID 0
#define B_PCH_PCIE_CFG_L1PMSECH_ECID (0x0000FFFF)



#define N_PCH_PCIE_CFG_L1PMSECH_CV 16
#define B_PCH_PCIE_CFG_L1PMSECH_CV (BIT19 | BIT18 | BIT17 | BIT16)

#define N_PCH_PCIE_CFG_L1PMSECH_NCO 20
#define B_PCH_PCIE_CFG_L1PMSECH_NCO (0xFFF00000)



#define R_PCH_PCIE_CFG_L1PMSCAP 0x000001D4
#define S_PCH_PCIE_CFG_L1PMSCAP 4

#define N_PCH_PCIE_CFG_L1PMSCAP_PPL1P2S 0
#define B_PCH_PCIE_CFG_L1PMSCAP_PPL1P2S BIT0

#define N_PCH_PCIE_CFG_L1PMSCAP_PPL1P1S 1
#define B_PCH_PCIE_CFG_L1PMSCAP_PPL1P1S BIT1

#define N_PCH_PCIE_CFG_L1PMSCAP_AL1P2S 2
#define B_PCH_PCIE_CFG_L1PMSCAP_AL1P2S BIT2

#define N_PCH_PCIE_CFG_L1PMSCAP_AL1P1S 3
#define B_PCH_PCIE_CFG_L1PMSCAP_AL1P1S BIT3

#define N_PCH_PCIE_CFG_L1PMSCAP_L1PSS 4
#define B_PCH_PCIE_CFG_L1PMSCAP_L1PSS BIT4

#define N_PCH_PCIE_CFG_L1PMSCAP_PCMRT 8
#define B_PCH_PCIE_CFG_L1PMSCAP_PCMRT (0x0000FF00)

#define N_PCH_PCIE_CFG_L1PMSCAP_PTPOS 16
#define B_PCH_PCIE_CFG_L1PMSCAP_PTPOS (BIT17 | BIT16)

#define N_PCH_PCIE_CFG_L1PMSCAP_PTPOV 19
#define B_PCH_PCIE_CFG_L1PMSCAP_PTPOV (0x00F80000)



#define R_PCH_PCIE_CFG_L1PMSCTL1 0x000001D8
#define S_PCH_PCIE_CFG_L1PMSCTL1 4

#define N_PCH_PCIE_CFG_L1PMSCTL1_PPL1P2E 0
#define B_PCH_PCIE_CFG_L1PMSCTL1_PPL1P2E BIT0

#define N_PCH_PCIE_CFG_L1PMSCTL1_PPL1P1E 1
#define B_PCH_PCIE_CFG_L1PMSCTL1_PPL1P1E BIT1

#define N_PCH_PCIE_CFG_L1PMSCTL1_AL1P2E 2
#define B_PCH_PCIE_CFG_L1PMSCTL1_AL1P2E BIT2

#define N_PCH_PCIE_CFG_L1PMSCTL1_AL1P1E 3
#define B_PCH_PCIE_CFG_L1PMSCTL1_AL1P1E BIT3

#define N_PCH_PCIE_CFG_L1PMSCTL1_CMRT 8
#define B_PCH_PCIE_CFG_L1PMSCTL1_CMRT (0x0000FF00)

#define N_PCH_PCIE_CFG_L1PMSCTL1_LTRL1P2TV 16
#define B_PCH_PCIE_CFG_L1PMSCTL1_LTRL1P2TV (0x03FF0000)

#define N_PCH_PCIE_CFG_L1PMSCTL1_LTRL1P2TS 29
#define B_PCH_PCIE_CFG_L1PMSCTL1_LTRL1P2TS (BIT31 | BIT30 | BIT29)



#define R_PCH_PCIE_CFG_L1PMSCTL2 0x000001DC
#define S_PCH_PCIE_CFG_L1PMSCTL2 4

#define N_PCH_PCIE_CFG_L1PMSCTL2_TPOS 0
#define B_PCH_PCIE_CFG_L1PMSCTL2_TPOS (BIT1 | BIT0)

#define N_PCH_PCIE_CFG_L1PMSCTL2_TPOV 3
#define B_PCH_PCIE_CFG_L1PMSCTL2_TPOV (0x000000F8)



#define R_PCH_PCIE_CFG_PTMECH 0x000001E0
#define S_PCH_PCIE_CFG_PTMECH 4



#define N_PCH_PCIE_CFG_PTMECH_ECID 0
#define B_PCH_PCIE_CFG_PTMECH_ECID (0x0000FFFF)

#define N_PCH_PCIE_CFG_PTMECH_CV 16
#define B_PCH_PCIE_CFG_PTMECH_CV (BIT19 | BIT18 | BIT17 | BIT16)

#define N_PCH_PCIE_CFG_PTMECH_NCO 20
#define B_PCH_PCIE_CFG_PTMECH_NCO (0xFFF00000)



#define R_PCH_PCIE_CFG_PTMCAP 0x000001E4
#define S_PCH_PCIE_CFG_PTMCAP 4

#define N_PCH_PCIE_CFG_PTMCAP_PTMREQC 0
#define B_PCH_PCIE_CFG_PTMCAP_PTMREQC BIT0

#define N_PCH_PCIE_CFG_PTMCAP_PTMRSPC 1
#define B_PCH_PCIE_CFG_PTMCAP_PTMRSPC BIT1

#define N_PCH_PCIE_CFG_PTMCAP_PTMRTC 2
#define B_PCH_PCIE_CFG_PTMCAP_PTMRTC BIT2

#define N_PCH_PCIE_CFG_PTMCAP_LCG 8
#define B_PCH_PCIE_CFG_PTMCAP_LCG (0x0000FF00)



#define R_PCH_PCIE_CFG_PTMCTL 0x000001E8
#define S_PCH_PCIE_CFG_PTMCTL 4

#define N_PCH_PCIE_CFG_PTMCTL_PTME 0
#define B_PCH_PCIE_CFG_PTMCTL_PTME BIT0

#define N_PCH_PCIE_CFG_PTMCTL_RTS 1
#define B_PCH_PCIE_CFG_PTMCTL_RTS BIT1

#define N_PCH_PCIE_CFG_PTMCTL_EG 8
#define B_PCH_PCIE_CFG_PTMCTL_EG (0x0000FF00)



#define R_PCH_PCIE_CFG_SECEXPCAP 0x00000200
#define S_PCH_PCIE_CFG_SECEXPCAP 4

#define N_PCH_PCIE_CFG_SECEXPCAP_ECID 0
#define B_PCH_PCIE_CFG_SECEXPCAP_ECID (0x0000FFFF)



#define N_PCH_PCIE_CFG_SECEXPCAP_CV 16
#define B_PCH_PCIE_CFG_SECEXPCAP_CV (BIT19 | BIT18 | BIT17 | BIT16)

#define N_PCH_PCIE_CFG_SECEXPCAP_NCO 20
#define B_PCH_PCIE_CFG_SECEXPCAP_NCO (0xFFF00000)



#define R_PCH_PCIE_CFG_LINKCTL3 0x00000204
#define S_PCH_PCIE_CFG_LINKCTL3 4

#define N_PCH_PCIE_CFG_LINKCTL3_PE 0
#define B_PCH_PCIE_CFG_LINKCTL3_PE BIT0

#define N_PCH_PCIE_CFG_LINKCTL3_LNKEQREQINTEN 1
#define B_PCH_PCIE_CFG_LINKCTL3_LNKEQREQINTEN BIT1

#define N_PCH_PCIE_CFG_LINKCTL3_ELSKPOSGV 9
#define B_PCH_PCIE_CFG_LINKCTL3_ELSKPOSGV (0x0000FE00)



#define R_PCH_PCIE_CFG_LANEERRSTS 0x00000208
#define S_PCH_PCIE_CFG_LANEERRSTS 4



#define N_PCH_PCIE_CFG_LANEERRSTS_L0ERR 0
#define B_PCH_PCIE_CFG_LANEERRSTS_L0ERR BIT0



#define N_PCH_PCIE_CFG_LANEERRSTS_L1ERR 1
#define B_PCH_PCIE_CFG_LANEERRSTS_L1ERR BIT1



#define N_PCH_PCIE_CFG_LANEERRSTS_L2ERR 2
#define B_PCH_PCIE_CFG_LANEERRSTS_L2ERR BIT2



#define N_PCH_PCIE_CFG_LANEERRSTS_L3ERR 3
#define B_PCH_PCIE_CFG_LANEERRSTS_L3ERR BIT3



#define N_PCH_PCIE_CFG_LANEERRSTS_L4ERR 4
#define B_PCH_PCIE_CFG_LANEERRSTS_L4ERR BIT4



#define N_PCH_PCIE_CFG_LANEERRSTS_L5ERR 5
#define B_PCH_PCIE_CFG_LANEERRSTS_L5ERR BIT5



#define N_PCH_PCIE_CFG_LANEERRSTS_L6ERR 6
#define B_PCH_PCIE_CFG_LANEERRSTS_L6ERR BIT6



#define N_PCH_PCIE_CFG_LANEERRSTS_L7ERR 7
#define B_PCH_PCIE_CFG_LANEERRSTS_L7ERR BIT7



#define R_PCH_PCIE_CFG_LANEEQCTL_0 0x0000020C
#define S_PCH_PCIE_CFG_LANEEQCTL_0 2

#define N_PCH_PCIE_CFG_LANEEQCTL_0_DPTP 0
#define B_PCH_PCIE_CFG_LANEEQCTL_0_DPTP (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_LANEEQCTL_0_DPRPH 4
#define B_PCH_PCIE_CFG_LANEEQCTL_0_DPRPH (BIT6 | BIT5 | BIT4)

#define N_PCH_PCIE_CFG_LANEEQCTL_0_UPTP 8
#define B_PCH_PCIE_CFG_LANEEQCTL_0_UPTP (BIT11 | BIT10 | BIT9 | BIT8)

#define N_PCH_PCIE_CFG_LANEEQCTL_0_UPRPH 12
#define B_PCH_PCIE_CFG_LANEEQCTL_0_UPRPH (BIT14 | BIT13 | BIT12)



#define R_PCH_PCIE_CFG_LANEEQCTL_1 0x0000020E
#define S_PCH_PCIE_CFG_LANEEQCTL_1 2

#define N_PCH_PCIE_CFG_LANEEQCTL_1_DPTP 0
#define B_PCH_PCIE_CFG_LANEEQCTL_1_DPTP (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_LANEEQCTL_1_DPRPH 4
#define B_PCH_PCIE_CFG_LANEEQCTL_1_DPRPH (BIT6 | BIT5 | BIT4)

#define N_PCH_PCIE_CFG_LANEEQCTL_1_UPTP 8
#define B_PCH_PCIE_CFG_LANEEQCTL_1_UPTP (BIT11 | BIT10 | BIT9 | BIT8)

#define N_PCH_PCIE_CFG_LANEEQCTL_1_UPRPH 12
#define B_PCH_PCIE_CFG_LANEEQCTL_1_UPRPH (BIT14 | BIT13 | BIT12)



#define R_PCH_PCIE_CFG_LANEEQCTL_2 0x00000210
#define S_PCH_PCIE_CFG_LANEEQCTL_2 2

#define N_PCH_PCIE_CFG_LANEEQCTL_2_DPTP 0
#define B_PCH_PCIE_CFG_LANEEQCTL_2_DPTP (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_LANEEQCTL_2_DPRPH 4
#define B_PCH_PCIE_CFG_LANEEQCTL_2_DPRPH (BIT6 | BIT5 | BIT4)

#define N_PCH_PCIE_CFG_LANEEQCTL_2_UPTP 8
#define B_PCH_PCIE_CFG_LANEEQCTL_2_UPTP (BIT11 | BIT10 | BIT9 | BIT8)

#define N_PCH_PCIE_CFG_LANEEQCTL_2_UPRPH 12
#define B_PCH_PCIE_CFG_LANEEQCTL_2_UPRPH (BIT14 | BIT13 | BIT12)



#define R_PCH_PCIE_CFG_LANEEQCTL_3 0x00000212
#define S_PCH_PCIE_CFG_LANEEQCTL_3 2

#define N_PCH_PCIE_CFG_LANEEQCTL_3_DPTP 0
#define B_PCH_PCIE_CFG_LANEEQCTL_3_DPTP (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_LANEEQCTL_3_DPRPH 4
#define B_PCH_PCIE_CFG_LANEEQCTL_3_DPRPH (BIT6 | BIT5 | BIT4)

#define N_PCH_PCIE_CFG_LANEEQCTL_3_UPTP 8
#define B_PCH_PCIE_CFG_LANEEQCTL_3_UPTP (BIT11 | BIT10 | BIT9 | BIT8)

#define N_PCH_PCIE_CFG_LANEEQCTL_3_UPRPH 12
#define B_PCH_PCIE_CFG_LANEEQCTL_3_UPRPH (BIT14 | BIT13 | BIT12)



#define R_PCH_PCIE_CFG_LANEEQCTL_4 0x00000214
#define S_PCH_PCIE_CFG_LANEEQCTL_4 2

#define N_PCH_PCIE_CFG_LANEEQCTL_4_DPTP 0
#define B_PCH_PCIE_CFG_LANEEQCTL_4_DPTP (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_LANEEQCTL_4_DPRPH 4
#define B_PCH_PCIE_CFG_LANEEQCTL_4_DPRPH (BIT6 | BIT5 | BIT4)

#define N_PCH_PCIE_CFG_LANEEQCTL_4_UPTP 8
#define B_PCH_PCIE_CFG_LANEEQCTL_4_UPTP (BIT11 | BIT10 | BIT9 | BIT8)

#define N_PCH_PCIE_CFG_LANEEQCTL_4_UPRPH 12
#define B_PCH_PCIE_CFG_LANEEQCTL_4_UPRPH (BIT14 | BIT13 | BIT12)



#define R_PCH_PCIE_CFG_LANEEQCTL_5 0x00000216
#define S_PCH_PCIE_CFG_LANEEQCTL_5 2

#define N_PCH_PCIE_CFG_LANEEQCTL_5_DPTP 0
#define B_PCH_PCIE_CFG_LANEEQCTL_5_DPTP (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_LANEEQCTL_5_DPRPH 4
#define B_PCH_PCIE_CFG_LANEEQCTL_5_DPRPH (BIT6 | BIT5 | BIT4)

#define N_PCH_PCIE_CFG_LANEEQCTL_5_UPTP 8
#define B_PCH_PCIE_CFG_LANEEQCTL_5_UPTP (BIT11 | BIT10 | BIT9 | BIT8)

#define N_PCH_PCIE_CFG_LANEEQCTL_5_UPRPH 12
#define B_PCH_PCIE_CFG_LANEEQCTL_5_UPRPH (BIT14 | BIT13 | BIT12)



#define R_PCH_PCIE_CFG_LANEEQCTL_6 0x00000218
#define S_PCH_PCIE_CFG_LANEEQCTL_6 2

#define N_PCH_PCIE_CFG_LANEEQCTL_6_DPTP 0
#define B_PCH_PCIE_CFG_LANEEQCTL_6_DPTP (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_LANEEQCTL_6_DPRPH 4
#define B_PCH_PCIE_CFG_LANEEQCTL_6_DPRPH (BIT6 | BIT5 | BIT4)

#define N_PCH_PCIE_CFG_LANEEQCTL_6_UPTP 8
#define B_PCH_PCIE_CFG_LANEEQCTL_6_UPTP (BIT11 | BIT10 | BIT9 | BIT8)

#define N_PCH_PCIE_CFG_LANEEQCTL_6_UPRPH 12
#define B_PCH_PCIE_CFG_LANEEQCTL_6_UPRPH (BIT14 | BIT13 | BIT12)



#define R_PCH_PCIE_CFG_LANEEQCTL_7 0x0000021A
#define S_PCH_PCIE_CFG_LANEEQCTL_7 2

#define N_PCH_PCIE_CFG_LANEEQCTL_7_DPTP 0
#define B_PCH_PCIE_CFG_LANEEQCTL_7_DPTP (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_LANEEQCTL_7_DPRPH 4
#define B_PCH_PCIE_CFG_LANEEQCTL_7_DPRPH (BIT6 | BIT5 | BIT4)

#define N_PCH_PCIE_CFG_LANEEQCTL_7_UPTP 8
#define B_PCH_PCIE_CFG_LANEEQCTL_7_UPTP (BIT11 | BIT10 | BIT9 | BIT8)

#define N_PCH_PCIE_CFG_LANEEQCTL_7_UPRPH 12
#define B_PCH_PCIE_CFG_LANEEQCTL_7_UPRPH (BIT14 | BIT13 | BIT12)



#define R_PCH_PCIE_CFG_VCECH 0x00000280
#define S_PCH_PCIE_CFG_VCECH 4



#define N_PCH_PCIE_CFG_VCECH_ECID 0
#define B_PCH_PCIE_CFG_VCECH_ECID (0x0000FFFF)



#define N_PCH_PCIE_CFG_VCECH_CV 16
#define B_PCH_PCIE_CFG_VCECH_CV (BIT19 | BIT18 | BIT17 | BIT16)

#define N_PCH_PCIE_CFG_VCECH_NCO 20
#define B_PCH_PCIE_CFG_VCECH_NCO (0xFFF00000)



#define R_PCH_PCIE_CFG_PVCCR1 0x00000284
#define S_PCH_PCIE_CFG_PVCCR1 4

#define N_PCH_PCIE_CFG_PVCCR1_EVCC 0
#define B_PCH_PCIE_CFG_PVCCR1_EVCC (BIT2 | BIT1 | BIT0)



#define R_PCH_PCIE_CFG_VC0RC 0x00000290
#define S_PCH_PCIE_CFG_VC0RC 4

#define N_PCH_PCIE_CFG_VC0RC_PAC 0
#define B_PCH_PCIE_CFG_VC0RC_PAC (0x000000FF)

#define N_PCH_PCIE_CFG_VC0RC_RST 15
#define B_PCH_PCIE_CFG_VC0RC_RST BIT15

#define N_PCH_PCIE_CFG_VC0RC_MTS 16
#define B_PCH_PCIE_CFG_VC0RC_MTS (0x007F0000)

#define N_PCH_PCIE_CFG_VC0RC_PATO 24
#define B_PCH_PCIE_CFG_VC0RC_PATO (0xFF000000)



#define R_PCH_PCIE_CFG_VC0RCTL 0x00000294
#define S_PCH_PCIE_CFG_VC0RCTL 4

#define N_PCH_PCIE_CFG_VC0RCTL_TC0VCM 0
#define B_PCH_PCIE_CFG_VC0RCTL_TC0VCM BIT0

#define N_PCH_PCIE_CFG_VC0RCTL_TCVCM 1
#define B_PCH_PCIE_CFG_VC0RCTL_TCVCM (0x000000FE)

#define N_PCH_PCIE_CFG_VC0RCTL_LPAT 16
#define B_PCH_PCIE_CFG_VC0RCTL_LPAT BIT16

#define N_PCH_PCIE_CFG_VC0RCTL_LPAS 17
#define B_PCH_PCIE_CFG_VC0RCTL_LPAS (BIT19 | BIT18 | BIT17)

#define N_PCH_PCIE_CFG_VC0RCTL_VCID 24
#define B_PCH_PCIE_CFG_VC0RCTL_VCID (BIT26 | BIT25 | BIT24)

#define N_PCH_PCIE_CFG_VC0RCTL_VCEN 31
#define B_PCH_PCIE_CFG_VC0RCTL_VCEN BIT31



#define R_PCH_PCIE_CFG_VC0RSTS 0x0000029A
#define S_PCH_PCIE_CFG_VC0RSTS 2

#define N_PCH_PCIE_CFG_VC0RSTS_PATS 0
#define B_PCH_PCIE_CFG_VC0RSTS_PATS BIT0

#define N_PCH_PCIE_CFG_VC0RSTS_VCNP 1
#define B_PCH_PCIE_CFG_VC0RSTS_VCNP BIT1



#define R_PCH_PCIE_CFG_VC1RC 0x0000029C
#define S_PCH_PCIE_CFG_VC1RC 4

#define N_PCH_PCIE_CFG_VC1RC_PAC 0
#define B_PCH_PCIE_CFG_VC1RC_PAC (0x000000FF)

#define N_PCH_PCIE_CFG_VC1RC_RST 15
#define B_PCH_PCIE_CFG_VC1RC_RST BIT15

#define N_PCH_PCIE_CFG_VC1RC_MTS 16
#define B_PCH_PCIE_CFG_VC1RC_MTS (0x007F0000)

#define N_PCH_PCIE_CFG_VC1RC_PATO 24
#define B_PCH_PCIE_CFG_VC1RC_PATO (0xFF000000)



#define R_PCH_PCIE_CFG_VC1RCTL 0x000002A0
#define S_PCH_PCIE_CFG_VC1RCTL 4

#define N_PCH_PCIE_CFG_VC1RCTL_TC0VCM 0
#define B_PCH_PCIE_CFG_VC1RCTL_TC0VCM BIT0

#define N_PCH_PCIE_CFG_VC1RCTL_TCVCM 1
#define B_PCH_PCIE_CFG_VC1RCTL_TCVCM (0x000000FE)

#define N_PCH_PCIE_CFG_VC1RCTL_LPAT 16
#define B_PCH_PCIE_CFG_VC1RCTL_LPAT BIT16

#define N_PCH_PCIE_CFG_VC1RCTL_LPAS 17
#define B_PCH_PCIE_CFG_VC1RCTL_LPAS (BIT19 | BIT18 | BIT17)

#define N_PCH_PCIE_CFG_VC1RCTL_VCID 24
#define B_PCH_PCIE_CFG_VC1RCTL_VCID (BIT26 | BIT25 | BIT24)

#define N_PCH_PCIE_CFG_VC1RCTL_VCEN 31
#define B_PCH_PCIE_CFG_VC1RCTL_VCEN BIT31



#define R_PCH_PCIE_CFG_VC1RSTS 0x000002A6
#define S_PCH_PCIE_CFG_VC1RSTS 2

#define N_PCH_PCIE_CFG_VC1RSTS_PATS 0
#define B_PCH_PCIE_CFG_VC1RSTS_PATS BIT0

#define N_PCH_PCIE_CFG_VC1RSTS_VCNP 1
#define B_PCH_PCIE_CFG_VC1RSTS_VCNP BIT1

#define R_PCH_PCIE_CFG_XPCDTHROTTLEP  0x000002D0
#define S_PCH_PCIE_CFG_XPCDTHROTTLEP 4

#define N_PCH_PCIE_CFG_XPCDTHROTTLEP_RXPRH 0
#define B_PCH_PCIE_CFG_XPCDTHROTTLEP_RXPRH (0x0000007F)

#define N_PCH_PCIE_CFG_XPCDTHROTTLEP_RXPRD 7
#define B_PCH_PCIE_CFG_XPCDTHROTTLEP_RXPRD (0x0000FF80)

#define N_PCH_PCIE_CFG_XPCDTHROTTLEP_TXPRH 16
#define B_PCH_PCIE_CFG_XPCDTHROTTLEP_TXPRH (0x007F0000)

#define N_PCH_PCIE_CFG_XPCDTHROTTLEP_TXPRD 23
#define B_PCH_PCIE_CFG_XPCDTHROTTLEP_TXPRD (0xFF800000)

#define R_PCH_PCIE_CFG_XPCDTHROTTLEN  0x000002D4
#define S_PCH_PCIE_CFG_XPCDTHROTTLEN 4

#define N_PCH_PCIE_CFG_XPCDTHROTTLEN_RXNPRH 0
#define B_PCH_PCIE_CFG_XPCDTHROTTLEN_RXNPRH (0x0000007F)

#define N_PCH_PCIE_CFG_XPCDTHROTTLEN_RXNPRD 7
#define B_PCH_PCIE_CFG_XPCDTHROTTLEN_RXNPRD (0x0000FF80)

#define N_PCH_PCIE_CFG_XPCDTHROTTLEN_TXNPRH 16
#define B_PCH_PCIE_CFG_XPCDTHROTTLEN_TXNPRH (0x007F0000)

#define N_PCH_PCIE_CFG_XPCDTHROTTLEN_TXNPRD 23
#define B_PCH_PCIE_CFG_XPCDTHROTTLEN_TXNPRD (0xFF800000)

#define R_PCH_PCIE_CFG_XPCDTHROTTLEC  0x000002D8
#define S_PCH_PCIE_CFG_XPCDTHROTTLEC 4

#define N_PCH_PCIE_CFG_XPCDTHROTTLEC_RXCPLH 0
#define B_PCH_PCIE_CFG_XPCDTHROTTLEC_RXCPLH (0x0000007F)

#define N_PCH_PCIE_CFG_XPCDTHROTTLEC_RXCPLD 7
#define B_PCH_PCIE_CFG_XPCDTHROTTLEC_RXCPLD (0x0000FF80)

#define N_PCH_PCIE_CFG_XPCDTHROTTLEC_TXCPLH 16
#define B_PCH_PCIE_CFG_XPCDTHROTTLEC_TXCPLH (0x007F0000)

#define N_PCH_PCIE_CFG_XPCDTHROTTLEC_TXCPLD 23
#define B_PCH_PCIE_CFG_XPCDTHROTTLEC_TXCPLD (0xFF800000)



#define R_PCH_PCIE_CFG_IOSFDEVCLKGCTL 0x000002E4
#define S_PCH_PCIE_CFG_IOSFDEVCLKGCTL 2

#define N_PCH_PCIE_CFG_IOSFDEVCLKGCTL_ICT 0
#define B_PCH_PCIE_CFG_IOSFDEVCLKGCTL_ICT (0x00FF)



#define N_PCH_PCIE_CFG_IOSFDEVCLKGCTL_ICGE 15
#define B_PCH_PCIE_CFG_IOSFDEVCLKGCTL_ICGE BIT15



#define R_PCH_PCIE_CFG_SBDEVCLKGCTL 0x000002E6
#define S_PCH_PCIE_CFG_SBDEVCLKGCTL 2

#define N_PCH_PCIE_CFG_SBDEVCLKGCTL_ICT 0
#define B_PCH_PCIE_CFG_SBDEVCLKGCTL_ICT (0x00FF)



#define N_PCH_PCIE_CFG_SBDEVCLKGCTL_ICGE 15
#define B_PCH_PCIE_CFG_SBDEVCLKGCTL_ICGE BIT15



#define R_PCH_PCIE_CFG_VDHDRCAP 0x00000300
#define S_PCH_PCIE_CFG_VDHDRCAP 4



#define N_PCH_PCIE_CFG_VDHDRCAP_PCIECAPID 0
#define B_PCH_PCIE_CFG_VDHDRCAP_PCIECAPID (0x0000FFFF)



#define N_PCH_PCIE_CFG_VDHDRCAP_PCIECAPVERSION 16
#define B_PCH_PCIE_CFG_VDHDRCAP_PCIECAPVERSION (BIT19 | BIT18 | BIT17 | BIT16)

#define N_PCH_PCIE_CFG_VDHDRCAP_PCIENEXTPTR 20
#define B_PCH_PCIE_CFG_VDHDRCAP_PCIENEXTPTR (0xFFF00000)



#define R_PCH_PCIE_CFG_IBSTHDRCAP 0x00000304
#define S_PCH_PCIE_CFG_IBSTHDRCAP 4



#define N_PCH_PCIE_CFG_IBSTHDRCAP_VSECID 0
#define B_PCH_PCIE_CFG_IBSTHDRCAP_VSECID (0x0000FFFF)



#define N_PCH_PCIE_CFG_IBSTHDRCAP_VSECIDREV 16
#define B_PCH_PCIE_CFG_IBSTHDRCAP_VSECIDREV (BIT19 | BIT18 | BIT17 | BIT16)



#define N_PCH_PCIE_CFG_IBSTHDRCAP_VSECLENGTH 20
#define B_PCH_PCIE_CFG_IBSTHDRCAP_VSECLENGTH (0xFFF00000)



#define R_PCH_PCIE_CFG_IBSTENGLKSPDCAP 0x00000310
#define S_PCH_PCIE_CFG_IBSTENGLKSPDCAP 4

#define N_PCH_PCIE_CFG_IBSTENGLKSPDCAP_LINKSPEEDCAP 0
#define B_PCH_PCIE_CFG_IBSTENGLKSPDCAP_LINKSPEEDCAP (0x000000FF)

#define N_PCH_PCIE_CFG_IBSTENGLKSPDCAP_LINKSPEEDCAP1 8
#define B_PCH_PCIE_CFG_IBSTENGLKSPDCAP_LINKSPEEDCAP1 (0x0000FF00)



#define N_PCH_PCIE_CFG_IBSTENGLKSPDCAP_NUMTESTCONTR 24
#define B_PCH_PCIE_CFG_IBSTENGLKSPDCAP_NUMTESTCONTR (BIT25 | BIT24)



#define N_PCH_PCIE_CFG_IBSTENGLKSPDCAP_SPDCTLPASSIVE 28
#define B_PCH_PCIE_CFG_IBSTENGLKSPDCAP_SPDCTLPASSIVE BIT28



#define N_PCH_PCIE_CFG_IBSTENGLKSPDCAP_UNIQSPD 29
#define B_PCH_PCIE_CFG_IBSTENGLKSPDCAP_UNIQSPD BIT29



#define R_PCH_PCIE_CFG_IBSTENGLKSPDCTL 0x00000314
#define S_PCH_PCIE_CFG_IBSTENGLKSPDCTL 4

#define N_PCH_PCIE_CFG_IBSTENGLKSPDCTL_LINK0SPEEDSEL 0
#define B_PCH_PCIE_CFG_IBSTENGLKSPDCTL_LINK0SPEEDSEL (0x000000FF)

#define N_PCH_PCIE_CFG_IBSTENGLKSPDCTL_LINK1SPEEDSEL 8
#define B_PCH_PCIE_CFG_IBSTENGLKSPDCTL_LINK1SPEEDSEL (0x0000FF00)

#define N_PCH_PCIE_CFG_IBSTENGLKSPDCTL_LINK2SPEEDSEL 16
#define B_PCH_PCIE_CFG_IBSTENGLKSPDCTL_LINK2SPEEDSEL (0x00FF0000)

#define N_PCH_PCIE_CFG_IBSTENGLKSPDCTL_LINK3SPEEDSEL 24
#define B_PCH_PCIE_CFG_IBSTENGLKSPDCTL_LINK3SPEEDSEL (0xFF000000)



#define R_PCH_PCIE_CFG_IBSTENGLKTXRXCFG 0x0000031C
#define S_PCH_PCIE_CFG_IBSTENGLKTXRXCFG 4

#define N_PCH_PCIE_CFG_IBSTENGLKTXRXCFG_LINKCONTROL 0
#define B_PCH_PCIE_CFG_IBSTENGLKTXRXCFG_LINKCONTROL (0x0000007F)



#define N_PCH_PCIE_CFG_IBSTENGLKTXRXCFG_LINKCONTROL1 8
#define B_PCH_PCIE_CFG_IBSTENGLKTXRXCFG_LINKCONTROL1 (0x00007F00)

#define N_PCH_PCIE_CFG_IBSTENGLKTXRXCFG_REUTDISABLE 24
#define B_PCH_PCIE_CFG_IBSTENGLKTXRXCFG_REUTDISABLE BIT24



#define N_PCH_PCIE_CFG_IBSTENGLKTXRXCFG_LINKAUTOCONFIGURATION 25
#define B_PCH_PCIE_CFG_IBSTENGLKTXRXCFG_LINKAUTOCONFIGURATION BIT25



#define R_PCH_PCIE_CFG_IBSTERRCRCSTS0 0x00000320
#define S_PCH_PCIE_CFG_IBSTERRCRCSTS0 4



#define N_PCH_PCIE_CFG_IBSTERRCRCSTS0_CRCECC2ERRCNT 0
#define B_PCH_PCIE_CFG_IBSTERRCRCSTS0_CRCECC2ERRCNT (0x00007FFF)



#define N_PCH_PCIE_CFG_IBSTERRCRCSTS0_CRCECC2OVRFLOW 15
#define B_PCH_PCIE_CFG_IBSTERRCRCSTS0_CRCECC2OVRFLOW BIT15

#define R_PCH_PCIE_CFG_IBSTERRRCRVSTS0  0x00000324
#define S_PCH_PCIE_CFG_IBSTERRRCRVSTS0 4



#define N_PCH_PCIE_CFG_IBSTERRRCRVSTS0_RXERRCNT 0
#define B_PCH_PCIE_CFG_IBSTERRRCRVSTS0_RXERRCNT (0x00007FFF)



#define N_PCH_PCIE_CFG_IBSTERRRCRVSTS0_RXERRCNTOVRFLOW 15
#define B_PCH_PCIE_CFG_IBSTERRRCRVSTS0_RXERRCNTOVRFLOW BIT15



#define N_PCH_PCIE_CFG_IBSTERRRCRVSTS0_RECOVCNT 16
#define B_PCH_PCIE_CFG_IBSTERRRCRVSTS0_RECOVCNT (0x7FFF0000)



#define N_PCH_PCIE_CFG_IBSTERRRCRVSTS0_LINKRECOVOVERFLOW 31
#define B_PCH_PCIE_CFG_IBSTERRRCRVSTS0_LINKRECOVOVERFLOW BIT31



#define R_PCH_PCIE_CFG_IBSTERRCRCSTS1 0x00000328
#define S_PCH_PCIE_CFG_IBSTERRCRCSTS1 4



#define N_PCH_PCIE_CFG_IBSTERRCRCSTS1_CRCECC2ERRCNT 0
#define B_PCH_PCIE_CFG_IBSTERRCRCSTS1_CRCECC2ERRCNT (0x00007FFF)



#define N_PCH_PCIE_CFG_IBSTERRCRCSTS1_CRCECC2OVRFLOW 15
#define B_PCH_PCIE_CFG_IBSTERRCRCSTS1_CRCECC2OVRFLOW BIT15

#define R_PCH_PCIE_CFG_IBSTERRRCRVSTS1  0x0000032C
#define S_PCH_PCIE_CFG_IBSTERRRCRVSTS1 4



#define N_PCH_PCIE_CFG_IBSTERRRCRVSTS1_RXERRCNT 0
#define B_PCH_PCIE_CFG_IBSTERRRCRVSTS1_RXERRCNT (0x00007FFF)



#define N_PCH_PCIE_CFG_IBSTERRRCRVSTS1_RXERRCNTOVRFLOW 15
#define B_PCH_PCIE_CFG_IBSTERRRCRVSTS1_RXERRCNTOVRFLOW BIT15



#define N_PCH_PCIE_CFG_IBSTERRRCRVSTS1_RECOVCNT 16
#define B_PCH_PCIE_CFG_IBSTERRRCRVSTS1_RECOVCNT (0x7FFF0000)



#define N_PCH_PCIE_CFG_IBSTERRRCRVSTS1_LINKRECOVOVERFLOW 31
#define B_PCH_PCIE_CFG_IBSTERRRCRVSTS1_LINKRECOVOVERFLOW BIT31



#define R_PCH_PCIE_CFG_IBSTERRCRCSTS2 0x00000330
#define S_PCH_PCIE_CFG_IBSTERRCRCSTS2 4



#define N_PCH_PCIE_CFG_IBSTERRCRCSTS2_CRCECC2ERRCNT 0
#define B_PCH_PCIE_CFG_IBSTERRCRCSTS2_CRCECC2ERRCNT (0x00007FFF)



#define N_PCH_PCIE_CFG_IBSTERRCRCSTS2_CRCECC2OVRFLOW 15
#define B_PCH_PCIE_CFG_IBSTERRCRCSTS2_CRCECC2OVRFLOW BIT15

#define R_PCH_PCIE_CFG_IBSTERRRCRVSTS2  0x00000334
#define S_PCH_PCIE_CFG_IBSTERRRCRVSTS2 4



#define N_PCH_PCIE_CFG_IBSTERRRCRVSTS2_RXERRCNT 0
#define B_PCH_PCIE_CFG_IBSTERRRCRVSTS2_RXERRCNT (0x00007FFF)



#define N_PCH_PCIE_CFG_IBSTERRRCRVSTS2_RXERRCNTOVRFLOW 15
#define B_PCH_PCIE_CFG_IBSTERRRCRVSTS2_RXERRCNTOVRFLOW BIT15



#define N_PCH_PCIE_CFG_IBSTERRRCRVSTS2_RECOVCNT 16
#define B_PCH_PCIE_CFG_IBSTERRRCRVSTS2_RECOVCNT (0x7FFF0000)



#define N_PCH_PCIE_CFG_IBSTERRRCRVSTS2_LINKRECOVOVERFLOW 31
#define B_PCH_PCIE_CFG_IBSTERRRCRVSTS2_LINKRECOVOVERFLOW BIT31



#define R_PCH_PCIE_CFG_IBSTERRCRCSTS3 0x00000338
#define S_PCH_PCIE_CFG_IBSTERRCRCSTS3 4



#define N_PCH_PCIE_CFG_IBSTERRCRCSTS3_CRCECC2ERRCNT 0
#define B_PCH_PCIE_CFG_IBSTERRCRCSTS3_CRCECC2ERRCNT (0x00007FFF)



#define N_PCH_PCIE_CFG_IBSTERRCRCSTS3_CRCECC2OVRFLOW 15
#define B_PCH_PCIE_CFG_IBSTERRCRCSTS3_CRCECC2OVRFLOW BIT15

#define R_PCH_PCIE_CFG_IBSTERRRCRVSTS3  0x0000033C
#define S_PCH_PCIE_CFG_IBSTERRRCRVSTS3 4



#define N_PCH_PCIE_CFG_IBSTERRRCRVSTS3_RXERRCNT 0
#define B_PCH_PCIE_CFG_IBSTERRRCRVSTS3_RXERRCNT (0x00007FFF)



#define N_PCH_PCIE_CFG_IBSTERRRCRVSTS3_RXERRCNTOVRFLOW 15
#define B_PCH_PCIE_CFG_IBSTERRRCRVSTS3_RXERRCNTOVRFLOW BIT15



#define N_PCH_PCIE_CFG_IBSTERRRCRVSTS3_RECOVCNT 16
#define B_PCH_PCIE_CFG_IBSTERRRCRVSTS3_RECOVCNT (0x7FFF0000)



#define N_PCH_PCIE_CFG_IBSTERRRCRVSTS3_LINKRECOVOVERFLOW 31
#define B_PCH_PCIE_CFG_IBSTERRRCRVSTS3_LINKRECOVOVERFLOW BIT31

#define R_PCH_PCIE_CFG_IBSTPHYLCTL0  0x00000344
#define S_PCH_PCIE_CFG_IBSTPHYLCTL0 4

#define N_PCH_PCIE_CFG_IBSTPHYLCTL0_PHYLAYERRESET 0
#define B_PCH_PCIE_CFG_IBSTPHYLCTL0_PHYLAYERRESET BIT0



#define N_PCH_PCIE_CFG_IBSTPHYLCTL0_BYPASSCALIB 2
#define B_PCH_PCIE_CFG_IBSTPHYLCTL0_BYPASSCALIB BIT2

#define N_PCH_PCIE_CFG_IBSTPHYLCTL0_INITIALIZATIONMODE 8
#define B_PCH_PCIE_CFG_IBSTPHYLCTL0_INITIALIZATIONMODE (BIT10 | BIT9 | BIT8)

#define N_PCH_PCIE_CFG_IBSTPHYLCTL0_INITABORTFREEZE 12
#define B_PCH_PCIE_CFG_IBSTPHYLCTL0_INITABORTFREEZE BIT12

#define N_PCH_PCIE_CFG_IBSTPHYLCTL0_DISABLEAUTOCOMPLIANCE 13
#define B_PCH_PCIE_CFG_IBSTPHYLCTL0_DISABLEAUTOCOMPLIANCE BIT13

#define N_PCH_PCIE_CFG_IBSTPHYLCTL0_ENABLESCRAMBLELFSR 22
#define B_PCH_PCIE_CFG_IBSTPHYLCTL0_ENABLESCRAMBLELFSR BIT22

#define R_PCH_PCIE_CFG_IBSTPHYLCTL1  0x00000348
#define S_PCH_PCIE_CFG_IBSTPHYLCTL1 4

#define N_PCH_PCIE_CFG_IBSTPHYLCTL1_PHYLAYERRESET 0
#define B_PCH_PCIE_CFG_IBSTPHYLCTL1_PHYLAYERRESET BIT0



#define N_PCH_PCIE_CFG_IBSTPHYLCTL1_BYPASSCALIB 2
#define B_PCH_PCIE_CFG_IBSTPHYLCTL1_BYPASSCALIB BIT2

#define N_PCH_PCIE_CFG_IBSTPHYLCTL1_INITIALIZATIONMODE 8
#define B_PCH_PCIE_CFG_IBSTPHYLCTL1_INITIALIZATIONMODE (BIT10 | BIT9 | BIT8)

#define N_PCH_PCIE_CFG_IBSTPHYLCTL1_INITABORTFREEZE 12
#define B_PCH_PCIE_CFG_IBSTPHYLCTL1_INITABORTFREEZE BIT12

#define N_PCH_PCIE_CFG_IBSTPHYLCTL1_DISABLEAUTOCOMPLIANCE 13
#define B_PCH_PCIE_CFG_IBSTPHYLCTL1_DISABLEAUTOCOMPLIANCE BIT13

#define N_PCH_PCIE_CFG_IBSTPHYLCTL1_ENABLESCRAMBLELFSR 22
#define B_PCH_PCIE_CFG_IBSTPHYLCTL1_ENABLESCRAMBLELFSR BIT22

#define R_PCH_PCIE_CFG_IBSTPHYLCTL2  0x0000034C
#define S_PCH_PCIE_CFG_IBSTPHYLCTL2 4

#define N_PCH_PCIE_CFG_IBSTPHYLCTL2_PHYLAYERRESET 0
#define B_PCH_PCIE_CFG_IBSTPHYLCTL2_PHYLAYERRESET BIT0



#define N_PCH_PCIE_CFG_IBSTPHYLCTL2_BYPASSCALIB 2
#define B_PCH_PCIE_CFG_IBSTPHYLCTL2_BYPASSCALIB BIT2

#define N_PCH_PCIE_CFG_IBSTPHYLCTL2_INITIALIZATIONMODE 8
#define B_PCH_PCIE_CFG_IBSTPHYLCTL2_INITIALIZATIONMODE (BIT10 | BIT9 | BIT8)

#define N_PCH_PCIE_CFG_IBSTPHYLCTL2_INITABORTFREEZE 12
#define B_PCH_PCIE_CFG_IBSTPHYLCTL2_INITABORTFREEZE BIT12

#define N_PCH_PCIE_CFG_IBSTPHYLCTL2_DISABLEAUTOCOMPLIANCE 13
#define B_PCH_PCIE_CFG_IBSTPHYLCTL2_DISABLEAUTOCOMPLIANCE BIT13

#define N_PCH_PCIE_CFG_IBSTPHYLCTL2_ENABLESCRAMBLELFSR 22
#define B_PCH_PCIE_CFG_IBSTPHYLCTL2_ENABLESCRAMBLELFSR BIT22

#define R_PCH_PCIE_CFG_IBSTPHYLCTL3  0x00000350
#define S_PCH_PCIE_CFG_IBSTPHYLCTL3 4

#define N_PCH_PCIE_CFG_IBSTPHYLCTL3_PHYLAYERRESET 0
#define B_PCH_PCIE_CFG_IBSTPHYLCTL3_PHYLAYERRESET BIT0



#define N_PCH_PCIE_CFG_IBSTPHYLCTL3_BYPASSCALIB 2
#define B_PCH_PCIE_CFG_IBSTPHYLCTL3_BYPASSCALIB BIT2

#define N_PCH_PCIE_CFG_IBSTPHYLCTL3_INITIALIZATIONMODE 8
#define B_PCH_PCIE_CFG_IBSTPHYLCTL3_INITIALIZATIONMODE (BIT10 | BIT9 | BIT8)

#define N_PCH_PCIE_CFG_IBSTPHYLCTL3_INITABORTFREEZE 12
#define B_PCH_PCIE_CFG_IBSTPHYLCTL3_INITABORTFREEZE BIT12

#define N_PCH_PCIE_CFG_IBSTPHYLCTL3_DISABLEAUTOCOMPLIANCE 13
#define B_PCH_PCIE_CFG_IBSTPHYLCTL3_DISABLEAUTOCOMPLIANCE BIT13

#define N_PCH_PCIE_CFG_IBSTPHYLCTL3_ENABLESCRAMBLELFSR 22
#define B_PCH_PCIE_CFG_IBSTPHYLCTL3_ENABLESCRAMBLELFSR BIT22



#define R_PCH_PCIE_CFG_IBSTTXLCTL 0x00000354
#define S_PCH_PCIE_CFG_IBSTTXLCTL 4

#define N_PCH_PCIE_CFG_IBSTTXLCTL_TXDATALANEDISABLE 0
#define B_PCH_PCIE_CFG_IBSTTXLCTL_TXDATALANEDISABLE (0x0000FFFF)



#define R_PCH_PCIE_CFG_IBSTTDSTS 0x00000358
#define S_PCH_PCIE_CFG_IBSTTDSTS 4

#define N_PCH_PCIE_CFG_IBSTTDSTS_TXLANEDETECTSTAT 0
#define B_PCH_PCIE_CFG_IBSTTDSTS_TXLANEDETECTSTAT (0x0000FFFF)



#define R_PCH_PCIE_CFG_IBSTPLLNSTS0 0x0000036C
#define S_PCH_PCIE_CFG_IBSTPLLNSTS0 4



#define N_PCH_PCIE_CFG_IBSTPLLNSTS0_LANE0PRESSTATE 0
#define B_PCH_PCIE_CFG_IBSTPLLNSTS0_LANE0PRESSTATE (BIT3 | BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_IBSTPLLNSTS0_LANE1PRESSTATE 4
#define B_PCH_PCIE_CFG_IBSTPLLNSTS0_LANE1PRESSTATE (BIT7 | BIT6 | BIT5 | BIT4)



#define N_PCH_PCIE_CFG_IBSTPLLNSTS0_LANE2PRESSTATE 8
#define B_PCH_PCIE_CFG_IBSTPLLNSTS0_LANE2PRESSTATE (BIT11 | BIT10 | BIT9 | BIT8)



#define N_PCH_PCIE_CFG_IBSTPLLNSTS0_LANE3PRESSTATE 12
#define B_PCH_PCIE_CFG_IBSTPLLNSTS0_LANE3PRESSTATE (BIT15 | BIT14 | BIT13 | BIT12)



#define N_PCH_PCIE_CFG_IBSTPLLNSTS0_LANE4PRESSTATE 16
#define B_PCH_PCIE_CFG_IBSTPLLNSTS0_LANE4PRESSTATE (BIT19 | BIT18 | BIT17 | BIT16)



#define N_PCH_PCIE_CFG_IBSTPLLNSTS0_LANE5PRESSTATE 20
#define B_PCH_PCIE_CFG_IBSTPLLNSTS0_LANE5PRESSTATE (BIT23 | BIT22 | BIT21 | BIT20)



#define N_PCH_PCIE_CFG_IBSTPLLNSTS0_LANE6PRESSTATE 24
#define B_PCH_PCIE_CFG_IBSTPLLNSTS0_LANE6PRESSTATE (BIT27 | BIT26 | BIT25 | BIT24)



#define N_PCH_PCIE_CFG_IBSTPLLNSTS0_LANE7PRESSTATE 28
#define B_PCH_PCIE_CFG_IBSTPLLNSTS0_LANE7PRESSTATE (BIT31 | BIT30 | BIT29 | BIT28)



#define R_PCH_PCIE_CFG_IBSTPRECFG0 0x00000370
#define S_PCH_PCIE_CFG_IBSTPRECFG0 4



#define N_PCH_PCIE_CFG_IBSTPRECFG0_PRECONFIGLANE0ID 0
#define B_PCH_PCIE_CFG_IBSTPRECFG0_PRECONFIGLANE0ID (BIT3 | BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_IBSTPRECFG0_PRECONFIGLANE1ID 4
#define B_PCH_PCIE_CFG_IBSTPRECFG0_PRECONFIGLANE1ID (BIT7 | BIT6 | BIT5 | BIT4)



#define N_PCH_PCIE_CFG_IBSTPRECFG0_PRECONFIGLANE2ID 8
#define B_PCH_PCIE_CFG_IBSTPRECFG0_PRECONFIGLANE2ID (BIT11 | BIT10 | BIT9 | BIT8)



#define N_PCH_PCIE_CFG_IBSTPRECFG0_PRECONFIGLANE3ID 12
#define B_PCH_PCIE_CFG_IBSTPRECFG0_PRECONFIGLANE3ID (BIT15 | BIT14 | BIT13 | BIT12)



#define N_PCH_PCIE_CFG_IBSTPRECFG0_PRECONFIGLANE4ID 16
#define B_PCH_PCIE_CFG_IBSTPRECFG0_PRECONFIGLANE4ID (BIT19 | BIT18 | BIT17 | BIT16)



#define N_PCH_PCIE_CFG_IBSTPRECFG0_PRECONFIGLANE5ID 20
#define B_PCH_PCIE_CFG_IBSTPRECFG0_PRECONFIGLANE5ID (BIT23 | BIT22 | BIT21 | BIT20)



#define N_PCH_PCIE_CFG_IBSTPRECFG0_PRECONFIGLANE6ID 24
#define B_PCH_PCIE_CFG_IBSTPRECFG0_PRECONFIGLANE6ID (BIT27 | BIT26 | BIT25 | BIT24)



#define N_PCH_PCIE_CFG_IBSTPRECFG0_PRECONFIGLANE7ID 28
#define B_PCH_PCIE_CFG_IBSTPRECFG0_PRECONFIGLANE7ID (BIT31 | BIT30 | BIT29 | BIT28)



#define R_PCH_PCIE_CFG_IBSTPOSTCFG0 0x00000374
#define S_PCH_PCIE_CFG_IBSTPOSTCFG0 4



#define N_PCH_PCIE_CFG_IBSTPOSTCFG0_POSTCONFIGLANE0ID 0
#define B_PCH_PCIE_CFG_IBSTPOSTCFG0_POSTCONFIGLANE0ID (BIT3 | BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_IBSTPOSTCFG0_POSTCONFIGLANE1ID 4
#define B_PCH_PCIE_CFG_IBSTPOSTCFG0_POSTCONFIGLANE1ID (BIT7 | BIT6 | BIT5 | BIT4)



#define N_PCH_PCIE_CFG_IBSTPOSTCFG0_POSTCONFIGLANE2ID 8
#define B_PCH_PCIE_CFG_IBSTPOSTCFG0_POSTCONFIGLANE2ID (BIT11 | BIT10 | BIT9 | BIT8)



#define N_PCH_PCIE_CFG_IBSTPOSTCFG0_POSTCONFIGLANE3ID 12
#define B_PCH_PCIE_CFG_IBSTPOSTCFG0_POSTCONFIGLANE3ID (BIT15 | BIT14 | BIT13 | BIT12)



#define N_PCH_PCIE_CFG_IBSTPOSTCFG0_POSTCONFIGLANE4ID 16
#define B_PCH_PCIE_CFG_IBSTPOSTCFG0_POSTCONFIGLANE4ID (BIT19 | BIT18 | BIT17 | BIT16)



#define N_PCH_PCIE_CFG_IBSTPOSTCFG0_POSTCONFIGLANE5ID 20
#define B_PCH_PCIE_CFG_IBSTPOSTCFG0_POSTCONFIGLANE5ID (BIT23 | BIT22 | BIT21 | BIT20)



#define N_PCH_PCIE_CFG_IBSTPOSTCFG0_POSTCONFIGLANE6ID 24
#define B_PCH_PCIE_CFG_IBSTPOSTCFG0_POSTCONFIGLANE6ID (BIT27 | BIT26 | BIT25 | BIT24)



#define N_PCH_PCIE_CFG_IBSTPOSTCFG0_POSTCONFIGLANE7ID 28
#define B_PCH_PCIE_CFG_IBSTPOSTCFG0_POSTCONFIGLANE7ID (BIT31 | BIT30 | BIT29 | BIT28)



#define R_PCH_PCIE_CFG_IBSTPLLNSTS1 0x00000378
#define S_PCH_PCIE_CFG_IBSTPLLNSTS1 4



#define N_PCH_PCIE_CFG_IBSTPLLNSTS1_LANE0PRESSTATE 0
#define B_PCH_PCIE_CFG_IBSTPLLNSTS1_LANE0PRESSTATE (BIT3 | BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_IBSTPLLNSTS1_LANE1PRESSTATE 4
#define B_PCH_PCIE_CFG_IBSTPLLNSTS1_LANE1PRESSTATE (BIT7 | BIT6 | BIT5 | BIT4)



#define N_PCH_PCIE_CFG_IBSTPLLNSTS1_LANE2PRESSTATE 8
#define B_PCH_PCIE_CFG_IBSTPLLNSTS1_LANE2PRESSTATE (BIT11 | BIT10 | BIT9 | BIT8)



#define N_PCH_PCIE_CFG_IBSTPLLNSTS1_LANE3PRESSTATE 12
#define B_PCH_PCIE_CFG_IBSTPLLNSTS1_LANE3PRESSTATE (BIT15 | BIT14 | BIT13 | BIT12)



#define N_PCH_PCIE_CFG_IBSTPLLNSTS1_LANE4PRESSTATE 16
#define B_PCH_PCIE_CFG_IBSTPLLNSTS1_LANE4PRESSTATE (BIT19 | BIT18 | BIT17 | BIT16)



#define N_PCH_PCIE_CFG_IBSTPLLNSTS1_LANE5PRESSTATE 20
#define B_PCH_PCIE_CFG_IBSTPLLNSTS1_LANE5PRESSTATE (BIT23 | BIT22 | BIT21 | BIT20)



#define N_PCH_PCIE_CFG_IBSTPLLNSTS1_LANE6PRESSTATE 24
#define B_PCH_PCIE_CFG_IBSTPLLNSTS1_LANE6PRESSTATE (BIT27 | BIT26 | BIT25 | BIT24)



#define N_PCH_PCIE_CFG_IBSTPLLNSTS1_LANE7PRESSTATE 28
#define B_PCH_PCIE_CFG_IBSTPLLNSTS1_LANE7PRESSTATE (BIT31 | BIT30 | BIT29 | BIT28)



#define R_PCH_PCIE_CFG_IBSTPRECFG1 0x0000037C
#define S_PCH_PCIE_CFG_IBSTPRECFG1 4



#define N_PCH_PCIE_CFG_IBSTPRECFG1_PRECONFIGLANE0ID 0
#define B_PCH_PCIE_CFG_IBSTPRECFG1_PRECONFIGLANE0ID (BIT3 | BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_IBSTPRECFG1_PRECONFIGLANE1ID 4
#define B_PCH_PCIE_CFG_IBSTPRECFG1_PRECONFIGLANE1ID (BIT7 | BIT6 | BIT5 | BIT4)



#define N_PCH_PCIE_CFG_IBSTPRECFG1_PRECONFIGLANE2ID 8
#define B_PCH_PCIE_CFG_IBSTPRECFG1_PRECONFIGLANE2ID (BIT11 | BIT10 | BIT9 | BIT8)



#define N_PCH_PCIE_CFG_IBSTPRECFG1_PRECONFIGLANE3ID 12
#define B_PCH_PCIE_CFG_IBSTPRECFG1_PRECONFIGLANE3ID (BIT15 | BIT14 | BIT13 | BIT12)



#define N_PCH_PCIE_CFG_IBSTPRECFG1_PRECONFIGLANE4ID 16
#define B_PCH_PCIE_CFG_IBSTPRECFG1_PRECONFIGLANE4ID (BIT19 | BIT18 | BIT17 | BIT16)



#define N_PCH_PCIE_CFG_IBSTPRECFG1_PRECONFIGLANE5ID 20
#define B_PCH_PCIE_CFG_IBSTPRECFG1_PRECONFIGLANE5ID (BIT23 | BIT22 | BIT21 | BIT20)



#define N_PCH_PCIE_CFG_IBSTPRECFG1_PRECONFIGLANE6ID 24
#define B_PCH_PCIE_CFG_IBSTPRECFG1_PRECONFIGLANE6ID (BIT27 | BIT26 | BIT25 | BIT24)



#define N_PCH_PCIE_CFG_IBSTPRECFG1_PRECONFIGLANE7ID 28
#define B_PCH_PCIE_CFG_IBSTPRECFG1_PRECONFIGLANE7ID (BIT31 | BIT30 | BIT29 | BIT28)



#define R_PCH_PCIE_CFG_IBSTPOSTCFG1 0x00000380
#define S_PCH_PCIE_CFG_IBSTPOSTCFG1 4



#define N_PCH_PCIE_CFG_IBSTPOSTCFG1_POSTCONFIGLANE0ID 0
#define B_PCH_PCIE_CFG_IBSTPOSTCFG1_POSTCONFIGLANE0ID (BIT3 | BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_IBSTPOSTCFG1_POSTCONFIGLANE1ID 4
#define B_PCH_PCIE_CFG_IBSTPOSTCFG1_POSTCONFIGLANE1ID (BIT7 | BIT6 | BIT5 | BIT4)



#define N_PCH_PCIE_CFG_IBSTPOSTCFG1_POSTCONFIGLANE2ID 8
#define B_PCH_PCIE_CFG_IBSTPOSTCFG1_POSTCONFIGLANE2ID (BIT11 | BIT10 | BIT9 | BIT8)



#define N_PCH_PCIE_CFG_IBSTPOSTCFG1_POSTCONFIGLANE3ID 12
#define B_PCH_PCIE_CFG_IBSTPOSTCFG1_POSTCONFIGLANE3ID (BIT15 | BIT14 | BIT13 | BIT12)



#define N_PCH_PCIE_CFG_IBSTPOSTCFG1_POSTCONFIGLANE4ID 16
#define B_PCH_PCIE_CFG_IBSTPOSTCFG1_POSTCONFIGLANE4ID (BIT19 | BIT18 | BIT17 | BIT16)



#define N_PCH_PCIE_CFG_IBSTPOSTCFG1_POSTCONFIGLANE5ID 20
#define B_PCH_PCIE_CFG_IBSTPOSTCFG1_POSTCONFIGLANE5ID (BIT23 | BIT22 | BIT21 | BIT20)



#define N_PCH_PCIE_CFG_IBSTPOSTCFG1_POSTCONFIGLANE6ID 24
#define B_PCH_PCIE_CFG_IBSTPOSTCFG1_POSTCONFIGLANE6ID (BIT27 | BIT26 | BIT25 | BIT24)



#define N_PCH_PCIE_CFG_IBSTPOSTCFG1_POSTCONFIGLANE7ID 28
#define B_PCH_PCIE_CFG_IBSTPOSTCFG1_POSTCONFIGLANE7ID (BIT31 | BIT30 | BIT29 | BIT28)



#define R_PCH_PCIE_CFG_XPPMDL0 0x00000580
#define S_PCH_PCIE_CFG_XPPMDL0 4



#define N_PCH_PCIE_CFG_XPPMDL0_CNTL 0
#define B_PCH_PCIE_CFG_XPPMDL0_CNTL (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_XPPMDL1 0x00000584
#define S_PCH_PCIE_CFG_XPPMDL1 4



#define N_PCH_PCIE_CFG_XPPMDL1_CNTL 0
#define B_PCH_PCIE_CFG_XPPMDL1_CNTL (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_XPPMCL0 0x00000588
#define S_PCH_PCIE_CFG_XPPMCL0 4



#define N_PCH_PCIE_CFG_XPPMCL0_CMPL 0
#define B_PCH_PCIE_CFG_XPPMCL0_CMPL (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_XPPMCL1 0x0000058C
#define S_PCH_PCIE_CFG_XPPMCL1 4



#define N_PCH_PCIE_CFG_XPPMCL1_CMPL 0
#define B_PCH_PCIE_CFG_XPPMCL1_CMPL (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_XPPMDH 0x00000590
#define S_PCH_PCIE_CFG_XPPMDH 2



#define N_PCH_PCIE_CFG_XPPMDH_CNTH0 0
#define B_PCH_PCIE_CFG_XPPMDH_CNTH0 (BIT3 | BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_XPPMDH_CNTH1 8
#define B_PCH_PCIE_CFG_XPPMDH_CNTH1 (BIT11 | BIT10 | BIT9 | BIT8)



#define R_PCH_PCIE_CFG_XPPMCH 0x00000592
#define S_PCH_PCIE_CFG_XPPMCH 2



#define N_PCH_PCIE_CFG_XPPMCH_CMPH0 0
#define B_PCH_PCIE_CFG_XPPMCH_CMPH0 (BIT3 | BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_XPPMCH_CMPH1 8
#define B_PCH_PCIE_CFG_XPPMCH_CMPH1 (BIT11 | BIT10 | BIT9 | BIT8)



#define R_PCH_PCIE_CFG_XPPMR0 0x00000594
#define S_PCH_PCIE_CFG_XPPMR0 4

#define N_PCH_PCIE_CFG_XPPMR0_CNTRST 0
#define B_PCH_PCIE_CFG_XPPMR0_CNTRST BIT0

#define N_PCH_PCIE_CFG_XPPMR0_OVS 1
#define B_PCH_PCIE_CFG_XPPMR0_OVS BIT1

#define N_PCH_PCIE_CFG_XPPMR0_CMPSTAT 2
#define B_PCH_PCIE_CFG_XPPMR0_CMPSTAT BIT2

#define N_PCH_PCIE_CFG_XPPMR0_PTO 3
#define B_PCH_PCIE_CFG_XPPMR0_PTO (BIT4 | BIT3)

#define N_PCH_PCIE_CFG_XPPMR0_PMSSIG 5
#define B_PCH_PCIE_CFG_XPPMR0_PMSSIG BIT5

#define N_PCH_PCIE_CFG_XPPMR0_CMPMD 6
#define B_PCH_PCIE_CFG_XPPMR0_CMPMD (BIT7 | BIT6)

#define N_PCH_PCIE_CFG_XPPMR0_RSTEVSEL 8
#define B_PCH_PCIE_CFG_XPPMR0_RSTEVSEL (BIT10 | BIT9 | BIT8)

#define N_PCH_PCIE_CFG_XPPMR0_CENS 11
#define B_PCH_PCIE_CFG_XPPMR0_CENS (BIT13 | BIT12 | BIT11)

#define N_PCH_PCIE_CFG_XPPMR0_CNTMD 14
#define B_PCH_PCIE_CFG_XPPMR0_CNTMD (BIT15 | BIT14)

#define N_PCH_PCIE_CFG_XPPMR0_EVPOLINV 16
#define B_PCH_PCIE_CFG_XPPMR0_EVPOLINV BIT16

#define N_PCH_PCIE_CFG_XPPMR0_CNTEVSEL 17
#define B_PCH_PCIE_CFG_XPPMR0_CNTEVSEL (BIT18 | BIT17)

#define N_PCH_PCIE_CFG_XPPMR0_EGS 19
#define B_PCH_PCIE_CFG_XPPMR0_EGS (BIT20 | BIT19)

#define N_PCH_PCIE_CFG_XPPMR0_LDES 21
#define B_PCH_PCIE_CFG_XPPMR0_LDES BIT21

#define N_PCH_PCIE_CFG_XPPMR0_DFXLNSEL 22
#define B_PCH_PCIE_CFG_XPPMR0_DFXLNSEL (BIT23 | BIT22)

#define N_PCH_PCIE_CFG_XPPMR0_RSTPULSEN 27
#define B_PCH_PCIE_CFG_XPPMR0_RSTPULSEN BIT27

#define N_PCH_PCIE_CFG_XPPMR0_LATCNTENSEL 28
#define B_PCH_PCIE_CFG_XPPMR0_LATCNTENSEL BIT28

#define N_PCH_PCIE_CFG_XPPMR0_FRCPMDADDZ 29
#define B_PCH_PCIE_CFG_XPPMR0_FRCPMDADDZ BIT29

#define N_PCH_PCIE_CFG_XPPMR0_NOTGRTCMP 30
#define B_PCH_PCIE_CFG_XPPMR0_NOTGRTCMP BIT30

#define N_PCH_PCIE_CFG_XPPMR0_LOCGLOBEVSEL 31
#define B_PCH_PCIE_CFG_XPPMR0_LOCGLOBEVSEL BIT31



#define R_PCH_PCIE_CFG_XPPMR1 0x00000598
#define S_PCH_PCIE_CFG_XPPMR1 4

#define N_PCH_PCIE_CFG_XPPMR1_CNTRST 0
#define B_PCH_PCIE_CFG_XPPMR1_CNTRST BIT0

#define N_PCH_PCIE_CFG_XPPMR1_OVS 1
#define B_PCH_PCIE_CFG_XPPMR1_OVS BIT1

#define N_PCH_PCIE_CFG_XPPMR1_CMPSTAT 2
#define B_PCH_PCIE_CFG_XPPMR1_CMPSTAT BIT2

#define N_PCH_PCIE_CFG_XPPMR1_PTO 3
#define B_PCH_PCIE_CFG_XPPMR1_PTO (BIT4 | BIT3)

#define N_PCH_PCIE_CFG_XPPMR1_PMSSIG 5
#define B_PCH_PCIE_CFG_XPPMR1_PMSSIG BIT5

#define N_PCH_PCIE_CFG_XPPMR1_CMPMD 6
#define B_PCH_PCIE_CFG_XPPMR1_CMPMD (BIT7 | BIT6)

#define N_PCH_PCIE_CFG_XPPMR1_RSTEVSEL 8
#define B_PCH_PCIE_CFG_XPPMR1_RSTEVSEL (BIT10 | BIT9 | BIT8)

#define N_PCH_PCIE_CFG_XPPMR1_CENS 11
#define B_PCH_PCIE_CFG_XPPMR1_CENS (BIT13 | BIT12 | BIT11)

#define N_PCH_PCIE_CFG_XPPMR1_CNTMD 14
#define B_PCH_PCIE_CFG_XPPMR1_CNTMD (BIT15 | BIT14)

#define N_PCH_PCIE_CFG_XPPMR1_EVPOLINV 16
#define B_PCH_PCIE_CFG_XPPMR1_EVPOLINV BIT16

#define N_PCH_PCIE_CFG_XPPMR1_CNTEVSEL 17
#define B_PCH_PCIE_CFG_XPPMR1_CNTEVSEL (BIT18 | BIT17)

#define N_PCH_PCIE_CFG_XPPMR1_EGS 19
#define B_PCH_PCIE_CFG_XPPMR1_EGS (BIT20 | BIT19)

#define N_PCH_PCIE_CFG_XPPMR1_LDES 21
#define B_PCH_PCIE_CFG_XPPMR1_LDES BIT21

#define N_PCH_PCIE_CFG_XPPMR1_DFXLNSEL 22
#define B_PCH_PCIE_CFG_XPPMR1_DFXLNSEL (BIT23 | BIT22)

#define N_PCH_PCIE_CFG_XPPMR1_RSTPULSEN 27
#define B_PCH_PCIE_CFG_XPPMR1_RSTPULSEN BIT27

#define N_PCH_PCIE_CFG_XPPMR1_LATCNTENSEL 28
#define B_PCH_PCIE_CFG_XPPMR1_LATCNTENSEL BIT28

#define N_PCH_PCIE_CFG_XPPMR1_FRCPMDADDZ 29
#define B_PCH_PCIE_CFG_XPPMR1_FRCPMDADDZ BIT29

#define N_PCH_PCIE_CFG_XPPMR1_NOTGRTCMP 30
#define B_PCH_PCIE_CFG_XPPMR1_NOTGRTCMP BIT30

#define N_PCH_PCIE_CFG_XPPMR1_LOCGLOBEVSEL 31
#define B_PCH_PCIE_CFG_XPPMR1_LOCGLOBEVSEL BIT31

#define R_PCH_PCIE_CFG_XPPMEVL0  0x0000059C
#define S_PCH_PCIE_CFG_XPPMEVL0 4

#define N_PCH_PCIE_CFG_XPPMEVL0_CMPSTAT 0
#define B_PCH_PCIE_CFG_XPPMEVL0_CMPSTAT (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_XPPMEVL0_DATLEN 4
#define B_PCH_PCIE_CFG_XPPMEVL0_DATLEN (0x000007F0)

#define N_PCH_PCIE_CFG_XPPMEVL0_TTYP 11
#define B_PCH_PCIE_CFG_XPPMEVL0_TTYP (0x0000F800)

#define N_PCH_PCIE_CFG_XPPMEVL0_CFGTYP 16
#define B_PCH_PCIE_CFG_XPPMEVL0_CFGTYP (BIT17 | BIT16)

#define N_PCH_PCIE_CFG_XPPMEVL0_EXTADDR 18
#define B_PCH_PCIE_CFG_XPPMEVL0_EXTADDR (BIT19 | BIT18)

#define N_PCH_PCIE_CFG_XPPMEVL0_LOCK 20
#define B_PCH_PCIE_CFG_XPPMEVL0_LOCK (BIT21 | BIT20)

#define N_PCH_PCIE_CFG_XPPMEVL0_CMPR 22
#define B_PCH_PCIE_CFG_XPPMEVL0_CMPR (BIT23 | BIT22)

#define N_PCH_PCIE_CFG_XPPMEVL0_RDWR 24
#define B_PCH_PCIE_CFG_XPPMEVL0_RDWR (BIT25 | BIT24)

#define N_PCH_PCIE_CFG_XPPMEVL0_REQCMP 26
#define B_PCH_PCIE_CFG_XPPMEVL0_REQCMP (BIT27 | BIT26)

#define N_PCH_PCIE_CFG_XPPMEVL0_SNATTR 28
#define B_PCH_PCIE_CFG_XPPMEVL0_SNATTR (BIT29 | BIT28)

#define N_PCH_PCIE_CFG_XPPMEVL0_DND 30
#define B_PCH_PCIE_CFG_XPPMEVL0_DND (BIT31 | BIT30)

#define R_PCH_PCIE_CFG_XPPMEVL1  0x000005A0
#define S_PCH_PCIE_CFG_XPPMEVL1 4

#define N_PCH_PCIE_CFG_XPPMEVL1_CMPSTAT 0
#define B_PCH_PCIE_CFG_XPPMEVL1_CMPSTAT (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_XPPMEVL1_DATLEN 4
#define B_PCH_PCIE_CFG_XPPMEVL1_DATLEN (0x000007F0)

#define N_PCH_PCIE_CFG_XPPMEVL1_TTYP 11
#define B_PCH_PCIE_CFG_XPPMEVL1_TTYP (0x0000F800)

#define N_PCH_PCIE_CFG_XPPMEVL1_CFGTYP 16
#define B_PCH_PCIE_CFG_XPPMEVL1_CFGTYP (BIT17 | BIT16)

#define N_PCH_PCIE_CFG_XPPMEVL1_EXTADDR 18
#define B_PCH_PCIE_CFG_XPPMEVL1_EXTADDR (BIT19 | BIT18)

#define N_PCH_PCIE_CFG_XPPMEVL1_LOCK 20
#define B_PCH_PCIE_CFG_XPPMEVL1_LOCK (BIT21 | BIT20)

#define N_PCH_PCIE_CFG_XPPMEVL1_CMPR 22
#define B_PCH_PCIE_CFG_XPPMEVL1_CMPR (BIT23 | BIT22)

#define N_PCH_PCIE_CFG_XPPMEVL1_RDWR 24
#define B_PCH_PCIE_CFG_XPPMEVL1_RDWR (BIT25 | BIT24)

#define N_PCH_PCIE_CFG_XPPMEVL1_REQCMP 26
#define B_PCH_PCIE_CFG_XPPMEVL1_REQCMP (BIT27 | BIT26)

#define N_PCH_PCIE_CFG_XPPMEVL1_SNATTR 28
#define B_PCH_PCIE_CFG_XPPMEVL1_SNATTR (BIT29 | BIT28)

#define N_PCH_PCIE_CFG_XPPMEVL1_DND 30
#define B_PCH_PCIE_CFG_XPPMEVL1_DND (BIT31 | BIT30)



#define R_PCH_PCIE_CFG_XPPMEVH0 0x000005A4
#define S_PCH_PCIE_CFG_XPPMEVH0 4

#define N_PCH_PCIE_CFG_XPPMEVH0_RXTXSEL 0
#define B_PCH_PCIE_CFG_XPPMEVH0_RXTXSEL (BIT1 | BIT0)

#define N_PCH_PCIE_CFG_XPPMEVH0_GESEL 2
#define B_PCH_PCIE_CFG_XPPMEVH0_GESEL (BIT5 | BIT4 | BIT3 | BIT2)



#define R_PCH_PCIE_CFG_XPPMEVH1 0x000005A8
#define S_PCH_PCIE_CFG_XPPMEVH1 4

#define N_PCH_PCIE_CFG_XPPMEVH1_RXTXSEL 0
#define B_PCH_PCIE_CFG_XPPMEVH1_RXTXSEL (BIT1 | BIT0)

#define N_PCH_PCIE_CFG_XPPMEVH1_GESEL 2
#define B_PCH_PCIE_CFG_XPPMEVH1_GESEL (BIT5 | BIT4 | BIT3 | BIT2)



#define R_PCH_PCIE_CFG_XPPMER0 0x000005AC
#define S_PCH_PCIE_CFG_XPPMER0 4

#define N_PCH_PCIE_CFG_XPPMER0_TXRXSEL 0
#define B_PCH_PCIE_CFG_XPPMER0_TXRXSEL (BIT1 | BIT0)

#define N_PCH_PCIE_CFG_XPPMER0_FCCSEL 2
#define B_PCH_PCIE_CFG_XPPMER0_FCCSEL (BIT4 | BIT3 | BIT2)



#define N_PCH_PCIE_CFG_XPPMER0_VCSEL 5
#define B_PCH_PCIE_CFG_XPPMER0_VCSEL (BIT7 | BIT6 | BIT5)

#define N_PCH_PCIE_CFG_XPPMER0_AVCSEL 8
#define B_PCH_PCIE_CFG_XPPMER0_AVCSEL BIT8

#define N_PCH_PCIE_CFG_XPPMER0_HDSEL 9
#define B_PCH_PCIE_CFG_XPPMER0_HDSEL BIT9

#define N_PCH_PCIE_CFG_XPPMER0_QMSEL 10
#define B_PCH_PCIE_CFG_XPPMER0_QMSEL (BIT11 | BIT10)

#define N_PCH_PCIE_CFG_XPPMER0_LNKUTIL 13
#define B_PCH_PCIE_CFG_XPPMER0_LNKUTIL (BIT16 | BIT15 | BIT14 | BIT13)

#define N_PCH_PCIE_CFG_XPPMER0_XPRSCA 17
#define B_PCH_PCIE_CFG_XPPMER0_XPRSCA (BIT20 | BIT19 | BIT18 | BIT17)

#define N_PCH_PCIE_CFG_XPPMER0_RXL0SU 21
#define B_PCH_PCIE_CFG_XPPMER0_RXL0SU BIT21

#define N_PCH_PCIE_CFG_XPPMER0_TXL0SU 22
#define B_PCH_PCIE_CFG_XPPMER0_TXL0SU BIT22



#define N_PCH_PCIE_CFG_XPPMER0_CNTCERR 23
#define B_PCH_PCIE_CFG_XPPMER0_CNTCERR BIT23



#define N_PCH_PCIE_CFG_XPPMER0_CNTUCERR 24
#define B_PCH_PCIE_CFG_XPPMER0_CNTUCERR BIT24

#define N_PCH_PCIE_CFG_XPPMER0_L1SUE 25
#define B_PCH_PCIE_CFG_XPPMER0_L1SUE BIT25



#define R_PCH_PCIE_CFG_XPPMER1 0x000005B0
#define S_PCH_PCIE_CFG_XPPMER1 4

#define N_PCH_PCIE_CFG_XPPMER1_TXRXSEL 0
#define B_PCH_PCIE_CFG_XPPMER1_TXRXSEL (BIT1 | BIT0)

#define N_PCH_PCIE_CFG_XPPMER1_FCCSEL 2
#define B_PCH_PCIE_CFG_XPPMER1_FCCSEL (BIT4 | BIT3 | BIT2)



#define N_PCH_PCIE_CFG_XPPMER1_VCSEL 5
#define B_PCH_PCIE_CFG_XPPMER1_VCSEL (BIT7 | BIT6 | BIT5)

#define N_PCH_PCIE_CFG_XPPMER1_AVCSEL 8
#define B_PCH_PCIE_CFG_XPPMER1_AVCSEL BIT8

#define N_PCH_PCIE_CFG_XPPMER1_HDSEL 9
#define B_PCH_PCIE_CFG_XPPMER1_HDSEL BIT9

#define N_PCH_PCIE_CFG_XPPMER1_QMSEL 10
#define B_PCH_PCIE_CFG_XPPMER1_QMSEL (BIT11 | BIT10)

#define N_PCH_PCIE_CFG_XPPMER1_LNKUTIL 13
#define B_PCH_PCIE_CFG_XPPMER1_LNKUTIL (BIT16 | BIT15 | BIT14 | BIT13)

#define N_PCH_PCIE_CFG_XPPMER1_XPRSCA 17
#define B_PCH_PCIE_CFG_XPPMER1_XPRSCA (BIT20 | BIT19 | BIT18 | BIT17)

#define N_PCH_PCIE_CFG_XPPMER1_RXL0SU 21
#define B_PCH_PCIE_CFG_XPPMER1_RXL0SU BIT21

#define N_PCH_PCIE_CFG_XPPMER1_TXL0SU 22
#define B_PCH_PCIE_CFG_XPPMER1_TXL0SU BIT22



#define N_PCH_PCIE_CFG_XPPMER1_CNTCERR 23
#define B_PCH_PCIE_CFG_XPPMER1_CNTCERR BIT23



#define N_PCH_PCIE_CFG_XPPMER1_CNTUCERR 24
#define B_PCH_PCIE_CFG_XPPMER1_CNTUCERR BIT24

#define N_PCH_PCIE_CFG_XPPMER1_L1SUE 25
#define B_PCH_PCIE_CFG_XPPMER1_L1SUE BIT25



#define R_PCH_PCIE_CFG_XPPMDFXMAT0 0x000005B4
#define S_PCH_PCIE_CFG_XPPMDFXMAT0 4



#define N_PCH_PCIE_CFG_XPPMDFXMAT0_DFXMAT0 0
#define B_PCH_PCIE_CFG_XPPMDFXMAT0_DFXMAT0 (0x000000FF)



#define N_PCH_PCIE_CFG_XPPMDFXMAT0_DFXMAT1 8
#define B_PCH_PCIE_CFG_XPPMDFXMAT0_DFXMAT1 (0x0000FF00)



#define N_PCH_PCIE_CFG_XPPMDFXMAT0_DFXMAT2 16
#define B_PCH_PCIE_CFG_XPPMDFXMAT0_DFXMAT2 (0x00FF0000)

#define N_PCH_PCIE_CFG_XPPMDFXMAT0_ORFLOC 24
#define B_PCH_PCIE_CFG_XPPMDFXMAT0_ORFLOC (BIT25 | BIT24)

#define N_PCH_PCIE_CFG_XPPMDFXMAT0_DIV 26
#define B_PCH_PCIE_CFG_XPPMDFXMAT0_DIV (BIT27 | BIT26)



#define R_PCH_PCIE_CFG_XPPMDFXMAT1 0x000005B8
#define S_PCH_PCIE_CFG_XPPMDFXMAT1 4



#define N_PCH_PCIE_CFG_XPPMDFXMAT1_DFXMAT0 0
#define B_PCH_PCIE_CFG_XPPMDFXMAT1_DFXMAT0 (0x000000FF)



#define N_PCH_PCIE_CFG_XPPMDFXMAT1_DFXMAT1 8
#define B_PCH_PCIE_CFG_XPPMDFXMAT1_DFXMAT1 (0x0000FF00)



#define N_PCH_PCIE_CFG_XPPMDFXMAT1_DFXMAT2 16
#define B_PCH_PCIE_CFG_XPPMDFXMAT1_DFXMAT2 (0x00FF0000)

#define N_PCH_PCIE_CFG_XPPMDFXMAT1_ORFLOC 24
#define B_PCH_PCIE_CFG_XPPMDFXMAT1_ORFLOC (BIT25 | BIT24)

#define N_PCH_PCIE_CFG_XPPMDFXMAT1_DIV 26
#define B_PCH_PCIE_CFG_XPPMDFXMAT1_DIV (BIT27 | BIT26)



#define R_PCH_PCIE_CFG_XPPMDFXMSK0 0x000005BC
#define S_PCH_PCIE_CFG_XPPMDFXMSK0 4



#define N_PCH_PCIE_CFG_XPPMDFXMSK0_DFXMSK0 0
#define B_PCH_PCIE_CFG_XPPMDFXMSK0_DFXMSK0 (0x000000FF)



#define N_PCH_PCIE_CFG_XPPMDFXMSK0_DFXMSK1 8
#define B_PCH_PCIE_CFG_XPPMDFXMSK0_DFXMSK1 (0x0000FF00)



#define N_PCH_PCIE_CFG_XPPMDFXMSK0_DFXMSK2 16
#define B_PCH_PCIE_CFG_XPPMDFXMSK0_DFXMSK2 (0x00FF0000)



#define R_PCH_PCIE_CFG_XPPMDFXMSK1 0x000005C0
#define S_PCH_PCIE_CFG_XPPMDFXMSK1 4



#define N_PCH_PCIE_CFG_XPPMDFXMSK1_DFXMSK0 0
#define B_PCH_PCIE_CFG_XPPMDFXMSK1_DFXMSK0 (0x000000FF)



#define N_PCH_PCIE_CFG_XPPMDFXMSK1_DFXMSK1 8
#define B_PCH_PCIE_CFG_XPPMDFXMSK1_DFXMSK1 (0x0000FF00)



#define N_PCH_PCIE_CFG_XPPMDFXMSK1_DFXMSK2 16
#define B_PCH_PCIE_CFG_XPPMDFXMSK1_DFXMSK2 (0x00FF0000)

#define R_PCH_PCIE_CFG_XPPERFCON  0x000005C4
#define S_PCH_PCIE_CFG_XPPERFCON 4

#define N_PCH_PCIE_CFG_XPPERFCON_GRST 0
#define B_PCH_PCIE_CFG_XPPERFCON_GRST BIT0

#define N_PCH_PCIE_CFG_XPPERFCON_GCE 1
#define B_PCH_PCIE_CFG_XPPERFCON_GCE BIT1



#define R_PCH_PCIE_CFG_XPPERFSTAT 0x000005C8
#define S_PCH_PCIE_CFG_XPPERFSTAT 1

#define N_PCH_PCIE_CFG_XPPERFSTAT_XPPM0STAT 0
#define B_PCH_PCIE_CFG_XPPERFSTAT_XPPM0STAT BIT0

#define N_PCH_PCIE_CFG_XPPERFSTAT_XPPM1STAT 1
#define B_PCH_PCIE_CFG_XPPERFSTAT_XPPM1STAT BIT1



#define R_PCH_PCIE_CFG_VISALTMSKL 0x00000700
#define S_PCH_PCIE_CFG_VISALTMSKL 4

#define N_PCH_PCIE_CFG_VISALTMSKL_MASK_REG_LOW 0
#define B_PCH_PCIE_CFG_VISALTMSKL_MASK_REG_LOW (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_VISALTMSKH 0x00000704
#define S_PCH_PCIE_CFG_VISALTMSKH 4

#define N_PCH_PCIE_CFG_VISALTMSKH_MASK_REG_HIGH 0
#define B_PCH_PCIE_CFG_VISALTMSKH_MASK_REG_HIGH (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_VISALTMATL 0x00000708
#define S_PCH_PCIE_CFG_VISALTMATL 4

#define N_PCH_PCIE_CFG_VISALTMATL_MATCH_REG_LOW 0
#define B_PCH_PCIE_CFG_VISALTMATL_MATCH_REG_LOW (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_VISALTMATH 0x0000070C
#define S_PCH_PCIE_CFG_VISALTMATH 4

#define N_PCH_PCIE_CFG_VISALTMATH_MATCH_REG_HIGH 0
#define B_PCH_PCIE_CFG_VISALTMATH_MATCH_REG_HIGH (0xFFFFFFFF)

#define R_PCH_PCIE_CFG_XPHMSK0  0x00000710
#define S_PCH_PCIE_CFG_XPHMSK0 4



#define N_PCH_PCIE_CFG_XPHMSK0_HMSKBYT0 0
#define B_PCH_PCIE_CFG_XPHMSK0_HMSKBYT0 (0x000000FF)



#define N_PCH_PCIE_CFG_XPHMSK0_HMSKBYT1 8
#define B_PCH_PCIE_CFG_XPHMSK0_HMSKBYT1 (0x0000FF00)



#define N_PCH_PCIE_CFG_XPHMSK0_HMSKBYT2 16
#define B_PCH_PCIE_CFG_XPHMSK0_HMSKBYT2 (0x00FF0000)



#define N_PCH_PCIE_CFG_XPHMSK0_HMSKBYT3 24
#define B_PCH_PCIE_CFG_XPHMSK0_HMSKBYT3 (0xFF000000)



#define R_PCH_PCIE_CFG_XPHMSK1 0x00000714
#define S_PCH_PCIE_CFG_XPHMSK1 4



#define N_PCH_PCIE_CFG_XPHMSK1_HMSKBYT4 0
#define B_PCH_PCIE_CFG_XPHMSK1_HMSKBYT4 (0x000000FF)



#define N_PCH_PCIE_CFG_XPHMSK1_HMSKBYT5 8
#define B_PCH_PCIE_CFG_XPHMSK1_HMSKBYT5 (0x0000FF00)



#define N_PCH_PCIE_CFG_XPHMSK1_HMSKBYT6 16
#define B_PCH_PCIE_CFG_XPHMSK1_HMSKBYT6 (0x00FF0000)



#define N_PCH_PCIE_CFG_XPHMSK1_HMSKBYT7 24
#define B_PCH_PCIE_CFG_XPHMSK1_HMSKBYT7 (0xFF000000)



#define R_PCH_PCIE_CFG_XPHMSK2 0x00000718
#define S_PCH_PCIE_CFG_XPHMSK2 4



#define N_PCH_PCIE_CFG_XPHMSK2_HMSKBYT8 0
#define B_PCH_PCIE_CFG_XPHMSK2_HMSKBYT8 (0x000000FF)



#define N_PCH_PCIE_CFG_XPHMSK2_HMSKBYT9 8
#define B_PCH_PCIE_CFG_XPHMSK2_HMSKBYT9 (0x0000FF00)



#define N_PCH_PCIE_CFG_XPHMSK2_HMSKBYT10 16
#define B_PCH_PCIE_CFG_XPHMSK2_HMSKBYT10 (0x00FF0000)



#define N_PCH_PCIE_CFG_XPHMSK2_HMSKBYT11 24
#define B_PCH_PCIE_CFG_XPHMSK2_HMSKBYT11 (0xFF000000)



#define R_PCH_PCIE_CFG_XPHMSK3 0x0000071C
#define S_PCH_PCIE_CFG_XPHMSK3 4



#define N_PCH_PCIE_CFG_XPHMSK3_HMSKBYT12 0
#define B_PCH_PCIE_CFG_XPHMSK3_HMSKBYT12 (0x000000FF)



#define N_PCH_PCIE_CFG_XPHMSK3_HMSKBYT13 8
#define B_PCH_PCIE_CFG_XPHMSK3_HMSKBYT13 (0x0000FF00)



#define N_PCH_PCIE_CFG_XPHMSK3_HMSKBYT14 16
#define B_PCH_PCIE_CFG_XPHMSK3_HMSKBYT14 (0x00FF0000)



#define N_PCH_PCIE_CFG_XPHMSK3_HMSKBYT15 24
#define B_PCH_PCIE_CFG_XPHMSK3_HMSKBYT15 (0xFF000000)



#define R_PCH_PCIE_CFG_XPHMAT0 0x00000720
#define S_PCH_PCIE_CFG_XPHMAT0 4



#define N_PCH_PCIE_CFG_XPHMAT0_HMATBYT0 0
#define B_PCH_PCIE_CFG_XPHMAT0_HMATBYT0 (0x000000FF)



#define N_PCH_PCIE_CFG_XPHMAT0_HMATBYT1 8
#define B_PCH_PCIE_CFG_XPHMAT0_HMATBYT1 (0x0000FF00)



#define N_PCH_PCIE_CFG_XPHMAT0_HMATBYT2 16
#define B_PCH_PCIE_CFG_XPHMAT0_HMATBYT2 (0x00FF0000)



#define N_PCH_PCIE_CFG_XPHMAT0_HMATBYT3 24
#define B_PCH_PCIE_CFG_XPHMAT0_HMATBYT3 (0xFF000000)



#define R_PCH_PCIE_CFG_XPHMAT1 0x00000724
#define S_PCH_PCIE_CFG_XPHMAT1 4



#define N_PCH_PCIE_CFG_XPHMAT1_HMATBYT4 0
#define B_PCH_PCIE_CFG_XPHMAT1_HMATBYT4 (0x000000FF)



#define N_PCH_PCIE_CFG_XPHMAT1_HMATBYT5 8
#define B_PCH_PCIE_CFG_XPHMAT1_HMATBYT5 (0x0000FF00)



#define N_PCH_PCIE_CFG_XPHMAT1_HMATBYT6 16
#define B_PCH_PCIE_CFG_XPHMAT1_HMATBYT6 (0x00FF0000)



#define N_PCH_PCIE_CFG_XPHMAT1_HMATBYT7 24
#define B_PCH_PCIE_CFG_XPHMAT1_HMATBYT7 (0xFF000000)



#define R_PCH_PCIE_CFG_XPHMAT2 0x00000728
#define S_PCH_PCIE_CFG_XPHMAT2 4



#define N_PCH_PCIE_CFG_XPHMAT2_HMATBYT8 0
#define B_PCH_PCIE_CFG_XPHMAT2_HMATBYT8 (0x000000FF)



#define N_PCH_PCIE_CFG_XPHMAT2_HMATBYT9 8
#define B_PCH_PCIE_CFG_XPHMAT2_HMATBYT9 (0x0000FF00)



#define N_PCH_PCIE_CFG_XPHMAT2_HMATBYT10 16
#define B_PCH_PCIE_CFG_XPHMAT2_HMATBYT10 (0x00FF0000)



#define N_PCH_PCIE_CFG_XPHMAT2_HMATBYT11 24
#define B_PCH_PCIE_CFG_XPHMAT2_HMATBYT11 (0xFF000000)



#define R_PCH_PCIE_CFG_XPHMAT3 0x0000072C
#define S_PCH_PCIE_CFG_XPHMAT3 4



#define N_PCH_PCIE_CFG_XPHMAT3_HMATBYT12 0
#define B_PCH_PCIE_CFG_XPHMAT3_HMATBYT12 (0x000000FF)



#define N_PCH_PCIE_CFG_XPHMAT3_HMATBYT13 8
#define B_PCH_PCIE_CFG_XPHMAT3_HMATBYT13 (0x0000FF00)



#define N_PCH_PCIE_CFG_XPHMAT3_HMATBYT14 16
#define B_PCH_PCIE_CFG_XPHMAT3_HMATBYT14 (0x00FF0000)



#define N_PCH_PCIE_CFG_XPHMAT3_HMATBYT15 24
#define B_PCH_PCIE_CFG_XPHMAT3_HMATBYT15 (0xFF000000)



#define R_PCH_PCIE_CFG_XPTRIGSEL 0x00000730
#define S_PCH_PCIE_CFG_XPTRIGSEL 2

#define N_PCH_PCIE_CFG_XPTRIGSEL_IPT0SEL 0
#define B_PCH_PCIE_CFG_XPTRIGSEL_IPT0SEL (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_XPTRIGSEL_IPT1SEL 4
#define B_PCH_PCIE_CFG_XPTRIGSEL_IPT1SEL (BIT7 | BIT6 | BIT5 | BIT4)

#define N_PCH_PCIE_CFG_XPTRIGSEL_IPT2SEL 8
#define B_PCH_PCIE_CFG_XPTRIGSEL_IPT2SEL (BIT11 | BIT10 | BIT9 | BIT8)

#define N_PCH_PCIE_CFG_XPTRIGSEL_IPT3SEL 12
#define B_PCH_PCIE_CFG_XPTRIGSEL_IPT3SEL (BIT15 | BIT14 | BIT13 | BIT12)



#define R_PCH_PCIE_CFG_LTSSMTOSEL 0x00000732
#define S_PCH_PCIE_CFG_LTSSMTOSEL 2

#define N_PCH_PCIE_CFG_LTSSMTOSEL_LTTO0SEL 0
#define B_PCH_PCIE_CFG_LTSSMTOSEL_LTTO0SEL (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_LTSSMTOSEL_LTTO1SEL 4
#define B_PCH_PCIE_CFG_LTSSMTOSEL_LTTO1SEL (BIT7 | BIT6 | BIT5 | BIT4)

#define N_PCH_PCIE_CFG_LTSSMTOSEL_LTTO2SEL 8
#define B_PCH_PCIE_CFG_LTSSMTOSEL_LTTO2SEL (BIT11 | BIT10 | BIT9 | BIT8)

#define N_PCH_PCIE_CFG_LTSSMTOSEL_LTTO3SEL 12
#define B_PCH_PCIE_CFG_LTSSMTOSEL_LTTO3SEL (BIT15 | BIT14 | BIT13 | BIT12)

#define R_PCH_PCIE_CFG_XPEINJ0  0x00000734
#define S_PCH_PCIE_CFG_XPEINJ0 2

#define N_PCH_PCIE_CFG_XPEINJ0_START_SEL 0
#define B_PCH_PCIE_CFG_XPEINJ0_START_SEL (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_XPEINJ0_STOP_SEL 4
#define B_PCH_PCIE_CFG_XPEINJ0_STOP_SEL (BIT7 | BIT6 | BIT5 | BIT4)

#define R_PCH_PCIE_CFG_XPEINJ1  0x00000736
#define S_PCH_PCIE_CFG_XPEINJ1 2

#define N_PCH_PCIE_CFG_XPEINJ1_START_SEL 0
#define B_PCH_PCIE_CFG_XPEINJ1_START_SEL (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_XPEINJ1_STOP_SEL 4
#define B_PCH_PCIE_CFG_XPEINJ1_STOP_SEL (BIT7 | BIT6 | BIT5 | BIT4)



#define R_PCH_PCIE_CFG_XPERRINJCTL 0x00000738
#define S_PCH_PCIE_CFG_XPERRINJCTL 4

#define N_PCH_PCIE_CFG_XPERRINJCTL_DPF 0
#define B_PCH_PCIE_CFG_XPERRINJCTL_DPF (0x000000FF)

#define N_PCH_PCIE_CFG_XPERRINJCTL_CPF 8
#define B_PCH_PCIE_CFG_XPERRINJCTL_CPF (BIT11 | BIT10 | BIT9 | BIT8)

#define N_PCH_PCIE_CFG_XPERRINJCTL_RSPDONEDIS 28
#define B_PCH_PCIE_CFG_XPERRINJCTL_RSPDONEDIS BIT28

#define N_PCH_PCIE_CFG_XPERRINJCTL_ERRINJSTS 29
#define B_PCH_PCIE_CFG_XPERRINJCTL_ERRINJSTS BIT29

#define N_PCH_PCIE_CFG_XPERRINJCTL_EIRFS 30
#define B_PCH_PCIE_CFG_XPERRINJCTL_EIRFS BIT30

#define N_PCH_PCIE_CFG_XPERRINJCTL_ERRINJEN 31
#define B_PCH_PCIE_CFG_XPERRINJCTL_ERRINJEN BIT31



#define R_PCH_PCIE_CFG_XPERRINJLOG 0x0000073C
#define S_PCH_PCIE_CFG_XPERRINJLOG 4



#define N_PCH_PCIE_CFG_XPERRINJLOG_LLPE 0
#define B_PCH_PCIE_CFG_XPERRINJLOG_LLPE BIT0



#define N_PCH_PCIE_CFG_XPERRINJLOG_TXPE 1
#define B_PCH_PCIE_CFG_XPERRINJLOG_TXPE BIT1



#define N_PCH_PCIE_CFG_XPERRINJLOG_RXPE 2
#define B_PCH_PCIE_CFG_XPERRINJLOG_RXPE BIT2



#define N_PCH_PCIE_CFG_XPERRINJLOG_IOSFPE 3
#define B_PCH_PCIE_CFG_XPERRINJLOG_IOSFPE BIT3



#define N_PCH_PCIE_CFG_XPERRINJLOG_CFGWRPE 4
#define B_PCH_PCIE_CFG_XPERRINJLOG_CFGWRPE BIT4



#define N_PCH_PCIE_CFG_XPERRINJLOG_CFGPE 5
#define B_PCH_PCIE_CFG_XPERRINJLOG_CFGPE BIT5



#define R_PCH_PCIE_CFG_TRIGEVMSK 0x00000750
#define S_PCH_PCIE_CFG_TRIGEVMSK 4

#define N_PCH_PCIE_CFG_TRIGEVMSK_MASK 0
#define B_PCH_PCIE_CFG_TRIGEVMSK_MASK (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_TRIGEVSTS 0x00000758
#define S_PCH_PCIE_CFG_TRIGEVSTS 4

#define N_PCH_PCIE_CFG_TRIGEVSTS_IPTRIGSTS 0
#define B_PCH_PCIE_CFG_TRIGEVSTS_IPTRIGSTS (0x0000003F)

#define N_PCH_PCIE_CFG_TRIGEVSTS_DBGEVSTS 8
#define B_PCH_PCIE_CFG_TRIGEVSTS_DBGEVSTS (0x0000FF00)



#define R_PCH_PCIE_CFG_ERRUNCDETMSK 0x00000774
#define S_PCH_PCIE_CFG_ERRUNCDETMSK 4



#define N_PCH_PCIE_CFG_ERRUNCDETMSK_DLPEDM 4
#define B_PCH_PCIE_CFG_ERRUNCDETMSK_DLPEDM BIT4



#define N_PCH_PCIE_CFG_ERRUNCDETMSK_SLDEDM 5
#define B_PCH_PCIE_CFG_ERRUNCDETMSK_SLDEDM BIT5



#define N_PCH_PCIE_CFG_ERRUNCDETMSK_PTLPEDM 12
#define B_PCH_PCIE_CFG_ERRUNCDETMSK_PTLPEDM BIT12



#define N_PCH_PCIE_CFG_ERRUNCDETMSK_FCEDM 13
#define B_PCH_PCIE_CFG_ERRUNCDETMSK_FCEDM BIT13



#define N_PCH_PCIE_CFG_ERRUNCDETMSK_CTEDM 14
#define B_PCH_PCIE_CFG_ERRUNCDETMSK_CTEDM BIT14



#define N_PCH_PCIE_CFG_ERRUNCDETMSK_CAEDM 15
#define B_PCH_PCIE_CFG_ERRUNCDETMSK_CAEDM BIT15



#define N_PCH_PCIE_CFG_ERRUNCDETMSK_UCEDM 16
#define B_PCH_PCIE_CFG_ERRUNCDETMSK_UCEDM BIT16



#define N_PCH_PCIE_CFG_ERRUNCDETMSK_ROEDM 17
#define B_PCH_PCIE_CFG_ERRUNCDETMSK_ROEDM BIT17



#define N_PCH_PCIE_CFG_ERRUNCDETMSK_MTLPEDM 18
#define B_PCH_PCIE_CFG_ERRUNCDETMSK_MTLPEDM BIT18



#define N_PCH_PCIE_CFG_ERRUNCDETMSK_ECRCEDM 19
#define B_PCH_PCIE_CFG_ERRUNCDETMSK_ECRCEDM BIT19



#define N_PCH_PCIE_CFG_ERRUNCDETMSK_UREDM 20
#define B_PCH_PCIE_CFG_ERRUNCDETMSK_UREDM BIT20



#define N_PCH_PCIE_CFG_ERRUNCDETMSK_ACSEDM 21
#define B_PCH_PCIE_CFG_ERRUNCDETMSK_ACSEDM BIT21



#define N_PCH_PCIE_CFG_ERRUNCDETMSK_UIEDM 22
#define B_PCH_PCIE_CFG_ERRUNCDETMSK_UIEDM BIT22



#define N_PCH_PCIE_CFG_ERRUNCDETMSK_MCEDM 23
#define B_PCH_PCIE_CFG_ERRUNCDETMSK_MCEDM BIT23



#define N_PCH_PCIE_CFG_ERRUNCDETMSK_AEBEDM 24
#define B_PCH_PCIE_CFG_ERRUNCDETMSK_AEBEDM BIT24



#define N_PCH_PCIE_CFG_ERRUNCDETMSK_TPBEDM 25
#define B_PCH_PCIE_CFG_ERRUNCDETMSK_TPBEDM BIT25



#define N_PCH_PCIE_CFG_ERRUNCDETMSK_PTLPEBDM 26
#define B_PCH_PCIE_CFG_ERRUNCDETMSK_PTLPEBDM BIT26



#define R_PCH_PCIE_CFG_ERRCORDETMSK 0x00000778
#define S_PCH_PCIE_CFG_ERRCORDETMSK 4



#define N_PCH_PCIE_CFG_ERRCORDETMSK_REDM 0
#define B_PCH_PCIE_CFG_ERRCORDETMSK_REDM BIT0



#define N_PCH_PCIE_CFG_ERRCORDETMSK_BTLPEDM 6
#define B_PCH_PCIE_CFG_ERRCORDETMSK_BTLPEDM BIT6



#define N_PCH_PCIE_CFG_ERRCORDETMSK_BDLLPEDM 7
#define B_PCH_PCIE_CFG_ERRCORDETMSK_BDLLPEDM BIT7



#define N_PCH_PCIE_CFG_ERRCORDETMSK_RNREDM 8
#define B_PCH_PCIE_CFG_ERRCORDETMSK_RNREDM BIT8



#define N_PCH_PCIE_CFG_ERRCORDETMSK_RTTEDM 12
#define B_PCH_PCIE_CFG_ERRCORDETMSK_RTTEDM BIT12



#define N_PCH_PCIE_CFG_ERRCORDETMSK_ANFEDM 13
#define B_PCH_PCIE_CFG_ERRCORDETMSK_ANFEDM BIT13



#define N_PCH_PCIE_CFG_ERRCORDETMSK_CIEDM 14
#define B_PCH_PCIE_CFG_ERRCORDETMSK_CIEDM BIT14



#define N_PCH_PCIE_CFG_ERRCORDETMSK_HLOEDM 15
#define B_PCH_PCIE_CFG_ERRCORDETMSK_HLOEDM BIT15



#define R_PCH_PCIE_CFG_ROOTERRDETMSK 0x0000077C
#define S_PCH_PCIE_CFG_ROOTERRDETMSK 4



#define N_PCH_PCIE_CFG_ROOTERRDETMSK_RCEMDM 0
#define B_PCH_PCIE_CFG_ROOTERRDETMSK_RCEMDM BIT0



#define N_PCH_PCIE_CFG_ROOTERRDETMSK_RNFMDM 1
#define B_PCH_PCIE_CFG_ROOTERRDETMSK_RNFMDM BIT1



#define N_PCH_PCIE_CFG_ROOTERRDETMSK_RFMDM 2
#define B_PCH_PCIE_CFG_ROOTERRDETMSK_RFMDM BIT2



#define R_PCH_PCIE_CFG_PTMPD 0x00000780
#define S_PCH_PCIE_CFG_PTMPD 4



#define N_PCH_PCIE_CFG_PTMPD_CPTMPDV 0
#define B_PCH_PCIE_CFG_PTMPD_CPTMPDV (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_PTMLLMT 0x00000784
#define S_PCH_PCIE_CFG_PTMLLMT 4



#define N_PCH_PCIE_CFG_PTMLLMT_LMTV 0
#define B_PCH_PCIE_CFG_PTMLLMT_LMTV (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_PTMULMT 0x00000788
#define S_PCH_PCIE_CFG_PTMULMT 4



#define N_PCH_PCIE_CFG_PTMULMT_UMTV 0
#define B_PCH_PCIE_CFG_PTMULMT_UMTV (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_PTMLLRMT 0x0000078C
#define S_PCH_PCIE_CFG_PTMLLRMT 4



#define N_PCH_PCIE_CFG_PTMLLRMT_LLMTV 0
#define B_PCH_PCIE_CFG_PTMLLRMT_LLMTV (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_PTMULRMT 0x00000790
#define S_PCH_PCIE_CFG_PTMULRMT 4



#define N_PCH_PCIE_CFG_PTMULRMT_ULMTV 0
#define B_PCH_PCIE_CFG_PTMULRMT_ULMTV (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_PTMGTECSR 0x00000794
#define S_PCH_PCIE_CFG_PTMGTECSR 4

#define N_PCH_PCIE_CFG_PTMGTECSR_IOSFMADP 0
#define B_PCH_PCIE_CFG_PTMGTECSR_IOSFMADP (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_PTMGTECSR_TGTSCF 8
#define B_PCH_PCIE_CFG_PTMGTECSR_TGTSCF BIT8

#define N_PCH_PCIE_CFG_PTMGTECSR_PGTSCFE 9
#define B_PCH_PCIE_CFG_PTMGTECSR_PGTSCFE BIT9

#define N_PCH_PCIE_CFG_PTMGTECSR_PGTSCFF 10
#define B_PCH_PCIE_CFG_PTMGTECSR_PGTSCFF (BIT12 | BIT11 | BIT10)



#define N_PCH_PCIE_CFG_PTMGTECSR_GTFSPC 13
#define B_PCH_PCIE_CFG_PTMGTECSR_GTFSPC BIT13

#define N_PCH_PCIE_CFG_PTMGTECSR_GTFFC 14
#define B_PCH_PCIE_CFG_PTMGTECSR_GTFFC (BIT15 | BIT14)



#define N_PCH_PCIE_CFG_PTMGTECSR_MTSV 16
#define B_PCH_PCIE_CFG_PTMGTECSR_MTSV BIT16

#define N_PCH_PCIE_CFG_PTMGTECSR_GTFFE 24
#define B_PCH_PCIE_CFG_PTMGTECSR_GTFFE BIT24

#define N_PCH_PCIE_CFG_PTMGTECSR_GTFFP 25
#define B_PCH_PCIE_CFG_PTMGTECSR_GTFFP (BIT26 | BIT25)



#define R_PCH_PCIE_CFG_PTMG1TXPSD 0x00000798
#define S_PCH_PCIE_CFG_PTMG1TXPSD 4

#define N_PCH_PCIE_CFG_PTMG1TXPSD_X1PSDC 0
#define B_PCH_PCIE_CFG_PTMG1TXPSD_X1PSDC (0x0000003F)

#define N_PCH_PCIE_CFG_PTMG1TXPSD_X2PSDC 6
#define B_PCH_PCIE_CFG_PTMG1TXPSD_X2PSDC (0x00000FC0)

#define N_PCH_PCIE_CFG_PTMG1TXPSD_X4PSDC 12
#define B_PCH_PCIE_CFG_PTMG1TXPSD_X4PSDC (0x0003F000)

#define N_PCH_PCIE_CFG_PTMG1TXPSD_X8PSDC 18
#define B_PCH_PCIE_CFG_PTMG1TXPSD_X8PSDC (0x00FC0000)

#define N_PCH_PCIE_CFG_PTMG1TXPSD_X16PSDC 24
#define B_PCH_PCIE_CFG_PTMG1TXPSD_X16PSDC (0x3F000000)

#define N_PCH_PCIE_CFG_PTMG1TXPSD_PSDS 30
#define B_PCH_PCIE_CFG_PTMG1TXPSD_PSDS (BIT31 | BIT30)



#define R_PCH_PCIE_CFG_PTMG1RXPSD 0x0000079C
#define S_PCH_PCIE_CFG_PTMG1RXPSD 4

#define N_PCH_PCIE_CFG_PTMG1RXPSD_X1PSDC 0
#define B_PCH_PCIE_CFG_PTMG1RXPSD_X1PSDC (0x0000003F)

#define N_PCH_PCIE_CFG_PTMG1RXPSD_X2PSDC 6
#define B_PCH_PCIE_CFG_PTMG1RXPSD_X2PSDC (0x00000FC0)

#define N_PCH_PCIE_CFG_PTMG1RXPSD_X4PSDC 12
#define B_PCH_PCIE_CFG_PTMG1RXPSD_X4PSDC (0x0003F000)

#define N_PCH_PCIE_CFG_PTMG1RXPSD_X8PSDC 18
#define B_PCH_PCIE_CFG_PTMG1RXPSD_X8PSDC (0x00FC0000)

#define N_PCH_PCIE_CFG_PTMG1RXPSD_X16PSDC 24
#define B_PCH_PCIE_CFG_PTMG1RXPSD_X16PSDC (0x3F000000)

#define N_PCH_PCIE_CFG_PTMG1RXPSD_PSDS 30
#define B_PCH_PCIE_CFG_PTMG1RXPSD_PSDS (BIT31 | BIT30)



#define R_PCH_PCIE_CFG_PTMG2TXPSD 0x000007A0
#define S_PCH_PCIE_CFG_PTMG2TXPSD 4

#define N_PCH_PCIE_CFG_PTMG2TXPSD_X1PSDC 0
#define B_PCH_PCIE_CFG_PTMG2TXPSD_X1PSDC (0x0000003F)

#define N_PCH_PCIE_CFG_PTMG2TXPSD_X2PSDC 6
#define B_PCH_PCIE_CFG_PTMG2TXPSD_X2PSDC (0x00000FC0)

#define N_PCH_PCIE_CFG_PTMG2TXPSD_X4PSDC 12
#define B_PCH_PCIE_CFG_PTMG2TXPSD_X4PSDC (0x0003F000)

#define N_PCH_PCIE_CFG_PTMG2TXPSD_X8PSDC 18
#define B_PCH_PCIE_CFG_PTMG2TXPSD_X8PSDC (0x00FC0000)

#define N_PCH_PCIE_CFG_PTMG2TXPSD_X16PSDC 24
#define B_PCH_PCIE_CFG_PTMG2TXPSD_X16PSDC (0x3F000000)

#define N_PCH_PCIE_CFG_PTMG2TXPSD_PSDS 30
#define B_PCH_PCIE_CFG_PTMG2TXPSD_PSDS (BIT31 | BIT30)



#define R_PCH_PCIE_CFG_PTMG2RXPSD 0x000007A4
#define S_PCH_PCIE_CFG_PTMG2RXPSD 4

#define N_PCH_PCIE_CFG_PTMG2RXPSD_X1PSDC 0
#define B_PCH_PCIE_CFG_PTMG2RXPSD_X1PSDC (0x0000003F)

#define N_PCH_PCIE_CFG_PTMG2RXPSD_X2PSDC 6
#define B_PCH_PCIE_CFG_PTMG2RXPSD_X2PSDC (0x00000FC0)

#define N_PCH_PCIE_CFG_PTMG2RXPSD_X4PSDC 12
#define B_PCH_PCIE_CFG_PTMG2RXPSD_X4PSDC (0x0003F000)

#define N_PCH_PCIE_CFG_PTMG2RXPSD_X8PSDC 18
#define B_PCH_PCIE_CFG_PTMG2RXPSD_X8PSDC (0x00FC0000)

#define N_PCH_PCIE_CFG_PTMG2RXPSD_X16PSDC 24
#define B_PCH_PCIE_CFG_PTMG2RXPSD_X16PSDC (0x3F000000)

#define N_PCH_PCIE_CFG_PTMG2RXPSD_PSDS 30
#define B_PCH_PCIE_CFG_PTMG2RXPSD_PSDS (BIT31 | BIT30)



#define R_PCH_PCIE_CFG_PTMG3TXPSD 0x000007A8
#define S_PCH_PCIE_CFG_PTMG3TXPSD 4

#define N_PCH_PCIE_CFG_PTMG3TXPSD_X1PSDC 0
#define B_PCH_PCIE_CFG_PTMG3TXPSD_X1PSDC (0x0000003F)

#define N_PCH_PCIE_CFG_PTMG3TXPSD_X2PSDC 6
#define B_PCH_PCIE_CFG_PTMG3TXPSD_X2PSDC (0x00000FC0)

#define N_PCH_PCIE_CFG_PTMG3TXPSD_X4PSDC 12
#define B_PCH_PCIE_CFG_PTMG3TXPSD_X4PSDC (0x0003F000)

#define N_PCH_PCIE_CFG_PTMG3TXPSD_X8PSDC 18
#define B_PCH_PCIE_CFG_PTMG3TXPSD_X8PSDC (0x00FC0000)

#define N_PCH_PCIE_CFG_PTMG3TXPSD_X16PSDC 24
#define B_PCH_PCIE_CFG_PTMG3TXPSD_X16PSDC (0x3F000000)

#define N_PCH_PCIE_CFG_PTMG3TXPSD_PSDS 30
#define B_PCH_PCIE_CFG_PTMG3TXPSD_PSDS (BIT31 | BIT30)



#define R_PCH_PCIE_CFG_PTMG3RXPSD 0x000007AC
#define S_PCH_PCIE_CFG_PTMG3RXPSD 4

#define N_PCH_PCIE_CFG_PTMG3RXPSD_X1PSDC 0
#define B_PCH_PCIE_CFG_PTMG3RXPSD_X1PSDC (0x0000003F)

#define N_PCH_PCIE_CFG_PTMG3RXPSD_X2PSDC 6
#define B_PCH_PCIE_CFG_PTMG3RXPSD_X2PSDC (0x00000FC0)

#define N_PCH_PCIE_CFG_PTMG3RXPSD_X4PSDC 12
#define B_PCH_PCIE_CFG_PTMG3RXPSD_X4PSDC (0x0003F000)

#define N_PCH_PCIE_CFG_PTMG3RXPSD_X8PSDC 18
#define B_PCH_PCIE_CFG_PTMG3RXPSD_X8PSDC (0x00FC0000)

#define N_PCH_PCIE_CFG_PTMG3RXPSD_X16PSDC 24
#define B_PCH_PCIE_CFG_PTMG3RXPSD_X16PSDC (0x3F000000)

#define N_PCH_PCIE_CFG_PTMG3RXPSD_PSDS 30
#define B_PCH_PCIE_CFG_PTMG3RXPSD_PSDS (BIT31 | BIT30)



#define R_PCH_PCIE_CFG_PTMECSR 0x000007B4
#define S_PCH_PCIE_CFG_PTMECSR 4



#define N_PCH_PCIE_CFG_PTMECSR_PTMRDV 0
#define B_PCH_PCIE_CFG_PTMECSR_PTMRDV BIT0

#define N_PCH_PCIE_CFG_PTMECSR_PTMRDID 8
#define B_PCH_PCIE_CFG_PTMECSR_PTMRDID (BIT10 | BIT9 | BIT8)



#define R_PCH_PCIE_CFG_FUSECSR1 0x000007F0
#define S_PCH_PCIE_CFG_FUSECSR1 4

#define N_PCH_PCIE_CFG_FUSECSR1_FI 0
#define B_PCH_PCIE_CFG_FUSECSR1_FI (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_FUSECSR2 0x000007F4
#define S_PCH_PCIE_CFG_FUSECSR2 4

#define N_PCH_PCIE_CFG_FUSECSR2_FI 0
#define B_PCH_PCIE_CFG_FUSECSR2_FI (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_STRAPCSR1 0x000007F8
#define S_PCH_PCIE_CFG_STRAPCSR1 4

#define N_PCH_PCIE_CFG_STRAPCSR1_SI 0
#define B_PCH_PCIE_CFG_STRAPCSR1_SI (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_STRAPCSR2 0x000007FC
#define S_PCH_PCIE_CFG_STRAPCSR2 4

#define N_PCH_PCIE_CFG_STRAPCSR2_SI 0
#define B_PCH_PCIE_CFG_STRAPCSR2_SI (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_FCCRDSSCTL 0x00000880
#define S_PCH_PCIE_CFG_FCCRDSSCTL 4

#define N_PCH_PCIE_CFG_FCCRDSSCTL_FLOW_CLASS 0
#define B_PCH_PCIE_CFG_FCCRDSSCTL_FLOW_CLASS (BIT1 | BIT0)



#define N_PCH_PCIE_CFG_FCCRDSSCTL_VIRTUAL_CHANNEL 4
#define B_PCH_PCIE_CFG_FCCRDSSCTL_VIRTUAL_CHANNEL (BIT6 | BIT5 | BIT4)



#define N_PCH_PCIE_CFG_FCCRDSSCTL_FREEZE_CNT 7
#define B_PCH_PCIE_CFG_FCCRDSSCTL_FREEZE_CNT BIT7



#define R_PCH_PCIE_CFG_FCCRDLSS 0x00000884
#define S_PCH_PCIE_CFG_FCCRDLSS 4



#define N_PCH_PCIE_CFG_FCCRDLSS_DSS 0
#define B_PCH_PCIE_CFG_FCCRDLSS_DSS (0x00000FFF)



#define N_PCH_PCIE_CFG_FCCRDLSS_ICFD 12
#define B_PCH_PCIE_CFG_FCCRDLSS_ICFD BIT12



#define N_PCH_PCIE_CFG_FCCRDLSS_HSS 16
#define B_PCH_PCIE_CFG_FCCRDLSS_HSS (0x00FF0000)



#define N_PCH_PCIE_CFG_FCCRDLSS_ICFH 24
#define B_PCH_PCIE_CFG_FCCRDLSS_ICFH BIT24



#define R_PCH_PCIE_CFG_FCCRDASS 0x00000888
#define S_PCH_PCIE_CFG_FCCRDASS 4



#define N_PCH_PCIE_CFG_FCCRDASS_DSS 0
#define B_PCH_PCIE_CFG_FCCRDASS_DSS (0x00000FFF)



#define N_PCH_PCIE_CFG_FCCRDASS_ICFD 12
#define B_PCH_PCIE_CFG_FCCRDASS_ICFD BIT12



#define N_PCH_PCIE_CFG_FCCRDASS_HSS 16
#define B_PCH_PCIE_CFG_FCCRDASS_HSS (0x00FF0000)



#define N_PCH_PCIE_CFG_FCCRDASS_ICFH 24
#define B_PCH_PCIE_CFG_FCCRDASS_ICFH BIT24



#define R_PCH_PCIE_CFG_FCCRDCSS 0x0000088C
#define S_PCH_PCIE_CFG_FCCRDCSS 4



#define N_PCH_PCIE_CFG_FCCRDCSS_DSS 0
#define B_PCH_PCIE_CFG_FCCRDCSS_DSS (0x00000FFF)



#define N_PCH_PCIE_CFG_FCCRDCSS_HSS 16
#define B_PCH_PCIE_CFG_FCCRDCSS_HSS (0x00FF0000)



#define R_PCH_PCIE_CFG_FCCRDRSS 0x00000890
#define S_PCH_PCIE_CFG_FCCRDRSS 4



#define N_PCH_PCIE_CFG_FCCRDRSS_DSS 0
#define B_PCH_PCIE_CFG_FCCRDRSS_DSS (0x00000FFF)



#define N_PCH_PCIE_CFG_FCCRDRSS_HSS 16
#define B_PCH_PCIE_CFG_FCCRDRSS_HSS (0x00FF0000)



#define R_PCH_PCIE_CFG_FCCRDDSS 0x00000894
#define S_PCH_PCIE_CFG_FCCRDDSS 4



#define N_PCH_PCIE_CFG_FCCRDDSS_RDD 0
#define B_PCH_PCIE_CFG_FCCRDDSS_RDD (0x000000FF)



#define N_PCH_PCIE_CFG_FCCRDDSS_RHD 8
#define B_PCH_PCIE_CFG_FCCRDDSS_RHD (0x0000FF00)



#define N_PCH_PCIE_CFG_FCCRDDSS_TDD 16
#define B_PCH_PCIE_CFG_FCCRDDSS_TDD (0x00FF0000)



#define N_PCH_PCIE_CFG_FCCRDDSS_THD 24
#define B_PCH_PCIE_CFG_FCCRDDSS_THD (0xFF000000)



#define R_PCH_PCIE_CFG_RPR 0x000008B0
#define S_PCH_PCIE_CFG_RPR 4

#define N_PCH_PCIE_CFG_RPR_DM 0
#define B_PCH_PCIE_CFG_RPR_DM (BIT1 | BIT0)

#define N_PCH_PCIE_CFG_RPR_WRM 2
#define B_PCH_PCIE_CFG_RPR_WRM (BIT3 | BIT2)

#define N_PCH_PCIE_CFG_RPR_CRM 4
#define B_PCH_PCIE_CFG_RPR_CRM (BIT5 | BIT4)

#define N_PCH_PCIE_CFG_RPR_S3SM 6
#define B_PCH_PCIE_CFG_RPR_S3SM (BIT7 | BIT6)

#define N_PCH_PCIE_CFG_RPR_S4SM 8
#define B_PCH_PCIE_CFG_RPR_S4SM (BIT9 | BIT8)

#define N_PCH_PCIE_CFG_RPR_S5SM 10
#define B_PCH_PCIE_CFG_RPR_S5SM (BIT11 | BIT10)

#define N_PCH_PCIE_CFG_RPR_CL 31
#define B_PCH_PCIE_CFG_RPR_CL BIT31



#define R_PCH_PCIE_CFG_SPADSEMA 0x000008C0
#define S_PCH_PCIE_CFG_SPADSEMA 4

#define N_PCH_PCIE_CFG_SPADSEMA_SPADSEMA 0
#define B_PCH_PCIE_CFG_SPADSEMA_SPADSEMA BIT0



#define R_PCH_PCIE_CFG_SPAD 0x000008C4
#define S_PCH_PCIE_CFG_SPAD 4



#define N_PCH_PCIE_CFG_SPAD_SPAD 0
#define B_PCH_PCIE_CFG_SPAD_SPAD (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_VPPDEF 0x000008D8
#define S_PCH_PCIE_CFG_VPPDEF 4

#define N_PCH_PCIE_CFG_VPPDEF_BSURR 0
#define B_PCH_PCIE_CFG_VPPDEF_BSURR BIT0

#define N_PCH_PCIE_CFG_VPPDEF_BDAP 1
#define B_PCH_PCIE_CFG_VPPDEF_BDAP BIT1

#define N_PCH_PCIE_CFG_VPPDEF_CTO 2
#define B_PCH_PCIE_CFG_VPPDEF_CTO (0x000000FC)

#define N_PCH_PCIE_CFG_VPPDEF_DAGTO 8
#define B_PCH_PCIE_CFG_VPPDEF_DAGTO (0x00003F00)

#define N_PCH_PCIE_CFG_VPPDEF_LEDBF 14
#define B_PCH_PCIE_CFG_VPPDEF_LEDBF BIT14

#define N_PCH_PCIE_CFG_VPPDEF_PFDDISEDGE 15
#define B_PCH_PCIE_CFG_VPPDEF_PFDDISEDGE BIT15



#define N_PCH_PCIE_CFG_VPPDEF_RECO 16
#define B_PCH_PCIE_CFG_VPPDEF_RECO (0xFFFF0000)



#define R_PCH_PCIE_CFG_PT0TXNCLKGCTL 0x000008E4
#define S_PCH_PCIE_CFG_PT0TXNCLKGCTL 2

#define N_PCH_PCIE_CFG_PT0TXNCLKGCTL_ICT 0
#define B_PCH_PCIE_CFG_PT0TXNCLKGCTL_ICT (0x00FF)



#define N_PCH_PCIE_CFG_PT0TXNCLKGCTL_ICGE 15
#define B_PCH_PCIE_CFG_PT0TXNCLKGCTL_ICGE BIT15



#define R_PCH_PCIE_CFG_PT1TXNCLKGCTL 0x000008E6
#define S_PCH_PCIE_CFG_PT1TXNCLKGCTL 2

#define N_PCH_PCIE_CFG_PT1TXNCLKGCTL_ICT 0
#define B_PCH_PCIE_CFG_PT1TXNCLKGCTL_ICT (0x00FF)



#define N_PCH_PCIE_CFG_PT1TXNCLKGCTL_ICGE 15
#define B_PCH_PCIE_CFG_PT1TXNCLKGCTL_ICGE BIT15



#define R_PCH_PCIE_CFG_PT2TXNCLKGCTL 0x000008E8
#define S_PCH_PCIE_CFG_PT2TXNCLKGCTL 2

#define N_PCH_PCIE_CFG_PT2TXNCLKGCTL_ICT 0
#define B_PCH_PCIE_CFG_PT2TXNCLKGCTL_ICT (0x00FF)



#define N_PCH_PCIE_CFG_PT2TXNCLKGCTL_ICGE 15
#define B_PCH_PCIE_CFG_PT2TXNCLKGCTL_ICGE BIT15



#define R_PCH_PCIE_CFG_PT3TXNCLKGCTL 0x000008EA
#define S_PCH_PCIE_CFG_PT3TXNCLKGCTL 2

#define N_PCH_PCIE_CFG_PT3TXNCLKGCTL_ICT 0
#define B_PCH_PCIE_CFG_PT3TXNCLKGCTL_ICT (0x00FF)



#define N_PCH_PCIE_CFG_PT3TXNCLKGCTL_ICGE 15
#define B_PCH_PCIE_CFG_PT3TXNCLKGCTL_ICGE BIT15



#define R_PCH_PCIE_CFG_EXPHDRXENGCTL 0x000008EC
#define S_PCH_PCIE_CFG_EXPHDRXENGCTL 4



#define N_PCH_PCIE_CFG_EXPHDRXENGCTL_XOR_TTYPE 0
#define B_PCH_PCIE_CFG_EXPHDRXENGCTL_XOR_TTYPE (0x0000001F)



#define N_PCH_PCIE_CFG_EXPHDRXENGCTL_XOR_MEM_CFG_ADDR 5
#define B_PCH_PCIE_CFG_EXPHDRXENGCTL_XOR_MEM_CFG_ADDR (0x00001FE0)

#define N_PCH_PCIE_CFG_EXPHDRXENGCTL_XOR_IO_ADDR 13
#define B_PCH_PCIE_CFG_EXPHDRXENGCTL_XOR_IO_ADDR (BIT15 | BIT14 | BIT13)

#define N_PCH_PCIE_CFG_EXPHDRXENGCTL_CFG_TTYPE_XOR_EN 16
#define B_PCH_PCIE_CFG_EXPHDRXENGCTL_CFG_TTYPE_XOR_EN BIT16

#define N_PCH_PCIE_CFG_EXPHDRXENGCTL_IO_TTYPE_XOR_EN 17
#define B_PCH_PCIE_CFG_EXPHDRXENGCTL_IO_TTYPE_XOR_EN BIT17

#define N_PCH_PCIE_CFG_EXPHDRXENGCTL_MEM_TTYPE_XOR_EN 18
#define B_PCH_PCIE_CFG_EXPHDRXENGCTL_MEM_TTYPE_XOR_EN BIT18

#define N_PCH_PCIE_CFG_EXPHDRXENGCTL_CFG_ADDR_XOR_EN 19
#define B_PCH_PCIE_CFG_EXPHDRXENGCTL_CFG_ADDR_XOR_EN BIT19

#define N_PCH_PCIE_CFG_EXPHDRXENGCTL_IO_ADDR_XOR_EN 20
#define B_PCH_PCIE_CFG_EXPHDRXENGCTL_IO_ADDR_XOR_EN BIT20



#define N_PCH_PCIE_CFG_EXPHDRXENGCTL_MEM_ADDR_XOR_EN 21
#define B_PCH_PCIE_CFG_EXPHDRXENGCTL_MEM_ADDR_XOR_EN BIT21



#define N_PCH_PCIE_CFG_EXPHDRXENGCTL_DEXPTE 31
#define B_PCH_PCIE_CFG_EXPHDRXENGCTL_DEXPTE BIT31



#define R_PCH_PCIE_CFG_TXCRSTOCTL 0x000008F0
#define S_PCH_PCIE_CFG_TXCRSTOCTL 4

#define N_PCH_PCIE_CFG_TXCRSTOCTL_TXTOFCEN 0
#define B_PCH_PCIE_CFG_TXCRSTOCTL_TXTOFCEN (BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_TXCRSTOCTL_TXNPCTODIS 3
#define B_PCH_PCIE_CFG_TXCRSTOCTL_TXNPCTODIS BIT3

#define N_PCH_PCIE_CFG_TXCRSTOCTL_TXTOV 4
#define B_PCH_PCIE_CFG_TXCRSTOCTL_TXTOV (BIT7 | BIT6 | BIT5 | BIT4)



#define N_PCH_PCIE_CFG_TXCRSTOCTL_TXTOUREN 8
#define B_PCH_PCIE_CFG_TXCRSTOCTL_TXTOUREN (BIT10 | BIT9 | BIT8)



#define N_PCH_PCIE_CFG_TXCRSTOCTL_TXTOLDEN 11
#define B_PCH_PCIE_CFG_TXCRSTOCTL_TXTOLDEN (BIT13 | BIT12 | BIT11)

#define N_PCH_PCIE_CFG_TXCRSTOCTL_TXTOSTR 14
#define B_PCH_PCIE_CFG_TXCRSTOCTL_TXTOSTR BIT14



#define N_PCH_PCIE_CFG_TXCRSTOCTL_CRS_TO_DIS 15
#define B_PCH_PCIE_CFG_TXCRSTOCTL_CRS_TO_DIS BIT15

#define N_PCH_PCIE_CFG_TXCRSTOCTL_TXTOSTS 16
#define B_PCH_PCIE_CFG_TXCRSTOCTL_TXTOSTS (BIT18 | BIT17 | BIT16)



#define N_PCH_PCIE_CFG_TXCRSTOCTL_TXNPCTOSTS 19
#define B_PCH_PCIE_CFG_TXCRSTOCTL_TXNPCTOSTS BIT19

#define N_PCH_PCIE_CFG_TXCRSTOCTL_CRS_TO_STS 20
#define B_PCH_PCIE_CFG_TXCRSTOCTL_CRS_TO_STS BIT20



#define R_PCH_PCIE_CFG_XPTDEF 0x000008F4
#define S_PCH_PCIE_CFG_XPTDEF 4

#define N_PCH_PCIE_CFG_XPTDEF_ASSPMD 0
#define B_PCH_PCIE_CFG_XPTDEF_ASSPMD BIT0

#define N_PCH_PCIE_CFG_XPTDEF_ECRCFD 1
#define B_PCH_PCIE_CFG_XPTDEF_ECRCFD BIT1

#define N_PCH_PCIE_CFG_XPTDEF_TTLPPD 2
#define B_PCH_PCIE_CFG_XPTDEF_TTLPPD BIT2

#define N_PCH_PCIE_CFG_XPTDEF_PMNAKBOTM 3
#define B_PCH_PCIE_CFG_XPTDEF_PMNAKBOTM BIT3

#define N_PCH_PCIE_CFG_XPTDEF_ETCP 4
#define B_PCH_PCIE_CFG_XPTDEF_ETCP BIT4

#define N_PCH_PCIE_CFG_XPTDEF_SFO 5
#define B_PCH_PCIE_CFG_XPTDEF_SFO (BIT6 | BIT5)

#define N_PCH_PCIE_CFG_XPTDEF_TRRA 7
#define B_PCH_PCIE_CFG_XPTDEF_TRRA BIT7

#define N_PCH_PCIE_CFG_XPTDEF_MCD 8
#define B_PCH_PCIE_CFG_XPTDEF_MCD BIT8

#define N_PCH_PCIE_CFG_XPTDEF_IOCD 9
#define B_PCH_PCIE_CFG_XPTDEF_IOCD BIT9

#define N_PCH_PCIE_CFG_XPTDEF_VGACD 10
#define B_PCH_PCIE_CFG_XPTDEF_VGACD BIT10

#define N_PCH_PCIE_CFG_XPTDEF_ISACD 11
#define B_PCH_PCIE_CFG_XPTDEF_ISACD BIT11

#define N_PCH_PCIE_CFG_XPTDEF_CCD 12
#define B_PCH_PCIE_CFG_XPTDEF_CCD BIT12

#define N_PCH_PCIE_CFG_XPTDEF_MSGRIDCD 13
#define B_PCH_PCIE_CFG_XPTDEF_MSGRIDCD BIT13

#define N_PCH_PCIE_CFG_XPTDEF_CFGT1CD 14
#define B_PCH_PCIE_CFG_XPTDEF_CFGT1CD BIT14

#define N_PCH_PCIE_CFG_XPTDEF_DIS_INB_P2PCFG 15
#define B_PCH_PCIE_CFG_XPTDEF_DIS_INB_P2PCFG BIT15

#define N_PCH_PCIE_CFG_XPTDEF_TXCMDPERRDIS 16
#define B_PCH_PCIE_CFG_XPTDEF_TXCMDPERRDIS BIT16

#define N_PCH_PCIE_CFG_XPTDEF_IMRTFCCSEL 17
#define B_PCH_PCIE_CFG_XPTDEF_IMRTFCCSEL (BIT19 | BIT18 | BIT17)

#define N_PCH_PCIE_CFG_XPTDEF_RXSCRD 20
#define B_PCH_PCIE_CFG_XPTDEF_RXSCRD BIT20

#define N_PCH_PCIE_CFG_XPTDEF_IDFMRTFCCSEL 21
#define B_PCH_PCIE_CFG_XPTDEF_IDFMRTFCCSEL (BIT23 | BIT22 | BIT21)

#define N_PCH_PCIE_CFG_XPTDEF_PDPMUXM 24
#define B_PCH_PCIE_CFG_XPTDEF_PDPMUXM BIT24

#define N_PCH_PCIE_CFG_XPTDEF_RXQDCRO 25
#define B_PCH_PCIE_CFG_XPTDEF_RXQDCRO BIT25

#define N_PCH_PCIE_CFG_XPTDEF_TXQDCRO 26
#define B_PCH_PCIE_CFG_XPTDEF_TXQDCRO BIT26

#define N_PCH_PCIE_CFG_XPTDEF_MALCHKD 28
#define B_PCH_PCIE_CFG_XPTDEF_MALCHKD BIT28

#define N_PCH_PCIE_CFG_XPTDEF_SBEMSGD 29
#define B_PCH_PCIE_CFG_XPTDEF_SBEMSGD BIT29



#define R_PCH_PCIE_CFG_XPTDEF2 0x000008F8
#define S_PCH_PCIE_CFG_XPTDEF2 4

#define N_PCH_PCIE_CFG_XPTDEF2_GBLSTOPD 0
#define B_PCH_PCIE_CFG_XPTDEF2_GBLSTOPD BIT0

#define N_PCH_PCIE_CFG_XPTDEF2_MSIXSMSGV 1
#define B_PCH_PCIE_CFG_XPTDEF2_MSIXSMSGV BIT1

#define N_PCH_PCIE_CFG_XPTDEF2_MCTPDBC 2
#define B_PCH_PCIE_CFG_XPTDEF2_MCTPDBC BIT2

#define N_PCH_PCIE_CFG_XPTDEF2_UCCHKD 3
#define B_PCH_PCIE_CFG_XPTDEF2_UCCHKD BIT3

#define N_PCH_PCIE_CFG_XPTDEF2_CRD 4
#define B_PCH_PCIE_CFG_XPTDEF2_CRD BIT4

#define N_PCH_PCIE_CFG_XPTDEF2_CPLCOMBINE_D 5
#define B_PCH_PCIE_CFG_XPTDEF2_CPLCOMBINE_D BIT5

#define N_PCH_PCIE_CFG_XPTDEF2_MSIGENOV 6
#define B_PCH_PCIE_CFG_XPTDEF2_MSIGENOV BIT6

#define N_PCH_PCIE_CFG_XPTDEF2_ERCO 7
#define B_PCH_PCIE_CFG_XPTDEF2_ERCO BIT7

#define N_PCH_PCIE_CFG_XPTDEF2_EVPID 8
#define B_PCH_PCIE_CFG_XPTDEF2_EVPID BIT8

#define N_PCH_PCIE_CFG_XPTDEF2_CPLCDT_EN 9
#define B_PCH_PCIE_CFG_XPTDEF2_CPLCDT_EN BIT9

#define N_PCH_PCIE_CFG_XPTDEF2_MMBNCE 10
#define B_PCH_PCIE_CFG_XPTDEF2_MMBNCE BIT10

#define N_PCH_PCIE_CFG_XPTDEF2_TCPAR_CHK_DIS 11
#define B_PCH_PCIE_CFG_XPTDEF2_TCPAR_CHK_DIS BIT11

#define N_PCH_PCIE_CFG_XPTDEF2_TDPAR_CHK_DIS 12
#define B_PCH_PCIE_CFG_XPTDEF2_TDPAR_CHK_DIS BIT12

#define N_PCH_PCIE_CFG_XPTDEF2_UPRODIS 13
#define B_PCH_PCIE_CFG_XPTDEF2_UPRODIS BIT13

#define N_PCH_PCIE_CFG_XPTDEF2_DNRODIS 14
#define B_PCH_PCIE_CFG_XPTDEF2_DNRODIS BIT14

#define N_PCH_PCIE_CFG_XPTDEF2_FORCERODN 15
#define B_PCH_PCIE_CFG_XPTDEF2_FORCERODN BIT15

#define N_PCH_PCIE_CFG_XPTDEF2_MSIAVCD 16
#define B_PCH_PCIE_CFG_XPTDEF2_MSIAVCD BIT16

#define N_PCH_PCIE_CFG_XPTDEF2_ECRCMFEPD 17
#define B_PCH_PCIE_CFG_XPTDEF2_ECRCMFEPD BIT17

#define N_PCH_PCIE_CFG_XPTDEF2_HRSRD 18
#define B_PCH_PCIE_CFG_XPTDEF2_HRSRD BIT18

#define N_PCH_PCIE_CFG_XPTDEF2_HRDLLSCSD 19
#define B_PCH_PCIE_CFG_XPTDEF2_HRDLLSCSD BIT19

#define N_PCH_PCIE_CFG_XPTDEF2_HRHPID 20
#define B_PCH_PCIE_CFG_XPTDEF2_HRHPID BIT20



#define N_PCH_PCIE_CFG_XPTDEF2_RECOP 21
#define B_PCH_PCIE_CFG_XPTDEF2_RECOP BIT21

#define N_PCH_PCIE_CFG_XPTDEF2_RSP 22
#define B_PCH_PCIE_CFG_XPTDEF2_RSP BIT22

#define N_PCH_PCIE_CFG_XPTDEF2_RECO 23
#define B_PCH_PCIE_CFG_XPTDEF2_RECO (0x7F800000)

#define N_PCH_PCIE_CFG_XPTDEF2_MSIAVS 31
#define B_PCH_PCIE_CFG_XPTDEF2_MSIAVS BIT31



#define R_PCH_PCIE_CFG_XPTDEF3 0x000008FC
#define S_PCH_PCIE_CFG_XPTDEF3 4



#define N_PCH_PCIE_CFG_XPTDEF3_RECO0 0
#define B_PCH_PCIE_CFG_XPTDEF3_RECO0 (BIT1 | BIT0)



#define N_PCH_PCIE_CFG_XPTDEF3_RECO 2
#define B_PCH_PCIE_CFG_XPTDEF3_RECO (0xFFFFFFFC)



#define R_PCH_PCIE_CFG_FCUCTL 0x00000900
#define S_PCH_PCIE_CFG_FCUCTL 4

#define N_PCH_PCIE_CFG_FCUCTL_IDLE_FC_PERIOD 0
#define B_PCH_PCIE_CFG_FCUCTL_IDLE_FC_PERIOD (0x0000003F)

#define N_PCH_PCIE_CFG_FCUCTL_FC_C_PERIOD 6
#define B_PCH_PCIE_CFG_FCUCTL_FC_C_PERIOD (0x00000FC0)

#define N_PCH_PCIE_CFG_FCUCTL_FC_N_PERIOD 12
#define B_PCH_PCIE_CFG_FCUCTL_FC_N_PERIOD (0x0003F000)

#define N_PCH_PCIE_CFG_FCUCTL_FC_P_PERIOD 18
#define B_PCH_PCIE_CFG_FCUCTL_FC_P_PERIOD (0x00FC0000)

#define N_PCH_PCIE_CFG_FCUCTL_FCU_MODE 24
#define B_PCH_PCIE_CFG_FCUCTL_FCU_MODE (BIT25 | BIT24)



#define R_PCH_PCIE_CFG_FCUJITPCTL0 0x00000904
#define S_PCH_PCIE_CFG_FCUJITPCTL0 4



#define N_PCH_PCIE_CFG_FCUJITPCTL0_FC_DAT_THRESH 0
#define B_PCH_PCIE_CFG_FCUJITPCTL0_FC_DAT_THRESH (0x000007FF)



#define N_PCH_PCIE_CFG_FCUJITPCTL0_FC_HDR_THRESH 12
#define B_PCH_PCIE_CFG_FCUJITPCTL0_FC_HDR_THRESH (0x0007F000)



#define R_PCH_PCIE_CFG_FCUJITPCTL1 0x00000908
#define S_PCH_PCIE_CFG_FCUJITPCTL1 4

#define N_PCH_PCIE_CFG_FCUJITPCTL1_FC_DAT_THRESH 0
#define B_PCH_PCIE_CFG_FCUJITPCTL1_FC_DAT_THRESH (0x000007FF)

#define N_PCH_PCIE_CFG_FCUJITPCTL1_FC_HDR_THRESH 12
#define B_PCH_PCIE_CFG_FCUJITPCTL1_FC_HDR_THRESH (0x0007F000)



#define R_PCH_PCIE_CFG_FCUJITNCTL0 0x00000910
#define S_PCH_PCIE_CFG_FCUJITNCTL0 4



#define N_PCH_PCIE_CFG_FCUJITNCTL0_FC_DAT_THRESH 0
#define B_PCH_PCIE_CFG_FCUJITNCTL0_FC_DAT_THRESH (0x000007FF)



#define N_PCH_PCIE_CFG_FCUJITNCTL0_FC_HDR_THRESH 12
#define B_PCH_PCIE_CFG_FCUJITNCTL0_FC_HDR_THRESH (0x0007F000)



#define R_PCH_PCIE_CFG_FCUJITNCTL1 0x00000914
#define S_PCH_PCIE_CFG_FCUJITNCTL1 4

#define N_PCH_PCIE_CFG_FCUJITNCTL1_FC_DAT_THRESH 0
#define B_PCH_PCIE_CFG_FCUJITNCTL1_FC_DAT_THRESH (0x000007FF)

#define N_PCH_PCIE_CFG_FCUJITNCTL1_FC_HDR_THRESH 12
#define B_PCH_PCIE_CFG_FCUJITNCTL1_FC_HDR_THRESH (0x0007F000)



#define R_PCH_PCIE_CFG_FCUJITCCTL0 0x0000091C
#define S_PCH_PCIE_CFG_FCUJITCCTL0 4



#define N_PCH_PCIE_CFG_FCUJITCCTL0_FC_DAT_THRESH 0
#define B_PCH_PCIE_CFG_FCUJITCCTL0_FC_DAT_THRESH (0x000007FF)



#define N_PCH_PCIE_CFG_FCUJITCCTL0_FC_HDR_THRESH 12
#define B_PCH_PCIE_CFG_FCUJITCCTL0_FC_HDR_THRESH (0x0007F000)



#define R_PCH_PCIE_CFG_FCUJITCCTL1 0x00000920
#define S_PCH_PCIE_CFG_FCUJITCCTL1 4

#define N_PCH_PCIE_CFG_FCUJITCCTL1_FC_DAT_THRESH 0
#define B_PCH_PCIE_CFG_FCUJITCCTL1_FC_DAT_THRESH (0x000007FF)

#define N_PCH_PCIE_CFG_FCUJITCCTL1_FC_HDR_THRESH 12
#define B_PCH_PCIE_CFG_FCUJITCCTL1_FC_HDR_THRESH (0x0007F000)



#define R_PCH_PCIE_CFG_RXPERRINJCTL 0x00000930
#define S_PCH_PCIE_CFG_RXPERRINJCTL 4

#define N_PCH_PCIE_CFG_RXPERRINJCTL_DWS 0
#define B_PCH_PCIE_CFG_RXPERRINJCTL_DWS (0x000003FF)

#define N_PCH_PCIE_CFG_RXPERRINJCTL_RSPDONEDIS 28
#define B_PCH_PCIE_CFG_RXPERRINJCTL_RSPDONEDIS BIT28

#define N_PCH_PCIE_CFG_RXPERRINJCTL_ERRINJSTS 29
#define B_PCH_PCIE_CFG_RXPERRINJCTL_ERRINJSTS BIT29

#define N_PCH_PCIE_CFG_RXPERRINJCTL_EIRFS 30
#define B_PCH_PCIE_CFG_RXPERRINJCTL_EIRFS BIT30

#define N_PCH_PCIE_CFG_RXPERRINJCTL_EIE 31
#define B_PCH_PCIE_CFG_RXPERRINJCTL_EIE BIT31



#define R_PCH_PCIE_CFG_VCXINITDLY 0x00000934
#define S_PCH_PCIE_CFG_VCXINITDLY 4



#define N_PCH_PCIE_CFG_VCXINITDLY_DELAY 0
#define B_PCH_PCIE_CFG_VCXINITDLY_DELAY (BIT2 | BIT1 | BIT0)



#define R_PCH_PCIE_CFG_LLRBERRINJCTL 0x00000938
#define S_PCH_PCIE_CFG_LLRBERRINJCTL 4

#define N_PCH_PCIE_CFG_LLRBERRINJCTL_DWS 0
#define B_PCH_PCIE_CFG_LLRBERRINJCTL_DWS (0x000003FF)

#define N_PCH_PCIE_CFG_LLRBERRINJCTL_INJCTL 10
#define B_PCH_PCIE_CFG_LLRBERRINJCTL_INJCTL BIT10

#define N_PCH_PCIE_CFG_LLRBERRINJCTL_INJHDR 11
#define B_PCH_PCIE_CFG_LLRBERRINJCTL_INJHDR BIT11

#define N_PCH_PCIE_CFG_LLRBERRINJCTL_INJDAT 12
#define B_PCH_PCIE_CFG_LLRBERRINJCTL_INJDAT BIT12

#define N_PCH_PCIE_CFG_LLRBERRINJCTL_RSPDONEDIS 28
#define B_PCH_PCIE_CFG_LLRBERRINJCTL_RSPDONEDIS BIT28

#define N_PCH_PCIE_CFG_LLRBERRINJCTL_ERRINJSTS 29
#define B_PCH_PCIE_CFG_LLRBERRINJCTL_ERRINJSTS BIT29

#define N_PCH_PCIE_CFG_LLRBERRINJCTL_EIRFS 30
#define B_PCH_PCIE_CFG_LLRBERRINJCTL_EIRFS BIT30

#define N_PCH_PCIE_CFG_LLRBERRINJCTL_EIE 31
#define B_PCH_PCIE_CFG_LLRBERRINJCTL_EIE BIT31



#define R_PCH_PCIE_CFG_ACKCTL 0x00000940
#define S_PCH_PCIE_CFG_ACKCTL 4



#define N_PCH_PCIE_CFG_ACKCTL_ACK_THRESHOLD 0
#define B_PCH_PCIE_CFG_ACKCTL_ACK_THRESHOLD (0x000007FF)

#define N_PCH_PCIE_CFG_ACKCTL_ACK_PERIOD 11
#define B_PCH_PCIE_CFG_ACKCTL_ACK_PERIOD (0x0000F800)

#define N_PCH_PCIE_CFG_ACKCTL_ACK_MODE 16
#define B_PCH_PCIE_CFG_ACKCTL_ACK_MODE BIT16

#define N_PCH_PCIE_CFG_ACKCTL_JIT_MODE 17
#define B_PCH_PCIE_CFG_ACKCTL_JIT_MODE BIT17



#define R_PCH_PCIE_CFG_PMIDLTMR 0x00000948
#define S_PCH_PCIE_CFG_PMIDLTMR 4



#define N_PCH_PCIE_CFG_PMIDLTMR_L1_IDLE_TIMER 0
#define B_PCH_PCIE_CFG_PMIDLTMR_L1_IDLE_TIMER (0x0000001F)



#define N_PCH_PCIE_CFG_PMIDLTMR_L0S_IDLE_TIMER 8
#define B_PCH_PCIE_CFG_PMIDLTMR_L0S_IDLE_TIMER (BIT11 | BIT10 | BIT9 | BIT8)

#define N_PCH_PCIE_CFG_PMIDLTMR_PMNAKTO 23
#define B_PCH_PCIE_CFG_PMIDLTMR_PMNAKTO (BIT26 | BIT25 | BIT24 | BIT23)

#define N_PCH_PCIE_CFG_PMIDLTMR_ENPMNAKTO 27
#define B_PCH_PCIE_CFG_PMIDLTMR_ENPMNAKTO BIT27



#define N_PCH_PCIE_CFG_PMIDLTMR_PMDLLPCNT 28
#define B_PCH_PCIE_CFG_PMIDLTMR_PMDLLPCNT (BIT30 | BIT29 | BIT28)

#define N_PCH_PCIE_CFG_PMIDLTMR_ENPMTIMEOUT 31
#define B_PCH_PCIE_CFG_PMIDLTMR_ENPMTIMEOUT BIT31



#define R_PCH_PCIE_CFG_CRCERRINJCTL 0x0000094C
#define S_PCH_PCIE_CFG_CRCERRINJCTL 4

#define N_PCH_PCIE_CFG_CRCERRINJCTL_TDBPS 23
#define B_PCH_PCIE_CFG_CRCERRINJCTL_TDBPS (BIT24 | BIT23)

#define N_PCH_PCIE_CFG_CRCERRINJCTL_CRCERRINJ 27
#define B_PCH_PCIE_CFG_CRCERRINJCTL_CRCERRINJ BIT27

#define N_PCH_PCIE_CFG_CRCERRINJCTL_ERRINJSTS 28
#define B_PCH_PCIE_CFG_CRCERRINJCTL_ERRINJSTS BIT28

#define N_PCH_PCIE_CFG_CRCERRINJCTL_RSPDONEDIS 29
#define B_PCH_PCIE_CFG_CRCERRINJCTL_RSPDONEDIS BIT29

#define N_PCH_PCIE_CFG_CRCERRINJCTL_RSPFNCSEL 30
#define B_PCH_PCIE_CFG_CRCERRINJCTL_RSPFNCSEL BIT30

#define N_PCH_PCIE_CFG_CRCERRINJCTL_ERRINJEN 31
#define B_PCH_PCIE_CFG_CRCERRINJCTL_ERRINJEN BIT31



#define R_PCH_PCIE_CFG_CRCERRINJMSK 0x00000950
#define S_PCH_PCIE_CFG_CRCERRINJMSK 4

#define N_PCH_PCIE_CFG_CRCERRINJMSK_MASK 0
#define B_PCH_PCIE_CFG_CRCERRINJMSK_MASK (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_ECRCERRINJCTL 0x00000954
#define S_PCH_PCIE_CFG_ECRCERRINJCTL 4

#define N_PCH_PCIE_CFG_ECRCERRINJCTL_ECRCERRINJ 27
#define B_PCH_PCIE_CFG_ECRCERRINJCTL_ECRCERRINJ BIT27

#define N_PCH_PCIE_CFG_ECRCERRINJCTL_ERRINJSTS 28
#define B_PCH_PCIE_CFG_ECRCERRINJCTL_ERRINJSTS BIT28

#define N_PCH_PCIE_CFG_ECRCERRINJCTL_RSPDONEDIS 29
#define B_PCH_PCIE_CFG_ECRCERRINJCTL_RSPDONEDIS BIT29

#define N_PCH_PCIE_CFG_ECRCERRINJCTL_RSPFNCSEL 30
#define B_PCH_PCIE_CFG_ECRCERRINJCTL_RSPFNCSEL BIT30

#define N_PCH_PCIE_CFG_ECRCERRINJCTL_ERRINJEN 31
#define B_PCH_PCIE_CFG_ECRCERRINJCTL_ERRINJEN BIT31



#define R_PCH_PCIE_CFG_ECRCERRINJMSK 0x00000958
#define S_PCH_PCIE_CFG_ECRCERRINJMSK 4



#define N_PCH_PCIE_CFG_ECRCERRINJMSK_MASK 0
#define B_PCH_PCIE_CFG_ECRCERRINJMSK_MASK (0xFFFFFFFF)

#define R_PCH_PCIE_CFG_RTRYCTL  0x00000988
#define S_PCH_PCIE_CFG_RTRYCTL 4

#define N_PCH_PCIE_CFG_RTRYCTL_REPLAY_TIMER 0
#define B_PCH_PCIE_CFG_RTRYCTL_REPLAY_TIMER (0x0000003F)

#define N_PCH_PCIE_CFG_RTRYCTL_RECOVERY_THRESHOLD 6
#define B_PCH_PCIE_CFG_RTRYCTL_RECOVERY_THRESHOLD (BIT8 | BIT7 | BIT6)

#define N_PCH_PCIE_CFG_RTRYCTL_UNUSABLE_LLRB_ENTRIES 9
#define B_PCH_PCIE_CFG_RTRYCTL_UNUSABLE_LLRB_ENTRIES (0x000FFE00)

#define N_PCH_PCIE_CFG_RTRYCTL_UNUSABLE_MAP_ENTRIES 20
#define B_PCH_PCIE_CFG_RTRYCTL_UNUSABLE_MAP_ENTRIES (0x7FF00000)

#define N_PCH_PCIE_CFG_RTRYCTL_RT_MODE 31
#define B_PCH_PCIE_CFG_RTRYCTL_RT_MODE BIT31



#define R_PCH_PCIE_CFG_LLRBSIZE 0x0000098C
#define S_PCH_PCIE_CFG_LLRBSIZE 4



#define N_PCH_PCIE_CFG_LLRBSIZE_LLRB_SIZE 0
#define B_PCH_PCIE_CFG_LLRBSIZE_LLRB_SIZE (0x000007FF)



#define N_PCH_PCIE_CFG_LLRBSIZE_LUT_SIZE 16
#define B_PCH_PCIE_CFG_LLRBSIZE_LUT_SIZE (0x07FF0000)



#define N_PCH_PCIE_CFG_LLRBSIZE_SKID 27
#define B_PCH_PCIE_CFG_LLRBSIZE_SKID (BIT30 | BIT29 | BIT28 | BIT27)



#define R_PCH_PCIE_CFG_FRMERRMSK 0x0000099C
#define S_PCH_PCIE_CFG_FRMERRMSK 2



#define N_PCH_PCIE_CFG_FRMERRMSK_DW1_ERR_MSK 0
#define B_PCH_PCIE_CFG_FRMERRMSK_DW1_ERR_MSK BIT0



#define N_PCH_PCIE_CFG_FRMERRMSK_PAD_ERR_MSK 1
#define B_PCH_PCIE_CFG_FRMERRMSK_PAD_ERR_MSK BIT1



#define N_PCH_PCIE_CFG_FRMERRMSK_IDL_ERR_MSK 2
#define B_PCH_PCIE_CFG_FRMERRMSK_IDL_ERR_MSK BIT2



#define N_PCH_PCIE_CFG_FRMERRMSK_GAP_STP_ERR_MSK 3
#define B_PCH_PCIE_CFG_FRMERRMSK_GAP_STP_ERR_MSK BIT3



#define N_PCH_PCIE_CFG_FRMERRMSK_GAP_SDP_ERR_MSK 4
#define B_PCH_PCIE_CFG_FRMERRMSK_GAP_SDP_ERR_MSK BIT4



#define N_PCH_PCIE_CFG_FRMERRMSK_STP_FRQ_ERR_MSK 5
#define B_PCH_PCIE_CFG_FRMERRMSK_STP_FRQ_ERR_MSK BIT5



#define N_PCH_PCIE_CFG_FRMERRMSK_SDP_FRQ_ERR_MSK 6
#define B_PCH_PCIE_CFG_FRMERRMSK_SDP_FRQ_ERR_MSK BIT6



#define N_PCH_PCIE_CFG_FRMERRMSK_ILL_STP_END_ERR_MSK 7
#define B_PCH_PCIE_CFG_FRMERRMSK_ILL_STP_END_ERR_MSK BIT7



#define N_PCH_PCIE_CFG_FRMERRMSK_DUMP_IN_TLP_MSK 8
#define B_PCH_PCIE_CFG_FRMERRMSK_DUMP_IN_TLP_MSK BIT8



#define N_PCH_PCIE_CFG_FRMERRMSK_DUMP_IN_DLLP_MSK 9
#define B_PCH_PCIE_CFG_FRMERRMSK_DUMP_IN_DLLP_MSK BIT9



#define R_PCH_PCIE_CFG_FRMERRSTS 0x0000099E
#define S_PCH_PCIE_CFG_FRMERRSTS 2



#define N_PCH_PCIE_CFG_FRMERRSTS_DW1_ERR 0
#define B_PCH_PCIE_CFG_FRMERRSTS_DW1_ERR BIT0



#define N_PCH_PCIE_CFG_FRMERRSTS_PAD_ERR 1
#define B_PCH_PCIE_CFG_FRMERRSTS_PAD_ERR BIT1



#define N_PCH_PCIE_CFG_FRMERRSTS_IDL_ERR 2
#define B_PCH_PCIE_CFG_FRMERRSTS_IDL_ERR BIT2



#define N_PCH_PCIE_CFG_FRMERRSTS_GAP_STP_ERR 3
#define B_PCH_PCIE_CFG_FRMERRSTS_GAP_STP_ERR BIT3



#define N_PCH_PCIE_CFG_FRMERRSTS_GAP_SDP_ERR 4
#define B_PCH_PCIE_CFG_FRMERRSTS_GAP_SDP_ERR BIT4



#define N_PCH_PCIE_CFG_FRMERRSTS_STP_FRQ_ERR 5
#define B_PCH_PCIE_CFG_FRMERRSTS_STP_FRQ_ERR BIT5



#define N_PCH_PCIE_CFG_FRMERRSTS_SDP_FRQ_ERR 6
#define B_PCH_PCIE_CFG_FRMERRSTS_SDP_FRQ_ERR BIT6



#define N_PCH_PCIE_CFG_FRMERRSTS_ILL_STP_END_ERR 7
#define B_PCH_PCIE_CFG_FRMERRSTS_ILL_STP_END_ERR BIT7



#define N_PCH_PCIE_CFG_FRMERRSTS_DUMP_IN_TLP_ERR 8
#define B_PCH_PCIE_CFG_FRMERRSTS_DUMP_IN_TLP_ERR BIT8



#define N_PCH_PCIE_CFG_FRMERRSTS_DUMP_IN_DLLP_ERR 9
#define B_PCH_PCIE_CFG_FRMERRSTS_DUMP_IN_DLLP_ERR BIT9



#define R_PCH_PCIE_CFG_XPLDEF 0x000009A0
#define S_PCH_PCIE_CFG_XPLDEF 4

#define N_PCH_PCIE_CFG_XPLDEF_DIS_L0S 0
#define B_PCH_PCIE_CFG_XPLDEF_DIS_L0S BIT0

#define N_PCH_PCIE_CFG_XPLDEF_DIS_ASPM_L1 1
#define B_PCH_PCIE_CFG_XPLDEF_DIS_ASPM_L1 BIT1

#define N_PCH_PCIE_CFG_XPLDEF_SSDIS 2
#define B_PCH_PCIE_CFG_XPLDEF_SSDIS BIT2

#define N_PCH_PCIE_CFG_XPLDEF_DIS_T_PACKING 3
#define B_PCH_PCIE_CFG_XPLDEF_DIS_T_PACKING BIT3

#define N_PCH_PCIE_CFG_XPLDEF_DIS_DT_PACKING 4
#define B_PCH_PCIE_CFG_XPLDEF_DIS_DT_PACKING BIT4

#define N_PCH_PCIE_CFG_XPLDEF_DIS_STP_SYMX 5
#define B_PCH_PCIE_CFG_XPLDEF_DIS_STP_SYMX BIT5

#define N_PCH_PCIE_CFG_XPLDEF_DIS_OPP_FCU 6
#define B_PCH_PCIE_CFG_XPLDEF_DIS_OPP_FCU BIT6

#define N_PCH_PCIE_CFG_XPLDEF_DIS_OPP_ACK 7
#define B_PCH_PCIE_CFG_XPLDEF_DIS_OPP_ACK BIT7

#define N_PCH_PCIE_CFG_XPLDEF_DIS_30US_FC_TMR 8
#define B_PCH_PCIE_CFG_XPLDEF_DIS_30US_FC_TMR BIT8

#define N_PCH_PCIE_CFG_XPLDEF_L1_NAK_STP_DLY 9
#define B_PCH_PCIE_CFG_XPLDEF_L1_NAK_STP_DLY (0x0001FE00)

#define N_PCH_PCIE_CFG_XPLDEF_L1_NAK_REQ_DLY 17
#define B_PCH_PCIE_CFG_XPLDEF_L1_NAK_REQ_DLY (0x01FE0000)

#define N_PCH_PCIE_CFG_XPLDEF_DIS_FCU_HINT 25
#define B_PCH_PCIE_CFG_XPLDEF_DIS_FCU_HINT (BIT27 | BIT26 | BIT25)

#define N_PCH_PCIE_CFG_XPLDEF_DIS_EDB_MODE 28
#define B_PCH_PCIE_CFG_XPLDEF_DIS_EDB_MODE BIT28

#define N_PCH_PCIE_CFG_XPLDEF_DIS_EDB_INV_LCRC 29
#define B_PCH_PCIE_CFG_XPLDEF_DIS_EDB_INV_LCRC BIT29

#define N_PCH_PCIE_CFG_XPLDEF_DIS_SS_HPE 30
#define B_PCH_PCIE_CFG_XPLDEF_DIS_SS_HPE BIT30

#define N_PCH_PCIE_CFG_XPLDEF_FORCE_L1 31
#define B_PCH_PCIE_CFG_XPLDEF_FORCE_L1 BIT31



#define R_PCH_PCIE_CFG_XPLDEF2 0x000009A4
#define S_PCH_PCIE_CFG_XPLDEF2 4



#define N_PCH_PCIE_CFG_XPLDEF2_DIS_FEM 0
#define B_PCH_PCIE_CFG_XPLDEF2_DIS_FEM BIT0



#define N_PCH_PCIE_CFG_XPLDEF2_FORCE_STALLREQ 1
#define B_PCH_PCIE_CFG_XPLDEF2_FORCE_STALLREQ BIT1



#define N_PCH_PCIE_CFG_XPLDEF2_IGN_SWL0S_IDLE 2
#define B_PCH_PCIE_CFG_XPLDEF2_IGN_SWL0S_IDLE BIT2



#define N_PCH_PCIE_CFG_XPLDEF2_IGN_SWL1_IDLE 3
#define B_PCH_PCIE_CFG_XPLDEF2_IGN_SWL1_IDLE BIT3



#define N_PCH_PCIE_CFG_XPLDEF2_DIS_2618989 4
#define B_PCH_PCIE_CFG_XPLDEF2_DIS_2618989 BIT4



#define N_PCH_PCIE_CFG_XPLDEF2_EN_FCI_WAIT_STATE 5
#define B_PCH_PCIE_CFG_XPLDEF2_EN_FCI_WAIT_STATE BIT5



#define N_PCH_PCIE_CFG_XPLDEF2_DIS_REPLAY_AFTER_EDB 6
#define B_PCH_PCIE_CFG_XPLDEF2_DIS_REPLAY_AFTER_EDB BIT6



#define N_PCH_PCIE_CFG_XPLDEF2_DIS_FCU_AFTER_L1 7
#define B_PCH_PCIE_CFG_XPLDEF2_DIS_FCU_AFTER_L1 BIT7



#define N_PCH_PCIE_CFG_XPLDEF2_DIS_ACK_AFTER_L1 8
#define B_PCH_PCIE_CFG_XPLDEF2_DIS_ACK_AFTER_L1 BIT8



#define N_PCH_PCIE_CFG_XPLDEF2_RECO 9
#define B_PCH_PCIE_CFG_XPLDEF2_RECO BIT9



#define N_PCH_PCIE_CFG_XPLDEF2_DIS_CLR_ABRT_L1_IN_L0S 10
#define B_PCH_PCIE_CFG_XPLDEF2_DIS_CLR_ABRT_L1_IN_L0S BIT10



#define N_PCH_PCIE_CFG_XPLDEF2_DIS_L0S_ENT_HINT 11
#define B_PCH_PCIE_CFG_XPLDEF2_DIS_L0S_ENT_HINT BIT11



#define N_PCH_PCIE_CFG_XPLDEF2_DIS_L1_ENT_HINT 12
#define B_PCH_PCIE_CFG_XPLDEF2_DIS_L1_ENT_HINT BIT12



#define N_PCH_PCIE_CFG_XPLDEF2_DIS_2620786 13
#define B_PCH_PCIE_CFG_XPLDEF2_DIS_2620786 BIT13



#define N_PCH_PCIE_CFG_XPLDEF2_DIS_2620815 14
#define B_PCH_PCIE_CFG_XPLDEF2_DIS_2620815 BIT14



#define N_PCH_PCIE_CFG_XPLDEF2_DIS_2620834 15
#define B_PCH_PCIE_CFG_XPLDEF2_DIS_2620834 BIT15



#define N_PCH_PCIE_CFG_XPLDEF2_DIS_L0S_RT_ADJ 16
#define B_PCH_PCIE_CFG_XPLDEF2_DIS_L0S_RT_ADJ BIT16



#define N_PCH_PCIE_CFG_XPLDEF2_DIS_2620944 17
#define B_PCH_PCIE_CFG_XPLDEF2_DIS_2620944 BIT17



#define N_PCH_PCIE_CFG_XPLDEF2_DIS_4718733 18
#define B_PCH_PCIE_CFG_XPLDEF2_DIS_4718733 BIT18



#define N_PCH_PCIE_CFG_XPLDEF2_DIS_L0S_EXIT_HINT 19
#define B_PCH_PCIE_CFG_XPLDEF2_DIS_L0S_EXIT_HINT BIT19



#define N_PCH_PCIE_CFG_XPLDEF2_DIS_L1_EXIT_HINT 20
#define B_PCH_PCIE_CFG_XPLDEF2_DIS_L1_EXIT_HINT BIT20

#define N_PCH_PCIE_CFG_XPLDEF2_DIS_L1_NAK_PEND_TLP 21
#define B_PCH_PCIE_CFG_XPLDEF2_DIS_L1_NAK_PEND_TLP BIT21



#define N_PCH_PCIE_CFG_XPLDEF2_DIS_SS_PTLPEB 22
#define B_PCH_PCIE_CFG_XPLDEF2_DIS_SS_PTLPEB BIT22



#define N_PCH_PCIE_CFG_XPLDEF2_DIS_L1_VCX_INIT 23
#define B_PCH_PCIE_CFG_XPLDEF2_DIS_L1_VCX_INIT BIT23



#define N_PCH_PCIE_CFG_XPLDEF2_RECO0 24
#define B_PCH_PCIE_CFG_XPLDEF2_RECO0 (0xFF000000)



#define R_PCH_PCIE_CFG_XPLDEF3 0x000009A8
#define S_PCH_PCIE_CFG_XPLDEF3 4



#define N_PCH_PCIE_CFG_XPLDEF3_RECO0 0
#define B_PCH_PCIE_CFG_XPLDEF3_RECO0 (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_PACKTHRESH 0x000009B0
#define S_PCH_PCIE_CFG_PACKTHRESH 4

#define N_PCH_PCIE_CFG_PACKTHRESH_X16THRESH 0
#define B_PCH_PCIE_CFG_PACKTHRESH_X16THRESH (0x0000001F)



#define R_PCH_PCIE_CFG_RTLATADJ 0x000009C0
#define S_PCH_PCIE_CFG_RTLATADJ 2



#define N_PCH_PCIE_CFG_RTLATADJ_RTLATADJ1 0
#define B_PCH_PCIE_CFG_RTLATADJ_RTLATADJ1 (0x001F)



#define N_PCH_PCIE_CFG_RTLATADJ_RTLATADJ2 5
#define B_PCH_PCIE_CFG_RTLATADJ_RTLATADJ2 (0x03E0)



#define N_PCH_PCIE_CFG_RTLATADJ_RTLATADJ3 10
#define B_PCH_PCIE_CFG_RTLATADJ_RTLATADJ3 (0x7C00)



#define R_PCH_PCIE_CFG_ACKLATADJ 0x000009C4
#define S_PCH_PCIE_CFG_ACKLATADJ 2



#define N_PCH_PCIE_CFG_ACKLATADJ_ACKLATADJ1 0
#define B_PCH_PCIE_CFG_ACKLATADJ_ACKLATADJ1 (0x001F)



#define N_PCH_PCIE_CFG_ACKLATADJ_ACKLATADJ2 5
#define B_PCH_PCIE_CFG_ACKLATADJ_ACKLATADJ2 (0x03E0)



#define N_PCH_PCIE_CFG_ACKLATADJ_ACKLATADJ3 10
#define B_PCH_PCIE_CFG_ACKLATADJ_ACKLATADJ3 (0x7C00)



#define R_PCH_PCIE_CFG_FCULATADJ 0x000009C8
#define S_PCH_PCIE_CFG_FCULATADJ 2



#define N_PCH_PCIE_CFG_FCULATADJ_FCULATADJ1 0
#define B_PCH_PCIE_CFG_FCULATADJ_FCULATADJ1 (0x001F)



#define N_PCH_PCIE_CFG_FCULATADJ_FCULATADJ2 5
#define B_PCH_PCIE_CFG_FCULATADJ_FCULATADJ2 (0x03E0)



#define N_PCH_PCIE_CFG_FCULATADJ_FCULATADJ3 10
#define B_PCH_PCIE_CFG_FCULATADJ_FCULATADJ3 (0x7C00)



#define R_PCH_PCIE_CFG_PT0LNKCLKGCTL 0x000009E4
#define S_PCH_PCIE_CFG_PT0LNKCLKGCTL 2

#define N_PCH_PCIE_CFG_PT0LNKCLKGCTL_ICT 0
#define B_PCH_PCIE_CFG_PT0LNKCLKGCTL_ICT (0x00FF)



#define N_PCH_PCIE_CFG_PT0LNKCLKGCTL_ICGE 15
#define B_PCH_PCIE_CFG_PT0LNKCLKGCTL_ICGE BIT15



#define R_PCH_PCIE_CFG_PT1LNKCLKGCTL 0x000009E6
#define S_PCH_PCIE_CFG_PT1LNKCLKGCTL 2

#define N_PCH_PCIE_CFG_PT1LNKCLKGCTL_ICT 0
#define B_PCH_PCIE_CFG_PT1LNKCLKGCTL_ICT (0x00FF)



#define N_PCH_PCIE_CFG_PT1LNKCLKGCTL_ICGE 15
#define B_PCH_PCIE_CFG_PT1LNKCLKGCTL_ICGE BIT15



#define R_PCH_PCIE_CFG_PT2LNKCLKGCTL 0x000009E8
#define S_PCH_PCIE_CFG_PT2LNKCLKGCTL 2

#define N_PCH_PCIE_CFG_PT2LNKCLKGCTL_ICT 0
#define B_PCH_PCIE_CFG_PT2LNKCLKGCTL_ICT (0x00FF)



#define N_PCH_PCIE_CFG_PT2LNKCLKGCTL_ICGE 15
#define B_PCH_PCIE_CFG_PT2LNKCLKGCTL_ICGE BIT15



#define R_PCH_PCIE_CFG_PT3LNKCLKGCTL 0x000009EA
#define S_PCH_PCIE_CFG_PT3LNKCLKGCTL 2

#define N_PCH_PCIE_CFG_PT3LNKCLKGCTL_ICT 0
#define B_PCH_PCIE_CFG_PT3LNKCLKGCTL_ICT (0x00FF)



#define N_PCH_PCIE_CFG_PT3LNKCLKGCTL_ICGE 15
#define B_PCH_PCIE_CFG_PT3LNKCLKGCTL_ICGE BIT15



#define R_PCH_PCIE_CFG_CFGPCIECLKGCTL 0x000009EC
#define S_PCH_PCIE_CFG_CFGPCIECLKGCTL 2

#define N_PCH_PCIE_CFG_CFGPCIECLKGCTL_ICT 0
#define B_PCH_PCIE_CFG_CFGPCIECLKGCTL_ICT (0x00FF)



#define N_PCH_PCIE_CFG_CFGPCIECLKGCTL_ICGE 15
#define B_PCH_PCIE_CFG_CFGPCIECLKGCTL_ICGE BIT15



#define R_PCH_PCIE_CFG_SYMLCKCTL 0x00000A00
#define S_PCH_PCIE_CFG_SYMLCKCTL 2

#define N_PCH_PCIE_CFG_SYMLCKCTL_KALIGNMODE 0
#define B_PCH_PCIE_CFG_SYMLCKCTL_KALIGNMODE (BIT1 | BIT0)



#define R_PCH_PCIE_CFG_SYMLCKSTS 0x00000A02
#define S_PCH_PCIE_CFG_SYMLCKSTS 2



#define N_PCH_PCIE_CFG_SYMLCKSTS_BITSLIPDSTS 0
#define B_PCH_PCIE_CFG_SYMLCKSTS_BITSLIPDSTS (0x00FF)



#define R_PCH_PCIE_CFG_EICTL 0x00000A10
#define S_PCH_PCIE_CFG_EICTL 4



#define N_PCH_PCIE_CFG_EICTL_EIESEN 0
#define B_PCH_PCIE_CFG_EICTL_EIESEN BIT0



#define N_PCH_PCIE_CFG_EICTL_INFEREIEN 8
#define B_PCH_PCIE_CFG_EICTL_INFEREIEN BIT8



#define N_PCH_PCIE_CFG_EICTL_ENPEREXITEI 9
#define B_PCH_PCIE_CFG_EICTL_ENPEREXITEI BIT9



#define N_PCH_PCIE_CFG_EICTL_INFEREIPRIOR 10
#define B_PCH_PCIE_CFG_EICTL_INFEREIPRIOR BIT10



#define N_PCH_PCIE_CFG_EICTL_SQEXIT4INFEREI 11
#define B_PCH_PCIE_CFG_EICTL_SQEXIT4INFEREI BIT11



#define N_PCH_PCIE_CFG_EICTL_TSSOS4INFEREI 12
#define B_PCH_PCIE_CFG_EICTL_TSSOS4INFEREI BIT12

#define N_PCH_PCIE_CFG_EICTL_EIEXLNSEL 22
#define B_PCH_PCIE_CFG_EICTL_EIEXLNSEL (BIT23 | BIT22)



#define N_PCH_PCIE_CFG_EICTL_EIEXDETL0DIS 24
#define B_PCH_PCIE_CFG_EICTL_EIEXDETL0DIS BIT24



#define R_PCH_PCIE_CFG_RCVDETCTL 0x00000A18
#define S_PCH_PCIE_CFG_RCVDETCTL 4



#define N_PCH_PCIE_CFG_RCVDETCTL_BYPASSDETECT 6
#define B_PCH_PCIE_CFG_RCVDETCTL_BYPASSDETECT BIT6



#define N_PCH_PCIE_CFG_RCVDETCTL_NOTEI4RCVDET 7
#define B_PCH_PCIE_CFG_RCVDETCTL_NOTEI4RCVDET BIT7



#define R_PCH_PCIE_CFG_RCVDETMSK 0x00000A1C
#define S_PCH_PCIE_CFG_RCVDETMSK 2



#define N_PCH_PCIE_CFG_RCVDETMSK_FORCERCVDET 0
#define B_PCH_PCIE_CFG_RCVDETMSK_FORCERCVDET (0x00FF)



#define R_PCH_PCIE_CFG_DESKEWCTL 0x00000A20
#define S_PCH_PCIE_CFG_DESKEWCTL 4

#define N_PCH_PCIE_CFG_DESKEWCTL_CFGDSKSKP 0
#define B_PCH_PCIE_CFG_DESKEWCTL_CFGDSKSKP BIT0

#define N_PCH_PCIE_CFG_DESKEWCTL_RECDSKSKP 1
#define B_PCH_PCIE_CFG_DESKEWCTL_RECDSKSKP BIT1

#define N_PCH_PCIE_CFG_DESKEWCTL_DROPCOMSKP 2
#define B_PCH_PCIE_CFG_DESKEWCTL_DROPCOMSKP BIT2

#define N_PCH_PCIE_CFG_DESKEWCTL_G1WINSIZE 3
#define B_PCH_PCIE_CFG_DESKEWCTL_G1WINSIZE (0x000000F8)

#define N_PCH_PCIE_CFG_DESKEWCTL_G3WINSIZE 8
#define B_PCH_PCIE_CFG_DESKEWCTL_G3WINSIZE (0x00001F00)



#define N_PCH_PCIE_CFG_DESKEWCTL_MASKDBERR 13
#define B_PCH_PCIE_CFG_DESKEWCTL_MASKDBERR BIT13



#define R_PCH_PCIE_CFG_DESKEWSTS 0x00000A24
#define S_PCH_PCIE_CFG_DESKEWSTS 4

#define N_PCH_PCIE_CFG_DESKEWSTS_SKEW 0
#define B_PCH_PCIE_CFG_DESKEWSTS_SKEW (0x0000001F)



#define N_PCH_PCIE_CFG_DESKEWSTS_DBERR 15
#define B_PCH_PCIE_CFG_DESKEWSTS_DBERR BIT15



#define N_PCH_PCIE_CFG_DESKEWSTS_NODBMARKSET 16
#define B_PCH_PCIE_CFG_DESKEWSTS_NODBMARKSET (0xFFFF0000)



#define R_PCH_PCIE_CFG_LTSSMPMCTL 0x00000A28
#define S_PCH_PCIE_CFG_LTSSMPMCTL 4



#define N_PCH_PCIE_CFG_LTSSMPMCTL_DISEIDETL0L0S 0
#define B_PCH_PCIE_CFG_LTSSMPMCTL_DISEIDETL0L0S BIT0



#define N_PCH_PCIE_CFG_LTSSMPMCTL_DISEIDETL1 1
#define B_PCH_PCIE_CFG_LTSSMPMCTL_DISEIDETL1 BIT1

#define N_PCH_PCIE_CFG_LTSSMPMCTL_TXL0SMINIDLE 2
#define B_PCH_PCIE_CFG_LTSSMPMCTL_TXL0SMINIDLE (0x00000FFC)

#define N_PCH_PCIE_CFG_LTSSMPMCTL_RXL0SMINIDLE 12
#define B_PCH_PCIE_CFG_LTSSMPMCTL_RXL0SMINIDLE (0x0001F000)



#define N_PCH_PCIE_CFG_LTSSMPMCTL_RXL0SMINUNIT 17
#define B_PCH_PCIE_CFG_LTSSMPMCTL_RXL0SMINUNIT BIT17

#define N_PCH_PCIE_CFG_LTSSMPMCTL_L1MINIDLE 18
#define B_PCH_PCIE_CFG_LTSSMPMCTL_L1MINIDLE (0x007C0000)



#define N_PCH_PCIE_CFG_LTSSMPMCTL_L1MINUNIT 23
#define B_PCH_PCIE_CFG_LTSSMPMCTL_L1MINUNIT BIT23



#define R_PCH_PCIE_CFG_LTSSMTRNCTL 0x00000A30
#define S_PCH_PCIE_CFG_LTSSMTRNCTL 4

#define N_PCH_PCIE_CFG_LTSSMTRNCTL_WIDTHMASK 0
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_WIDTHMASK (0x0000001F)

#define N_PCH_PCIE_CFG_LTSSMTRNCTL_REVERSEOVVR 5
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_REVERSEOVVR BIT5

#define N_PCH_PCIE_CFG_LTSSMTRNCTL_REVERSEVAL 6
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_REVERSEVAL BIT6

#define N_PCH_PCIE_CFG_LTSSMTRNCTL_ALWAYS2RCVDET 7
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_ALWAYS2RCVDET BIT7

#define N_PCH_PCIE_CFG_LTSSMTRNCTL_HALFTSRCVD 8
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_HALFTSRCVD BIT8

#define N_PCH_PCIE_CFG_LTSSMTRNCTL_DBLEIESCNT 9
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_DBLEIESCNT BIT9

#define N_PCH_PCIE_CFG_LTSSMTRNCTL_DBLTSSEND 10
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_DBLTSSEND BIT10

#define N_PCH_PCIE_CFG_LTSSMTRNCTL_DETQUIETTOEN 11
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_DETQUIETTOEN BIT11

#define N_PCH_PCIE_CFG_LTSSMTRNCTL_DMIPORT 12
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_DMIPORT BIT12

#define N_PCH_PCIE_CFG_LTSSMTRNCTL_GOTORCVRLCKRECIDLETO 13
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_GOTORCVRLCKRECIDLETO BIT13

#define N_PCH_PCIE_CFG_LTSSMTRNCTL_LEAKAGE_WA 14
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_LEAKAGE_WA BIT14

#define N_PCH_PCIE_CFG_LTSSMTRNCTL_SEND_256_IDLES 15
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_SEND_256_IDLES BIT15

#define N_PCH_PCIE_CFG_LTSSMTRNCTL_WAITRCVRCFGTILLSOSSENT 16
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_WAITRCVRCFGTILLSOSSENT BIT16

#define N_PCH_PCIE_CFG_LTSSMTRNCTL_DISLINKDOWN 17
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_DISLINKDOWN BIT17

#define N_PCH_PCIE_CFG_LTSSMTRNCTL_ENFORCEDREC 18
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_ENFORCEDREC BIT18

#define N_PCH_PCIE_CFG_LTSSMTRNCTL_ENFORCRECNOTALLSOS 19
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_ENFORCRECNOTALLSOS BIT19

#define N_PCH_PCIE_CFG_LTSSMTRNCTL_SURLNKDNEN 20
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_SURLNKDNEN BIT20

#define N_PCH_PCIE_CFG_LTSSMTRNCTL_DETQUIETDETEIANY 21
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_DETQUIETDETEIANY BIT21

#define N_PCH_PCIE_CFG_LTSSMTRNCTL_EIEXIT2RECTO 22
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_EIEXIT2RECTO (0x3FC00000)



#define N_PCH_PCIE_CFG_LTSSMTRNCTL_ENFDEEMPHOVR 30
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_ENFDEEMPHOVR BIT30



#define N_PCH_PCIE_CFG_LTSSMTRNCTL_LOCKLANE0 31
#define B_PCH_PCIE_CFG_LTSSMTRNCTL_LOCKLANE0 BIT31

#define R_PCH_PCIE_CFG_LTSSMTRNCTL2  0x00000A38
#define S_PCH_PCIE_CFG_LTSSMTRNCTL2 4

#define N_PCH_PCIE_CFG_LTSSMTRNCTL2_SLOTWIDTH 0
#define B_PCH_PCIE_CFG_LTSSMTRNCTL2_SLOTWIDTH (BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_LTSSMTRNCTL2_SLOTWIDTHOVR 3
#define B_PCH_PCIE_CFG_LTSSMTRNCTL2_SLOTWIDTHOVR BIT3

#define N_PCH_PCIE_CFG_LTSSMTRNCTL2_AUTOSLTWMASK 4
#define B_PCH_PCIE_CFG_LTSSMTRNCTL2_AUTOSLTWMASK (BIT7 | BIT6 | BIT5 | BIT4)



#define N_PCH_PCIE_CFG_LTSSMTRNCTL2_SELFLB 8
#define B_PCH_PCIE_CFG_LTSSMTRNCTL2_SELFLB BIT8

#define N_PCH_PCIE_CFG_LTSSMTRNCTL2_CLKREQSMPDLY 13
#define B_PCH_PCIE_CFG_LTSSMTRNCTL2_CLKREQSMPDLY (BIT15 | BIT14 | BIT13)



#define N_PCH_PCIE_CFG_LTSSMTRNCTL2_TXRXDETPOL 16
#define B_PCH_PCIE_CFG_LTSSMTRNCTL2_TXRXDETPOL BIT16

#define N_PCH_PCIE_CFG_LTSSMTRNCTL2_TXRXDETPOLTERMDIS 17
#define B_PCH_PCIE_CFG_LTSSMTRNCTL2_TXRXDETPOLTERMDIS BIT17

#define N_PCH_PCIE_CFG_LTSSMTRNCTL2_TXRXDETPOLIDL 18
#define B_PCH_PCIE_CFG_LTSSMTRNCTL2_TXRXDETPOLIDL (BIT19 | BIT18)

#define N_PCH_PCIE_CFG_LTSSMTRNCTL2_TXRXDETPOLATT 20
#define B_PCH_PCIE_CFG_LTSSMTRNCTL2_TXRXDETPOLATT (BIT21 | BIT20)

#define N_PCH_PCIE_CFG_LTSSMTRNCTL2_RPRSTMD 22
#define B_PCH_PCIE_CFG_LTSSMTRNCTL2_RPRSTMD BIT22

#define N_PCH_PCIE_CFG_LTSSMTRNCTL2_EIEXIT2RECTOMAX 24
#define B_PCH_PCIE_CFG_LTSSMTRNCTL2_EIEXIT2RECTOMAX (0xFF000000)



#define R_PCH_PCIE_CFG_LTSSMSTATEJMP 0x00000A40
#define S_PCH_PCIE_CFG_LTSSMSTATEJMP 4



#define N_PCH_PCIE_CFG_LTSSMSTATEJMP_FORCEMSTLB 0
#define B_PCH_PCIE_CFG_LTSSMSTATEJMP_FORCEMSTLB BIT0



#define N_PCH_PCIE_CFG_LTSSMSTATEJMP_EXITSLVLB 1
#define B_PCH_PCIE_CFG_LTSSMSTATEJMP_EXITSLVLB BIT1

#define N_PCH_PCIE_CFG_LTSSMSTATEJMP_FORCEDETECT 2
#define B_PCH_PCIE_CFG_LTSSMSTATEJMP_FORCEDETECT BIT2

#define N_PCH_PCIE_CFG_LTSSMSTATEJMP_MODIFPOLLB 3
#define B_PCH_PCIE_CFG_LTSSMSTATEJMP_MODIFPOLLB BIT3

#define N_PCH_PCIE_CFG_LTSSMSTATEJMP_NO_COMPLIANCE 4
#define B_PCH_PCIE_CFG_LTSSMSTATEJMP_NO_COMPLIANCE BIT4

#define N_PCH_PCIE_CFG_LTSSMSTATEJMP_PREL0WIDTHMASK 5
#define B_PCH_PCIE_CFG_LTSSMSTATEJMP_PREL0WIDTHMASK (0x000003E0)



#define N_PCH_PCIE_CFG_LTSSMSTATEJMP_HARDFORCE 10
#define B_PCH_PCIE_CFG_LTSSMSTATEJMP_HARDFORCE BIT10



#define R_PCH_PCIE_CFG_OSDECODECTL 0x00000A48
#define S_PCH_PCIE_CFG_OSDECODECTL 4

#define N_PCH_PCIE_CFG_OSDECODECTL_EIOS1IDLE 0
#define B_PCH_PCIE_CFG_OSDECODECTL_EIOS1IDLE BIT0



#define N_PCH_PCIE_CFG_OSDECODECTL_G3IDLESEEN 4
#define B_PCH_PCIE_CFG_OSDECODECTL_G3IDLESEEN (BIT7 | BIT6 | BIT5 | BIT4)



#define N_PCH_PCIE_CFG_OSDECODECTL_RSMONTS 8
#define B_PCH_PCIE_CFG_OSDECODECTL_RSMONTS BIT8



#define N_PCH_PCIE_CFG_OSDECODECTL_G3PARDIS 9
#define B_PCH_PCIE_CFG_OSDECODECTL_G3PARDIS BIT9



#define N_PCH_PCIE_CFG_OSDECODECTL_G36PRESET 10
#define B_PCH_PCIE_CFG_OSDECODECTL_G36PRESET BIT10



#define R_PCH_PCIE_CFG_DMONSEL 0x00000A50
#define S_PCH_PCIE_CFG_DMONSEL 4

#define N_PCH_PCIE_CFG_DMONSEL_SELA 0
#define B_PCH_PCIE_CFG_DMONSEL_SELA (0x000000FF)

#define N_PCH_PCIE_CFG_DMONSEL_SELB 8
#define B_PCH_PCIE_CFG_DMONSEL_SELB (0x0000FF00)



#define N_PCH_PCIE_CFG_DMONSEL_STRETCHA 16
#define B_PCH_PCIE_CFG_DMONSEL_STRETCHA (BIT19 | BIT18 | BIT17 | BIT16)



#define N_PCH_PCIE_CFG_DMONSEL_STRETCHB 20
#define B_PCH_PCIE_CFG_DMONSEL_STRETCHB (BIT23 | BIT22 | BIT21 | BIT20)



#define N_PCH_PCIE_CFG_DMONSEL_STRETCHALOW 24
#define B_PCH_PCIE_CFG_DMONSEL_STRETCHALOW BIT24



#define N_PCH_PCIE_CFG_DMONSEL_STRETCHBLOW 25
#define B_PCH_PCIE_CFG_DMONSEL_STRETCHBLOW BIT25



#define R_PCH_PCIE_CFG_PIPECTL 0x00000A58
#define S_PCH_PCIE_CFG_PIPECTL 4



#define N_PCH_PCIE_CFG_PIPECTL_PWRDNPERPORT 0
#define B_PCH_PCIE_CFG_PIPECTL_PWRDNPERPORT BIT0



#define N_PCH_PCIE_CFG_PIPECTL_RATECHP0ONLY 1
#define B_PCH_PCIE_CFG_PIPECTL_RATECHP0ONLY BIT1



#define N_PCH_PCIE_CFG_PIPECTL_G1DEEMPHPRESPD 2
#define B_PCH_PCIE_CFG_PIPECTL_G1DEEMPHPRESPD BIT2



#define R_PCH_PCIE_CFG_PIPECTL2 0x00000A5C
#define S_PCH_PCIE_CFG_PIPECTL2 4

#define N_PCH_PCIE_CFG_PIPECTL2_TXSWING 0
#define B_PCH_PCIE_CFG_PIPECTL2_TXSWING BIT0



#define N_PCH_PCIE_CFG_PIPECTL2_G1INL1 1
#define B_PCH_PCIE_CFG_PIPECTL2_G1INL1 BIT1



#define N_PCH_PCIE_CFG_PIPECTL2_G1INDIS 2
#define B_PCH_PCIE_CFG_PIPECTL2_G1INDIS BIT2



#define N_PCH_PCIE_CFG_PIPECTL2_G1INL2 3
#define B_PCH_PCIE_CFG_PIPECTL2_G1INL2 BIT3



#define N_PCH_PCIE_CFG_PIPECTL2_L1P0_PSMAP 4
#define B_PCH_PCIE_CFG_PIPECTL2_L1P0_PSMAP (BIT6 | BIT5 | BIT4)



#define N_PCH_PCIE_CFG_PIPECTL2_EN_TXYANKHNDSHKBYP 8
#define B_PCH_PCIE_CFG_PIPECTL2_EN_TXYANKHNDSHKBYP BIT8



#define N_PCH_PCIE_CFG_PIPECTL2_NODEEMPHG1 9
#define B_PCH_PCIE_CFG_PIPECTL2_NODEEMPHG1 BIT9



#define N_PCH_PCIE_CFG_PIPECTL2_NODEEMPHG2 10
#define B_PCH_PCIE_CFG_PIPECTL2_NODEEMPHG2 BIT10

#define N_PCH_PCIE_CFG_PIPECTL2_RXINTFLTROVR 11
#define B_PCH_PCIE_CFG_PIPECTL2_RXINTFLTROVR (BIT12 | BIT11)



#define N_PCH_PCIE_CFG_PIPECTL2_RXSTDBY4PROLONGREC 13
#define B_PCH_PCIE_CFG_PIPECTL2_RXSTDBY4PROLONGREC BIT13



#define N_PCH_PCIE_CFG_PIPECTL2_WAITONALLRXSTDBY 14
#define B_PCH_PCIE_CFG_PIPECTL2_WAITONALLRXSTDBY BIT14

#define N_PCH_PCIE_CFG_PIPECTL2_ZRXDCNOTMETING3 15
#define B_PCH_PCIE_CFG_PIPECTL2_ZRXDCNOTMETING3 BIT15



#define N_PCH_PCIE_CFG_PIPECTL2_L1P1_PSMAP 16
#define B_PCH_PCIE_CFG_PIPECTL2_L1P1_PSMAP (BIT18 | BIT17 | BIT16)



#define N_PCH_PCIE_CFG_PIPECTL2_L1P2_PSMAP 19
#define B_PCH_PCIE_CFG_PIPECTL2_L1P2_PSMAP (BIT21 | BIT20 | BIT19)



#define N_PCH_PCIE_CFG_PIPECTL2_DIS_PSMAP 22
#define B_PCH_PCIE_CFG_PIPECTL2_DIS_PSMAP (BIT24 | BIT23 | BIT22)



#define N_PCH_PCIE_CFG_PIPECTL2_CFGOFF_PSMAP 25
#define B_PCH_PCIE_CFG_PIPECTL2_CFGOFF_PSMAP (BIT27 | BIT26 | BIT25)



#define N_PCH_PCIE_CFG_PIPECTL2_L2_PSMAP 28
#define B_PCH_PCIE_CFG_PIPECTL2_L2_PSMAP (BIT30 | BIT29 | BIT28)



#define N_PCH_PCIE_CFG_PIPECTL2_DISCMNMODEL1P2 31
#define B_PCH_PCIE_CFG_PIPECTL2_DISCMNMODEL1P2 BIT31



#define R_PCH_PCIE_CFG_EIFILTCTL 0x00000A60
#define S_PCH_PCIE_CFG_EIFILTCTL 4

#define N_PCH_PCIE_CFG_EIFILTCTL_WINSZ 0
#define B_PCH_PCIE_CFG_EIFILTCTL_WINSZ (0x0000007F)



#define N_PCH_PCIE_CFG_EIFILTCTL_EIEXN 8
#define B_PCH_PCIE_CFG_EIFILTCTL_EIEXN (0x00007F00)



#define N_PCH_PCIE_CFG_EIFILTCTL_REFWINSZ 16
#define B_PCH_PCIE_CFG_EIFILTCTL_REFWINSZ (0x007F0000)



#define N_PCH_PCIE_CFG_EIFILTCTL_REFEIEXN 24
#define B_PCH_PCIE_CFG_EIFILTCTL_REFEIEXN (0x7F000000)



#define R_PCH_PCIE_CFG_LTSSMSMSTS 0x00000A68
#define S_PCH_PCIE_CFG_LTSSMSMSTS 4



#define N_PCH_PCIE_CFG_LTSSMSMSTS_LTSSMLNKUP 0
#define B_PCH_PCIE_CFG_LTSSMSMSTS_LTSSMLNKUP BIT0



#define N_PCH_PCIE_CFG_LTSSMSMSTS_DLACTIVE 1
#define B_PCH_PCIE_CFG_LTSSMSMSTS_DLACTIVE BIT1



#define N_PCH_PCIE_CFG_LTSSMSMSTS_LNKREVERSED 2
#define B_PCH_PCIE_CFG_LTSSMSMSTS_LNKREVERSED BIT2



#define N_PCH_PCIE_CFG_LTSSMSMSTS_RCVRATESUP 3
#define B_PCH_PCIE_CFG_LTSSMSMSTS_RCVRATESUP (BIT4 | BIT3)



#define N_PCH_PCIE_CFG_LTSSMSMSTS_LNKNUM 5
#define B_PCH_PCIE_CFG_LTSSMSMSTS_LNKNUM (0x00001FE0)



#define N_PCH_PCIE_CFG_LTSSMSMSTS_LTSSMRECEQSM 16
#define B_PCH_PCIE_CFG_LTSSMSMSTS_LTSSMRECEQSM (BIT18 | BIT17 | BIT16)



#define N_PCH_PCIE_CFG_LTSSMSMSTS_LTSSMRXL0SSM 20
#define B_PCH_PCIE_CFG_LTSSMSMSTS_LTSSMRXL0SSM (BIT22 | BIT21 | BIT20)



#define N_PCH_PCIE_CFG_LTSSMSMSTS_LTSSMSTATESUB 24
#define B_PCH_PCIE_CFG_LTSSMSMSTS_LTSSMSTATESUB (BIT27 | BIT26 | BIT25 | BIT24)



#define N_PCH_PCIE_CFG_LTSSMSMSTS_LTSSMSTATEMAIN 28
#define B_PCH_PCIE_CFG_LTSSMSMSTS_LTSSMSTATEMAIN (BIT31 | BIT30 | BIT29 | BIT28)



#define R_PCH_PCIE_CFG_LTSSMLNSTS0 0x00000A70
#define S_PCH_PCIE_CFG_LTSSMLNSTS0 4



#define N_PCH_PCIE_CFG_LTSSMLNSTS0_RCVRSMLN0 0
#define B_PCH_PCIE_CFG_LTSSMLNSTS0_RCVRSMLN0 (BIT3 | BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_LTSSMLNSTS0_RCVRSMLN1 4
#define B_PCH_PCIE_CFG_LTSSMLNSTS0_RCVRSMLN1 (BIT7 | BIT6 | BIT5 | BIT4)



#define N_PCH_PCIE_CFG_LTSSMLNSTS0_RCVRSMLN2 8
#define B_PCH_PCIE_CFG_LTSSMLNSTS0_RCVRSMLN2 (BIT11 | BIT10 | BIT9 | BIT8)



#define N_PCH_PCIE_CFG_LTSSMLNSTS0_RCVRSMLN3 12
#define B_PCH_PCIE_CFG_LTSSMLNSTS0_RCVRSMLN3 (BIT15 | BIT14 | BIT13 | BIT12)



#define N_PCH_PCIE_CFG_LTSSMLNSTS0_RCVRSMLN4 16
#define B_PCH_PCIE_CFG_LTSSMLNSTS0_RCVRSMLN4 (BIT19 | BIT18 | BIT17 | BIT16)



#define N_PCH_PCIE_CFG_LTSSMLNSTS0_RCVRSMLN5 20
#define B_PCH_PCIE_CFG_LTSSMLNSTS0_RCVRSMLN5 (BIT23 | BIT22 | BIT21 | BIT20)



#define N_PCH_PCIE_CFG_LTSSMLNSTS0_RCVRSMLN6 24
#define B_PCH_PCIE_CFG_LTSSMLNSTS0_RCVRSMLN6 (BIT27 | BIT26 | BIT25 | BIT24)



#define N_PCH_PCIE_CFG_LTSSMLNSTS0_RCVRSMLN7 28
#define B_PCH_PCIE_CFG_LTSSMLNSTS0_RCVRSMLN7 (BIT31 | BIT30 | BIT29 | BIT28)



#define R_PCH_PCIE_CFG_LTSSMSTATELOG0 0x00000A80
#define S_PCH_PCIE_CFG_LTSSMSTATELOG0 4

#define N_PCH_PCIE_CFG_LTSSMSTATELOG0_LAST8MAIN 0
#define B_PCH_PCIE_CFG_LTSSMSTATELOG0_LAST8MAIN (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_LTSSMSTATELOG1 0x00000A84
#define S_PCH_PCIE_CFG_LTSSMSTATELOG1 4

#define N_PCH_PCIE_CFG_LTSSMSTATELOG1_LAST8SUB 0
#define B_PCH_PCIE_CFG_LTSSMSTATELOG1_LAST8SUB (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_LTSSMSTATELOG2 0x00000A88
#define S_PCH_PCIE_CFG_LTSSMSTATELOG2 4

#define N_PCH_PCIE_CFG_LTSSMSTATELOG2_LAST8RXL0S 0
#define B_PCH_PCIE_CFG_LTSSMSTATELOG2_LAST8RXL0S (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_LTSSMSTATELOGCTL 0x00000A8C
#define S_PCH_PCIE_CFG_LTSSMSTATELOGCTL 4



#define N_PCH_PCIE_CFG_LTSSMSTATELOGCTL_START 0
#define B_PCH_PCIE_CFG_LTSSMSTATELOGCTL_START BIT0

#define N_PCH_PCIE_CFG_LTSSMSTATELOGCTL_STOP 1
#define B_PCH_PCIE_CFG_LTSSMSTATELOGCTL_STOP (0x000001FE)



#define R_PCH_PCIE_CFG_LTLNERRCTRL 0x00000A94
#define S_PCH_PCIE_CFG_LTLNERRCTRL 2

#define N_PCH_PCIE_CFG_LTLNERRCTRL_SEL1 0
#define B_PCH_PCIE_CFG_LTLNERRCTRL_SEL1 (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_LTLNERRCTRL_SEL2 4
#define B_PCH_PCIE_CFG_LTLNERRCTRL_SEL2 (BIT7 | BIT6 | BIT5 | BIT4)



#define R_PCH_PCIE_CFG_LTLNERRSTS 0x00000A96
#define S_PCH_PCIE_CFG_LTLNERRSTS 2



#define N_PCH_PCIE_CFG_LTLNERRSTS_CAPTURED1 0
#define B_PCH_PCIE_CFG_LTLNERRSTS_CAPTURED1 BIT0



#define N_PCH_PCIE_CFG_LTLNERRSTS_CAPTURED2 1
#define B_PCH_PCIE_CFG_LTLNERRSTS_CAPTURED2 BIT1



#define R_PCH_PCIE_CFG_LTLNERRLOG 0x00000A98
#define S_PCH_PCIE_CFG_LTLNERRLOG 4



#define N_PCH_PCIE_CFG_LTLNERRLOG_L0ERRSTS1 0
#define B_PCH_PCIE_CFG_LTLNERRLOG_L0ERRSTS1 BIT0



#define N_PCH_PCIE_CFG_LTLNERRLOG_L1ERRSTS1 1
#define B_PCH_PCIE_CFG_LTLNERRLOG_L1ERRSTS1 BIT1



#define N_PCH_PCIE_CFG_LTLNERRLOG_L2ERRSTS1 2
#define B_PCH_PCIE_CFG_LTLNERRLOG_L2ERRSTS1 BIT2



#define N_PCH_PCIE_CFG_LTLNERRLOG_L3ERRSTS1 3
#define B_PCH_PCIE_CFG_LTLNERRLOG_L3ERRSTS1 BIT3



#define N_PCH_PCIE_CFG_LTLNERRLOG_L4ERRSTS1 4
#define B_PCH_PCIE_CFG_LTLNERRLOG_L4ERRSTS1 BIT4



#define N_PCH_PCIE_CFG_LTLNERRLOG_L5ERRSTS1 5
#define B_PCH_PCIE_CFG_LTLNERRLOG_L5ERRSTS1 BIT5



#define N_PCH_PCIE_CFG_LTLNERRLOG_L6ERRSTS1 6
#define B_PCH_PCIE_CFG_LTLNERRLOG_L6ERRSTS1 BIT6



#define N_PCH_PCIE_CFG_LTLNERRLOG_L7ERRSTS1 7
#define B_PCH_PCIE_CFG_LTLNERRLOG_L7ERRSTS1 BIT7



#define N_PCH_PCIE_CFG_LTLNERRLOG_L0ERRSTS2 16
#define B_PCH_PCIE_CFG_LTLNERRLOG_L0ERRSTS2 BIT16



#define N_PCH_PCIE_CFG_LTLNERRLOG_L1ERRSTS2 17
#define B_PCH_PCIE_CFG_LTLNERRLOG_L1ERRSTS2 BIT17



#define N_PCH_PCIE_CFG_LTLNERRLOG_L2ERRSTS2 18
#define B_PCH_PCIE_CFG_LTLNERRLOG_L2ERRSTS2 BIT18



#define N_PCH_PCIE_CFG_LTLNERRLOG_L3ERRSTS2 19
#define B_PCH_PCIE_CFG_LTLNERRLOG_L3ERRSTS2 BIT19



#define N_PCH_PCIE_CFG_LTLNERRLOG_L4ERRSTS2 20
#define B_PCH_PCIE_CFG_LTLNERRLOG_L4ERRSTS2 BIT20



#define N_PCH_PCIE_CFG_LTLNERRLOG_L5ERRSTS2 21
#define B_PCH_PCIE_CFG_LTLNERRLOG_L5ERRSTS2 BIT21



#define N_PCH_PCIE_CFG_LTLNERRLOG_L6ERRSTS2 22
#define B_PCH_PCIE_CFG_LTLNERRLOG_L6ERRSTS2 BIT22



#define N_PCH_PCIE_CFG_LTLNERRLOG_L7ERRSTS2 23
#define B_PCH_PCIE_CFG_LTLNERRLOG_L7ERRSTS2 BIT23



#define R_PCH_PCIE_CFG_G3LNLFSFID0 0x00000AA0
#define S_PCH_PCIE_CFG_G3LNLFSFID0 4

#define N_PCH_PCIE_CFG_G3LNLFSFID0_LNOVREN 0
#define B_PCH_PCIE_CFG_G3LNLFSFID0_LNOVREN (0x000000FF)

#define N_PCH_PCIE_CFG_G3LNLFSFID0_LNID 8
#define B_PCH_PCIE_CFG_G3LNLFSFID0_LNID (0xFFFFFF00)



#define R_PCH_PCIE_CFG_G3LNLFSFID1 0x00000AA4
#define S_PCH_PCIE_CFG_G3LNLFSFID1 4

#define N_PCH_PCIE_CFG_G3LNLFSFID1_LNOVREN 0
#define B_PCH_PCIE_CFG_G3LNLFSFID1_LNOVREN (0x000000FF)

#define N_PCH_PCIE_CFG_G3LNLFSFID1_LNID 8
#define B_PCH_PCIE_CFG_G3LNLFSFID1_LNID (0xFFFFFF00)



#define R_PCH_PCIE_CFG_RXTERMENCTL 0x00000AA8
#define S_PCH_PCIE_CFG_RXTERMENCTL 4

#define N_PCH_PCIE_CFG_RXTERMENCTL_RXTERMEN 0
#define B_PCH_PCIE_CFG_RXTERMENCTL_RXTERMEN (0x000000FF)



#define N_PCH_PCIE_CFG_RXTERMENCTL_OVREN 16
#define B_PCH_PCIE_CFG_RXTERMENCTL_OVREN BIT16



#define R_PCH_PCIE_CFG_LANEDISMASK 0x00000AB0
#define S_PCH_PCIE_CFG_LANEDISMASK 4



#define N_PCH_PCIE_CFG_LANEDISMASK_MASK 0
#define B_PCH_PCIE_CFG_LANEDISMASK_MASK (0x000000FF)



#define R_PCH_PCIE_CFG_UPCFGCSR 0x00000AB8
#define S_PCH_PCIE_CFG_UPCFGCSR 4

#define N_PCH_PCIE_CFG_UPCFGCSR_UPCFGEN 0
#define B_PCH_PCIE_CFG_UPCFGCSR_UPCFGEN BIT0

#define N_PCH_PCIE_CFG_UPCFGCSR_TLW 1
#define B_PCH_PCIE_CFG_UPCFGCSR_TLW (0x0000007E)



#define N_PCH_PCIE_CFG_UPCFGCSR_UPCFGCAPEN 7
#define B_PCH_PCIE_CFG_UPCFGCSR_UPCFGCAPEN BIT7

#define N_PCH_PCIE_CFG_UPCFGCSR_ILW 16
#define B_PCH_PCIE_CFG_UPCFGCSR_ILW (0x003F0000)



#define N_PCH_PCIE_CFG_UPCFGCSR_RCVDUPCFGCAP 22
#define B_PCH_PCIE_CFG_UPCFGCSR_RCVDUPCFGCAP BIT22



#define R_PCH_PCIE_CFG_SOSCTL 0x00000AC8
#define S_PCH_PCIE_CFG_SOSCTL 4

#define N_PCH_PCIE_CFG_SOSCTL_SOSINTERVAL 0
#define B_PCH_PCIE_CFG_SOSCTL_SOSINTERVAL (0x000007FF)



#define N_PCH_PCIE_CFG_SOSCTL_SRISSOSINT 11
#define B_PCH_PCIE_CFG_SOSCTL_SRISSOSINT (0x003FF800)



#define N_PCH_PCIE_CFG_SOSCTL_SRISEN 22
#define B_PCH_PCIE_CFG_SOSCTL_SRISEN BIT22



#define R_PCH_PCIE_CFG_G3SOSERRSTS 0x00000ACC
#define S_PCH_PCIE_CFG_G3SOSERRSTS 4



#define N_PCH_PCIE_CFG_G3SOSERRSTS_PARERR 0
#define B_PCH_PCIE_CFG_G3SOSERRSTS_PARERR (0x0000FFFF)



#define N_PCH_PCIE_CFG_G3SOSERRSTS_LFSRERR 16
#define B_PCH_PCIE_CFG_G3SOSERRSTS_LFSRERR (0xFFFF0000)



#define R_PCH_PCIE_CFG_DETQUIETENTERTO 0x00000AD0
#define S_PCH_PCIE_CFG_DETQUIETENTERTO 4

#define N_PCH_PCIE_CFG_DETQUIETENTERTO_NORMOP 0
#define B_PCH_PCIE_CFG_DETQUIETENTERTO_NORMOP (0x0000001F)

#define N_PCH_PCIE_CFG_DETQUIETENTERTO_HVMOP 5
#define B_PCH_PCIE_CFG_DETQUIETENTERTO_HVMOP (0x00001FE0)



#define R_PCH_PCIE_CFG_IOPWRREQCTL 0x00000AD4
#define S_PCH_PCIE_CFG_IOPWRREQCTL 4

#define N_PCH_PCIE_CFG_IOPWRREQCTL_COREREQ 0
#define B_PCH_PCIE_CFG_IOPWRREQCTL_COREREQ (0x0000007F)



#define N_PCH_PCIE_CFG_IOPWRREQCTL_SUSREQ 16
#define B_PCH_PCIE_CFG_IOPWRREQCTL_SUSREQ (0x007F0000)



#define N_PCH_PCIE_CFG_IOPWRREQCTL_SUSREQIFPORTOFF 28
#define B_PCH_PCIE_CFG_IOPWRREQCTL_SUSREQIFPORTOFF BIT28



#define R_PCH_PCIE_CFG_IOPWRREQSTS 0x00000AD8
#define S_PCH_PCIE_CFG_IOPWRREQSTS 4



#define N_PCH_PCIE_CFG_IOPWRREQSTS_PHYSTATALL 0
#define B_PCH_PCIE_CFG_IOPWRREQSTS_PHYSTATALL BIT0



#define N_PCH_PCIE_CFG_IOPWRREQSTS_COREALLACKOFF 1
#define B_PCH_PCIE_CFG_IOPWRREQSTS_COREALLACKOFF BIT1



#define N_PCH_PCIE_CFG_IOPWRREQSTS_SUSALLACKOFF 2
#define B_PCH_PCIE_CFG_IOPWRREQSTS_SUSALLACKOFF BIT2



#define N_PCH_PCIE_CFG_IOPWRREQSTS_COREALLNOTSTABLE 3
#define B_PCH_PCIE_CFG_IOPWRREQSTS_COREALLNOTSTABLE BIT3



#define N_PCH_PCIE_CFG_IOPWRREQSTS_SUSALLNOTSTABLE 4
#define B_PCH_PCIE_CFG_IOPWRREQSTS_SUSALLNOTSTABLE BIT4



#define R_PCH_PCIE_CFG_PT0PHYCLKGCTL 0x00000AE4
#define S_PCH_PCIE_CFG_PT0PHYCLKGCTL 2

#define N_PCH_PCIE_CFG_PT0PHYCLKGCTL_ICT 0
#define B_PCH_PCIE_CFG_PT0PHYCLKGCTL_ICT (0x00FF)



#define N_PCH_PCIE_CFG_PT0PHYCLKGCTL_ICGE 15
#define B_PCH_PCIE_CFG_PT0PHYCLKGCTL_ICGE BIT15



#define R_PCH_PCIE_CFG_PT1PHYCLKGCTL 0x00000AE6
#define S_PCH_PCIE_CFG_PT1PHYCLKGCTL 2

#define N_PCH_PCIE_CFG_PT1PHYCLKGCTL_ICT 0
#define B_PCH_PCIE_CFG_PT1PHYCLKGCTL_ICT (0x00FF)



#define N_PCH_PCIE_CFG_PT1PHYCLKGCTL_ICGE 15
#define B_PCH_PCIE_CFG_PT1PHYCLKGCTL_ICGE BIT15



#define R_PCH_PCIE_CFG_PT2PHYCLKGCTL 0x00000AE8
#define S_PCH_PCIE_CFG_PT2PHYCLKGCTL 2

#define N_PCH_PCIE_CFG_PT2PHYCLKGCTL_ICT 0
#define B_PCH_PCIE_CFG_PT2PHYCLKGCTL_ICT (0x00FF)



#define N_PCH_PCIE_CFG_PT2PHYCLKGCTL_ICGE 15
#define B_PCH_PCIE_CFG_PT2PHYCLKGCTL_ICGE BIT15



#define R_PCH_PCIE_CFG_PT3PHYCLKGCTL 0x00000AEA
#define S_PCH_PCIE_CFG_PT3PHYCLKGCTL 2

#define N_PCH_PCIE_CFG_PT3PHYCLKGCTL_ICT 0
#define B_PCH_PCIE_CFG_PT3PHYCLKGCTL_ICT (0x00FF)



#define N_PCH_PCIE_CFG_PT3PHYCLKGCTL_ICGE 15
#define B_PCH_PCIE_CFG_PT3PHYCLKGCTL_ICGE BIT15



#define R_PCH_PCIE_CFG_LTLGCAP 0x00000B00
#define S_PCH_PCIE_CFG_LTLGCAP 4



#define N_PCH_PCIE_CFG_LTLGCAP_NUMSUBLOG 0
#define B_PCH_PCIE_CFG_LTLGCAP_NUMSUBLOG (BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_LTLGCAP_RAMSIZE 4
#define B_PCH_PCIE_CFG_LTLGCAP_RAMSIZE (0x0000FFF0)



#define N_PCH_PCIE_CFG_LTLGCAP_BAROFFSET 16
#define B_PCH_PCIE_CFG_LTLGCAP_BAROFFSET (0xFFFF0000)



#define R_PCH_PCIE_CFG_LTLGCTRL 0x00000B04
#define S_PCH_PCIE_CFG_LTLGCTRL 4

#define N_PCH_PCIE_CFG_LTLGCTRL_SPLITCTL 0
#define B_PCH_PCIE_CFG_LTLGCTRL_SPLITCTL (BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_LTLGCTRL_CLEARALL 4
#define B_PCH_PCIE_CFG_LTLGCTRL_CLEARALL BIT4



#define N_PCH_PCIE_CFG_LTLGCTRL_SUBLOG0PT 8
#define B_PCH_PCIE_CFG_LTLGCTRL_SUBLOG0PT (BIT10 | BIT9 | BIT8)



#define N_PCH_PCIE_CFG_LTLGCTRL_SUBLOG1PT 12
#define B_PCH_PCIE_CFG_LTLGCTRL_SUBLOG1PT (BIT14 | BIT13 | BIT12)



#define N_PCH_PCIE_CFG_LTLGCTRL_SUBLOG2PT 16
#define B_PCH_PCIE_CFG_LTLGCTRL_SUBLOG2PT (BIT18 | BIT17 | BIT16)



#define N_PCH_PCIE_CFG_LTLGCTRL_SUBLOG3PT 20
#define B_PCH_PCIE_CFG_LTLGCTRL_SUBLOG3PT (BIT22 | BIT21 | BIT20)



#define R_PCH_PCIE_CFG_LTLGSTART0 0x00000B08
#define S_PCH_PCIE_CFG_LTLGSTART0 4

#define N_PCH_PCIE_CFG_LTLGSTART0_START 0
#define B_PCH_PCIE_CFG_LTLGSTART0_START BIT0



#define N_PCH_PCIE_CFG_LTLGSTART0_STARTTRIGGERED 2
#define B_PCH_PCIE_CFG_LTLGSTART0_STARTTRIGGERED BIT2



#define N_PCH_PCIE_CFG_LTLGSTART0_STARTTRGEN 3
#define B_PCH_PCIE_CFG_LTLGSTART0_STARTTRGEN BIT3

#define N_PCH_PCIE_CFG_LTLGSTART0_STARTTRG 4
#define B_PCH_PCIE_CFG_LTLGSTART0_STARTTRG (0x0003FFF0)

#define N_PCH_PCIE_CFG_LTLGSTART0_STARTTRGMSK 18
#define B_PCH_PCIE_CFG_LTLGSTART0_STARTTRGMSK (0xFFFC0000)



#define R_PCH_PCIE_CFG_LTLGSTART1 0x00000B0C
#define S_PCH_PCIE_CFG_LTLGSTART1 4

#define N_PCH_PCIE_CFG_LTLGSTART1_START 0
#define B_PCH_PCIE_CFG_LTLGSTART1_START BIT0



#define N_PCH_PCIE_CFG_LTLGSTART1_STARTTRIGGERED 2
#define B_PCH_PCIE_CFG_LTLGSTART1_STARTTRIGGERED BIT2



#define N_PCH_PCIE_CFG_LTLGSTART1_STARTTRGEN 3
#define B_PCH_PCIE_CFG_LTLGSTART1_STARTTRGEN BIT3

#define N_PCH_PCIE_CFG_LTLGSTART1_STARTTRG 4
#define B_PCH_PCIE_CFG_LTLGSTART1_STARTTRG (0x0003FFF0)

#define N_PCH_PCIE_CFG_LTLGSTART1_STARTTRGMSK 18
#define B_PCH_PCIE_CFG_LTLGSTART1_STARTTRGMSK (0xFFFC0000)



#define R_PCH_PCIE_CFG_LTLGSTART2 0x00000B10
#define S_PCH_PCIE_CFG_LTLGSTART2 4

#define N_PCH_PCIE_CFG_LTLGSTART2_START 0
#define B_PCH_PCIE_CFG_LTLGSTART2_START BIT0



#define N_PCH_PCIE_CFG_LTLGSTART2_STARTTRIGGERED 2
#define B_PCH_PCIE_CFG_LTLGSTART2_STARTTRIGGERED BIT2



#define N_PCH_PCIE_CFG_LTLGSTART2_STARTTRGEN 3
#define B_PCH_PCIE_CFG_LTLGSTART2_STARTTRGEN BIT3

#define N_PCH_PCIE_CFG_LTLGSTART2_STARTTRG 4
#define B_PCH_PCIE_CFG_LTLGSTART2_STARTTRG (0x0003FFF0)

#define N_PCH_PCIE_CFG_LTLGSTART2_STARTTRGMSK 18
#define B_PCH_PCIE_CFG_LTLGSTART2_STARTTRGMSK (0xFFFC0000)



#define R_PCH_PCIE_CFG_LTLGSTART3 0x00000B14
#define S_PCH_PCIE_CFG_LTLGSTART3 4

#define N_PCH_PCIE_CFG_LTLGSTART3_START 0
#define B_PCH_PCIE_CFG_LTLGSTART3_START BIT0



#define N_PCH_PCIE_CFG_LTLGSTART3_STARTTRIGGERED 2
#define B_PCH_PCIE_CFG_LTLGSTART3_STARTTRIGGERED BIT2



#define N_PCH_PCIE_CFG_LTLGSTART3_STARTTRGEN 3
#define B_PCH_PCIE_CFG_LTLGSTART3_STARTTRGEN BIT3

#define N_PCH_PCIE_CFG_LTLGSTART3_STARTTRG 4
#define B_PCH_PCIE_CFG_LTLGSTART3_STARTTRG (0x0003FFF0)

#define N_PCH_PCIE_CFG_LTLGSTART3_STARTTRGMSK 18
#define B_PCH_PCIE_CFG_LTLGSTART3_STARTTRGMSK (0xFFFC0000)



#define R_PCH_PCIE_CFG_LTLGSTP0 0x00000B18
#define S_PCH_PCIE_CFG_LTLGSTP0 4

#define N_PCH_PCIE_CFG_LTLGSTP0_STOPTRGEN 0
#define B_PCH_PCIE_CFG_LTLGSTP0_STOPTRGEN BIT0

#define N_PCH_PCIE_CFG_LTLGSTP0_STOPTRG 1
#define B_PCH_PCIE_CFG_LTLGSTP0_STOPTRG (0x00007FFE)



#define N_PCH_PCIE_CFG_LTLGSTP0_STOPTRGMSK 15
#define B_PCH_PCIE_CFG_LTLGSTP0_STOPTRGMSK (0x1FFF8000)



#define N_PCH_PCIE_CFG_LTLGSTP0_XSTOPTRGEN 29
#define B_PCH_PCIE_CFG_LTLGSTP0_XSTOPTRGEN BIT29



#define N_PCH_PCIE_CFG_LTLGSTP0_XTRIGGERED 30
#define B_PCH_PCIE_CFG_LTLGSTP0_XTRIGGERED BIT30



#define N_PCH_PCIE_CFG_LTLGSTP0_TRIGGERED 31
#define B_PCH_PCIE_CFG_LTLGSTP0_TRIGGERED BIT31



#define R_PCH_PCIE_CFG_LTLGSTP1 0x00000B1C
#define S_PCH_PCIE_CFG_LTLGSTP1 4

#define N_PCH_PCIE_CFG_LTLGSTP1_STOPTRGEN 0
#define B_PCH_PCIE_CFG_LTLGSTP1_STOPTRGEN BIT0

#define N_PCH_PCIE_CFG_LTLGSTP1_STOPTRG 1
#define B_PCH_PCIE_CFG_LTLGSTP1_STOPTRG (0x00007FFE)



#define N_PCH_PCIE_CFG_LTLGSTP1_STOPTRGMSK 15
#define B_PCH_PCIE_CFG_LTLGSTP1_STOPTRGMSK (0x1FFF8000)



#define N_PCH_PCIE_CFG_LTLGSTP1_XSTOPTRGEN 29
#define B_PCH_PCIE_CFG_LTLGSTP1_XSTOPTRGEN BIT29



#define N_PCH_PCIE_CFG_LTLGSTP1_XTRIGGERED 30
#define B_PCH_PCIE_CFG_LTLGSTP1_XTRIGGERED BIT30



#define N_PCH_PCIE_CFG_LTLGSTP1_TRIGGERED 31
#define B_PCH_PCIE_CFG_LTLGSTP1_TRIGGERED BIT31



#define R_PCH_PCIE_CFG_LTLGSTP2 0x00000B20
#define S_PCH_PCIE_CFG_LTLGSTP2 4

#define N_PCH_PCIE_CFG_LTLGSTP2_STOPTRGEN 0
#define B_PCH_PCIE_CFG_LTLGSTP2_STOPTRGEN BIT0

#define N_PCH_PCIE_CFG_LTLGSTP2_STOPTRG 1
#define B_PCH_PCIE_CFG_LTLGSTP2_STOPTRG (0x00007FFE)



#define N_PCH_PCIE_CFG_LTLGSTP2_STOPTRGMSK 15
#define B_PCH_PCIE_CFG_LTLGSTP2_STOPTRGMSK (0x1FFF8000)



#define N_PCH_PCIE_CFG_LTLGSTP2_XSTOPTRGEN 29
#define B_PCH_PCIE_CFG_LTLGSTP2_XSTOPTRGEN BIT29



#define N_PCH_PCIE_CFG_LTLGSTP2_XTRIGGERED 30
#define B_PCH_PCIE_CFG_LTLGSTP2_XTRIGGERED BIT30



#define N_PCH_PCIE_CFG_LTLGSTP2_TRIGGERED 31
#define B_PCH_PCIE_CFG_LTLGSTP2_TRIGGERED BIT31



#define R_PCH_PCIE_CFG_LTLGSTP3 0x00000B24
#define S_PCH_PCIE_CFG_LTLGSTP3 4

#define N_PCH_PCIE_CFG_LTLGSTP3_STOPTRGEN 0
#define B_PCH_PCIE_CFG_LTLGSTP3_STOPTRGEN BIT0

#define N_PCH_PCIE_CFG_LTLGSTP3_STOPTRG 1
#define B_PCH_PCIE_CFG_LTLGSTP3_STOPTRG (0x00007FFE)



#define N_PCH_PCIE_CFG_LTLGSTP3_STOPTRGMSK 15
#define B_PCH_PCIE_CFG_LTLGSTP3_STOPTRGMSK (0x1FFF8000)



#define N_PCH_PCIE_CFG_LTLGSTP3_XSTOPTRGEN 29
#define B_PCH_PCIE_CFG_LTLGSTP3_XSTOPTRGEN BIT29



#define N_PCH_PCIE_CFG_LTLGSTP3_XTRIGGERED 30
#define B_PCH_PCIE_CFG_LTLGSTP3_XTRIGGERED BIT30



#define N_PCH_PCIE_CFG_LTLGSTP3_TRIGGERED 31
#define B_PCH_PCIE_CFG_LTLGSTP3_TRIGGERED BIT31



#define R_PCH_PCIE_CFG_LTLGTMEV0 0x00000B28
#define S_PCH_PCIE_CFG_LTLGTMEV0 4

#define N_PCH_PCIE_CFG_LTLGTMEV0_ENABLE 0
#define B_PCH_PCIE_CFG_LTLGTMEV0_ENABLE BIT0



#define N_PCH_PCIE_CFG_LTLGTMEV0_SMEGC 1
#define B_PCH_PCIE_CFG_LTLGTMEV0_SMEGC BIT1

#define N_PCH_PCIE_CFG_LTLGTMEV0_UNIT 2
#define B_PCH_PCIE_CFG_LTLGTMEV0_UNIT BIT2

#define N_PCH_PCIE_CFG_LTLGTMEV0_CMP 3
#define B_PCH_PCIE_CFG_LTLGTMEV0_CMP (BIT5 | BIT4 | BIT3)



#define N_PCH_PCIE_CFG_LTLGTMEV0_COUNT 6
#define B_PCH_PCIE_CFG_LTLGTMEV0_COUNT (0x007FFFC0)

#define N_PCH_PCIE_CFG_LTLGTMEV0_EVLVL 23
#define B_PCH_PCIE_CFG_LTLGTMEV0_EVLVL BIT23



#define N_PCH_PCIE_CFG_LTLGTMEV0_TRIGGERED 31
#define B_PCH_PCIE_CFG_LTLGTMEV0_TRIGGERED BIT31



#define R_PCH_PCIE_CFG_LTLGTMEV1 0x00000B2C
#define S_PCH_PCIE_CFG_LTLGTMEV1 4

#define N_PCH_PCIE_CFG_LTLGTMEV1_ENABLE 0
#define B_PCH_PCIE_CFG_LTLGTMEV1_ENABLE BIT0



#define N_PCH_PCIE_CFG_LTLGTMEV1_SMEGC 1
#define B_PCH_PCIE_CFG_LTLGTMEV1_SMEGC BIT1

#define N_PCH_PCIE_CFG_LTLGTMEV1_UNIT 2
#define B_PCH_PCIE_CFG_LTLGTMEV1_UNIT BIT2

#define N_PCH_PCIE_CFG_LTLGTMEV1_CMP 3
#define B_PCH_PCIE_CFG_LTLGTMEV1_CMP (BIT5 | BIT4 | BIT3)



#define N_PCH_PCIE_CFG_LTLGTMEV1_COUNT 6
#define B_PCH_PCIE_CFG_LTLGTMEV1_COUNT (0x007FFFC0)

#define N_PCH_PCIE_CFG_LTLGTMEV1_EVLVL 23
#define B_PCH_PCIE_CFG_LTLGTMEV1_EVLVL BIT23



#define N_PCH_PCIE_CFG_LTLGTMEV1_TRIGGERED 31
#define B_PCH_PCIE_CFG_LTLGTMEV1_TRIGGERED BIT31



#define R_PCH_PCIE_CFG_LTLGTMEV2 0x00000B30
#define S_PCH_PCIE_CFG_LTLGTMEV2 4

#define N_PCH_PCIE_CFG_LTLGTMEV2_ENABLE 0
#define B_PCH_PCIE_CFG_LTLGTMEV2_ENABLE BIT0



#define N_PCH_PCIE_CFG_LTLGTMEV2_SMEGC 1
#define B_PCH_PCIE_CFG_LTLGTMEV2_SMEGC BIT1

#define N_PCH_PCIE_CFG_LTLGTMEV2_UNIT 2
#define B_PCH_PCIE_CFG_LTLGTMEV2_UNIT BIT2

#define N_PCH_PCIE_CFG_LTLGTMEV2_CMP 3
#define B_PCH_PCIE_CFG_LTLGTMEV2_CMP (BIT5 | BIT4 | BIT3)



#define N_PCH_PCIE_CFG_LTLGTMEV2_COUNT 6
#define B_PCH_PCIE_CFG_LTLGTMEV2_COUNT (0x007FFFC0)

#define N_PCH_PCIE_CFG_LTLGTMEV2_EVLVL 23
#define B_PCH_PCIE_CFG_LTLGTMEV2_EVLVL BIT23



#define N_PCH_PCIE_CFG_LTLGTMEV2_TRIGGERED 31
#define B_PCH_PCIE_CFG_LTLGTMEV2_TRIGGERED BIT31



#define R_PCH_PCIE_CFG_LTLGTMEV3 0x00000B34
#define S_PCH_PCIE_CFG_LTLGTMEV3 4

#define N_PCH_PCIE_CFG_LTLGTMEV3_ENABLE 0
#define B_PCH_PCIE_CFG_LTLGTMEV3_ENABLE BIT0



#define N_PCH_PCIE_CFG_LTLGTMEV3_SMEGC 1
#define B_PCH_PCIE_CFG_LTLGTMEV3_SMEGC BIT1

#define N_PCH_PCIE_CFG_LTLGTMEV3_UNIT 2
#define B_PCH_PCIE_CFG_LTLGTMEV3_UNIT BIT2

#define N_PCH_PCIE_CFG_LTLGTMEV3_CMP 3
#define B_PCH_PCIE_CFG_LTLGTMEV3_CMP (BIT5 | BIT4 | BIT3)



#define N_PCH_PCIE_CFG_LTLGTMEV3_COUNT 6
#define B_PCH_PCIE_CFG_LTLGTMEV3_COUNT (0x007FFFC0)

#define N_PCH_PCIE_CFG_LTLGTMEV3_EVLVL 23
#define B_PCH_PCIE_CFG_LTLGTMEV3_EVLVL BIT23



#define N_PCH_PCIE_CFG_LTLGTMEV3_TRIGGERED 31
#define B_PCH_PCIE_CFG_LTLGTMEV3_TRIGGERED BIT31



#define R_PCH_PCIE_CFG_LTLGRDCT 0x00000B40
#define S_PCH_PCIE_CFG_LTLGRDCT 4

#define N_PCH_PCIE_CFG_LTLGRDCT_RDINDEX 0
#define B_PCH_PCIE_CFG_LTLGRDCT_RDINDEX (0x0000003F)

#define N_PCH_PCIE_CFG_LTLGRDCT_AUTOINC 15
#define B_PCH_PCIE_CFG_LTLGRDCT_AUTOINC BIT15



#define N_PCH_PCIE_CFG_LTLGRDCT_LOGSEL 16
#define B_PCH_PCIE_CFG_LTLGRDCT_LOGSEL (BIT17 | BIT16)



#define R_PCH_PCIE_CFG_LTLGRES 0x00000B44
#define S_PCH_PCIE_CFG_LTLGRES 4

#define N_PCH_PCIE_CFG_LTLGRES_ENTRY 0
#define B_PCH_PCIE_CFG_LTLGRES_ENTRY (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_LTLGSMEV0 0x00000B48
#define S_PCH_PCIE_CFG_LTLGSMEV0 4



#define N_PCH_PCIE_CFG_LTLGSMEV0_ENABLE 0
#define B_PCH_PCIE_CFG_LTLGSMEV0_ENABLE BIT0

#define N_PCH_PCIE_CFG_LTLGSMEV0_VALUE 1
#define B_PCH_PCIE_CFG_LTLGSMEV0_VALUE (0x00007FFE)



#define N_PCH_PCIE_CFG_LTLGSMEV0_MASK 15
#define B_PCH_PCIE_CFG_LTLGSMEV0_MASK (0x1FFF8000)



#define N_PCH_PCIE_CFG_LTLGSMEV0_TRIGGERED 31
#define B_PCH_PCIE_CFG_LTLGSMEV0_TRIGGERED BIT31



#define R_PCH_PCIE_CFG_LTLGSMEV1 0x00000B4C
#define S_PCH_PCIE_CFG_LTLGSMEV1 4



#define N_PCH_PCIE_CFG_LTLGSMEV1_ENABLE 0
#define B_PCH_PCIE_CFG_LTLGSMEV1_ENABLE BIT0

#define N_PCH_PCIE_CFG_LTLGSMEV1_VALUE 1
#define B_PCH_PCIE_CFG_LTLGSMEV1_VALUE (0x00007FFE)



#define N_PCH_PCIE_CFG_LTLGSMEV1_MASK 15
#define B_PCH_PCIE_CFG_LTLGSMEV1_MASK (0x1FFF8000)



#define N_PCH_PCIE_CFG_LTLGSMEV1_TRIGGERED 31
#define B_PCH_PCIE_CFG_LTLGSMEV1_TRIGGERED BIT31



#define R_PCH_PCIE_CFG_NFTSCOMCLK 0x00000B50
#define S_PCH_PCIE_CFG_NFTSCOMCLK 4



#define N_PCH_PCIE_CFG_NFTSCOMCLK_GEN1NFTS 0
#define B_PCH_PCIE_CFG_NFTSCOMCLK_GEN1NFTS (0x000000FF)



#define N_PCH_PCIE_CFG_NFTSCOMCLK_GEN2NFTS 8
#define B_PCH_PCIE_CFG_NFTSCOMCLK_GEN2NFTS (0x0000FF00)



#define N_PCH_PCIE_CFG_NFTSCOMCLK_GEN3NFTS 16
#define B_PCH_PCIE_CFG_NFTSCOMCLK_GEN3NFTS (0x00FF0000)



#define R_PCH_PCIE_CFG_NFTSDSCCLK 0x00000B54
#define S_PCH_PCIE_CFG_NFTSDSCCLK 4



#define N_PCH_PCIE_CFG_NFTSDSCCLK_GEN1NFTS 0
#define B_PCH_PCIE_CFG_NFTSDSCCLK_GEN1NFTS (0x000000FF)



#define N_PCH_PCIE_CFG_NFTSDSCCLK_GEN2NFTS 8
#define B_PCH_PCIE_CFG_NFTSDSCCLK_GEN2NFTS (0x0000FF00)



#define N_PCH_PCIE_CFG_NFTSDSCCLK_GEN3NFTS 16
#define B_PCH_PCIE_CFG_NFTSDSCCLK_GEN3NFTS (0x00FF0000)



#define R_PCH_PCIE_CFG_LEKBERR 0x00000B58
#define S_PCH_PCIE_CFG_LEKBERR 4

#define N_PCH_PCIE_CFG_LEKBERR_AGGRERR 0
#define B_PCH_PCIE_CFG_LEKBERR_AGGRERR (0x000FFFFF)

#define N_PCH_PCIE_CFG_LEKBERR_ERRTHRESH 20
#define B_PCH_PCIE_CFG_LEKBERR_ERRTHRESH (0x01F00000)



#define N_PCH_PCIE_CFG_LEKBERR_G3ERRTHRESH 25
#define B_PCH_PCIE_CFG_LEKBERR_G3ERRTHRESH (0x3E000000)



#define N_PCH_PCIE_CFG_LEKBERR_G3LBEEN 31
#define B_PCH_PCIE_CFG_LEKBERR_G3LBEEN BIT31



#define R_PCH_PCIE_CFG_EXPBERR0 0x00000B5C
#define S_PCH_PCIE_CFG_EXPBERR0 4

#define N_PCH_PCIE_CFG_EXPBERR0_EXP_BER 0
#define B_PCH_PCIE_CFG_EXPBERR0_EXP_BER (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_EXPBERR1 0x00000B60
#define S_PCH_PCIE_CFG_EXPBERR1 4

#define N_PCH_PCIE_CFG_EXPBERR1_EXP_BER 0
#define B_PCH_PCIE_CFG_EXPBERR1_EXP_BER (0x0003FFFF)



#define N_PCH_PCIE_CFG_EXPBERR1_G3AGGRERR 24
#define B_PCH_PCIE_CFG_EXPBERR1_G3AGGRERR (0xFF000000)



#define R_PCH_PCIE_CFG_LEKBPROERR 0x00000B64
#define S_PCH_PCIE_CFG_LEKBPROERR 4

#define N_PCH_PCIE_CFG_LEKBPROERR_ERRLNSTS 0
#define B_PCH_PCIE_CFG_LEKBPROERR_ERRLNSTS (0x000000FF)



#define N_PCH_PCIE_CFG_LEKBPROERR_G3ERRLNSTS 16
#define B_PCH_PCIE_CFG_LEKBPROERR_G3ERRLNSTS (0x00FF0000)



#define R_PCH_PCIE_CFG_SPEEDCTL 0x00000B68
#define S_PCH_PCIE_CFG_SPEEDCTL 4

#define N_PCH_PCIE_CFG_SPEEDCTL_DIRECTEDSPEEDCHNG 0
#define B_PCH_PCIE_CFG_SPEEDCTL_DIRECTEDSPEEDCHNG BIT0



#define N_PCH_PCIE_CFG_SPEEDCTL_DISG2UNLESSRCVDTS 1
#define B_PCH_PCIE_CFG_SPEEDCTL_DISG2UNLESSRCVDTS BIT1



#define N_PCH_PCIE_CFG_SPEEDCTL_DISG3UNLESSRCVDTS 2
#define B_PCH_PCIE_CFG_SPEEDCTL_DISG3UNLESSRCVDTS BIT2



#define N_PCH_PCIE_CFG_SPEEDCTL_DISG2POLCFG 3
#define B_PCH_PCIE_CFG_SPEEDCTL_DISG2POLCFG BIT3



#define N_PCH_PCIE_CFG_SPEEDCTL_DISG3POLCFG 4
#define B_PCH_PCIE_CFG_SPEEDCTL_DISG3POLCFG BIT4

#define N_PCH_PCIE_CFG_SPEEDCTL_MAINTAINTLS 5
#define B_PCH_PCIE_CFG_SPEEDCTL_MAINTAINTLS BIT5



#define N_PCH_PCIE_CFG_SPEEDCTL_OVRDISGEN2 6
#define B_PCH_PCIE_CFG_SPEEDCTL_OVRDISGEN2 BIT6



#define N_PCH_PCIE_CFG_SPEEDCTL_OVRDISGEN3 7
#define B_PCH_PCIE_CFG_SPEEDCTL_OVRDISGEN3 BIT7

#define N_PCH_PCIE_CFG_SPEEDCTL_FORCEGEN2 8
#define B_PCH_PCIE_CFG_SPEEDCTL_FORCEGEN2 BIT8

#define N_PCH_PCIE_CFG_SPEEDCTL_FORCEGEN3 9
#define B_PCH_PCIE_CFG_SPEEDCTL_FORCEGEN3 BIT9

#define N_PCH_PCIE_CFG_SPEEDCTL_DISINITSPDCHNG 10
#define B_PCH_PCIE_CFG_SPEEDCTL_DISINITSPDCHNG BIT10

#define N_PCH_PCIE_CFG_SPEEDCTL_RPTCFGCHANGE 11
#define B_PCH_PCIE_CFG_SPEEDCTL_RPTCFGCHANGE BIT11

#define N_PCH_PCIE_CFG_SPEEDCTL_RPTSPDCHANGE 12
#define B_PCH_PCIE_CFG_SPEEDCTL_RPTSPDCHANGE BIT12



#define N_PCH_PCIE_CFG_SPEEDCTL_SPDCHGFAILLIM 13
#define B_PCH_PCIE_CFG_SPEEDCTL_SPDCHGFAILLIM (BIT15 | BIT14 | BIT13)



#define N_PCH_PCIE_CFG_SPEEDCTL_UPTLS 16
#define B_PCH_PCIE_CFG_SPEEDCTL_UPTLS (BIT19 | BIT18 | BIT17 | BIT16)



#define N_PCH_PCIE_CFG_SPEEDCTL_RL 20
#define B_PCH_PCIE_CFG_SPEEDCTL_RL BIT20



#define N_PCH_PCIE_CFG_SPEEDCTL_LBEG2DEGRADEEN 24
#define B_PCH_PCIE_CFG_SPEEDCTL_LBEG2DEGRADEEN BIT24



#define N_PCH_PCIE_CFG_SPEEDCTL_LBEG3DEGRADEEN 25
#define B_PCH_PCIE_CFG_SPEEDCTL_LBEG3DEGRADEEN BIT25



#define N_PCH_PCIE_CFG_SPEEDCTL_LBEG2DIS 28
#define B_PCH_PCIE_CFG_SPEEDCTL_LBEG2DIS BIT28



#define N_PCH_PCIE_CFG_SPEEDCTL_LBEG3DIS 29
#define B_PCH_PCIE_CFG_SPEEDCTL_LBEG3DIS BIT29



#define R_PCH_PCIE_CFG_RCVRDETSTS 0x00000B6C
#define S_PCH_PCIE_CFG_RCVRDETSTS 4



#define N_PCH_PCIE_CFG_RCVRDETSTS_RCVRDETSTS 0
#define B_PCH_PCIE_CFG_RCVRDETSTS_RCVRDETSTS (0x000000FF)



#define R_PCH_PCIE_CFG_RCVRERR 0x00000B70
#define S_PCH_PCIE_CFG_RCVRERR 4



#define N_PCH_PCIE_CFG_RCVRERR_LANE 0
#define B_PCH_PCIE_CFG_RCVRERR_LANE (0x000000FF)



#define N_PCH_PCIE_CFG_RCVRERR_MASK 16
#define B_PCH_PCIE_CFG_RCVRERR_MASK (0x00FF0000)



#define R_PCH_PCIE_CFG_EBERR 0x00000B74
#define S_PCH_PCIE_CFG_EBERR 4



#define N_PCH_PCIE_CFG_EBERR_EBEMPTYERR 0
#define B_PCH_PCIE_CFG_EBERR_EBEMPTYERR (0x000000FF)



#define N_PCH_PCIE_CFG_EBERR_EBFULLERR 16
#define B_PCH_PCIE_CFG_EBERR_EBFULLERR (0x00FF0000)



#define R_PCH_PCIE_CFG_EBERRMSK 0x00000B78
#define S_PCH_PCIE_CFG_EBERRMSK 4



#define N_PCH_PCIE_CFG_EBERRMSK_MASK 0
#define B_PCH_PCIE_CFG_EBERRMSK_MASK (0x000000FF)



#define R_PCH_PCIE_CFG_OBEINJCTL 0x00000B7C
#define S_PCH_PCIE_CFG_OBEINJCTL 4

#define N_PCH_PCIE_CFG_OBEINJCTL_EINJEN 0
#define B_PCH_PCIE_CFG_OBEINJCTL_EINJEN BIT0

#define N_PCH_PCIE_CFG_OBEINJCTL_EINJFUNCTSEL 1
#define B_PCH_PCIE_CFG_OBEINJCTL_EINJFUNCTSEL BIT1

#define N_PCH_PCIE_CFG_OBEINJCTL_BLKTYPE 4
#define B_PCH_PCIE_CFG_OBEINJCTL_BLKTYPE BIT4

#define N_PCH_PCIE_CFG_OBEINJCTL_HDRINJ 5
#define B_PCH_PCIE_CFG_OBEINJCTL_HDRINJ BIT5

#define N_PCH_PCIE_CFG_OBEINJCTL_BLKBYTEOFF 6
#define B_PCH_PCIE_CFG_OBEINJCTL_BLKBYTEOFF (BIT9 | BIT8 | BIT7 | BIT6)

#define N_PCH_PCIE_CFG_OBEINJCTL_INJERRTYPE 10
#define B_PCH_PCIE_CFG_OBEINJCTL_INJERRTYPE (BIT11 | BIT10)

#define N_PCH_PCIE_CFG_OBEINJCTL_STPINJ 21
#define B_PCH_PCIE_CFG_OBEINJCTL_STPINJ BIT21

#define N_PCH_PCIE_CFG_OBEINJCTL_ENDINJ 22
#define B_PCH_PCIE_CFG_OBEINJCTL_ENDINJ BIT22

#define N_PCH_PCIE_CFG_OBEINJCTL_SDPINJ 23
#define B_PCH_PCIE_CFG_OBEINJCTL_SDPINJ BIT23

#define N_PCH_PCIE_CFG_OBEINJCTL_OTHRINJ 24
#define B_PCH_PCIE_CFG_OBEINJCTL_OTHRINJ BIT24

#define N_PCH_PCIE_CFG_OBEINJCTL_LNSLCT 27
#define B_PCH_PCIE_CFG_OBEINJCTL_LNSLCT (BIT30 | BIT29 | BIT28 | BIT27)

#define N_PCH_PCIE_CFG_OBEINJCTL_RESPDONEDIS 31
#define B_PCH_PCIE_CFG_OBEINJCTL_RESPDONEDIS BIT31



#define R_PCH_PCIE_CFG_LTSSMERRSTS0 0x00000B80
#define S_PCH_PCIE_CFG_LTSSMERRSTS0 4



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_SPEEDCHANGEFAIL 0
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_SPEEDCHANGEFAIL BIT0



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_PARTIAL_RCVRDET 1
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_PARTIAL_RCVRDET BIT1



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_POLACT_NOTS 2
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_POLACT_NOTS BIT2



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_POLCFG_NOTS 3
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_POLCFG_NOTS BIT3



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_CFGLNKWDST_TO 4
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_CFGLNKWDST_TO BIT4



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_CFGLNKWDAC_TO 5
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_CFGLNKWDAC_TO BIT5



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_CFGLNNUMWT_TO 6
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_CFGLNNUMWT_TO BIT6



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_CFGLNNUMAC_TO 7
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_CFGLNNUMAC_TO BIT7



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_CFGCMPLT_TO 8
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_CFGCMPLT_TO BIT8



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_CFGIDLE_TO 9
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_CFGIDLE_TO BIT9



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_UPL12RCVEIOS_TO 10
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_UPL12RCVEIOS_TO BIT10



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_RECRCVRLCKDOWN_TO 11
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_RECRCVRLCKDOWN_TO BIT11



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_RECRCVRLCKBW_TO 12
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_RECRCVRLCKBW_TO BIT12



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_RECSPDIDLWTEI_TO 13
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_RECSPDIDLWTEI_TO BIT13



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_RECSPDEXITEIEX_TO 14
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_RECSPDEXITEIEX_TO BIT14



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_RECRCVRCFGDOWN_TO 15
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_RECRCVRCFGDOWN_TO BIT15



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_RECRCVRCFGSPDOWN_TO 16
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_RECRCVRCFGSPDOWN_TO BIT16



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_RECIDLEDOWN_TO 17
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_RECIDLEDOWN_TO BIT17



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_DISWTEIOS_TO 18
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_DISWTEIOS_TO BIT18



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_LBMSTENTRY_TO 19
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_LBMSTENTRY_TO BIT19



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_UNEXPECTEDEI 20
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_UNEXPECTEDEI BIT20



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_RXL0SFTS_TO 21
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_RXL0SFTS_TO BIT21



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_RECRCVRLCKNOTALLTS 22
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_RECRCVRLCKNOTALLTS BIT22



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_RECRCVRLCKWIDTH 23
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_RECRCVRLCKWIDTH BIT23



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_EQPH0_TO 24
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_EQPH0_TO BIT24



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_EQPH1_TO 25
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_EQPH1_TO BIT25



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_EQSEVASYNC_TO 26
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_EQSEVASYNC_TO BIT26



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_EQSEVA_TO 27
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_EQSEVA_TO BIT27



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_EQMEVALCK_TO 28
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_EQMEVALCK_TO BIT28



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_EQMEVAL_TO 29
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_EQMEVAL_TO BIT29



#define N_PCH_PCIE_CFG_LTSSMERRSTS0_TBD 30
#define B_PCH_PCIE_CFG_LTSSMERRSTS0_TBD (BIT31 | BIT30)



#define R_PCH_PCIE_CFG_LTSSMERRSTS1 0x00000B84
#define S_PCH_PCIE_CFG_LTSSMERRSTS1 4



#define N_PCH_PCIE_CFG_LTSSMERRSTS1_G2FAILCTR 0
#define B_PCH_PCIE_CFG_LTSSMERRSTS1_G2FAILCTR (BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_LTSSMERRSTS1_G2FAILLIMERR 3
#define B_PCH_PCIE_CFG_LTSSMERRSTS1_G2FAILLIMERR BIT3



#define N_PCH_PCIE_CFG_LTSSMERRSTS1_G3FAILCTR 4
#define B_PCH_PCIE_CFG_LTSSMERRSTS1_G3FAILCTR (BIT6 | BIT5 | BIT4)



#define N_PCH_PCIE_CFG_LTSSMERRSTS1_G3FAILLIMERR 7
#define B_PCH_PCIE_CFG_LTSSMERRSTS1_G3FAILLIMERR BIT7



#define N_PCH_PCIE_CFG_LTSSMERRSTS1_TBD 8
#define B_PCH_PCIE_CFG_LTSSMERRSTS1_TBD (0x07FFFF00)



#define N_PCH_PCIE_CFG_LTSSMERRSTS1_LTERR0FERR 27
#define B_PCH_PCIE_CFG_LTSSMERRSTS1_LTERR0FERR (0xF8000000)



#define R_PCH_PCIE_CFG_EQEVALCTL6 0x00000B8C
#define S_PCH_PCIE_CFG_EQEVALCTL6 4

#define N_PCH_PCIE_CFG_EQEVALCTL6_BACKOFFTIME 0
#define B_PCH_PCIE_CFG_EQEVALCTL6_BACKOFFTIME (0x0000001F)



#define N_PCH_PCIE_CFG_EQEVALCTL6_REEQCTLEADPTEN 5
#define B_PCH_PCIE_CFG_EQEVALCTL6_REEQCTLEADPTEN BIT5

#define N_PCH_PCIE_CFG_EQEVALCTL6_REEQCTLEADPTWT 6
#define B_PCH_PCIE_CFG_EQEVALCTL6_REEQCTLEADPTWT (BIT8 | BIT7 | BIT6)



#define N_PCH_PCIE_CFG_EQEVALCTL6_LBCTLEADPTEN 9
#define B_PCH_PCIE_CFG_EQEVALCTL6_LBCTLEADPTEN BIT9

#define N_PCH_PCIE_CFG_EQEVALCTL6_LBCTLEADPTWT 10
#define B_PCH_PCIE_CFG_EQEVALCTL6_LBCTLEADPTWT (BIT12 | BIT11 | BIT10)



#define N_PCH_PCIE_CFG_EQEVALCTL6_SPDCHGCTLEADPTEN 13
#define B_PCH_PCIE_CFG_EQEVALCTL6_SPDCHGCTLEADPTEN BIT13



#define N_PCH_PCIE_CFG_EQEVALCTL6_LOCBUSFETCHEN 14
#define B_PCH_PCIE_CFG_EQEVALCTL6_LOCBUSFETCHEN BIT14



#define N_PCH_PCIE_CFG_EQEVALCTL6_LOCBUSFETCHINIT 15
#define B_PCH_PCIE_CFG_EQEVALCTL6_LOCBUSFETCHINIT BIT15



#define N_PCH_PCIE_CFG_EQEVALCTL6_EIEREENTIME 16
#define B_PCH_PCIE_CFG_EQEVALCTL6_EIEREENTIME (0x003F0000)



#define N_PCH_PCIE_CFG_EQEVALCTL6_EIEREENERRCTRMSK 22
#define B_PCH_PCIE_CFG_EQEVALCTL6_EIEREENERRCTRMSK (0x0FC00000)



#define N_PCH_PCIE_CFG_EQEVALCTL6_REQLBMSTRCOEFF 28
#define B_PCH_PCIE_CFG_EQEVALCTL6_REQLBMSTRCOEFF BIT28



#define R_PCH_PCIE_CFG_EQEVALCTL7 0x00000B90
#define S_PCH_PCIE_CFG_EQEVALCTL7 4



#define N_PCH_PCIE_CFG_EQEVALCTL7_FOMSTPLIM 0
#define B_PCH_PCIE_CFG_EQEVALCTL7_FOMSTPLIM (0x000000FF)



#define R_PCH_PCIE_CFG_EQFARFSLF 0x00000B9C
#define S_PCH_PCIE_CFG_EQFARFSLF 4



#define N_PCH_PCIE_CFG_EQFARFSLF_FARFS 0
#define B_PCH_PCIE_CFG_EQFARFSLF_FARFS (0x0000003F)



#define N_PCH_PCIE_CFG_EQFARFSLF_FARLF 8
#define B_PCH_PCIE_CFG_EQFARFSLF_FARLF (0x00003F00)



#define N_PCH_PCIE_CFG_EQFARFSLF_FSSAME 16
#define B_PCH_PCIE_CFG_EQFARFSLF_FSSAME BIT16



#define N_PCH_PCIE_CFG_EQFARFSLF_LFSAME 17
#define B_PCH_PCIE_CFG_EQFARFSLF_LFSAME BIT17



#define R_PCH_PCIE_CFG_FOMINCCTL 0x00000BA4
#define S_PCH_PCIE_CFG_FOMINCCTL 4



#define N_PCH_PCIE_CFG_FOMINCCTL_TFI_VAL 0
#define B_PCH_PCIE_CFG_FOMINCCTL_TFI_VAL (0x0000003F)

#define N_PCH_PCIE_CFG_FOMINCCTL_TFI_UNIT 6
#define B_PCH_PCIE_CFG_FOMINCCTL_TFI_UNIT (BIT7 | BIT6)



#define N_PCH_PCIE_CFG_FOMINCCTL_TSI_VAL 8
#define B_PCH_PCIE_CFG_FOMINCCTL_TSI_VAL (0x00003F00)



#define N_PCH_PCIE_CFG_FOMINCCTL_TSI_UNIT 14
#define B_PCH_PCIE_CFG_FOMINCCTL_TSI_UNIT (BIT15 | BIT14)



#define N_PCH_PCIE_CFG_FOMINCCTL_TEM_VAL 16
#define B_PCH_PCIE_CFG_FOMINCCTL_TEM_VAL (0x003F0000)

#define N_PCH_PCIE_CFG_FOMINCCTL_TEM_UNIT 22
#define B_PCH_PCIE_CFG_FOMINCCTL_TEM_UNIT BIT22



#define N_PCH_PCIE_CFG_FOMINCCTL_ERRMASKEN 23
#define B_PCH_PCIE_CFG_FOMINCCTL_ERRMASKEN BIT23



#define N_PCH_PCIE_CFG_FOMINCCTL_SLOWTIMERTHRESH 24
#define B_PCH_PCIE_CFG_FOMINCCTL_SLOWTIMERTHRESH (0xFF000000)



#define R_PCH_PCIE_CFG_PHYRECAL 0x00000BA8
#define S_PCH_PCIE_CFG_PHYRECAL 4



#define N_PCH_PCIE_CFG_PHYRECAL_G2L1EXITEN 0
#define B_PCH_PCIE_CFG_PHYRECAL_G2L1EXITEN BIT0



#define N_PCH_PCIE_CFG_PHYRECAL_G3L1EXITEN 1
#define B_PCH_PCIE_CFG_PHYRECAL_G3L1EXITEN BIT1



#define N_PCH_PCIE_CFG_PHYRECAL_G2RECONERREN 2
#define B_PCH_PCIE_CFG_PHYRECAL_G2RECONERREN BIT2



#define N_PCH_PCIE_CFG_PHYRECAL_G3RECONERREN 3
#define B_PCH_PCIE_CFG_PHYRECAL_G3RECONERREN BIT3



#define R_PCH_PCIE_CFG_PLLSTBYCTL 0x00000BAC
#define S_PCH_PCIE_CFG_PLLSTBYCTL 4



#define N_PCH_PCIE_CFG_PLLSTBYCTL_PSE 0
#define B_PCH_PCIE_CFG_PLLSTBYCTL_PSE (BIT3 | BIT2 | BIT1 | BIT0)

#define N_PCH_PCIE_CFG_PLLSTBYCTL_PCLK_TRUNK_CGE 4
#define B_PCH_PCIE_CFG_PLLSTBYCTL_PCLK_TRUNK_CGE BIT4

#define N_PCH_PCIE_CFG_PLLSTBYCTL_P2VSP1 8
#define B_PCH_PCIE_CFG_PLLSTBYCTL_P2VSP1 BIT8

#define N_PCH_PCIE_CFG_PLLSTBYCTL_PCLK_ACK1TOREQ0 12
#define B_PCH_PCIE_CFG_PLLSTBYCTL_PCLK_ACK1TOREQ0 (BIT15 | BIT14 | BIT13 | BIT12)

#define N_PCH_PCIE_CFG_PLLSTBYCTL_PCLK_IDLETOREQ0 16
#define B_PCH_PCIE_CFG_PLLSTBYCTL_PCLK_IDLETOREQ0 (BIT19 | BIT18 | BIT17 | BIT16)

#define N_PCH_PCIE_CFG_PLLSTBYCTL_PSMAT 20
#define B_PCH_PCIE_CFG_PLLSTBYCTL_PSMAT (BIT23 | BIT22 | BIT21 | BIT20)

#define N_PCH_PCIE_CFG_PLLSTBYCTL_PSTBYA 24
#define B_PCH_PCIE_CFG_PLLSTBYCTL_PSTBYA (BIT27 | BIT26 | BIT25 | BIT24)

#define N_PCH_PCIE_CFG_PLLSTBYCTL_PSIP 28
#define B_PCH_PCIE_CFG_PLLSTBYCTL_PSIP (BIT31 | BIT30 | BIT29 | BIT28)



#define R_PCH_PCIE_CFG_PLUTXEQCTL 0x00000BB0
#define S_PCH_PCIE_CFG_PLUTXEQCTL 4



#define N_PCH_PCIE_CFG_PLUTXEQCTL_LF 16
#define B_PCH_PCIE_CFG_PLUTXEQCTL_LF (0x003F0000)



#define N_PCH_PCIE_CFG_PLUTXEQCTL_FS 22
#define B_PCH_PCIE_CFG_PLUTXEQCTL_FS (0x0FC00000)



#define R_PCH_PCIE_CFG_PHYCGIDLEMSK 0x00000BB4
#define S_PCH_PCIE_CFG_PHYCGIDLEMSK 4



#define N_PCH_PCIE_CFG_PHYCGIDLEMSK_DISSUCC 0
#define B_PCH_PCIE_CFG_PHYCGIDLEMSK_DISSUCC BIT0



#define N_PCH_PCIE_CFG_PHYCGIDLEMSK_L2IDLE 1
#define B_PCH_PCIE_CFG_PHYCGIDLEMSK_L2IDLE BIT1



#define N_PCH_PCIE_CFG_PHYCGIDLEMSK_L1IDLE 2
#define B_PCH_PCIE_CFG_PHYCGIDLEMSK_L1IDLE BIT2

#define N_PCH_PCIE_CFG_PHYCGIDLEMSK_PLL_DISSUCC 3
#define B_PCH_PCIE_CFG_PHYCGIDLEMSK_PLL_DISSUCC BIT3

#define N_PCH_PCIE_CFG_PHYCGIDLEMSK_PLL_L2IDLE 4
#define B_PCH_PCIE_CFG_PHYCGIDLEMSK_PLL_L2IDLE BIT4

#define N_PCH_PCIE_CFG_PHYCGIDLEMSK_PLL_L1IDLE 5
#define B_PCH_PCIE_CFG_PHYCGIDLEMSK_PLL_L1IDLE BIT5



#define R_PCH_PCIE_CFG_EQEVALCTL4 0x00000BB8
#define S_PCH_PCIE_CFG_EQEVALCTL4 4



#define N_PCH_PCIE_CFG_EQEVALCTL4_FOMERRTHRESH 0
#define B_PCH_PCIE_CFG_EQEVALCTL4_FOMERRTHRESH (0x000003FF)



#define N_PCH_PCIE_CFG_EQEVALCTL4_FOMSEARCH_EN 17
#define B_PCH_PCIE_CFG_EQEVALCTL4_FOMSEARCH_EN BIT17



#define N_PCH_PCIE_CFG_EQEVALCTL4_RXHINT7OVR_EN 19
#define B_PCH_PCIE_CFG_EQEVALCTL4_RXHINT7OVR_EN BIT19

#define N_PCH_PCIE_CFG_EQEVALCTL4_QCHKTMUNIT 23
#define B_PCH_PCIE_CFG_EQEVALCTL4_QCHKTMUNIT BIT23

#define N_PCH_PCIE_CFG_EQEVALCTL4_QCHKTMVAL 24
#define B_PCH_PCIE_CFG_EQEVALCTL4_QCHKTMVAL (0x7F000000)



#define N_PCH_PCIE_CFG_EQEVALCTL4_REVERSEEQTS2 31
#define B_PCH_PCIE_CFG_EQEVALCTL4_REVERSEEQTS2 BIT31



#define R_PCH_PCIE_CFG_EQEVALCTL5 0x00000BBC
#define S_PCH_PCIE_CFG_EQEVALCTL5 4

#define N_PCH_PCIE_CFG_EQEVALCTL5_LOCKTIME 0
#define B_PCH_PCIE_CFG_EQEVALCTL5_LOCKTIME (BIT3 | BIT2 | BIT1 | BIT0)



#define N_PCH_PCIE_CFG_EQEVALCTL5_COEFFEVALWAIT 4
#define B_PCH_PCIE_CFG_EQEVALCTL5_COEFFEVALWAIT (0x00000FF0)



#define N_PCH_PCIE_CFG_EQEVALCTL5_USEPREEVALWAIT 12
#define B_PCH_PCIE_CFG_EQEVALCTL5_USEPREEVALWAIT (0x000FF000)

#define N_PCH_PCIE_CFG_EQEVALCTL5_PHASETODIS 20
#define B_PCH_PCIE_CFG_EQEVALCTL5_PHASETODIS (BIT22 | BIT21 | BIT20)



#define N_PCH_PCIE_CFG_EQEVALCTL5_PHMTIMERVAL 23
#define B_PCH_PCIE_CFG_EQEVALCTL5_PHMTIMERVAL (BIT26 | BIT25 | BIT24 | BIT23)



#define N_PCH_PCIE_CFG_EQEVALCTL5_PHSTIMERVAL 27
#define B_PCH_PCIE_CFG_EQEVALCTL5_PHSTIMERVAL (BIT30 | BIT29 | BIT28 | BIT27)



#define R_PCH_PCIE_CFG_LEKBLNERRCNT0 0x00000BC0
#define S_PCH_PCIE_CFG_LEKBLNERRCNT0 4

#define N_PCH_PCIE_CFG_LEKBLNERRCNT0_ERRCNT0 0
#define B_PCH_PCIE_CFG_LEKBLNERRCNT0_ERRCNT0 (0x0000001F)

#define N_PCH_PCIE_CFG_LEKBLNERRCNT0_ERRCNT1 5
#define B_PCH_PCIE_CFG_LEKBLNERRCNT0_ERRCNT1 (0x000003E0)

#define N_PCH_PCIE_CFG_LEKBLNERRCNT0_ERRCNT2 10
#define B_PCH_PCIE_CFG_LEKBLNERRCNT0_ERRCNT2 (0x00007C00)

#define N_PCH_PCIE_CFG_LEKBLNERRCNT0_ERRCNT3 15
#define B_PCH_PCIE_CFG_LEKBLNERRCNT0_ERRCNT3 (0x000F8000)

#define N_PCH_PCIE_CFG_LEKBLNERRCNT0_ERRCNT4 20
#define B_PCH_PCIE_CFG_LEKBLNERRCNT0_ERRCNT4 (0x01F00000)

#define N_PCH_PCIE_CFG_LEKBLNERRCNT0_ERRCNT5 25
#define B_PCH_PCIE_CFG_LEKBLNERRCNT0_ERRCNT5 (0x3E000000)



#define R_PCH_PCIE_CFG_LEKBLNERRCNT1 0x00000BC4
#define S_PCH_PCIE_CFG_LEKBLNERRCNT1 4

#define N_PCH_PCIE_CFG_LEKBLNERRCNT1_ERRCNT6 0
#define B_PCH_PCIE_CFG_LEKBLNERRCNT1_ERRCNT6 (0x0000001F)

#define N_PCH_PCIE_CFG_LEKBLNERRCNT1_ERRCNT7 5
#define B_PCH_PCIE_CFG_LEKBLNERRCNT1_ERRCNT7 (0x000003E0)



#define R_PCH_PCIE_CFG_EQEVALCTL 0x00000BD0
#define S_PCH_PCIE_CFG_EQEVALCTL 4



#define N_PCH_PCIE_CFG_EQEVALCTL_DEFPRESET 24
#define B_PCH_PCIE_CFG_EQEVALCTL_DEFPRESET (BIT27 | BIT26 | BIT25 | BIT24)



#define N_PCH_PCIE_CFG_EQEVALCTL_BYPASSEQTS2 28
#define B_PCH_PCIE_CFG_EQEVALCTL_BYPASSEQTS2 BIT28



#define N_PCH_PCIE_CFG_EQEVALCTL_NODLINITBLK 29
#define B_PCH_PCIE_CFG_EQEVALCTL_NODLINITBLK BIT29



#define N_PCH_PCIE_CFG_EQEVALCTL_BYPASSEQ 30
#define B_PCH_PCIE_CFG_EQEVALCTL_BYPASSEQ BIT30



#define R_PCH_PCIE_CFG_EQEVALCTL2 0x00000BD4
#define S_PCH_PCIE_CFG_EQEVALCTL2 4

#define N_PCH_PCIE_CFG_EQEVALCTL2_EVALTIME 0
#define B_PCH_PCIE_CFG_EQEVALCTL2_EVALTIME (0x000000FF)



#define N_PCH_PCIE_CFG_EQEVALCTL2_EVALATT 8
#define B_PCH_PCIE_CFG_EQEVALCTL2_EVALATT (0x0000FF00)



#define N_PCH_PCIE_CFG_EQEVALCTL2_REEQSPDDEGRADE 23
#define B_PCH_PCIE_CFG_EQEVALCTL2_REEQSPDDEGRADE BIT23

#define N_PCH_PCIE_CFG_EQEVALCTL2_SKIPEVALPH 24
#define B_PCH_PCIE_CFG_EQEVALCTL2_SKIPEVALPH BIT24



#define N_PCH_PCIE_CFG_EQEVALCTL2_IGNOREMD 25
#define B_PCH_PCIE_CFG_EQEVALCTL2_IGNOREMD BIT25



#define N_PCH_PCIE_CFG_EQEVALCTL2_EXTEIEOS 26
#define B_PCH_PCIE_CFG_EQEVALCTL2_EXTEIEOS BIT26



#define N_PCH_PCIE_CFG_EQEVALCTL2_HWREEQEN 27
#define B_PCH_PCIE_CFG_EQEVALCTL2_HWREEQEN BIT27



#define N_PCH_PCIE_CFG_EQEVALCTL2_HWQUIESCE 28
#define B_PCH_PCIE_CFG_EQEVALCTL2_HWQUIESCE BIT28



#define N_PCH_PCIE_CFG_EQEVALCTL2_IGNOREQUIESCE 29
#define B_PCH_PCIE_CFG_EQEVALCTL2_IGNOREQUIESCE BIT29



#define N_PCH_PCIE_CFG_EQEVALCTL2_BLKUPSPEED 30
#define B_PCH_PCIE_CFG_EQEVALCTL2_BLKUPSPEED BIT30

#define N_PCH_PCIE_CFG_EQEVALCTL2_BLKUPEQREQ 31
#define B_PCH_PCIE_CFG_EQEVALCTL2_BLKUPEQREQ BIT31



#define R_PCH_PCIE_CFG_EQEVALCTL3 0x00000BD8
#define S_PCH_PCIE_CFG_EQEVALCTL3 4



#define N_PCH_PCIE_CFG_EQEVALCTL3_ERRTHRESH1 0
#define B_PCH_PCIE_CFG_EQEVALCTL3_ERRTHRESH1 (0x000000FF)



#define N_PCH_PCIE_CFG_EQEVALCTL3_ERRTHRESH2 8
#define B_PCH_PCIE_CFG_EQEVALCTL3_ERRTHRESH2 (0x0000FF00)



#define N_PCH_PCIE_CFG_EQEVALCTL3_OVERT2SPDFAIL 16
#define B_PCH_PCIE_CFG_EQEVALCTL3_OVERT2SPDFAIL BIT16



#define N_PCH_PCIE_CFG_EQEVALCTL3_UNDERT2REDO 17
#define B_PCH_PCIE_CFG_EQEVALCTL3_UNDERT2REDO BIT17



#define R_PCH_PCIE_CFG_EQEVALSTS 0x00000BDC
#define S_PCH_PCIE_CFG_EQEVALSTS 4



#define N_PCH_PCIE_CFG_EQEVALSTS_LNOPT0 0
#define B_PCH_PCIE_CFG_EQEVALSTS_LNOPT0 BIT0



#define N_PCH_PCIE_CFG_EQEVALSTS_LNOPT1 1
#define B_PCH_PCIE_CFG_EQEVALSTS_LNOPT1 BIT1



#define N_PCH_PCIE_CFG_EQEVALSTS_LNOPT2 2
#define B_PCH_PCIE_CFG_EQEVALSTS_LNOPT2 BIT2



#define N_PCH_PCIE_CFG_EQEVALSTS_LNOPT3 3
#define B_PCH_PCIE_CFG_EQEVALSTS_LNOPT3 BIT3



#define N_PCH_PCIE_CFG_EQEVALSTS_LNOPT4 4
#define B_PCH_PCIE_CFG_EQEVALSTS_LNOPT4 BIT4



#define N_PCH_PCIE_CFG_EQEVALSTS_LNOPT5 5
#define B_PCH_PCIE_CFG_EQEVALSTS_LNOPT5 BIT5



#define N_PCH_PCIE_CFG_EQEVALSTS_LNOPT6 6
#define B_PCH_PCIE_CFG_EQEVALSTS_LNOPT6 BIT6



#define N_PCH_PCIE_CFG_EQEVALSTS_LNOPT7 7
#define B_PCH_PCIE_CFG_EQEVALSTS_LNOPT7 BIT7

#define N_PCH_PCIE_CFG_EQEVALSTS_LNLOOP0 16
#define B_PCH_PCIE_CFG_EQEVALSTS_LNLOOP0 BIT16

#define N_PCH_PCIE_CFG_EQEVALSTS_LNLOOP1 17
#define B_PCH_PCIE_CFG_EQEVALSTS_LNLOOP1 BIT17

#define N_PCH_PCIE_CFG_EQEVALSTS_LNLOOP2 18
#define B_PCH_PCIE_CFG_EQEVALSTS_LNLOOP2 BIT18

#define N_PCH_PCIE_CFG_EQEVALSTS_LNLOOP3 19
#define B_PCH_PCIE_CFG_EQEVALSTS_LNLOOP3 BIT19

#define N_PCH_PCIE_CFG_EQEVALSTS_LNLOOP4 20
#define B_PCH_PCIE_CFG_EQEVALSTS_LNLOOP4 BIT20

#define N_PCH_PCIE_CFG_EQEVALSTS_LNLOOP5 21
#define B_PCH_PCIE_CFG_EQEVALSTS_LNLOOP5 BIT21

#define N_PCH_PCIE_CFG_EQEVALSTS_LNLOOP6 22
#define B_PCH_PCIE_CFG_EQEVALSTS_LNLOOP6 BIT22

#define N_PCH_PCIE_CFG_EQEVALSTS_LNLOOP7 23
#define B_PCH_PCIE_CFG_EQEVALSTS_LNLOOP7 BIT23



#define R_PCH_PCIE_CFG_EQEVALSTS2 0x00000BE0
#define S_PCH_PCIE_CFG_EQEVALSTS2 4



#define N_PCH_PCIE_CFG_EQEVALSTS2_EVALATTS 0
#define B_PCH_PCIE_CFG_EQEVALSTS2_EVALATTS (0x000000FF)



#define N_PCH_PCIE_CFG_EQEVALSTS2_REEQSPDDISG3 8
#define B_PCH_PCIE_CFG_EQEVALSTS2_REEQSPDDISG3 BIT8



#define R_PCH_PCIE_CFG_EQEVALSTS3 0x00000BE4
#define S_PCH_PCIE_CFG_EQEVALSTS3 4



#define N_PCH_PCIE_CFG_EQEVALSTS3_LNERRTH2MET0 0
#define B_PCH_PCIE_CFG_EQEVALSTS3_LNERRTH2MET0 BIT0



#define N_PCH_PCIE_CFG_EQEVALSTS3_LNERRTH2MET1 1
#define B_PCH_PCIE_CFG_EQEVALSTS3_LNERRTH2MET1 BIT1



#define N_PCH_PCIE_CFG_EQEVALSTS3_LNERRTH2MET2 2
#define B_PCH_PCIE_CFG_EQEVALSTS3_LNERRTH2MET2 BIT2



#define N_PCH_PCIE_CFG_EQEVALSTS3_LNERRTH2MET3 3
#define B_PCH_PCIE_CFG_EQEVALSTS3_LNERRTH2MET3 BIT3



#define N_PCH_PCIE_CFG_EQEVALSTS3_LNERRTH2MET4 4
#define B_PCH_PCIE_CFG_EQEVALSTS3_LNERRTH2MET4 BIT4



#define N_PCH_PCIE_CFG_EQEVALSTS3_LNERRTH2MET5 5
#define B_PCH_PCIE_CFG_EQEVALSTS3_LNERRTH2MET5 BIT5



#define N_PCH_PCIE_CFG_EQEVALSTS3_LNERRTH2MET6 6
#define B_PCH_PCIE_CFG_EQEVALSTS3_LNERRTH2MET6 BIT6



#define N_PCH_PCIE_CFG_EQEVALSTS3_LNERRTH2MET7 7
#define B_PCH_PCIE_CFG_EQEVALSTS3_LNERRTH2MET7 BIT7

#define N_PCH_PCIE_CFG_EQEVALSTS3_LNRULELIM0 16
#define B_PCH_PCIE_CFG_EQEVALSTS3_LNRULELIM0 BIT16

#define N_PCH_PCIE_CFG_EQEVALSTS3_LNRULELIM1 17
#define B_PCH_PCIE_CFG_EQEVALSTS3_LNRULELIM1 BIT17

#define N_PCH_PCIE_CFG_EQEVALSTS3_LNRULELIM2 18
#define B_PCH_PCIE_CFG_EQEVALSTS3_LNRULELIM2 BIT18

#define N_PCH_PCIE_CFG_EQEVALSTS3_LNRULELIM3 19
#define B_PCH_PCIE_CFG_EQEVALSTS3_LNRULELIM3 BIT19

#define N_PCH_PCIE_CFG_EQEVALSTS3_LNRULELIM4 20
#define B_PCH_PCIE_CFG_EQEVALSTS3_LNRULELIM4 BIT20

#define N_PCH_PCIE_CFG_EQEVALSTS3_LNRULELIM5 21
#define B_PCH_PCIE_CFG_EQEVALSTS3_LNRULELIM5 BIT21

#define N_PCH_PCIE_CFG_EQEVALSTS3_LNRULELIM6 22
#define B_PCH_PCIE_CFG_EQEVALSTS3_LNRULELIM6 BIT22

#define N_PCH_PCIE_CFG_EQEVALSTS3_LNRULELIM7 23
#define B_PCH_PCIE_CFG_EQEVALSTS3_LNRULELIM7 BIT23



#define R_PCH_PCIE_CFG_G3FRAMEERR 0x00000BEC
#define S_PCH_PCIE_CFG_G3FRAMEERR 4



#define N_PCH_PCIE_CFG_G3FRAMEERR_RDOK 0
#define B_PCH_PCIE_CFG_G3FRAMEERR_RDOK BIT0



#define N_PCH_PCIE_CFG_G3FRAMEERR_SDP2 1
#define B_PCH_PCIE_CFG_G3FRAMEERR_SDP2 BIT1



#define N_PCH_PCIE_CFG_G3FRAMEERR_STP2 2
#define B_PCH_PCIE_CFG_G3FRAMEERR_STP2 BIT2



#define N_PCH_PCIE_CFG_G3FRAMEERR_EDS 3
#define B_PCH_PCIE_CFG_G3FRAMEERR_EDS BIT3



#define N_PCH_PCIE_CFG_G3FRAMEERR_BK1FE 4
#define B_PCH_PCIE_CFG_G3FRAMEERR_BK1FE BIT4



#define N_PCH_PCIE_CFG_G3FRAMEERR_BKFE 5
#define B_PCH_PCIE_CFG_G3FRAMEERR_BKFE BIT5



#define N_PCH_PCIE_CFG_G3FRAMEERR_SDSFE 6
#define B_PCH_PCIE_CFG_G3FRAMEERR_SDSFE BIT6



#define N_PCH_PCIE_CFG_G3FRAMEERR_ITKNTL 7
#define B_PCH_PCIE_CFG_G3FRAMEERR_ITKNTL BIT7



#define N_PCH_PCIE_CFG_G3FRAMEERR_ITKNDL 8
#define B_PCH_PCIE_CFG_G3FRAMEERR_ITKNDL BIT8



#define N_PCH_PCIE_CFG_G3FRAMEERR_ITKNLI 9
#define B_PCH_PCIE_CFG_G3FRAMEERR_ITKNLI BIT9



#define N_PCH_PCIE_CFG_G3FRAMEERR_ITKNL0 10
#define B_PCH_PCIE_CFG_G3FRAMEERR_ITKNL0 BIT10



#define N_PCH_PCIE_CFG_G3FRAMEERR_FCRC 11
#define B_PCH_PCIE_CFG_G3FRAMEERR_FCRC BIT11



#define N_PCH_PCIE_CFG_G3FRAMEERR_G3FRAMEFERR 27
#define B_PCH_PCIE_CFG_G3FRAMEERR_G3FRAMEFERR (BIT30 | BIT29 | BIT28 | BIT27)



#define R_PCH_PCIE_CFG_XPPDEF 0x00000BF4
#define S_PCH_PCIE_CFG_XPPDEF 4

#define N_PCH_PCIE_CFG_XPPDEF_RECO0 0
#define B_PCH_PCIE_CFG_XPPDEF_RECO0 (0xFFFFFFFF)



#define R_PCH_PCIE_CFG_XPPDEF2 0x00000BF8
#define S_PCH_PCIE_CFG_XPPDEF2 4

#define N_PCH_PCIE_CFG_XPPDEF2_RECO0 0
#define B_PCH_PCIE_CFG_XPPDEF2_RECO0 (0xFFFFFFFF)
#endif /* _PCIE_0_9_0_CFG_INSTCOMMON_h */
